
/*!
 **************************************************************************************
 * \file
 *    output.h
 * \brief
 *    Picture writing routine headers
 * \author
 *    Main contributors (see contributors.h for copyright, address and affiliation details) 
 *      - Karsten Suehring        <suehring@hhi.de>
 ***************************************************************************************
 */

#ifndef _OUTPUT_H_
#define _OUTPUT_H_

int testEndian(void);

void write_stored_frame(FrameStore *fs, int p_out);
void direct_output(StorablePicture *p, int p_out);
void init_out_buffer(void);
void uninit_out_buffer(void);

#ifdef  INTERNAL_BIT_DEPTH_INCREASE

void img2buf ( imgpel** imgX,            //!< Pointer to image plane
               unsigned char* buf,       //!< Buffer for file output
               int size_x,               //!< horizontal size of picture
               int size_y,               //!< vertical size of picture
               int symbol_size_in_bytes, //!< number of bytes in file used to represent a pel
               int crop_left,            //!< pixels to crop from left
               int crop_right,           //!< pixels to crop from right
               int crop_top,             //!< pixels to crop from top
               int crop_bottom,           //!< pixels to crop from bottom
               int input_bit_depth,
               int bit_depth_increase
               );
#else
void img2buf (imgpel** imgX, unsigned char* buf, int size_x, int size_y, int symbol_size_in_bytes, int crop_left, int crop_right, int crop_top, int crop_bottom);
#endif

#endif //_OUTPUT_H_
