//
//
//
#ifndef SWITCHED_FILTERS_H
#define SWITCHED_FILTERS_H

#define NUM_SIFO                        4             // Number of filters
#define NORM_FACTOR                     0.25          // 0.5
#define NO_SAMPLES                      {  1,  2, 16, 64} // noSamples
#define BL_SIZE                         16            // Block size
#define NO_DC_VAL                       64            // Number of DC levels
#define USE_DCMINMAX
#define THRESHOLD_FRAME_OFFSETS

#define HPF_SIFO_FPO                    4             // input->UseHPFilter

// Defines for img->filterParam
#define SIFO_FIRST_PASS_FPO             3             // Use sequence filters and first pass offsets 
#define SIFO_INTRA                      4             // P slice converted to I

//RAHUL - SIFO comments
//Sequence filter is calculated using previous frames
//Frame filter is calculated using 1st pass MVs

#define SIFO_USE_OFFSETS                1
#define NO_BEST_FILTER                  0

void SwapFilteredFrames(void);                        // slice.c
void UnifiedOneForthPixFiltSel(int filterParam);      // slice.c

void rdPictureCodingFilterP_IPass(void);              // image.c

void initSIFOFilters();                               // mbuffer.c
int Clip3Fun(int low, int high, int val);             // epzs.c
void setFirstPassSubpelOffset(int list);              // slice.c

int ComputeFiltersAndOffsets(void);                   // image.c
void UpdateSequenceFilters_B(void);                   // image.c
void UpdateSequenceFilters_P(void);                   // image.c
void resetFirstPassSubpelOffset(int list);            // slice.c
int getNonzero(int yuv, int list);
#endif  // SWITCHED_FILTERS_H

