//
//  MAIN PROGRAM FOR ENCODING
//



#include "PostFilter.h"
#include "cabac.h"
#ifdef USE_POST_FILTER
//results psnrBitsRes;
//int configurationFlag = 0;

//
//
//
void postProcessing(Bitstream *bitstream, imgpel **imgY_rec, imgpel **imgY_org, int frNo, int qp, int img_height, int img_width, int BDI, int BDL)
{
  static int first=0;
  static imgpel **imgY_var;
  int filtNo_best, varIndTab[NO_VAR_BINS], usePrevFiltBest[NO_VAR_BINS], prevFiltInd, i, j;
  double errorEnc;
  static double **filterCoeffSym;
  int force0;
  int codedFlag;

//#if DEBUGGING==1
//  double errorDec;
//#endif

  if(frNo==0)   //initialize all static variables
  {
    first=0;
  }

#if IBDI_FIX_PF
  BitDepthIncreasePF = BDI;
#endif

  if(first == 0)
  {
    initMatrix_ushort(&imgY_var, img_height, img_width); 
    initMatrix_double(&filterCoeffSym, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    first = 1;
  }
  // zero all variables - debugging purposes
  filtNo_best = 0; 
  prevFiltInd = 0;
  for(i = 0; i < NO_VAR_BINS; i++)
  {
    varIndTab[i] = 0;
    usePrevFiltBest[i] = 0;
    for(j = 0; j < MAX_SQR_FILT_LENGTH; j++)
      filterCoeffSym[i][j] = 0;
  }

  calcVar(imgY_var, imgY_rec, 3, img_height, img_width);

  errorEnc = findBestFilterVarPred(bitstream, imgY_rec, imgY_org, imgY_var, frNo, qp, &filtNo_best, filterCoeffSym, varIndTab, 
    usePrevFiltBest, &prevFiltInd, &force0, &codedFlag, img_height, img_width);

//#if DEBUGGING==1
//  errorDec = decFilterVarPred(imgY_rec, imgY_org, imgY_var, frNo, filtNo_best, filterCoeffSym, varIndTab, usePrevFiltBest, 
//    prevFiltInd, codedFlag, img_height, img_width);
//
//  assert(errorEnc == errorDec);
//#endif
}

int TerminateSliceForPF(Picture* pic,Bitstream *pfbitstream)
{
  int bytes_written;
  Bitstream *currStream;
  Slice *currSlice;
  EncodingEnvironmentPtr eep;
  int i, j, slice;
  int byte_pos_before_startcode_emu_prevention;
  int min_num_bytes=0;
  int stuffing_bytes=0;

  static int MbWidthC  [4]= { 0, 8, 8,  16};
  static int MbHeightC [4]= { 0, 8, 16, 16};
  int RawMbBits;

  int sh_end_pos, pf_end_pos, sd_end_pos;

  for (slice=0; slice<pic->no_slices; slice++)
  {
    currSlice   = pic->slices[slice];
    sh_end_pos  = currSlice->sh_byte_pos_pf;
    pf_end_pos = sh_end_pos + pfbitstream->byte_pos;
    for (i=0; i<currSlice->max_part_nr; i++)
    {
        currStream = (currSlice->partArr[i]).bitstream;
        sd_end_pos = currStream->byte_pos;
        for (j=0; j<sd_end_pos - sh_end_pos; j++)
        {
          currStream->streamBuffer[sd_end_pos+pfbitstream->byte_pos-j-1] = currStream->streamBuffer[sd_end_pos-j-1];
        }
        for (j=0; j<pfbitstream->byte_pos; j++)
        {
          currStream->streamBuffer[sh_end_pos+j] = pfbitstream->streamBuffer[j];
        }
        currStream->byte_pos = sd_end_pos + pfbitstream->byte_pos;

      if (input->symbol_mode == UVLC)
      {
        SODBtoRBSP(currStream);
        byte_pos_before_startcode_emu_prevention = currStream->byte_pos;
        currStream->byte_pos = RBSPtoEBSP(currStream->streamBuffer, 0 , currStream->byte_pos, 0);
        *(stats->em_prev_bits) += (currStream->byte_pos - byte_pos_before_startcode_emu_prevention) * 8;
      }
      else     // CABAC
      {
        eep = &((currSlice->partArr[i]).ee_cabac);
        // terminate the arithmetic code
        arienco_done_encoding(eep);
        currStream->bits_to_go = eep->Ebits_to_go;
        currStream->byte_buf = 0;
        bytes_written = currStream->byte_pos;
        img->bytes_in_picture += currStream->byte_pos;

        byte_pos_before_startcode_emu_prevention= currStream->byte_pos;

      if ( i==((currSlice->max_part_nr-1)))
      {
        RawMbBits = 256 * img->bitdepth_luma + 2 * MbWidthC[active_sps->chroma_format_idc] * MbHeightC[active_sps->chroma_format_idc] * img->bitdepth_chroma;
        min_num_bytes = ((96 * get_pic_bin_count()) - (RawMbBits * (int)img->PicSizeInMbs *3) + 1023) / 1024;
        if (min_num_bytes>img->bytes_in_picture)
        {
          stuffing_bytes = min_num_bytes - img->bytes_in_picture;
          printf ("CABAC stuffing words = %6d\n", stuffing_bytes/3);
        }
      }

        currStream->byte_pos = RBSPtoEBSP(currStream->streamBuffer, 0, currStream->byte_pos, currStream->byte_pos + stuffing_bytes);
        *(stats->em_prev_bits) += (currStream->byte_pos - byte_pos_before_startcode_emu_prevention) * 8;
      }           // CABAC
    } // partition loop
  }

  pfbitstream->byte_pos  = 0;
  return 0;
}




#endif  //#ifdef USE_POST_FILTER
