#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <limits.h>
#include <float.h>
#include <memory.h>

#include "global.h"
#include "rdopt_coding_state.h"
#include "mb_access.h"
#include "intrarefresh.h"
#include "image.h"
#include "transform8x8.h"
#include "fast_me.h"
#include "simplified_fast_me.h"
#include "mode_decision.h"
#include "fmo.h"

#include "mv_competition.h"
extern MV_Competition mv_comp;
extern int skip_mode;


#define FASTMODE 0    //added by Rahul for big blocks

#ifdef MB32X32
int no32x32=0, no64x64=0;//tm_vlc
#define IS_INTER_SLICE(type) ((type) == B_SLICE || (type) == P_SLICE) //also defined in rdopt.c



void SetMotionVectorsMB32 (Macroblock* currMB, int bframe, int mb_ext_level);

void
PartitionMotionSearch32 (int    blocktype,
                       int    block8x8, //MB32X32: block8x8=32x32, 32x16, 16x32, 16x16; MB16x16: block8x8=16x16, 16x8, 8x16, 8x8 -peisong 
                       int    lambda_factor,
#ifdef RDO_Q
                       int   transform8x8,
#endif
                       int mb_ext_level
                       );
void FindSkipModeMotionVector32 (int mb_ext_level);
void Get_Direct_Motion_Vectors32 (int mb_ext_level);
void CheckAvailabilityOfNeighborsCABAC(void);
int BPredPartitionCost32 (int   blocktype,
                        int   block8x8,
                        short fw_ref,
                        short bw_ref,
                        int   lambda_factor,
                        int   list,
                        int   mb_ext_level);
int BIDPartitionCost32 (int   blocktype,
                      int   block8x8,
                      short fw_ref,
                      short bw_ref,
                      int   lambda_factor,
                      int   mb_ext_level);
int Not_MB16_3(int mb_nr);
void find_Mb_cluster(int level, int CurrentMbAddr, int *CurrentMbAddr_x, int *CurrentMbAddr_y, int *extend_x, int *extend_y, int *num_MB, int *nextMbAddr);
int writeMBLayer_Big (int rdopt, int *coeff_rate, int bigger_block_type, int mb32i, int mb16i);

#ifdef USE_INTRA_MDDT
extern int   bestCofAC16[2][16*17];
#endif 

int curr_mbi, curr_mb32i;

int   cbp16[1<<(2*MAX_MB_EXT_LEVEL)], cbp16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
int   cbp_32[1<<(2*(MAX_MB_EXT_LEVEL-1))], cbp_32_RDCost[1<<(2*(MAX_MB_EXT_LEVEL-1))];
int64 cbp_blk16[1<<(2*MAX_MB_EXT_LEVEL)], cbp_blk16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
int   ****cofAC32[1<<(2*MAX_MB_EXT_LEVEL)], ****cofAC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];// ****cofAC8x8=NULL;        // [8x8block][4x4block][level/run][scan_pos]
int   ***cofDC32[1<<(2*MAX_MB_EXT_LEVEL)], ***cofDC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];                       // [yuv][level/run][scan_pos]

int    **cof32AC16x16[1<<(2*MAX_MB_EXT_LEVEL)], **cof32AC16x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][257];
int    ***cof32AC16x8[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC16x8_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];
int    ***cof32AC8x16[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC8x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];
int only_16x16_transform=0;

int   luma_transform_size_8x8_flag32[1<<(2*MAX_MB_EXT_LEVEL)], luma_transform_size_8x8_flag32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
char  frefframe32[4<<MAX_MB_EXT_LEVEL][4<<MAX_MB_EXT_LEVEL], brefframe32[4<<MAX_MB_EXT_LEVEL][4<<MAX_MB_EXT_LEVEL];
extern char  frefframe[4][4], brefframe[4][4];
int   best16x16pdir[4];
int bestmode32;
extern int best_c_imode;
extern int best_i16offset;
//extern int   ****cofAC=NULL, ****cofAC8x8=NULL;        // [8x8block][4x4block][level/run][scan_pos]
//extern int   ***cofDC=NULL;                       // [yuv][level/run][scan_pos]
extern int   b8mode[4], b8pdir[4];
extern int   luma_transform_size_8x8_flag;
extern  int ****cofAC;               //!< AC coefficients [8x8block][4x4block][level/run][scan_pos]
extern  int ***cofDC;                //!< DC coefficients [yuv][level/run][scan_pos]
Macroblock  MB32;
#ifdef MB64X64
Macroblock  MB64;
int bestmode64;
int mb32type[1<<(2*(MAX_MB_EXT_LEVEL-1))];
int RDCost_for_macroblocks64 (double   lambda,       // <-- lagrange multiplier
                            int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
                            int      *mode_idx,
                            double*  min_rdcost,   // <-> minimum rate-distortion cost
                            double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
                            int i16mode,
                            int mb_ext_level);
double encode_macroblock_cluster32(int CurrentMbAddr, int mb32count);
double encode_macroblock_cluster64(int CurrentMbAddr);
#endif
Macroblock MB32_16x16;//32x32 block, 16x16 mb type
int saved_mb32_nr;
int saved_mb32_geo[4];
int test_geo_flag=0;
int encode_one_macroblock_geo (double min_rdcost0, int mb_ext_level);
void dense_motion_field(int mb32count, int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y, int transform8x8, int mb_ext_level);
void MV_segmentation(int mb32count, int mb_ext_level);
extern int Segmentation_Selected;
void reuse_16x16_geo(int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y, int mb_ext_level);


double compute_mode_RD_cost_RDOQ32(Macroblock *currMB, RD_PARAMS enc_mb, short *bestQPcount, int mb_ext_level);
extern void propagate_qp_info     (int CurrentMbAddr, int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y);
extern void propagate_qp_infoFinal(int CurrentMbAddr, int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y);

void save_mv_for_speedup(int mb_ext_level);

void CheckAvailabilityOfNeighbors_Z(void)
{
  const int mb_nr = img->current_mb_nr;
  Macroblock *currMB = &img->mb_data[mb_nr];

  // mark all neighbors as unavailable
  currMB->mb_available_up   = NULL;
  currMB->mb_available_left = NULL;


    currMB->mbAddrA = mb_nr - 1;
    currMB->mbAddrB = mb_nr - img->PicWidthInMbs;
    currMB->mbAddrC = mb_nr - img->PicWidthInMbs + 1;
    currMB->mbAddrD = mb_nr - img->PicWidthInMbs - 1;

    currMB->mbAvailA = mb_is_available(currMB->mbAddrA, mb_nr) && ((mb_nr % img->PicWidthInMbs)!=0);
    currMB->mbAvailB = mb_is_available(currMB->mbAddrB, mb_nr);
    currMB->mbAvailC =  Not_MB16_3(mb_nr) && mb_is_available(currMB->mbAddrC, mb_nr) && (((mb_nr+1) % img->PicWidthInMbs)!=0);
    currMB->mbAvailD = mb_is_available(currMB->mbAddrD, mb_nr) && ((mb_nr % img->PicWidthInMbs)!=0);


  if (currMB->mbAvailA) currMB->mb_available_left = &(img->mb_data[currMB->mbAddrA]);
  if (currMB->mbAvailB) currMB->mb_available_up   = &(img->mb_data[currMB->mbAddrB]);
}

/*!
 ************************************************************************
 * \brief
 *    Checks the availability of neighboring macroblocks of
 *    the current macroblock for prediction and context determination;
 *    mb_ext_level: 2-this is 64x64 block; 1-this is 32x32 block; 0-a 16x16 block inside a 32x32 block
 ************************************************************************
 */
void CheckAvailabilityOfNeighbors32(int mb_ext_level)
{
  const int mb_nr = img->current_mb_nr;
  Macroblock *currMB = &img->mb_data[mb_nr];

  // mark all neighbors as unavailable
  currMB->mb_available_up   = NULL;
  currMB->mb_available_left = NULL;

  {
    currMB->mbAddrA = mb_nr - 1;
    currMB->mbAddrB = mb_nr - img->PicWidthInMbs;
    currMB->mbAddrC = mb_nr - img->PicWidthInMbs + (1<<mb_ext_level);
    currMB->mbAddrD = mb_nr - img->PicWidthInMbs - 1;

    currMB->mbAvailA = mb_is_available(currMB->mbAddrA, mb_nr) && ((mb_nr % img->PicWidthInMbs)!=0);
    currMB->mbAvailB = mb_is_available(currMB->mbAddrB, mb_nr);
    if(img->type != I_SLICE)
    {
      if(mb_ext_level)
        currMB->mbAvailC = mb_is_available(currMB->mbAddrC, mb_nr) && (((mb_nr+(1<<mb_ext_level)) % img->PicWidthInMbs)!=0);
      else
        currMB->mbAvailC = Not_MB16_3(mb_nr) && mb_is_available(currMB->mbAddrC, mb_nr) && (((mb_nr+1) % img->PicWidthInMbs)!=0);
    }
    else
        currMB->mbAvailC = mb_is_available(currMB->mbAddrC, mb_nr) && (((mb_nr+1) % img->PicWidthInMbs)!=0);

    currMB->mbAvailD = mb_is_available(currMB->mbAddrD, mb_nr) && ((mb_nr % img->PicWidthInMbs)!=0);
  }

  if (currMB->mbAvailA) currMB->mb_available_left = &(img->mb_data[currMB->mbAddrA]);
  if (currMB->mbAvailB) currMB->mb_available_up   = &(img->mb_data[currMB->mbAddrB]);
}

/*!
************************************************************************
* \brief
*    initializes the current macroblock
*
* \param 
*    mb32: 
*       2-initialization for 64x64 block;
*       1-initialization for 32x32 block;
*       0-initialization for a 16x16 block inside a 32x32 block
*    mb_addr: macroblock address in scan order
*    if mb32 is 1, mb_addr is the upper left 16x16 block index in scan order
*    if mb32 is 0, mb_addr is the 16x16 block index in scan order
************************************************************************
*/
void start_macroblock32(int mb_addr, int mb32)
{
  int i,j,l;
  Macroblock *currMB = &img->mb_data[mb_addr];
  //Slice *curr_slice = img->currentSlice;

//  int max_qp_delta = 25 + img->bitdepth_luma_qp_scale/2;
//  int min_qp_delta = (26 + img->bitdepth_luma_qp_scale/2);
  int prev_mb;
  
  
  set_MB_parameters (mb_addr); //get the upper left corner coordinators -peisong
  
  prev_mb = FmoGetPreviousMBNr(img->current_mb_nr);
  
  
  // Save the slice number of this macroblock. When the macroblock below
  // is coded it will use this to decide if prediction for above is possible
  currMB->slice_nr = img->current_slice_nr;
   
  //currMB->qp = img->qp = img->masterQP; 
  if (prev_mb>-1)
  {
    currMB->prev_qp       = Prev_QP;
    currMB->prev_delta_qp = Prev_Delta_QP;
  }
  else
  {
    currMB->prev_qp       = img->masterQP;
    currMB->prev_delta_qp = 0;
  }
  if(!mb32)
  {
    currMB->qp = MB32.qp;
  }
  currMB->delta_qp = currMB->qp - currMB->prev_qp;
  set_chroma_qp (currMB);

  // Initialize counter for MB symbols
  currMB->currSEnr=0;
  
  // loop filter parameter
  if (active_pps->deblocking_filter_control_present_flag)
  {
    currMB->LFDisableIdc    = img->LFDisableIdc;
    currMB->LFAlphaC0Offset = img->LFAlphaC0Offset;
    currMB->LFBetaOffset    = img->LFBetaOffset;
  }
  else
  {
    currMB->LFDisableIdc    = 0;
    currMB->LFAlphaC0Offset = 0;
    currMB->LFBetaOffset    = 0;
  }
  
  // If MB is next to a slice boundary, mark neighboring blocks unavailable for prediction
  CheckAvailabilityOfNeighbors32(mb32);
  
  if (input->symbol_mode == CABAC)
    CheckAvailabilityOfNeighborsCABAC();
  
  if(mb32)
  {
    // Reset vectors and reference indices before doing motion search in motion_search().
    for (l=0; l<2; l++)
    {
      for (j=img->block_y; j < img->block_y + (BLOCK_MULTIPLE<<mb32); j++)
      {
        memset(&enc_picture->ref_idx[l][j][img->block_x], -1, (BLOCK_MULTIPLE<<mb32) * sizeof(char));     
        memset(enc_picture->mv [l][j][img->block_x], 0, 2 * (BLOCK_MULTIPLE<<mb32) * sizeof(short));
        for (i=img->block_x; i < img->block_x + (BLOCK_MULTIPLE<<mb32); i++)
          enc_picture->ref_pic_id[l][j][i]= -1;
      }
    }
  }

  // Reset syntax element entries in MB struct
  currMB->mb_type      = 0;
  currMB->cbp_blk      = 0;
  currMB->cbp          = 0;
  currMB->cbp_bits     = 0;

  currMB->c_ipred_mode = DC_PRED_8;
  
  memset (currMB->mvd, 0, BLOCK_CONTEXT * sizeof(int));  
  memset (currMB->intra_pred_modes, DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char)); // changing this to char would allow us to use memset
  memset (currMB->intra_pred_modes8x8, DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char));
  
  
  // Initialize bitcounters for this macroblock
  if(prev_mb < 0) // No slice header to account for
  {
    currMB->bitcounter[BITS_HEADER] = 0;
  }
  else if (currMB->slice_nr == img->mb_data[prev_mb].slice_nr) // current MB belongs to the
    // same slice as the last MB
  {
    currMB->bitcounter[BITS_HEADER] = 0;
  }
  
  currMB->bitcounter[BITS_MB_MODE       ] = 0;
  currMB->bitcounter[BITS_COEFF_Y_MB    ] = 0;
  currMB->bitcounter[BITS_INTER_MB      ] = 0;
  currMB->bitcounter[BITS_CBP_MB        ] = 0;
  currMB->bitcounter[BITS_DELTA_QUANT_MB] = 0;
  currMB->bitcounter[BITS_COEFF_UV_MB   ] = 0;
#ifdef MV_COMPETITION
  currMB->bitcounter[BITS_SKIP_PRED     ] = 0;
  currMB->bitcounter[BITS_MV_PRED       ] = 0;
#endif
  

}
/*!
*************************************************************************************
* \brief
*    Sets modes and reference frames for a 16x16 macroblock
*************************************************************************************
*/
void SetModesAndRefframeForBlocks32 (int mode, short best16x16pdir, short best16x16fwref, short best16x16bwref)
{
  int i,j,k,l;
  Macroblock *currMB = &img->mb_data[img->current_mb_nr];
  int  bframe  = (img->type==B_SLICE);
  int  block_x, block_y;
  int  cur_ref[2];  
  
  //--- macroblock type ---
  currMB->mb_type = mode;    
  currMB->bi_pred_me= (mode == 1 ? img->bi_pred_me[mode] : 0);  
  
  //--- block 8x8 mode and prediction direction ---
  switch (mode)
  {
  case 0:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = 0;
      currMB->b8pdir[i] = (bframe ? direct_pdir[img->block_y + (i >> 1)*2][img->block_x + (i & 0x01)*2] : 0);
      if(i>0)
      {
        assert(currMB->b8pdir[i] == currMB->b8pdir[i-1]);
      }
    }
    break;
  case 1:
  case 2:
  case 3:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = mode;
      currMB->b8pdir[i] = best16x16pdir;
    }
    break;
  default:
    printf ("Unsupported mode in SetModesAndRefframeForBlocks32!\n");
    exit (1);
  }

#define IS_FW ((best16x16pdir==0 || best16x16pdir==2))
#define IS_BW ((best16x16pdir==1 || best16x16pdir==2))

  //--- reference frame arrays ---
  if (mode==0 || mode==I4MB || mode==I16MB || mode==I8MB)
  {
    if (bframe)
    {
      if (!mode)
      {
        for (j = img->block_y; j < img->block_y + 4; j++)
        {
          memcpy(&enc_picture->ref_idx[LIST_0][j][img->block_x],&direct_ref_idx[LIST_0][j][img->block_x], 4 * sizeof(char));
          memcpy(&enc_picture->ref_idx[LIST_1][j][img->block_x],&direct_ref_idx[LIST_1][j][img->block_x], 4 * sizeof(char));
        }
      }
    }
    else
    {
      if (!mode)
      {
        for (j = img->block_y; j < img->block_y + 4; j++)
          memset(&enc_picture->ref_idx[LIST_0][j][img->block_x],0, 4 * sizeof(char));
      }
    }
  }
  else
  {
    if (bframe)
    {
      for (j=0;j<4;j++)
      {
        block_y = img->block_y + j;
        for (i=0;i<4;i++)
        {
          block_x = img->block_x + i;
          k = 2*(j >> 1) + (i >> 1);
          l = 2*(j & 0x01) + (i & 0x01);
          
          if (mode ==1 && currMB->bi_pred_me && IS_FW && IS_BW)
          {
            enc_picture->ref_idx[LIST_0][block_y][block_x] = 0;
            enc_picture->ref_idx[LIST_1][block_y][block_x] = 0;
          }
          else
          {
            enc_picture->ref_idx[LIST_0][block_y][block_x] = (IS_FW ? best16x16fwref : -1);
            enc_picture->ref_idx[LIST_1][block_y][block_x] = (IS_BW ? best16x16bwref : -1);
          }
        }
      }
    }
    else
    {
      for (j=0;j<4;j++)
      {
        block_y = img->block_y + j;
        for (i=0;i<4;i++)
        {
          block_x = img->block_x + i;
          k = 2*(j >> 1) + (i >> 1);
          l = 2*(j & 0x01) + (i & 0x01);
          enc_picture->ref_idx[LIST_0][block_y][block_x] = (IS_FW ? best16x16fwref : -1);
        }
      }
    }
  }
  
  if (bframe)
  {
    
    for (j = img->block_y; j < img->block_y + 4; j++)
      for (i = img->block_x; i < img->block_x + 4;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];
        cur_ref[LIST_1] = (int) enc_picture->ref_idx[LIST_1][j][i];
        
        enc_picture->ref_pic_id [LIST_0][j][i] = (cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
          : -1);
        enc_picture->ref_pic_id [LIST_1][j][i] = (cur_ref[LIST_1]>=0 
          ? enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][cur_ref[LIST_1]]
          : -1);
      }
  }
  else
  {  
    for (j = img->block_y; j < img->block_y + 4; j++)
      for (i = img->block_x; i < img->block_x + 4;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];
        enc_picture->ref_pic_id [LIST_0][j][i] = (cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
          : -1);
      }
  }
  
#undef IS_FW
#undef IS_BW
}

void switchback_data_after_write(int encodeMbAddr, int mbcount, int mode)
{
  int ****i4p, ***i3p;
  int **i2p;

  i4p=cofAC32_RDCost[mbcount]; cofAC32_RDCost[mbcount]=img->cofAC; img->cofAC=i4p;
  i3p=cofDC32_RDCost[mbcount]; cofDC32_RDCost[mbcount]=img->cofDC; img->cofDC=i3p;
  i2p=cof32AC16x16_RDCost[mbcount]; cof32AC16x16_RDCost[mbcount]=img->cofAC16x16; img->cofAC16x16=i2p;
}

void prepare_data_for_write_RDCost(int encodeMbAddr, int mbcount, int mode)
{
  int ****i4p, ***i3p;
  Macroblock  *currMB  = &img->mb_data[encodeMbAddr];
  int **i2p;

  currMB->cbp = cbp16_RDCost[mbcount];
  currMB->cbp_blk = cbp_blk16_RDCost[mbcount];
  currMB->mb_type = mode;
  //currMB->luma_transform_size_8x8_flag = luma_transform_size_8x8_flag32_RDCost[mbcount];

  i4p=cofAC32_RDCost[mbcount]; cofAC32_RDCost[mbcount]=img->cofAC; img->cofAC=i4p;
  i3p=cofDC32_RDCost[mbcount]; cofDC32_RDCost[mbcount]=img->cofDC; img->cofDC=i3p;
  i2p=cof32AC16x16_RDCost[mbcount]; cof32AC16x16_RDCost[mbcount]=img->cofAC16x16; img->cofAC16x16=i2p;
}

#ifdef H264_COMPLIANT
void prepare_mv_h264(int mb_count, int mode)
{
  int i, j, list, ref, k;
  short******i6p;

  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      for(list=0; list<2; list++)
        for(ref=0; ref<img->max_num_references; ref++)
          //for(mode=0; mode<9; mode++)
            for(k=0; k<2; k++)                    
              img->all_mv32[i][j][list][ref][1][k] = img->all_mv[(mb_count>>1)*4+i][(mb_count&1)*4+j][list][ref][mode][k];

  i6p=img->all_mv; img->all_mv=img->all_mv32; img->all_mv32=i6p;

}
#endif


void prepare_mv(int mbi_x, int mbi_y)
{
  int i, j, ref, mode;
  short******i6p;
  int x = mbi_x << 2;
  int y = mbi_y << 2;
    
  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      for(ref=0; ref<img->max_num_references; ref++)
        for(mode=0; mode<9; mode++)
        {
          img->all_mv32[i][j][0][ref][mode][0] = img->all_mv[y+i][x+j][0][ref][mode][0];
          img->all_mv32[i][j][0][ref][mode][1] = img->all_mv[y+i][x+j][0][ref][mode][1];
          img->all_mv32[i][j][1][ref][mode][0] = img->all_mv[y+i][x+j][1][ref][mode][0];
          img->all_mv32[i][j][1][ref][mode][1] = img->all_mv[y+i][x+j][1][ref][mode][1];
        }
  i6p=img->all_mv; img->all_mv=img->all_mv32; img->all_mv32=i6p;
}

void switch_back_mv()
{
  short******i6p;
  i6p=img->all_mv; img->all_mv=img->all_mv32; img->all_mv32=i6p;
}

/*!
*************************************************************************************
* \brief
*    R-D Cost for a macroblock
*************************************************************************************
*/
int RDCost_for_macroblocks32 (double   lambda,       // <-- lagrange multiplier
                            int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
                            int      *mode_idx,
                            double*  min_rdcost,   // <-> minimum rate-distortion cost
                            double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
                            int i16mode,
                            int mb_ext_level)
{
  int         mbi, mbj; 
  int         rate = 0, coeff_rate = 0;
  int64       distortion = 0;
  double      rdcost;
  Macroblock  *currMB;
//Macroblock  *prevMB;
  int         bframe    = (img->type==B_SLICE);
  int         use_of_cc =  (img->type!=I_SLICE &&  input->symbol_mode!=CABAC);
  int         dummy;
  int         cr_cbp = 0;
  int      return_val = 0;
  int saved_luma_transform_size_8x8_flag;
  int encodeMbAddr, CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, num_MB, nextMbAddr, mb_count=0;
  int ****i4p, ***i3p;
  int **i2p;

#ifdef MV_COMPETITION
  short iter, nbiter;
  short ******all_mv = img->all_mv;
  short loopbreak=0;
#endif

#ifdef MV_COMPETITION
  if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
    nbiter = mv_comp.nb_mode_for_skip + 1;
  else
    nbiter = 1;
  
  // Let's iterate on each possible mode for the SKIP
  for (iter= 0; iter < nbiter; iter++)
  {
    loopbreak = 0;
    if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))  
    {
      distortion = 0;
      coeff_rate = 0;
      rate = 0;
      cr_cbp = 0;
    }
#endif

  /*******************************
   * restore some global variables
   *******************************/
  set_MB_parameters(saved_mb32_nr);
  saved_luma_transform_size_8x8_flag = img->mb_data[img->current_mb_nr].luma_transform_size_8x8_flag;

  //=====   S T O R E   C O D I N G   S T A T E   =====
  //---------------------------------------------------
  store_coding_state (cs_cm);
    
  
  find_Mb_cluster(mb_ext_level, img->current_mb_nr, &CurrentMbAddr_x, &CurrentMbAddr_y, &extend_x, &extend_y, &num_MB, &nextMbAddr);

  mb_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi++)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj++)   
    {             
      encodeMbAddr = mbi*img->PicWidthInMbs + mbj;
      
      start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

      currMB   = &img->mb_data[img->current_mb_nr];   
      //prevMB   = img->current_mb_nr ? &img->mb_data[img->current_mb_nr-1] : NULL;
      //=====
      //=====  SET REFERENCE FRAMES AND BLOCK MODES
      //=====    
      SetModesAndRefframeForBlocks32 (mode, best8x8pdir[mode][mb_count], best8x8fwref[mode][mb_count], best8x8bwref[mode][mb_count]);
      best16x16pdir[mb_count] = currMB->b8pdir[0];

      mb_count++;
    }
  }

  mb_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi++)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj++)   
    {             
      encodeMbAddr = mbi*img->PicWidthInMbs + mbj;

      start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

      currMB   = &img->mb_data[img->current_mb_nr];   
      //=====  SET REFERENCE FRAMES AND BLOCK MODES
      if(mb_count>0)
      {
        img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;
      }
      SetModesAndRefframeForBlocks32 (mode, best8x8pdir[mode][mb_count], best8x8fwref[mode][mb_count], best8x8bwref[mode][mb_count]);


      //=====
      //=====  GET COEFFICIENTS, RECONSTRUCTIONS, CBP
      //=====

#ifdef MV_COMPETITION
      if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
      {
        // The last iteration consist of re-launching with the bestmode,
        // to set needed variables for the JM
        if (iter == (nbiter - 1))
          mv_comp.current_predictor_for_skip = MB32.best_predictor_for_skip;
        else
        {
          mv_comp.current_predictor_for_skip = iter;
          if ((mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][0] == NOT_AVAILABLE) || (mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][1] == NOT_AVAILABLE))
          {
            loopbreak=1;
            goto nextinloop;
            //continue;
          }
        }

        prepare_mv((mb_count&1), (mb_count>>1));
        only_16x16_transform = (currMB->luma_transform_size_8x8_flag == 2);
        LumaResidualCoding ((mb_count&1), (mb_count>>1), mode, *mode_idx);
        only_16x16_transform = 0;
        switch_back_mv();

        prepare_mv((mb_count&1), (mb_count>>1));
        img->i16offset = 0;
        dummy = 0;
        if (img->yuv_format!=YUV400)
          ChromaResidualCoding ((mb_count&1), (mb_count>>1), mode, *mode_idx, &dummy);


	  //==== motion vectors =====
	   SetMotionVectorsMB(currMB, img->type==B_SLICE);
        switch_back_mv();      
      }

      else //if((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
      {
#endif
        if (mode<P8x8)
        {
          prepare_mv((mb_count&1), (mb_count>>1));
          only_16x16_transform = (currMB->luma_transform_size_8x8_flag == 2);
          LumaResidualCoding ((mb_count&1), (mb_count>>1), mode, *mode_idx);
          only_16x16_transform = 0;
          switch_back_mv();
        }

          prepare_mv((mb_count&1), (mb_count>>1));

          img->i16offset = 0;
          dummy = 0;
          if (img->yuv_format!=YUV400)
            ChromaResidualCoding ((mb_count&1), (mb_count>>1), mode, *mode_idx,&dummy);

	  //==== motion vectors =====
	   SetMotionVectorsMB(currMB, img->type==B_SLICE);
          switch_back_mv();

#ifdef MV_COMPETITION
      }
#endif

      //=====
      //=====   GET DISTORTION
      //=====
      // LUMA
  distortion += compute_SSE(imgY_org, enc_picture->imgY , img->opix_y, img->pix_y, img->opix_x, img->opix_x, MB_BLOCK_SIZE, MB_BLOCK_SIZE);
  distortion += compute_SSE(imgUV_org[0], enc_picture->imgUV[0] , img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);
  distortion += compute_SSE(imgUV_org[1], enc_picture->imgUV[1] , img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);

      /******************************************
      *save macroblock info for each 16x16 block
      *****************************************/
      i4p=cofAC32_RDCost[mb_count]; cofAC32_RDCost[mb_count]=img->cofAC; img->cofAC=i4p;  //MB32X32
      i3p=cofDC32_RDCost[mb_count]; cofDC32_RDCost[mb_count]=img->cofDC; img->cofDC=i3p;  //MB32X32
      i2p=cof32AC16x16_RDCost[mb_count]; cof32AC16x16_RDCost[mb_count]=img->cofAC16x16; img->cofAC16x16=i2p;
      cbp16_RDCost[mb_count] = currMB->cbp;  //MB32X32
      cbp_blk16_RDCost[mb_count] = currMB->cbp_blk;  //MB32X32

      if (((currMB->cbp & 15) == 0) && !(IS_OLDINTRA(currMB) || currMB->mb_type == I8MB))//originally done in set_stored_macroblock_parameters -peisong
        luma_transform_size_8x8_flag32_RDCost[mb_count] = 0;
      else
        luma_transform_size_8x8_flag32_RDCost[mb_count] = currMB->luma_transform_size_8x8_flag;

      mb_count++;
    } // j             
  }//i
      

#ifdef MV_COMPETITION
nextinloop:
  if(loopbreak==1)
    continue;   //for (iter= 0; iter < nbiter; iter++)
#endif

  //prepare 32x32 block cbp     
   MB32.cbp=0;
  for(mbi=0; mbi<4; mbi++)
  {
    if(cbp16_RDCost[mbi] != 0)
    {
      MB32.cbp = 1;
      break;
    }
  }      
  MB32.mb_type = mode;
  MB32.geo_mode = -1;

    if (distortion > *min_rdcost)
    {
      rdcost = (double)distortion;
      rate=0;
    }
    else
    {

  mb_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi++)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj++)   
    {             
      encodeMbAddr = mbi*img->PicWidthInMbs + mbj;

      start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

      currMB   = &img->mb_data[img->current_mb_nr];   

      /******************************************
      *for the upper left 16x16 block, set b8mode
      *b8pdir for the whole 32x32 block in order
      *to write motion info in 1 shot
      * mv and ref_idx are set in SetModesAndRefframeForBlocks32
      *****************************************/
      if(mb_count == 0)
      {
        int i;
        for(i=0;i<4;i++)
        {
          currMB->b8mode[i] = mode;
          currMB->b8pdir[i] = best16x16pdir[i];
        }    
      }

      prepare_data_for_write_RDCost(encodeMbAddr, mb_count, mode);
      img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;

      rate += writeMBLayer_Big (1, &coeff_rate, 1, 0, mb_count);

      switchback_data_after_write(encodeMbAddr, mb_count, mode);

      mb_count++;
    } // j       
  }//i
     
    }


      //=====   R E S T O R E   C O D I N G   S T A T E   =====
      //-------------------------------------------------------
      //restore some global variables
      set_MB_parameters(saved_mb32_nr);
      //restore some global variables

      reset_coding_state (cs_cm);

      rdcost = (double)distortion + lambda * max(0.5,(double)rate);

    if (!(rdcost >= *min_rdcost || ((img->qp + img->bitdepth_luma_qp_scale)==0 && img->lossless_qpprime_flag==1 && distortion!=0)))
      {
        //=====   U P D A T E   M I N I M U M   C O S T   =====
        //-----------------------------------------------------
        *min_rdcost = rdcost;
        *min_rate = lambda * (double)coeff_rate;
          
#ifdef MV_COMPETITION      
          if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
          {
            int by, bx;
            
            MB32.best_predictor_for_skip = mv_comp.current_predictor_for_skip;
            
            for (by = 0;by < 4<<mb_ext_level;by++)
            {
              for (bx = 0;bx < 4<<mb_ext_level;bx++)
              {
                all_mv [by][bx][0][0][0][0] = mv_comp.mv_pred_skip[MB32.best_predictor_for_skip][0];
                all_mv [by][bx][0][0][0][1] = mv_comp.mv_pred_skip[MB32.best_predictor_for_skip][1];
              }
            }
          }
#endif
          return_val = 1;
    }
    else 
    {
#ifdef MV_COMPETITION
      if (!((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE)))
      {
#endif
#if FASTMODE
        // Reordering RDCost comparison order of mode 0 and mode 1 in P_SLICE
        // if RDcost of mode 0 and mode 1 is same, we choose best_mode is 0
        // This might not always be good since mode 0 is more biased towards rate than quality.
        if((img->type!=P_SLICE || mode != 0 || rdcost != *min_rdcost) || input->ProfileIDC>=FREXT_HP)
#endif
          return_val = 0;
#ifdef MV_COMPETITION
      }
#endif
    }
#ifdef MV_COMPETITION
  }  //for (iter= 0; iter < nbiter; iter++)
#endif 
  
  return (return_val);
}

#ifdef MB64X64
int RDCost_for_macroblocks64 (double   lambda,       // <-- lagrange multiplier
                            int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
                            int      *mode_idx,
                            double*  min_rdcost,   // <-> minimum rate-distortion cost
                            double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
                            int i16mode,
                            int mb_ext_level)
{
  int         k, mbi, mbj, ii, jj; 
  int         rate = 0, coeff_rate = 0;
  int64       distortion = 0;
  double      rdcost;
  Macroblock  *currMB;
//Macroblock  *prevMB;
int         bframe    = (img->type==B_SLICE);
int         use_of_cc =  (img->type!=I_SLICE &&  input->symbol_mode!=CABAC);
  int         dummy;
  int         cr_cbp = 0;
  int      return_val = 0;

  int saved_luma_transform_size_8x8_flag;
  int encodeMbAddr, CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, num_MB, nextMbAddr, mb16_count=0, mb32_count=0;
  int ****i4p, ***i3p;
  int **i2p;

#ifdef MV_COMPETITION
  short iter, nbiter;
  short ******all_mv = img->all_mv;
  short loopbreak=0;
#endif

#ifdef MV_COMPETITION
  if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
    nbiter = mv_comp.nb_mode_for_skip + 1;
  else
    nbiter = 1;
  
  // Let's iterate on each possible mode for the SKIP
  for (iter= 0; iter < nbiter; iter++)
  {
    loopbreak = 0;
    if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))  
    {
      distortion = 0;
      coeff_rate = 0;
      rate = 0;
      cr_cbp = 0;
    }
#endif


  /*******************************
   * restore some global variables
   *******************************/
  set_MB_parameters(saved_mb32_nr);
  saved_luma_transform_size_8x8_flag = img->mb_data[img->current_mb_nr].luma_transform_size_8x8_flag;

  //=====   S T O R E   C O D I N G   S T A T E   =====
  //---------------------------------------------------
  store_coding_state (cs_cm);
    
  
  find_Mb_cluster(2, img->current_mb_nr, &CurrentMbAddr_x, &CurrentMbAddr_y, &extend_x, &extend_y, &num_MB, &nextMbAddr);

  mb32_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi+=2)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj+=2)   
    {             
      for(ii=0; ii<2; ii++)
      {
        for(jj=0; jj<2; jj++)
        {
          encodeMbAddr = (mbi+ii)*img->PicWidthInMbs + (mbj+jj);
          
          start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

          currMB   = &img->mb_data[img->current_mb_nr];   
          //prevMB   = img->current_mb_nr ? &img->mb_data[img->current_mb_nr-1] : NULL;
          //=====
          //=====  SET REFERENCE FRAMES AND BLOCK MODES
          //=====    
          SetModesAndRefframeForBlocks32 (mode, best8x8pdir[mode][mb32_count], best8x8fwref[mode][mb32_count], best8x8bwref[mode][mb32_count]);
        }
      }
      best16x16pdir[mb32_count] = currMB->b8pdir[0];
      mb32_count++;
    }
  }

  mb16_count=0;
  mb32_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi+=2)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj+=2)    
    {             
      for(ii=0; ii<2; ii++)    
      {
        for(jj=0; jj<2; jj++)
        {
          encodeMbAddr = (mbi+ii)*img->PicWidthInMbs + (mbj+jj);

          start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

          currMB   = &img->mb_data[img->current_mb_nr];   
          //prevMB   = img->current_mb_nr ? &img->mb_data[img->current_mb_nr-1] : NULL;
          //=====
          //=====  SET REFERENCE FRAMES AND BLOCK MODES
          //=====    
          img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;

          SetModesAndRefframeForBlocks32 (mode, best8x8pdir[mode][mb32_count], best8x8fwref[mode][mb32_count], best8x8bwref[mode][mb32_count]);

          //=====
          //=====  GET COEFFICIENTS, RECONSTRUCTIONS, CBP
          //=====

#ifdef MV_COMPETITION
          if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
          {
            // The last iteration consist of re-launching with the bestmode,
            // to set needed variables for the JM
            if (iter == (nbiter - 1))
              mv_comp.current_predictor_for_skip = MB64.best_predictor_for_skip;
            else
            {
              mv_comp.current_predictor_for_skip = iter;
              if ((mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][0] == NOT_AVAILABLE) || (mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][1] == NOT_AVAILABLE))
              {
                loopbreak=1;
                goto nextinloop;
                //continue;
              }
            }

            prepare_mv(mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y);
            only_16x16_transform = (currMB->luma_transform_size_8x8_flag == 2);
            LumaResidualCoding (mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y, mode, *mode_idx);
            only_16x16_transform = 0;
            switch_back_mv();

            prepare_mv(mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y);
            img->i16offset = 0;
            dummy = 0;
            if (img->yuv_format!=YUV400)
              ChromaResidualCoding (mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y, mode, *mode_idx,&dummy);


			SetMotionVectorsMB(currMB, img->type==B_SLICE);

            switch_back_mv();
          }

          else //if((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
          {
#endif
            if (mode<P8x8)
            {
              prepare_mv(mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y);
              only_16x16_transform = currMB->luma_transform_size_8x8_flag == 2;
              LumaResidualCoding (mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y, mode, *mode_idx);
              only_16x16_transform = 0;

			  SetMotionVectorsMB(currMB, img->type==B_SLICE);
              switch_back_mv();
            }


#ifdef RDO_Q
            prepare_mv(mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y);
            img->i16offset = 0;
            dummy = 0;
            if (img->yuv_format!=YUV400)
              ChromaResidualCoding (mbj+jj-CurrentMbAddr_x, mbi+ii-CurrentMbAddr_y, mode, *mode_idx, &dummy);
			      SetMotionVectorsMB(currMB, img->type==B_SLICE);
            switch_back_mv();
#else
          img->i16offset = 0;
          dummy = 0;
          if ((!(img->residue_transform_flag && (mode==I4MB || mode==I16MB || mode==I8MB)))
            && (img->yuv_format!=YUV400)
            ChromaResidualCoding (&dummy);

          if (mode==I16MB)     
            img->i16offset = I16Offset  (currMB->cbp, i16mode);

#endif
#ifdef MV_COMPETITION
          }
#endif
          //=====
          //=====   GET DISTORTION
          //=====
          // LUMA
  distortion += compute_SSE(imgY_org, enc_picture->imgY , img->opix_y, img->pix_y, img->opix_x, img->opix_x, MB_BLOCK_SIZE, MB_BLOCK_SIZE);
  distortion += compute_SSE(imgUV_org[0], enc_picture->imgUV[0] , img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);
  distortion += compute_SSE(imgUV_org[1], enc_picture->imgUV[1] , img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);

          /******************************************
          *for the upper left 16x16 block, set b8mode
          *b8pdir for the whole 32x32 block in order
          *to write motion info in 1 shot
          *****************************************/
          //if(mb_count == 0)
          //{
          //  int i;
          //  for(i=0;i<4;i++)
          //  {
          //    currMB->b8mode[i] = mode;
          //    currMB->b8pdir[i] = best16x16pdir[i];
          //  }    
          //}
          //      SetModesAndRefframeForBlocks32 (mode, best8x8pdir[mode][mb_count], best8x8fwref[mode][mb_count], best8x8bwref[mode][mb_count]);
          //rate += writeMBLayer_Big (1, &coeff_rate, 1, mb_count);


          /******************************************
          *save macroblock info for each 16x16 block
          *****************************************/
          i4p=cofAC32_RDCost[mb16_count]; cofAC32_RDCost[mb16_count]=img->cofAC; img->cofAC=i4p;  //MB32X32
          i3p=cofDC32_RDCost[mb16_count]; cofDC32_RDCost[mb16_count]=img->cofDC; img->cofDC=i3p;  //MB32X32
          i2p=cof32AC16x16_RDCost[mb16_count]; cof32AC16x16_RDCost[mb16_count]=img->cofAC16x16; img->cofAC16x16=i2p;

          cbp16_RDCost[mb16_count] = currMB->cbp;  //MB32X32
          cbp_blk16_RDCost[mb16_count] = currMB->cbp_blk;  //MB32X32

          if (((currMB->cbp & 15) == 0) && !(IS_OLDINTRA(currMB) || currMB->mb_type == I8MB))//originally done in set_stored_macroblock_parameters -peisong
            luma_transform_size_8x8_flag32_RDCost[mb16_count] = 0;
          else
            luma_transform_size_8x8_flag32_RDCost[mb16_count] = currMB->luma_transform_size_8x8_flag;

          mb16_count++;
        }//jj
      }//ii

      //prepare 32x32 block cbp     
      cbp_32_RDCost[mb32_count]=0;
      for(k=0; k<4; k++)
      {
        if(cbp16_RDCost[mb32_count*4+k] != 0)
        {
          cbp_32_RDCost[mb32_count] = 1;
          break;
        }
      }      

      mb32_count++;


    } // mbj             
  }//mbi
   

#ifdef MV_COMPETITION
nextinloop:
  if(loopbreak==1)
    continue; //for (iter= 0; iter < nbiter; iter++)
#endif

  //prepare 64x64 block cbp     
  MB64.cbp=0;
  for(k=0; k<4; k++)
  {
    if(cbp_32_RDCost[k] != 0)
    {
      MB64.cbp = 1;//will be used in writeMBLayer64
      break;
    }
  }      

  MB64.mb_type = mode;//will be used in writeMBLayer64
     MB64.geo_mode = -1;

    if (distortion > *min_rdcost)
      rdcost = (double)distortion;
    else
    {

  mb16_count=0;
  mb32_count=0;
  for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi+=2)  
  {      
    for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj+=2)   
    {             
      MB32.cbp = cbp_32_RDCost[mb32_count];//will be used in writeMBLayer64

      for(ii=0; ii<2; ii++)
      {
        for(jj=0; jj<2; jj++)
        {
          encodeMbAddr = (mbi+ii)*img->PicWidthInMbs + (mbj+jj);
          
          start_macroblock32 (encodeMbAddr, 0);//reset img->current_mb_nr and other global variables

          currMB   = &img->mb_data[img->current_mb_nr];   
     
            /******************************************
             *for the upper left 16x16 block, set b8mode
             *b8pdir for the whole 32x32 block in order
             *to write motion info in 1 shot
             * mv and ref_idx are set in SetModesAndRefframeForBlocks32
             *****************************************/
            if(mb32_count == 0 && mb16_count == 0)
            {
              int i;
              for(i=0;i<4;i++)
              {
                currMB->b8mode[i] = mode;
                currMB->b8pdir[i] = best16x16pdir[i];
              }    
            }

            prepare_data_for_write_RDCost(encodeMbAddr, mb16_count, mode);
            img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;

            rate += writeMBLayer_Big (1, &coeff_rate, 2, mb32_count, mb16_count&3);
            switchback_data_after_write(encodeMbAddr, mb16_count, mode);

            mb16_count++;
        }
      }
      mb32_count++;    
    } // j       
  }//i

    }

      
      //=====   R E S T O R E   C O D I N G   S T A T E   =====
      //-------------------------------------------------------
      //restore some global variables
      set_MB_parameters(saved_mb32_nr);
      //restore some global variables

      reset_coding_state (cs_cm);

      
      rdcost = (double)distortion + lambda * max(0.5,(double)rate);
    
    if (!(rdcost >= *min_rdcost ||
      ((img->qp + img->bitdepth_luma_qp_scale)==0 && img->lossless_qpprime_flag==1 && distortion!=0)))
    {               
      {
        //=====   U P D A T E   M I N I M U M   C O S T   =====
        //-----------------------------------------------------
        *min_rdcost = rdcost;
        *min_rate = lambda * (double)coeff_rate;
        
#ifdef BEST_NZ_COEFF
        for (j=0;j<4;j++)
          for (i=0; i<(4+img->num_blk8x8_uv); i++)
            gaaiMBAFF_NZCoeff[j][i] = img->nz_coeff[img->current_mb_nr][j][i]; 
#endif
          
#ifdef MV_COMPETITION      
          if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
          {
            int by, bx;
            
            MB64.best_predictor_for_skip = mv_comp.current_predictor_for_skip;
            
            for (by = 0;by < 4<<mb_ext_level;by++)
            {
              for (bx = 0;bx < 4<<mb_ext_level;bx++)
              {
                all_mv [by][bx][0][0][0][0] = mv_comp.mv_pred_skip[MB64.best_predictor_for_skip][0];
                all_mv [by][bx][0][0][0][1] = mv_comp.mv_pred_skip[MB64.best_predictor_for_skip][1];
              }
            }
          }
#endif
          return_val = 1;
      }
      
      
    }
    else 
    {
#ifdef MV_COMPETITION
      if (!((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE)))
      {
#endif
        
#if FASTMODE
        // Reordering RDCost comparison order of mode 0 and mode 1 in P_SLICE
        // if RDcost of mode 0 and mode 1 is same, we choose best_mode is 0
        // This might not always be good since mode 0 is more biased towards rate than quality.
        if((img->type!=P_SLICE || mode != 0 || rdcost != *min_rdcost) || input->ProfileIDC>=FREXT_HP)
#endif
          return_val = 0;
#ifdef MV_COMPETITION
      }
#endif
    }
#ifdef MV_COMPETITION
  }  //for (iter= 0; iter < nbiter; iter++)
#endif  
  
  return (return_val);
}
#endif

/*!
*************************************************************************************
* \brief
*    Store 32x32 block parameters
*************************************************************************************
*/
void store_macroblock_parameters32 (int mode, int mb_ext_level)
{
  int  j, ****i4p, ***i3p;
  Macroblock *currMB  = &img->mb_data[img->current_mb_nr];
  int        bframe   = (img->type==B_SLICE);
  int **i2p;
 
  //--- store best mode ---
  best_mode = mode;

  best_c_imode = currMB->c_ipred_mode;
  best_i16offset = img->i16offset;


  // If condition is not really necessary.
  bi_pred_me = (mode == 1) ? currMB->bi_pred_me : 0;  

  b8mode[0] = b8mode[1] = b8mode[2] = b8mode[3] = mode;
  memcpy(b8pdir, best16x16pdir, BLOCK_MULTIPLE * sizeof(int));

  //--- reconstructed blocks ----
  for (j = 0; j < (MB_BLOCK_SIZE<<mb_ext_level); j++)
  {
    memcpy(rec_mbY[j],&enc_picture->imgY[img->pix_y+j][img->pix_x], (MB_BLOCK_SIZE<<mb_ext_level) * sizeof(imgpel));
  }
  
  if (img->yuv_format != YUV400)
  {
    for (j = 0; j<(img->mb_cr_size_y<<mb_ext_level); j++)
    {
      memcpy(rec_mbU[j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], (img->mb_cr_size_x<<mb_ext_level) * sizeof(imgpel));
      memcpy(rec_mbV[j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], (img->mb_cr_size_x<<mb_ext_level) * sizeof(imgpel));
    }
  }

  //--- coeff, cbp, kac ---
#if P_DIRECT    //lets not make the cbp=0 for mode=0 in Pslice..coz it can be Pdirect also...
  if(1)
#else
  if (mode || bframe)
#endif
  {
    int i;
    for(i=0; i<(1<<(2*mb_ext_level)); i++)
    {
      i4p=cofAC32[i]; cofAC32[i]=cofAC32_RDCost[i]; cofAC32_RDCost[i]=i4p;
      i3p=cofDC32[i]; cofDC32[i]=cofDC32_RDCost[i]; cofDC32_RDCost[i]=i3p;
      i2p=cof32AC16x16[i]; cof32AC16x16[i]=cof32AC16x16_RDCost[i]; cof32AC16x16_RDCost[i]=i2p;
    }

#ifdef MB64X64
    memcpy(cbp_32, cbp_32_RDCost, (1<<(2*(mb_ext_level-1))) * sizeof(int)); 
#endif
    memcpy(cbp16, cbp16_RDCost, (1<<(2*mb_ext_level)) * sizeof(int)); 
    memcpy(cbp_blk16, cbp_blk16_RDCost, (1<<(2*mb_ext_level)) * sizeof(int64));
  }
  else
  {
#ifdef MB64X64
    memset(cbp_32, 0, (1<<(2*(mb_ext_level-1))) * sizeof(int)); 
#endif
    memset(cbp16, 0, (1<<(2*mb_ext_level)) * sizeof(int)); 
    memset(cbp_blk16, 0, (1<<(2*mb_ext_level)) * sizeof(int64));
  }

    cbp=0;
    //prepare 32x32 block cbp      
    if((mb_ext_level == 1) && ((cbp16[0] != 0) || (cbp16[1] != 0) || (cbp16[2] != 0) || (cbp16[3] != 0)))
      cbp = 1;

    //prepare 64x64 block cbp      
    if((mb_ext_level == 2) && ((cbp_32[0] != 0) || (cbp_32[1] != 0) || (cbp_32[2] != 0) || (cbp_32[3] != 0)))
      cbp = 1;

  //--- store transform size ---  
  memcpy(luma_transform_size_8x8_flag32, luma_transform_size_8x8_flag32_RDCost, (1<<(2*mb_ext_level)) * sizeof(int)); 


  for (j = 0; j<(4<<mb_ext_level); j++)
    memcpy(frefframe32[j],&enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x], (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));
  if (bframe)
  {
    for (j = 0; j<(4<<mb_ext_level); j++)
      memcpy(brefframe32[j],&enc_picture->ref_idx[LIST_1][img->block_y+j][img->block_x], (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));
  }  
  
#ifdef USE_INTRA_MDDT
  if(input->UseIntraMDDT) //no use during MB32X32
  {
    memcpy(bestCofAC16[0], img->cofAC16[0], sizeof(int)*16*17);
    memcpy(bestCofAC16[1], img->cofAC16[1], sizeof(int)*16*17);
  }
#endif 

}



typedef enum {
  T4x4 = 0
  ,T8x8 = 1
  ,T16x16 = 2
  ,T16x8 = 3
  ,T8x16 = 4
} TRANS_TYPE;

#define NUM_TRANS_TYPE 5

/*!
************************************************************************
* \brief
*    set list of available transforms (tlist) based on mode, mb_ext_level, etc.
************************************************************************
*/
static void derive_transform_list(int *tlist, Macroblock *currMB, RD_PARAMS enc_mb, int mode, short bslice, int mb_ext_level)
{
  int i;

  //=========== initially only 4x4 transform is enabled ===========
  for (i=0; i<NUM_TRANS_TYPE; i++)
  {
    tlist[i] = 0;
  }
  tlist[T4x4] = 1;

  if (input->Transform8x8Mode==2)
  {
    if ((mode >= 1 && mode <= 3)
        || (mode == 0 && bslice && active_sps->direct_8x8_inference_flag)
        || ((mode == P8x8) && (enc_mb.valid[4])))
    {
      tlist[T4x4] = 0;
      tlist[T8x8] = 1;
    }
  }
  else if (input->Transform8x8Mode==1)
  {
    //=========== try mb_types 1,2,3 with 8x8 transform ===========
    if (mode >= 1 && mode <= 3)
    {
      tlist[T8x8] = 1;
    }

    //=========== try mb_types 1,2,3 with 16x16/16x8/8x16 transform ===========
    if (mode == 1)
    {
      tlist[T16x16] = 1;
    }
    else if (mode == 2)
    {
      tlist[T16x8] = 1;
    }
    else if (mode == 3)
    {
      tlist[T8x16] = 1;
    }
#if P_DIRECT
    //=========== try DIRECT-MODE with 8x8 transform ===========
    else if (mode == 0 && img->type==P_SLICE)
    {
      tlist[T8x8] = 1;
      tlist[T16x16] = 1;
    }
#endif
    //=========== try DIRECT-MODE with 8x8 transform ===========
    else if (mode == 0 && bslice && active_sps->direct_8x8_inference_flag)
    {
      tlist[T8x8] = 1;
      tlist[T16x16] = 1;
    }
  }

  //=========== disable 4x4 and 8x8 transform in MB64 ===========
  if (input->DisableSmallTransInLargeMB && mb_ext_level>=1 && input->Transform8x8Mode == 1)
  {
#if P_DIRECT
    if (1)
#else
    if (mode!=0 || (mode==0 && bslice && active_sps->direct_8x8_inference_flag))
#endif
    {
      tlist[T4x4] = 0;
      tlist[T8x8] = 0;
    }
  }
}

/*!
************************************************************************
* \brief
*    set luma_transform_size_8x8_flag according to transform type
************************************************************************
*/
static void set_transform_info(Macroblock *currMB, int mode, int transform_idx)
{
  switch (transform_idx)
  {
  case T4x4:
    currMB->luma_transform_size_8x8_flag = 0;
    break;
  case T8x8:
    currMB->luma_transform_size_8x8_flag = 1;
    break;
  case T16x16:
  case T16x8:
  case T8x16:
    currMB->luma_transform_size_8x8_flag = 2;
    break;
  default:
    currMB->luma_transform_size_8x8_flag = 0;
  }
}

void compute_mode_RD_cost32(int mode, 
                            int *mode_idx,
                          Macroblock *currMB, 
                          RD_PARAMS enc_mb, 
                          double *min_rdcost, 
                          double *min_rate, 
                          int i16mode, 
                          short bslice, 
                          short *inter_skip,
                          int   mb_ext_level)
{
      int temp_cbp=0;
  int tlist[NUM_TRANS_TYPE];
  int i;

  derive_transform_list(tlist, currMB, enc_mb, mode, bslice, mb_ext_level);
 
  // Encode with coefficients
  img->NoResidueDirect = 0;  
  for (i=0; i<NUM_TRANS_TYPE; i++)
  {
    if (tlist[i] == 0) { continue; }

#ifdef MV_COMPETITION
      if ((mode == 0) && (img->type==P_SLICE) && (input->mv_competition > 0))
        skip_mode = TRUE;
      else 
        skip_mode = FALSE;
#endif
    set_transform_info(currMB, mode, i);

      if(mb_ext_level == 1)
      {
        if (RDCost_for_macroblocks32 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
        {
          store_macroblock_parameters32 (mode, mb_ext_level);
        }
      }
#ifdef MB64X64
      if(mb_ext_level == 2)
      {    
        if (RDCost_for_macroblocks64 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
        {
          store_macroblock_parameters32 (mode, mb_ext_level);
        }
      }
#endif
 }

//==================================

//use proper block cbp after Direct mode is evaluated
#if P_DIRECT
    if ( img->type==P_SLICE && mode == 0 && enc_mb.valid[mode] )
    {
      temp_cbp=0;
      if(mb_ext_level == 1)        //prepare 32x32 block cbp      
          if((cbp16[0] != 0) || (cbp16[1] != 0) || (cbp16[2] != 0) || (cbp16[3] != 0))
            temp_cbp = 1;

      if(mb_ext_level == 2)        //prepare 64x64 block cbp      
          if((cbp_32[0] != 0) || (cbp_32[1] != 0) || (cbp_32[2] != 0) || (cbp_32[3] != 0))
            temp_cbp = 1;
    
      //currMB->cbp = temp_cbp;
    }
#endif

//encode P_SKIP mode  ...above mode=0 was for P_Direct to encode with coefficients..
//later merge this code with BSKIP code below....coz both have same conditions---Rahul
    //for skip mode , transform size doesnt matter as there are no residuals...cbp=0
#if P_DIRECT
    if ( img->type==P_SLICE && mode == 0 && temp_cbp && enc_mb.valid[mode] )
    {
      img->NoResidueDirect = 1; 
      currMB->luma_transform_size_8x8_flag = 0;
#ifdef MV_COMPETITION
      if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
        skip_mode = TRUE;
      else 
        skip_mode = FALSE;
#endif
      if(mb_ext_level == 1)
        if (RDCost_for_macroblocks32 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
          store_macroblock_parameters32 (mode, mb_ext_level);
#ifdef MB64X64
      if(mb_ext_level == 2)
        if (RDCost_for_macroblocks64 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
          store_macroblock_parameters32 (mode, mb_ext_level);
#endif
   }
#endif


//use proper block cbp after Direct mode is evaluated
    if ( bslice && mode == 0 && enc_mb.valid[mode] )
    {
      temp_cbp=0;
      if(mb_ext_level == 1)        //prepare 32x32 block cbp      
          if((cbp16[0] != 0) || (cbp16[1] != 0) || (cbp16[2] != 0) || (cbp16[3] != 0))
            temp_cbp = 1;

      if(mb_ext_level == 2)        //prepare 64x64 block cbp      
          if((cbp_32[0] != 0) || (cbp_32[1] != 0) || (cbp_32[2] != 0) || (cbp_32[3] != 0))
            temp_cbp = 1;
    
      //currMB->cbp = temp_cbp;
    }

    // Encode with no coefficients. Currently only for direct. This could be extended to all other modes as in example.
    //if (mode < P8x8 && (*inter_skip == 0) && enc_mb.valid[mode] && currMB->cbp && (currMB->cbp&15) != 15 && !input->nobskip)
    if ( bslice && mode == 0 && (*inter_skip == 0) && enc_mb.valid[mode] 
      && temp_cbp && !input->nobskip) 
    {
      img->NoResidueDirect = 1;
      currMB->luma_transform_size_8x8_flag = 0;
      if(mb_ext_level == 1)
      {
        if (RDCost_for_macroblocks32 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
        {
          store_macroblock_parameters32 (mode, mb_ext_level);
        }
      }
#ifdef MB64X64
      if(mb_ext_level == 2)
      {    
        if (RDCost_for_macroblocks64 (enc_mb.lambda_md, mode, mode_idx, min_rdcost, min_rate, i16mode, mb_ext_level))
        {
          store_macroblock_parameters32 (mode, mb_ext_level);
        }
      }
#endif
    }
}


/*!
*************************************************************************************
* \brief
*    computation of prediction list (including biprediction) cost
*************************************************************************************
*/
void list_prediction_cost32(int list, int block, int mode, RD_PARAMS enc_mb, int bmcost[5], char best_ref[2], int mb_ext_level)
{
  short ref;
  int mcost;
  int cur_list = list < BI_PRED ? enc_mb.list_offset[list] : enc_mb.list_offset[LIST_0];
  
  //--- get cost and reference frame for forward prediction ---
  
  if (list < BI_PRED)
  {
    for (ref=0; ref < listXsize[cur_list]; ref++)
    {
      if (!img->checkref || list || ref==0 || CheckReliabilityOfRef (block, list, ref, mode)) //img->checkref=0 -peisong
      {
        // limit the number of reference frames to 1 when switching SP frames are used
        if((!input->sp2_frame_indicator && !input->sp_output_indicator)||
          ((input->sp2_frame_indicator || input->sp_output_indicator) && (img->type!=P_SLICE && img->type!=SP_SLICE))||
          ((input->sp2_frame_indicator || input->sp_output_indicator) && ((img->type==P_SLICE || img->type==SP_SLICE) &&(ref==0))))
        {
          mcost  = (input->rdopt 
            ? REF_COST (enc_mb.lambda_mf, ref, cur_list) 
            : (int) (2 * enc_mb.lambda_me * min(ref, 1)));     
          
          mcost += motion_cost[mode][list][ref][block];
          if (mcost < bmcost[list])
          {
            bmcost[list]   = mcost;
            best_ref[list] = (char)ref;
          }
        }
      }
    }
  }
  else if (list == BI_PRED)
  {
    bmcost[list]  = (input->rdopt 
      ? (REF_COST  (enc_mb.lambda_mf, (short)best_ref[LIST_0], cur_list)
      +  REF_COST  (enc_mb.lambda_mf, (short)best_ref[LIST_1], cur_list + LIST_1)) 
      : (int) (2 * (enc_mb.lambda_me * (min((short)best_ref[LIST_0], 1) + min((short)best_ref[LIST_1], 1)))));    
    bmcost[list] += BIDPartitionCost32 (mode, block, (short)best_ref[LIST_0], (short)best_ref[LIST_1], enc_mb.lambda_mf, mb_ext_level);    
  }
  else
  {
    bmcost[list]  = (input->rdopt 
      ? (REF_COST (enc_mb.lambda_mf, 0, cur_list) 
      +  REF_COST (enc_mb.lambda_mf, 0, cur_list + LIST_1)) 
      : (int) (4 * enc_mb.lambda_me));
    bmcost[list] += BPredPartitionCost32(mode, block, 0, 0, enc_mb.lambda_mf, !(list&1), mb_ext_level);                
  }
}  

void assign_enc_picture_params32(int mode, int best_pdir, int block, int list_offset, int best_fw_ref, int best_bw_ref, int bframe, int mb_ext_level)
{
  int i,j;
  int block_x, block_y;
  short *cur_mv;
  
  if (mode==1)
  {
    assert(block==0);

    if (best_pdir==1)
    {
      for (j=img->block_y+(block&2); j<img->block_y+(block&2) + (BLOCK_MULTIPLE<<mb_ext_level); j++) //MB32X32  //block=0 b/c mode =1
      {
        block_x = img->block_x+(block&1)*2; //block=1 b/c mode =1
        
        memset(&enc_picture->ref_idx[LIST_0][j][block_x], -1 ,     (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
        memset(enc_picture->mv      [LIST_0][j][block_x],  0 , 2 * (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(short));//MB32X32
        for (i=block_x; i<block_x + (BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
        {
          enc_picture->ref_pic_id [LIST_0][j][i]    = -1;
        }
      }
    }
    else if (img->bi_pred_me[mode])
    {
      for (j=0; j<(BLOCK_MULTIPLE<<mb_ext_level); j++)//MB32X32
      {
        block_y = img->block_y+(block&2)+j;  //block=0 b/c mode =1
        block_x = img->block_x+(block&1)*2;   //block=0 b/c mode =1
        memset(&enc_picture->ref_idx[LIST_0][block_y][block_x], 0, (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
        for (i=0; i<(BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
        {            
          cur_mv = img->bi_pred_me[mode] == 1 
            ? img->bipred_mv1[i][j][LIST_0][0][mode] 
            : img->bipred_mv2[i][j][LIST_0][0][mode];
          
          enc_picture->ref_pic_id [LIST_0][block_y][block_x + i]    = enc_picture->ref_pic_num[LIST_0 + list_offset][0];  
          enc_picture->mv         [LIST_0][block_y][block_x + i][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x + i][1] = cur_mv[1];
        }
      }
    }
    else 
    {
      for (j=0; j<(BLOCK_MULTIPLE<<mb_ext_level); j++)//MB32X32
      {
        block_y = img->block_y+(block&2)+j;  //block=0 b/c mode =1
        block_x = img->block_x+(block&1)*2;  //block=0 b/c mode =1
        memset(&enc_picture->ref_idx[LIST_0][block_y][block_x], best_fw_ref , (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
        for (i=0; i<(BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
        {                                
          cur_mv = img->all_mv[j][i][LIST_0][best_fw_ref][mode];
          
          enc_picture->ref_pic_id [LIST_0][block_y][block_x + i]    = enc_picture->ref_pic_num[LIST_0 + list_offset][best_fw_ref];  
          enc_picture->mv         [LIST_0][block_y][block_x + i][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x + i][1] = cur_mv[1];
        }          
      }
    }
    
    if (bframe)
    {
      if (best_pdir==0)
      {
        for (j=img->block_y+(block&2); j<img->block_y+(block&2) + (BLOCK_MULTIPLE<<mb_ext_level); j++)  //block=0 b/c mode =1 //MB32X32
        {
          block_x = img->block_x+(block&1)*2;  //block=0 b/c mode =1
          memset(&enc_picture->ref_idx[LIST_1][j][block_x], -1 , (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
          memset(enc_picture->mv[LIST_1][j][block_x], 0 , 2 * (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(short));//MB32X32
          for (i=block_x; i<block_x + (BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
          {
            enc_picture->ref_pic_id [LIST_1][j][i] = -1;
          }
        }
      }
      else
      {
        if (img->bi_pred_me[mode])
        {
          for (j=0; j<(BLOCK_MULTIPLE<<mb_ext_level); j++)//MB32X32
          {
            block_y = img->block_y+(block&2)+j;  //block=0 b/c mode =1
            block_x = img->block_x+(block&1)*2;  //block=0 b/c mode =1
            memset(&enc_picture->ref_idx[LIST_1][block_y][block_x], 0, (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
            for (i=0; i<(BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
            {                     
              cur_mv = img->bi_pred_me[mode] == 1 
                ? img->bipred_mv1[i][j][LIST_1][0][mode] 
                : img->bipred_mv2[i][j][LIST_1][0][mode];
              
              enc_picture->ref_pic_id [LIST_1][block_y][block_x + i] = 
                enc_picture->ref_pic_num[LIST_1 + list_offset][0];
              enc_picture->mv         [LIST_1][block_y][block_x + i][0] = cur_mv[0];
              enc_picture->mv         [LIST_1][block_y][block_x + i][1] = cur_mv[1];
            }
          }
        }
        else 
        {
          for (j=0; j<(BLOCK_MULTIPLE<<mb_ext_level); j++)//MB32X32
          {
            block_y = img->block_y+(block&2)+j; //block=0 b/c mode =1
            block_x = img->block_x+(block&1)*2; // //block=0 b/c mode =1
            memset(&enc_picture->ref_idx[LIST_1][block_y][block_x], best_bw_ref, (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));//MB32X32
            for (i=0; i<(BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
            {                     
              
              enc_picture->ref_pic_id [LIST_1][block_y][block_x + i] = 
                enc_picture->ref_pic_num[LIST_1 + list_offset][best_bw_ref];
              if(best_bw_ref>=0)
              {
                cur_mv = img->all_mv[j][i][LIST_1][best_bw_ref][mode];
                enc_picture->mv[LIST_1][block_y][block_x + i][0] = cur_mv[0];
                enc_picture->mv[LIST_1][block_y][block_x + i][1] = cur_mv[1];
              }
            }            
          }
        }
      }
    }
  }
  else if (mode==2)
  {
    for (j=0; j<(2<<mb_ext_level); j++)
    {
      block_y = img->block_y + block * (2<<mb_ext_level) + j;
      for (i=0; i<(BLOCK_MULTIPLE<<mb_ext_level); i++)//MB32X32
      {
        block_x = img->block_x + i;
        if (best_pdir==1)
        {
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;
        }
        else
        {                     
          cur_mv = img->all_mv[j+block*(2<<mb_ext_level)][i][LIST_0][best_fw_ref][mode];
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = best_fw_ref;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = 
            enc_picture->ref_pic_num[LIST_0 + list_offset][best_fw_ref];
          enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
        }
        
        if (bframe)
        {
          if (best_pdir==0)
          {
            enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
            enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
            enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
            enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
          }
          else
          {
            enc_picture->ref_idx[LIST_1][block_y][block_x] = best_bw_ref;
            if(best_bw_ref>=0)
            {
              cur_mv = img->all_mv[j+ block*(2<<mb_ext_level)][i][LIST_1][best_bw_ref][mode];
              enc_picture->ref_pic_id [LIST_1][block_y][block_x] = 
                enc_picture->ref_pic_num[LIST_1 + list_offset][best_bw_ref];
              enc_picture->mv[LIST_1][block_y][block_x][0] = cur_mv[0];
              enc_picture->mv[LIST_1][block_y][block_x][1] = cur_mv[1];
            }                       
          }
        }
      }
    }
  }
  else
  {
    for (j=0; j<(BLOCK_MULTIPLE<<mb_ext_level); j++)//MB32X32
    {
      block_y = img->block_y+j;
      for (i=0; i<(2<<mb_ext_level); i++)
      {
        block_x = img->block_x + block*(2<<mb_ext_level) + i;
        if (best_pdir==1)
        {
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;
        }
        else
        {
          cur_mv = img->all_mv[j][block*(2<<mb_ext_level)+i][LIST_0][best_fw_ref][mode];
          enc_picture->ref_idx    [LIST_0][block_y][block_x] = best_fw_ref;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x] = 
            enc_picture->ref_pic_num[LIST_0 + list_offset][best_fw_ref];          
          enc_picture->mv[LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv[LIST_0][block_y][block_x][1] = cur_mv[1];
        }
        
        if (bframe)
        {
          if (best_pdir==0)
          {
            enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
            enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
            enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
            enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
          }
          else
          {
            enc_picture->ref_idx[LIST_1][block_y][block_x] = best_bw_ref;
            if(best_bw_ref>=0)
            {
              cur_mv = img->all_mv[j][block*(2<<mb_ext_level)+i][LIST_1][best_bw_ref][mode];
              enc_picture->ref_pic_id [LIST_1][block_y][block_x] = 
                enc_picture->ref_pic_num[LIST_1 + list_offset][best_bw_ref];
              
              enc_picture->mv[LIST_1][block_y][block_x][0] = cur_mv[0];
              enc_picture->mv[LIST_1][block_y][block_x][1] = cur_mv[1];
            }
          }
        }
      }
    }
  }
}

/*!
*************************************************************************************
* \brief
*    Set reference frames and motion vectors
*************************************************************************************
*/
void SetRefAndMotionVectors32 (int block, int mode, int pdir, int fwref, int bwref, int mb_ext_level)
{
  int     i, j=0;
  int     bslice  = (img->type==B_SLICE);
  int     pmode   = (mode==1||mode==2||mode==3?mode:4);
  int     j0      = ((block >> 1)<<1);  //block == 0 -peisong
  int     i0      = ((block & 0x01)<<1);//block == 0 -peisong
  int     j1      = j0 + ((input->part_size[pmode][1])<<mb_ext_level);
  int     i1      = i0 + ((input->part_size[pmode][0])<<mb_ext_level);
  int     block_x, block_y;
  short   *cur_mv;
  Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];
  
  if (pdir<0)
  {
    for (j = img->block_y + j0; j < img->block_y + j1; j++)
    {
      for (i=img->block_x + i0; i<img->block_x +i1; i++)
      {
        enc_picture->ref_pic_id[LIST_0][j][i] = -1;
        enc_picture->ref_pic_id[LIST_1][j][i] = -1;
      }
      memset(&enc_picture->ref_idx[LIST_0][j][img->block_x + i0], -1, ((input->part_size[pmode][0]) << mb_ext_level) * sizeof(char));
      memset(&enc_picture->ref_idx[LIST_1][j][img->block_x + i0], -1, ((input->part_size[pmode][0]) <<mb_ext_level) * sizeof(char));
      memset(enc_picture->mv[LIST_0][j][img->block_x + i0], 0, 2*((input->part_size[pmode][0]) <<mb_ext_level) * sizeof(short));
      memset(enc_picture->mv[LIST_1][j][img->block_x + i0], 0, 2*((input->part_size[pmode][0]) <<mb_ext_level) * sizeof(short));
    }
    return;
  }
  
  if (!bslice)
  {
    for (j=j0; j<j1; j++)
    {
      block_y = img->block_y + j;
      memset(&enc_picture->ref_idx   [LIST_0][block_y][img->block_x + i0], fwref, ((input->part_size[pmode][0]) <<mb_ext_level) * sizeof(char));
      for (i=i0; i<i1; i++)
      {
        block_x = img->block_x + i;        
        cur_mv = img->all_mv[j][i][LIST_0][fwref][mode];                
        enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
        enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
        enc_picture->ref_pic_id[LIST_0][block_y][block_x] = enc_picture->ref_pic_num[LIST_0+currMB->list_offset][fwref];
      }
    }
    return;
  }
  else
  {
    for (j=j0; j<j1; j++)
    {
      block_y = img->block_y + j;
      for (i=i0; i<i1; i++)
      {
        block_x = img->block_x + i;
        if (mode==0)
        {
          pdir  = direct_pdir[block_y][block_x];
          fwref = direct_ref_idx[LIST_0][block_y][block_x];
          bwref = direct_ref_idx[LIST_1][block_y][block_x];
        }
        
        if ((pdir==0 || pdir==2))
        {
          if (currMB->bi_pred_me && (pdir == 2) && mode == 1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_0][0][mode]
              : img->bipred_mv2[j][i][LIST_0][0][mode];
            
            enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_0][block_y][block_x]    = 0;            
            enc_picture->ref_pic_id[LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0+currMB->list_offset][0];
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_0][fwref][mode];
            
            enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_0][block_y][block_x] = fwref;
            enc_picture->ref_pic_id[LIST_0][block_y][block_x] = 
              enc_picture->ref_pic_num[LIST_0+currMB->list_offset][(short)enc_picture->ref_idx[LIST_0][block_y][block_x]];
          }
        }
        else
        {
          enc_picture->mv        [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv        [LIST_0][block_y][block_x][1] = 0;
          enc_picture->ref_idx   [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id[LIST_0][block_y][block_x]    = -1;
        }
        
        if ((pdir==1 || pdir==2))
        {
          if (currMB->bi_pred_me && (pdir == 2) && mode == 1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_1][0][mode]
              : img->bipred_mv2[j][i][LIST_1][0][mode];
            
            enc_picture->mv        [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_1][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_1][block_y][block_x]    = 0;            
            enc_picture->ref_pic_id[LIST_1][block_y][block_x]    = enc_picture->ref_pic_num[LIST_1+currMB->list_offset][0];
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_1][bwref][mode];
            
            enc_picture->mv        [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_1][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_1][block_y][block_x] = bwref;
            enc_picture->ref_pic_id[LIST_1][block_y][block_x] = 
              enc_picture->ref_pic_num[LIST_1+currMB->list_offset][(short)enc_picture->ref_idx[LIST_1][block_y][block_x]];
          }
        }
        else
        {
          enc_picture->mv        [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv        [LIST_1][block_y][block_x][1] = 0;
          enc_picture->ref_idx   [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id[LIST_1][block_y][block_x]    = -1;
        }
      }
    }
  }
}



/*!
*************************************************************************************
* \brief
*    Sets motion vectors for a macroblock
*************************************************************************************
*/
void SetMotionVectorsMB32 (Macroblock* currMB, int bframe, int mb_ext_level)
{
  int i, j, k, mode8, pdir8, ref, by, bx;
  short ******all_mv  = img->all_mv;
//short ******pred_mv = img->pred_mv;
  int  bw_ref;
  int jdiv;

  if (!bframe)
  {
    for (j = 0; j<(4<<mb_ext_level); j++)
    {
      jdiv = j >>   (1+mb_ext_level);
      by    = img->block_y+j;

      for (i = 0; i<(4<<mb_ext_level); i++)
      {
        mode8 = currMB->b8mode[k=2*jdiv+(i>>(1+mb_ext_level))];
        bx   = img->block_x+i;
        
        pdir8 = currMB->b8pdir[k];
        ref    = enc_picture->ref_idx[LIST_0][by][bx];
        
        if (pdir8>=0) 
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];
        }
        else
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;
        }
      }
    }
  }
  else
  {
    for (j = 0; j<(4<<mb_ext_level); j++)
    {
      jdiv = j >>   (1+mb_ext_level);
      by    = img->block_y+j;

      for (i = 0; i<(4<<mb_ext_level); i++)
      {
        mode8 = currMB->b8mode[k=2*jdiv+(i>>(1+mb_ext_level))];
        bx    = img->block_x+i;
        
        pdir8 = currMB->b8pdir[k];
        ref    = enc_picture->ref_idx[LIST_0][by][bx];
        bw_ref = enc_picture->ref_idx[LIST_1][by][bx];
        
        if (currMB->bi_pred_me && (pdir8 == 2) && currMB->mb_type==1)
        {
          all_mv  = currMB->bi_pred_me == 1 ? img->bipred_mv1 : img->bipred_mv2;
          ref = 0;
          bw_ref = 0;
        }
        
        if (pdir8==-1) // intra
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;
          enc_picture->mv[LIST_1][by][bx][0] = 0;
          enc_picture->mv[LIST_1][by][bx][1] = 0;
        }
        else if (pdir8==0) // list 0
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];
          enc_picture->mv[LIST_1][by][bx][0] = 0;
          enc_picture->mv[LIST_1][by][bx][1] = 0;
          enc_picture->ref_idx[LIST_1][by][bx] = -1;
        }
        else if (pdir8==1) // list 1
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;          
          enc_picture->ref_idx[LIST_0][by][bx] = -1;
          enc_picture->mv[LIST_1][by][bx][0] = all_mv [j][i][LIST_1][bw_ref][mode8][0];
          enc_picture->mv[LIST_1][by][bx][1] = all_mv [j][i][LIST_1][bw_ref][mode8][1];
        }
        else if (pdir8==2) // bipredictive
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];                   
          enc_picture->mv[LIST_1][by][bx][0] = all_mv [j][i][LIST_1][bw_ref][mode8][0];
          enc_picture->mv[LIST_1][by][bx][1] = all_mv [j][i][LIST_1][bw_ref][mode8][1];
        }
        else
        {
          error("invalid direction mode", 255);
        }
        
      }
    }
  }
 }

/*!
*************************************************************************************
* \brief
*    Set stored 32x32 block parameters
*************************************************************************************
*/
void set_stored_macroblock_parameters32 (int mb_ext_level)
{
  int  i, j, k;
  Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];
  int         mode     = best_mode; //best_mode is decided in store_macroblock_parameters32 -peisong
  int         bframe   = (img->type==B_SLICE);
//char    **ipredmodes = img->ipredmode;
  
  imgpel        **imgY  = enc_picture->imgY;
  imgpel       ***imgUV = enc_picture->imgUV;
  int        block_x, block_y;  
  short   *cur_mv;

  //===== reconstruction values =====
  for (j = 0; j < (MB_BLOCK_SIZE<<mb_ext_level); j++) //MB32X32
  {
    memcpy(&imgY[img->pix_y+j][img->pix_x],rec_mbY[j], (MB_BLOCK_SIZE<<mb_ext_level) * sizeof(imgpel)); //MB32X32
  }
  
  if (img->yuv_format != YUV400)
  {
    for (j = 0; j<(img->mb_cr_size_y << mb_ext_level); j++)
    {
      memcpy(&imgUV[0][img->pix_c_y+j][img->pix_c_x],rec_mbU[j], (img->mb_cr_size_x <<mb_ext_level) * sizeof(imgpel));
      memcpy(&imgUV[1][img->pix_c_y+j][img->pix_c_x],rec_mbV[j], (img->mb_cr_size_x <<mb_ext_level) * sizeof(imgpel));
    }
  }
  
  //==== macroblock type ====
  currMB->mb_type = mode;
  if(mb_ext_level == 1)
  {
    MB32.mb_type    = mode;

    MB32.cbp=0;
    //prepare 32x32 block cbp      
    for(i=0; i<4; i++)
    {
      if(cbp16[i] != 0)
      {
        MB32.cbp = 1;
        break;
      }
    }      
  }
#ifdef MB64X64
  if(mb_ext_level == 2)
  {
    int mbi;
    MB64.cbp=0;
    //prepare 32x32 block cbp      
    for(mbi=0; mbi<4; mbi++)
    {
      if(cbp_32[mbi] != 0)
      {
        MB64.cbp = 1;
        break;
      }
    }      
  }
#endif

  memcpy(currMB->b8mode,b8mode, BLOCK_MULTIPLE * sizeof(int));
  memcpy(currMB->b8pdir,b8pdir, BLOCK_MULTIPLE * sizeof(int));

  if(mb_ext_level == 1)
  {
    memcpy(MB32.b8mode,   b8mode, BLOCK_MULTIPLE * sizeof(int));
    memcpy(MB32.b8pdir,   b8pdir, BLOCK_MULTIPLE * sizeof(int));
  }
#ifdef MB64X64
  if(mb_ext_level == 2)
  {
    memcpy(MB64.b8mode,   b8mode, BLOCK_MULTIPLE * sizeof(int));
    memcpy(MB64.b8pdir,   b8pdir, BLOCK_MULTIPLE * sizeof(int));
  }
#endif


  currMB->bi_pred_me = currMB->mb_type == 1 ? bi_pred_me : 0;  
  if(mb_ext_level == 1)
    MB32.bi_pred_me    = currMB->bi_pred_me;
#ifdef MB64X64
  if(mb_ext_level == 2)
    MB64.bi_pred_me    = currMB->bi_pred_me;
#endif

  //==== transform size flag ====
  rdopt->luma_transform_size_8x8_flag  = currMB->luma_transform_size_8x8_flag;

  //==== reference frames =====
  for (j = 0; j < (4<<mb_ext_level); j++)
  {
    block_y = img->block_y + j;
    for (i = 0; i < (4<<mb_ext_level); i++)
    {
      block_x = img->block_x + i;
      k = 2*(j >> (1+mb_ext_level))+(i >> (1+mb_ext_level));
  
      // backward prediction or intra
      if ((currMB->b8pdir[k] == 1) || IS_INTRA(currMB))
      {
        enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
        enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;          
        enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
        enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;
      }
      else
      {
        if (currMB->bi_pred_me && (currMB->b8pdir[k] == 2) && currMB->mb_type==1)
        {
          cur_mv = currMB->bi_pred_me == 1 
            ? img->bipred_mv1[j][i][LIST_0][0][currMB->b8mode[k]] 
            : img->bipred_mv2[j][i][LIST_0][0][currMB->b8mode[k]];
          
          enc_picture->ref_idx    [LIST_0][block_y][block_x] = 0;                         
          enc_picture->ref_pic_id [LIST_0][block_y][block_x] = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][0];
          enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
        }
        else
        {
          cur_mv = img->all_mv[j][i][LIST_0][(short)frefframe32[j][i]][currMB->b8mode[k]];
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = frefframe32[j][i];
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][(short)frefframe32[j][i]];
          enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
        }
      }
      
      // forward prediction or intra
      if ((currMB->b8pdir[k] == 0) || IS_INTRA(currMB))
      {
        enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
        enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
        enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
        enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
      }
    }
  }
  
  if (bframe)
  {
    for (j=0; j<(4<<mb_ext_level); j++)
    {
      block_y = img->block_y + j;
      for (i=0; i<(4<<mb_ext_level); i++)
      {          
        block_x = img->block_x + i;
        k = 2*(j >> (1+mb_ext_level))+(i >> (1+mb_ext_level));
        // forward
        if (IS_INTRA(currMB)||(currMB->b8pdir[k] == 0))
        {
          enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
        }
        else
        {
          if (currMB->bi_pred_me && (currMB->b8pdir[k] == 2) && currMB->mb_type==1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_1][0][currMB->b8mode[k]] 
              : img->bipred_mv2[j][i][LIST_1][0][currMB->b8mode[k]];
            
            enc_picture->ref_idx    [LIST_1][block_y][block_x] = 0; 
            enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][0];
            enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];        
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_1][(short)brefframe32[j][i]][currMB->b8mode[k]];
            enc_picture->ref_idx    [LIST_1][block_y][block_x] = brefframe32[j][i];
            enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][(short)brefframe32[j][i]];
            enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];
          }
        }
      }
    }
  }

  //==== intra prediction modes ====
  currMB->c_ipred_mode = best_c_imode;
  img->i16offset = best_i16offset;
  
  if(currMB->mb_type == I8MB)
  {
    memcpy(currMB->intra_pred_modes8x8,b8_intra_pred_modes8x8, MB_BLOCK_PARTITIONS * sizeof(char));            
    memcpy(currMB->intra_pred_modes,b8_intra_pred_modes8x8, MB_BLOCK_PARTITIONS * sizeof(char));            
    for(j = 0; j < BLOCK_MULTIPLE; j++)
    {
      memcpy(&img->ipredmode[img->block_y+j][img->block_x],b8_ipredmode8x8[j], BLOCK_MULTIPLE * sizeof(char));
      memcpy(&img->ipredmode8x8[img->block_y+j][img->block_x], b8_ipredmode8x8[j], BLOCK_MULTIPLE * sizeof(char));
    }
  }
  else if (mode!=I4MB && mode!=I8MB)
  {
    memset(currMB->intra_pred_modes,DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char));
    for(j = img->block_y; j < img->block_y + (BLOCK_MULTIPLE<<mb_ext_level); j++)
      memset(&img->ipredmode[j][img->block_x], DC_PRED, (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));
  }
  // Residue Color Transform
  else if (mode == I4MB)
  {
    memcpy(currMB->intra_pred_modes,b4_intra_pred_modes, MB_BLOCK_PARTITIONS * sizeof(char));
    for(j = 0; j < BLOCK_MULTIPLE; j++)
      memcpy(&img->ipredmode[img->block_y + j][img->block_x],&b4_ipredmode[BLOCK_MULTIPLE * j], BLOCK_MULTIPLE * sizeof(char));
  }

  //==== motion vectors =====
  //SetMotionVectorsMB32 (currMB, bframe, mb_ext_level);
  
#ifdef USE_INTRA_MDDT
  if(input->UseIntraMDDT) //no use during MB32X32
  {
    memcpy(img->cofAC16[0], bestCofAC16[0], sizeof(int)*16*17);
    memcpy(img->cofAC16[1], bestCofAC16[1], sizeof(int)*16*17);
  }
#endif 
}





double encode_one_macroblock32 (int mb_ext_level)
{  
  int         rerun, block, mode, i, j;
  short       best_pdir;
  RD_PARAMS   enc_mb;
  double      min_rdcost;
  char        best_ref[2] = {0, -1};
  int         bmcost[5] = {INT_MAX};
  int         cost=0;
  int         min_cost = INT_MAX;
  int         intra1 = 0;

  short       islice      = (img->type==I_SLICE);
  short       bslice      = (img->type==B_SLICE);
  short       pslice      = (img->type==P_SLICE) || (img->type==SP_SLICE);
  short       intra       = (islice || (pslice && img->mb_y==img->mb_y_upd && img->mb_y_upd!=img->mb_y_intra));
  
  short       runs        = (input->RestrictRef==1 && input->rdopt==3 && (pslice  || (bslice && img->nal_reference_idc>0)) ? 2 : 1);

  Macroblock* currMB      = &img->mb_data[img->current_mb_nr];
  
  // Fast Mode Decision
  short inter_skip = 0;
  
  short bestQPcount=0;

  isfirstQP = 1;    //its imp to set this to 1 for ME

#ifdef RDO_Q
  if(input->UseRDO_Q && active_pps->entropy_coding_mode_flag == CABAC)
  {
    estRunLevel_CABAC(LUMA_4x4);
    estRunLevel_CABAC(LUMA_8x8);
    estRunLevel_CABAC(LUMA_16AC);
#ifdef USE_INTRA_MDDT
    estRunLevel_CABAC(LUMA_16x16);
#endif
    estRunLevel_CABAC(LUMA_16x16P);
    estRunLevel_CABAC(LUMA_16x8P);
    estRunLevel_CABAC(LUMA_8x16P);
  }
#endif

  //===== Setup Macroblock encoding parameters =====
  init_enc_mb_params(currMB, &enc_mb, intra, bslice);

  // Perform multiple encodings if rdopt with losses is enabled
  for (rerun=0; rerun<runs; rerun++)
  {
    // reset chroma intra predictor to default
    currMB->c_ipred_mode = DC_PRED_8;
    
    //=====   S T O R E   C O D I N G   S T A T E   =====
    //---------------------------------------------------
    store_coding_state (cs_cm);
    
    if (!intra)
    {
      //===== set direct motion vectors =====
      best_mode = 1;
      if (bslice)
      {
        Get_Direct_Motion_Vectors32 (mb_ext_level);
      }
      
      //===== MOTION ESTIMATION FOR 32x32, 32x16, 16x32 BLOCKS =====      
      for (min_cost=INT_MAX, mode=1; mode<4; mode++)
      {
        bi_pred_me = 0;
        img->bi_pred_me[mode]=0;
        if (enc_mb.valid[mode] && !inter_skip)
        {
          for (cost=0, block=0; block<(mode==1?1:2); block++)
          {
#ifdef RDO_Q
            PartitionMotionSearch32 (mode, block, enc_mb.lambda_mf, 0, mb_ext_level);
#else
            PartitionMotionSearch32 (mode, block, enc_mb.lambda_mf, mb_ext_level);
#endif
           
            //--- set 4x4 block indizes (for getting MV) ---
            j = (block==1 && mode==2 ? (2<<mb_ext_level) : 0);
            i = (block==1 && mode==3 ? (2<<mb_ext_level) : 0);
          
            //--- get cost and reference frame for List 0 prediction ---
            bmcost[LIST_0] = INT_MAX;
            list_prediction_cost32(LIST_0, block, mode, enc_mb, bmcost, best_ref, mb_ext_level);
            if (bslice)
            {
              //--- get cost and reference frame for List 1 prediction ---
              bmcost[LIST_1] = INT_MAX;
              list_prediction_cost32(LIST_1, block, mode, enc_mb, bmcost, best_ref, mb_ext_level);
       
              bmcost[BI_PRED] = INT_MAX; 
              // Compute bipredictive cost between best list 0 and best list 1 references
              list_prediction_cost32(BI_PRED, block, mode, enc_mb, bmcost, best_ref, mb_ext_level);
        
              // Finally, if mode 16x16, compute cost for bipredictive ME vectore
              if (input->BiPredMotionEstimation && mode == 1)
              {                
                list_prediction_cost32(BI_PRED_L0, block, mode, enc_mb, bmcost, 0, mb_ext_level);
                list_prediction_cost32(BI_PRED_L1, block, mode, enc_mb, bmcost, 0, mb_ext_level);
              }
              else
              {
                bmcost[BI_PRED_L0] = INT_MAX;
                bmcost[BI_PRED_L1] = INT_MAX;
              }
              
              // Determine prediction list based on mode cost
              determine_prediction_list(mode, bmcost, best_ref, &best_pdir, &cost, &bi_pred_me);
            }
            else // if (bslice)
            {
              best_pdir  = 0;
              cost      += bmcost[LIST_0];
            }

            //----- set reference frame and direction parameters -----
            if (mode==3)
            {
              best8x8fwref [3][block  ] = best8x8fwref [3][  block+2] = best_ref[LIST_0];
              best8x8pdir  [3][block  ] = best8x8pdir  [3][  block+2] = best_pdir;
              best8x8bwref [3][block  ] = best8x8bwref [3][  block+2] = best_ref[LIST_1];
            }
            else if (mode==2)
            {
              best8x8fwref [2][2*block] = best8x8fwref [2][2*block+1] = best_ref[LIST_0];
              best8x8pdir  [2][2*block] = best8x8pdir  [2][2*block+1] = best_pdir;
              best8x8bwref [2][2*block] = best8x8bwref [2][2*block+1] = best_ref[LIST_1];
            }
            else
            {
              best8x8fwref [1][0] = best8x8fwref [1][1] = best8x8fwref [1][2] = best8x8fwref [1][3] = best_ref[LIST_0];
              best8x8pdir  [1][0] = best8x8pdir  [1][1] = best8x8pdir  [1][2] = best8x8pdir  [1][3] = best_pdir;
              best8x8bwref [1][0] = best8x8bwref [1][1] = best8x8bwref [1][2] = best8x8bwref [1][3] = best_ref[LIST_1];
            }
            
            //--- set reference frames and motion vectors ---
            //generate context for block 1 -peisong
            if (mode>1 && block==0)
              SetRefAndMotionVectors32 (block, mode, best_pdir, best_ref[LIST_0], best_ref[LIST_1], mb_ext_level);            
          } // for (block=0; block<(mode==1?1:2); block++)

          if ((!inter_skip) && (cost < min_cost))
          {
            best_mode = mode;
            min_cost  = cost;
          }
        } // if (enc_mb.valid[mode])
      } // for (mode=1; mode<4; mode++)
    
      // Find a motion vector for the Skip mode
      if(pslice)
        FindSkipModeMotionVector32 (mb_ext_level);
    }   
    else // if (!intra)
    {
      min_cost = INT_MAX;
    }
    
    
    //========= C H O O S E   B E S T   M A C R O B L O C K   M O D E =========
    //-------------------------------------------------------------------------
    if (input->rdopt)
    {
      min_rdcost = compute_mode_RD_cost_RDOQ32(currMB, enc_mb, &bestQPcount, mb_ext_level);
    }

     if (rerun==0)
       intra1 = IS_INTRA(currMB);
  } // for (rerun=0; rerun<runs; rerun++) 
  
  //=====  S E T   F I N A L   M A C R O B L O C K   P A R A M E T E R S ======
  //---------------------------------------------------------------------------  
  if (input->rdopt)
  {   
    if(img->type != I_SLICE && (enc_mb.valid[3]||test_geo_flag))
    {
      if(img->type != I_SLICE && Segmentation_Selected == 0)
        save_mv_for_speedup(mb_ext_level);

      if(encode_one_macroblock_geo(min_rdcost, mb_ext_level))
        return (rdopt->min_rdcost);
    }
    {
    if (cbp!=0 || best_mode==I16MB) //cbp is set in store_macroblock_parameters -peisong
      currMB->prev_cbp = 1;    
    else if (cbp==0)
    {
      currMB->delta_qp = 0;
      currMB->qp       = currMB->prev_qp;
      set_chroma_qp(currMB);
      img->qp          = currMB->qp;
      currMB->prev_cbp = 0;

//  make sure to save qp info into MB32.qp as this is used in start_macroblock32
      MB32.qp = currMB->qp;
      //MB32.prev_qp = currMB->prev_qp;
      //MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac

    } 
    set_stored_macroblock_parameters32 (mb_ext_level);
    }
  }

  rdopt->min_rdcost = input->rdopt ? min_rdcost : min_cost;


  return (rdopt->min_rdcost);
}

double encode_macroblock_cluster32(int CurrentMbAddr, int mb32count)
{
    double rdcost32=INT_MAX, rdcost16=INT_MAX;
    int i, j;
//  int initialMbAddr = CurrentMbAddr;
    int encodeMbAddr;
    int CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, num_MB, nextMbAddr, mbcount=0;

    find_Mb_cluster(1, CurrentMbAddr, &CurrentMbAddr_x, &CurrentMbAddr_y, &extend_x, &extend_y, &num_MB, &nextMbAddr);

    if(num_MB==4)//tm_vlc
      no32x32 = 0;
    else
      no32x32 = 1;

    /*****************
     *check 16x16 mode
     ****************/
    //MB32_16x16.mb_type = 4;
    //MB32_16x16.cbp = 0;
    
    MB32.mb_type = P8x8;
    rdcost16 = 0;
    for(i=CurrentMbAddr_y; i<=extend_y; i++)
    {
      for(j=CurrentMbAddr_x; j<=extend_x; j++)
      {
        encodeMbAddr = i*img->PicWidthInMbs + j;
        start_macroblock (encodeMbAddr);

        if(mbcount == 0 && num_MB == 4)
          MB32.write_mb32_mbtype = 1;
        else
          MB32.write_mb32_mbtype = 0;

#ifdef RDO_Q        
        curr_mbi = mb32count*4 + mbcount;
#endif


        clusterof16_isbetterthan_one32_duringRDOQ = 0;    //default value
        index16x16_insideBigBlock = mb32count*4 + mbcount;
        rdcost16 += encode_one_macroblock ();

        MB32.write_mb32_mbtype=0;

#if !P_DIRECT
        if(img->type==P_SLICE && (img->mb_data[encodeMbAddr]).mb_type == 0 )
          assert(img->mb_data[encodeMbAddr].cbp ==0);
#endif

        saveMode.MBsize16               [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].mb_type;
        saveMode.MBsize16_qp            [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].qp;
        saveMode.MBsize16_prev_qp       [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].prev_qp;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].prev_delta_qp;
        
        saveMode.MBsize32               [mb32count] = P8x8;
        saveMode.MBsize32_qp            [mb32count] = -1;
        saveMode.MBsize32_prev_qp       [mb32count] = -1;
        saveMode.MBsize32_prev_delta_qp [mb32count] = -1;

        mbcount++;
      }//j
    }//i
    bestmode32=P8x8;

    /**************************
     *check 32x32, 32x16, 16x32
     *************************/    

    if(num_MB == 4)
    {
      short save_valid_mode[4];
      save_valid_mode[0]     = input->InterSearchSkip;      
      save_valid_mode[1]     = input->InterSearch16x16;//use for 32x32
      save_valid_mode[2]     = input->InterSearch16x8; //use for 32x16
      save_valid_mode[3]     = input->InterSearch8x16; //use for 16x32

      j=0;
      for(i=0;i<4;i++)
      {
        if(saveMode.MBsize16[mb32count*4+i]==P8x8 || saveMode.MBsize16[mb32count*4+i]==I4MB || saveMode.MBsize16[mb32count*4+i]==I8MB)
        {
          j++;
        }
      }
      if(j>1)   //if any of the 16x16 MB has mode=P8x8 or I4x4 or I8x8 then skip 32x32 checking
      {
        input->InterSearchSkip  = 1;
        input->InterSearch16x16 = 0;
        input->InterSearch16x8  = 0;
        input->InterSearch8x16  = 0;
//  0 1
//  2 3
        if((saveMode.MBsize16[mb32count*4+0]==saveMode.MBsize16[mb32count*4+1])
        || (saveMode.MBsize16[mb32count*4+2]==saveMode.MBsize16[mb32count*4+3]))
          input->InterSearch16x8  = 1;
        else
          input->InterSearch8x16  = 1;
      }
      test_geo_flag = 1;

      if(Segmentation_Selected == 0)
      {
        dense_motion_field(mb32count, CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, 0, 1);
        MV_segmentation(mb32count, 1);
        reuse_16x16_geo(CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, 1);
      }

      start_macroblock32 (CurrentMbAddr, 1);
#ifdef RDO_Q        
      curr_mb32i = mb32count;
#endif

      //Motion_Selected = 0;

      rdcost32 = encode_one_macroblock32 (1);

        input->InterSearchSkip  = save_valid_mode[0];
        input->InterSearch16x16 = save_valid_mode[1];
        input->InterSearch16x8  = save_valid_mode[2];
        input->InterSearch8x16  = save_valid_mode[3];
        test_geo_flag = 0;

      if(rdcost32 < rdcost16)
      {
        //int W = img->PicWidthInMbs;
        bestmode32=img->mb_data[img->current_mb_nr].mb_type; //img->current_mb_nr point to the upper left 16x16 block of 32x32 block

        clusterof16_isbetterthan_one32_duringRDOQ = 0;
        saveMode.MBsize32               [mb32count] = bestmode32;
        saveMode.MBsize32_qp            [mb32count] = img->mb_data[img->current_mb_nr].qp;
        saveMode.MBsize32_prev_qp       [mb32count] = img->mb_data[img->current_mb_nr].prev_qp;
        saveMode.MBsize32_prev_delta_qp [mb32count] = img->mb_data[img->current_mb_nr].prev_delta_qp;
        
        saveMode.MBsize16               [mb32count*4 + 0] = -1;
        saveMode.MBsize16_qp            [mb32count*4 + 0] = -1;
        saveMode.MBsize16_prev_qp       [mb32count*4 + 0] = -1;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + 0] = -1;
        saveMode.MBsize16               [mb32count*4 + 1] = -1;
        saveMode.MBsize16_qp            [mb32count*4 + 1] = -1;
        saveMode.MBsize16_prev_qp       [mb32count*4 + 1] = -1;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + 1] = -1;
        saveMode.MBsize16               [mb32count*4 + 2] = -1;
        saveMode.MBsize16_qp            [mb32count*4 + 2] = -1;
        saveMode.MBsize16_prev_qp       [mb32count*4 + 2] = -1;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + 2] = -1;
        saveMode.MBsize16               [mb32count*4 + 3] = -1;
        saveMode.MBsize16_qp            [mb32count*4 + 3] = -1;
        saveMode.MBsize16_prev_qp       [mb32count*4 + 3] = -1;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + 3] = -1;

        //propogate QP info to all 4 16x16 MB within 32x32
      propagate_qp_info(CurrentMbAddr, CurrentMbAddr_x,CurrentMbAddr_y, extend_x, extend_y);
        return rdcost32;
      }
      else
      {
#ifdef MB64X64
          int saved_Segmentation_Selected = Segmentation_Selected;
          if(Segmentation_Selected == 0)
            Segmentation_Selected = 1;
        // we have to redo mode decision to rebuild the correct context for the remaining blocks inside the 64x64
        //*delta_qp_sent = saved_delta_qp_sent64;
        mbcount = 0;

        for(i=CurrentMbAddr_y; i<=extend_y; i++)
        {
          for(j=CurrentMbAddr_x; j<=extend_x; j++)
          {
            encodeMbAddr = i*img->PicWidthInMbs + j;
            start_macroblock (encodeMbAddr);

            if(mbcount == 0 && num_MB == 4)
              MB32.write_mb32_mbtype = 1;
            else
              MB32.write_mb32_mbtype = 0;

#ifdef RDO_Q        
            curr_mbi = mb32count*4 + mbcount;
#endif

            clusterof16_isbetterthan_one32_duringRDOQ = 1;
            index16x16_insideBigBlock = mb32count*4 + mbcount;
//during re-encoding 16x16 cluster, we only do best qp and best mode....
            finalbestQP = saveMode.MBsize16_qp[mb32count*4 + mbcount];

            encode_one_macroblock ();
            clusterof16_isbetterthan_one32_duringRDOQ = 0;

            MB32.write_mb32_mbtype=0;

        saveMode.MBsize16               [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].mb_type;
        saveMode.MBsize16_qp            [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].qp;
        saveMode.MBsize16_prev_qp       [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].prev_qp;
        saveMode.MBsize16_prev_delta_qp [mb32count*4 + mbcount] = img->mb_data[encodeMbAddr].prev_delta_qp;
        
        saveMode.MBsize32               [mb32count] = P8x8;
        saveMode.MBsize32_qp            [mb32count] = -1;
        saveMode.MBsize32_prev_qp       [mb32count] = -1;
        saveMode.MBsize32_prev_delta_qp [mb32count] = -1;
            mbcount++;
          }//j
        }//i
        if(saved_Segmentation_Selected == 0)
          Segmentation_Selected = 0;
#endif
      }
    }

    return rdcost16;
}






#ifdef MB64X64
double encode_macroblock_cluster64(int CurrentMbAddr)
{
    double rdcost64=INT_MAX, rdcost32=INT_MAX;

    int i, j;
//  int initialMbAddr = CurrentMbAddr;
    int encodeMbAddr;
    int CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, num_MB, nextMbAddr, mb32count=0;

    find_Mb_cluster(2, CurrentMbAddr, &CurrentMbAddr_x, &CurrentMbAddr_y, &extend_x, &extend_y, &num_MB, &nextMbAddr);

    if(num_MB==16)//tm_vlc
    {
      no64x64 = 0;
      no32x32 = 0;
    }
    else
      no64x64 = 1;

    /*****************
     *check 32x32 mode
     ****************/
    //MB32_16x16.mb_type = 4;
    //MB32_16x16.cbp = 0;
    
    MB64.mb_type = P8x8;
    rdcost32=0;
    for(i=CurrentMbAddr_y; i<=extend_y; i+=2)
    {
      for(j=CurrentMbAddr_x; j<=extend_x; j+=2)
      {
        encodeMbAddr = i*img->PicWidthInMbs + j;
        start_macroblock (encodeMbAddr);

        if(mb32count == 0 && num_MB == 16)
          MB64.write_mb64_mbtype = 1;
        else
          MB64.write_mb64_mbtype = 0;

        rdcost32 += encode_macroblock_cluster32 (encodeMbAddr, mb32count);

        MB64.write_mb64_mbtype = 0;

        saved_mb32_geo[mb32count] = MB32.geo_mode;

        if(i+1<=extend_y && j+1<=extend_x)
          mb32type[mb32count] = bestmode32;
        mb32count++;
      }//j
    }//i
    bestmode64=P8x8;

    saveMode.MBsize64               = P8x8;
    saveMode.MBsize64_qp            = -1;
    saveMode.MBsize64_prev_qp       = -1;
    saveMode.MBsize64_prev_delta_qp = -1;

    /**************************
     *check 64x64, 64x32, 32x64
     *************************/    
    if(num_MB == 16)
    {

      short save_valid_mode[4];
      save_valid_mode[0]     = input->InterSearchSkip;      
      save_valid_mode[1]     = input->InterSearch16x16;//use for 32x32
      save_valid_mode[2]     = input->InterSearch16x8; //use for 32x16
      save_valid_mode[3]     = input->InterSearch8x16; //use for 16x32

      j=0;
      for(i=0;i<4;i++)
      {
        if(saveMode.MBsize32[i]==P8x8)
        {
          j++;
        }
      }
      if(j>1)   //if any of the 16x16 MB has mode=P8x8 or I4x4 or I8x8 then skip 32x32 checking
      {
        input->InterSearchSkip  = 1;
        input->InterSearch16x16 = 0;
        input->InterSearch16x8  = 0;
        input->InterSearch8x16  = 0;
//  0 1
//  2 3
        if((saveMode.MBsize32[0]==saveMode.MBsize32[1])
        || (saveMode.MBsize32[2]==saveMode.MBsize32[3]))
          input->InterSearch16x8  = 1;
        else
          input->InterSearch8x16  = 1;
      }
      test_geo_flag = 1;



      if(Segmentation_Selected == 0)
      {
        dense_motion_field(0, CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, 0, 2);
        MV_segmentation(0, 2);
        reuse_16x16_geo(CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, 2);
      }
      start_macroblock32 (CurrentMbAddr, 2);
      
      //Motion_Selected = 0;
      
      rdcost64 = encode_one_macroblock32 (2);

        input->InterSearchSkip  = save_valid_mode[0];
        input->InterSearch16x16 = save_valid_mode[1];
        input->InterSearch16x8  = save_valid_mode[2];
        input->InterSearch8x16  = save_valid_mode[3];
        test_geo_flag = 0;


      if(rdcost64 < rdcost32)
      {
        //int W = img->PicWidthInMbs;
        bestmode64=img->mb_data[img->current_mb_nr].mb_type; //img->current_mb_nr point to the upper left 16x16 block of 64x64 block

        saveMode.MBsize64 = bestmode64;
        saveMode.MBsize64_qp             = img->mb_data[img->current_mb_nr].qp;
        saveMode.MBsize64_prev_qp        = img->mb_data[img->current_mb_nr].prev_qp;
        saveMode.MBsize64_prev_delta_qp  = img->mb_data[img->current_mb_nr].prev_delta_qp;

        memset(saveMode.MBsize32              , -1 ,  4 * sizeof(int));
        memset(saveMode.MBsize32_qp           , -1 ,  4 * sizeof(int));
        memset(saveMode.MBsize32_prev_qp      , -1 ,  4 * sizeof(int));
        memset(saveMode.MBsize32_prev_delta_qp, -1 ,  4 * sizeof(int));
        memset(saveMode.MBsize16              , -1 , 16 * sizeof(int));
        memset(saveMode.MBsize16_qp           , -1 , 16 * sizeof(int));
        memset(saveMode.MBsize16_prev_qp      , -1 , 16 * sizeof(int));
        memset(saveMode.MBsize16_prev_delta_qp, -1 , 16 * sizeof(int));

      //propogate QP info to all 16 16x16 MB within 64x64
      propagate_qp_info(CurrentMbAddr, CurrentMbAddr_x,CurrentMbAddr_y, extend_x, extend_y);
      }  
      else  //Rahul
      {   //need to call this coz img->mb_data[encodeMbAddr].qp is the last QP used during RDOQ of encode_one_macroblock32(2)
          // and if it turns out that 64x64 is not better than 4 32x32 then we need to restore the best QP for 32x32 modes...
        propagate_qp_infoFinal(CurrentMbAddr, CurrentMbAddr_x,CurrentMbAddr_y, extend_x, extend_y);
      }
    }
    if((num_MB == 16) && (rdcost64 < rdcost32))
      return rdcost64;
    else
      return rdcost32;
}
#endif

double compute_mode_RD_cost_RDOQ32(Macroblock *currMB, RD_PARAMS enc_mb, short *bestQPcount, int mb_ext_level)
{
  int mode_idx;
  int max_index, index=0, mode, ctr16x16;
  int i16mode=0;
  double dummy1;
  short dummy2 = 0;

  short       islice      = (img->type==I_SLICE);
  short       bslice      = (img->type==B_SLICE);
  short       pslice      = (img->type==P_SLICE);
  short       intra       = (islice || (pslice && img->mb_y==img->mb_y_upd && img->mb_y_upd!=img->mb_y_intra));

  //  Macroblock* currMB      = &img->mb_data[img->current_mb_nr];

  int deltaQP, bestQP=currMB->qp;
  double RDOQ_min_rdcost=1e30, min_rdcost=1e30; 
  int qp_left, qp_up;
  int best_deltaQP=0;
  int deltaQPCnt; 
  int master_cr_qp=0, master_cr_cbp=0, chroma_qp=0;

  static int deltaQPTabB[] = {0, 2, 3};
  int deltaQPTabSizeB = 3;
  static int deltaQPTabP[] = {0, 1, -1, 2, -2};
  int deltaQPTabSizeP = 1;
  int deltaQPTabSize = bslice? deltaQPTabSizeB : deltaQPTabSizeP;
  int qp_anchor;

  qp_left = (currMB->mb_available_left) ? currMB->mb_available_left->qp:img->masterQP;
  qp_up   = (currMB->mb_available_up  ) ? currMB->mb_available_up->qp  :img->masterQP;
  qp_anchor = (qp_left + qp_up + 1) >> 1;

  isfirstQP = 1;
  for (deltaQPCnt=0; deltaQPCnt<deltaQPTabSize; deltaQPCnt++)
  {
    if(bslice)
    {
#ifdef ADAPTIVE_GOP 
      deltaQP = deltaQPTabB[deltaQPCnt];
      if(input->AdaptiveGOP && isAdapGOP)
        deltaQP = deltaQPTabP[deltaQPCnt];
#else
      deltaQP = deltaQPTabB[deltaQPCnt];
#endif
    }
    else
      deltaQP = deltaQPTabP[deltaQPCnt];

    currMB->qp=Clip3(0, 51, (img->masterQP+deltaQP));
    img->qp = currMB->qp;       //this is set coz img->qp is used in 8x8 DCT, KLT, 16x16 DCT, 16x8 DCT, 8x16 DCT
                                //for 4x4 DCT it uses currMB->qp......inconsistency
    currMB->delta_qp = currMB->qp - currMB->prev_qp;
    set_chroma_qp(currMB);


//backup MB32X32 information    //this is used MB32.qp in start_macroblock32 called during modeRDO
      MB32.prev_qp = currMB->prev_qp;
      MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac
      MB32.qp = currMB->qp;
      saved_mb32_nr = img->current_mb_nr;
//backup MB32X32 information


  if(final_mb_encoding)   //during write_mb_cluster, we only do best qp and best mode....
  {
    if(currMB->qp != finalbestQP)
      continue;
  }
  else   //skip these checking during final QP
  {
    // skip this QP if deltaQP is too large based on local stats
    if(!bslice && (deltaQP != 0) && !(currMB->qp-qp_anchor >= -2 && currMB->qp-qp_anchor <= 1) && currMB->mb_available_left && currMB->mb_available_up)
      continue; 
    if(bslice  &&                   !(currMB->qp-qp_anchor >= -1 && currMB->qp-qp_anchor <= 2) && currMB->mb_available_left && currMB->mb_available_up)
      continue;

    //prevent QP to become too high..otherwise chroma will be affected.
    if(input->successive_Bframe==0)
    {     
      static byte QP_SCALE_CR[52]=
      {
        0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,
        12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,
        28,29,29,30,31,32,32,33,34,34,35,35,36,36,37,37,
        37,38,38,38,39,39,39,39
      };

      chroma_qp = Clip3 ( -img->bitdepth_chroma_qp_scale, 51, currMB->qp + img->chroma_qp_offset[0] );
      chroma_qp = (chroma_qp < 0 ? chroma_qp : QP_SCALE_CR[chroma_qp]) + img->bitdepth_chroma_qp_scale;
      if( (!isfirstQP) && (chroma_qp > master_cr_qp) && (master_cr_cbp!=0) )
        continue;
    }
  }

  store_coding_state (cs_eachQP);
    //==========================================
    {
      max_index = 4;    //(0)SKIP  (1)M x M   (2)M x M/2   (3)M/2 x M

      if (input->BiPredMotionEstimation)
        img->bi_pred_me[1] =0;  

      mode_idx = 0;
      //===== GET BEST MACROBLOCK MODE =====
      for (ctr16x16=0, index=0; index < max_index; index++)
      {
        mode = mb_mode_table[index];
        i16mode = 0; 
        //--- for INTER16x16 check all prediction directions ---
        if (mode==1 && bslice)
        {
          best8x8pdir[1][0] = best8x8pdir[1][1] = best8x8pdir[1][2] = best8x8pdir[1][3] = ctr16x16;

          if ( (bslice) && (input->BiPredMotionEstimation) 
            && (ctr16x16 == 2 && img->bi_pred_me[mode] < 2 && mode == 1))
            ctr16x16--;
          if (ctr16x16 < 2) 
            index--;
          ctr16x16++;
        }

        // Skip intra modes in inter slices if best inter mode is 
        // a MB partition and cbp is 0.
        if (input->SkipIntraInInterSlices && !intra && mode >= I16MB 
          && best_mode <=3 && currMB->cbp == 0)
          continue;

        if (enc_mb.valid[mode])
          compute_mode_RD_cost32(mode, &mode_idx, currMB, enc_mb, &min_rdcost, &dummy1, i16mode, bslice, &dummy2, mb_ext_level);

        if ((input->BiPredMotionEstimation) && (bslice) && ctr16x16 == 2 
          && img->bi_pred_me[mode] < 2 && mode == 1 && best8x8pdir[1][0] == 2) 
          img->bi_pred_me[mode] = img->bi_pred_me[mode] + 1;

        if(mode !=0)
          mode_idx++;   //BACKUP_PREDICTION
      }// for (ctr16x16=0, index=0; index<max_index; index++)

    }
    //==========================================
     reset_coding_state (cs_eachQP);

    if(!final_mb_encoding)
    {
      if(input->successive_Bframe==0)
      {     
        //chroma_qp = currMB->qpc[0];
        if(isfirstQP) // deltaQP =0 has to be test first!
        {
          master_cr_cbp = img->mb_data[img->current_mb_nr].cbp>>4;
          master_cr_qp  = chroma_qp;
        }
      }
    }

    if (min_rdcost < RDOQ_min_rdcost)
    {
      RDOQ_min_rdcost=min_rdcost;
      bestQP=currMB->qp;
      best_deltaQP = deltaQPCnt;  //deltaQP;
      saved_best_mode = best_mode;
    }

    isfirstQP = 0;

    if(best_mode==0 && cbp==0)   //no need to check other QPs if the best mode is SKIP for current QP
      break;
  }//for (deltaQPCnt=0; deltaQPCnt<deltaQPTabSize; deltaQPCnt++)


  currMB->qp = bestQP;  //Clip3(0, 51, (img->masterQP + best_deltaQP));
  img->qp    = bestQP;
  currMB->delta_qp = currMB->qp - currMB->prev_qp;
  set_chroma_qp(currMB);
  

//  make sure to store the bestQP to MB32.qp. as this is used in start_macroblock32
      MB32.prev_qp = currMB->prev_qp;
      MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac
      MB32.qp = currMB->qp;


  *bestQPcount = best_deltaQP;
  return RDOQ_min_rdcost;
}




#endif    //MB32X32

