/* 
  ====================================================================================================================

	The copyright in this software is being made available under the License included below. 
	This software may be subject to other third party and 	contributor rights, including patent rights, and no such 
	rights are granted under this license.
 
	Copyright (c) 2010, QUALCOMM INC.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification, are permitted only for 
	the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
	promoting such standards. The following conditions are required to be met:

		* Redistributions of source code must retain the above copyright notice, this list of conditions and 
		  the following disclaimer.
		* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
		  the following disclaimer in the documentation and/or other materials provided with the distribution.
		* The name of QUALCOMM INC.  may not be used to endorse or promote products derived from this software without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  ====================================================================================================================
*/
#ifndef _QC_FILTER_H_
#define _QC_FILTER_H_

#ifdef ADAPTIVE_LOOP_FILTER
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "global.h"
#include "alf_filter_common.h"
//
//  varBasedPostprocessing.c
//

void init_qc_filter(int height,int width);
void delete_qc_filter();
void CalValImage( imgpel **ImgDec);
void FilteringFrameLuma_qc(imgpel **ImgOrg, imgpel **ImgDec, imgpel **ImgRest,int tap,alf_parameter_set_rbsp_t* temp_alfps);
void StoreInBlockMartix(unsigned int *****blk_corr,imgpel** ImgOrg, imgpel** ImgDec);
int fillInMartix_direct(alf_parameter_set_rbsp_t* temp_alfps,imgpel** ImgOrg, imgpel** ImgDec,int getfromImg,int tap);
int send_ALFLumaParam_qc(Bitstream * bitstream);
void saveBestBitstream();
void LoadBestBitstream();
void saveBitstream_fullframe();
void printImgHeight();
int fillInMartixfromBlockMatrix(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int getfromImg,imgpel** ImgOrg, imgpel** ImgDec);
void storeInBlockMartix(double *****blk_corr,double ***blk_pixAcc,imgpel** ImgOrg, imgpel** ImgDec);
int storeInBlockMartix_update(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int prev_idx);
int fillInMartixfromBlockMatrix_update(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int getfromImg);

void setCodedFilter();

void postProcessing(alf_parameter_set_rbsp_t* alfps,Bitstream *alfstream,imgpel** ImgOrg, imgpel** imgY_rec);
#endif
#endif

