/* 
  ====================================================================================================================

	The copyright in this software is being made available under the License included below. 
	This software may be subject to other third party and 	contributor rights, including patent rights, and no such 
	rights are granted under this license.
 
	Copyright (c) 2010, QUALCOMM INC.
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification, are permitted only for 
	the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
	promoting such standards. The following conditions are required to be met:

		* Redistributions of source code must retain the above copyright notice, this list of conditions and 
		  the following disclaimer.
		* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
		  the following disclaimer in the documentation and/or other materials provided with the distribution.
		* The name of QUALCOMM INC.  may not be used to endorse or promote products derived from this software without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  ====================================================================================================================
*/
#ifndef _MV_COMPETITION_H
#define _MV_COMPETITION_H

#include "global.h"
#include "mbuffer.h"

#define DISABLED      -1
#define ENABLED        0 
#define NOT_AVAILABLE    999

#define MVMODE_COST_FACTOR  1        

#define PRED_H264_MEDIAN       0
#define PRED_EXTENDEDSPATIAL   1
#define PRED_A                 2
#define PRED_B                 3
#define PRED_C                 4  
#define PRED_ZERO              5  
#define PRED_COLOCATED         6

typedef struct
{
  int nb_mode_for_skip;            // Number of active predictors for the skip mode 
  //this variable is in macroblock structure  int best_predictor_for_skip;  
  // Index of the best predictor for the skip mode
  int current_predictor_for_skip;  // Currently tested predictor for the skip mode
  int *predictor_for_skip;         // Contains the name of the active predictors (PRED_H264_MEDIAN, PRED_A, etc) 
  int **mv_pred_skip;              // [Mode_Skip][hv] Contains the motion vectors for each skip predictors
  int nb_mode_for_mvp;             // Number of active predictors for the motion vectors of P frames 
  int nb_mode_for_mvb;             // Number of active predictors for the motion vectors of B frames
  int *predictor_for_mvp;          // Contains the name of the active predictors for P frames 
  int *predictor_for_mvb;          // Contains the name of the active predictors for B frames 
} MV_Competition;


void  init_MV_Competition();
void  close_MV_Competition();
int   write_predictor_index_for_skip_mode();
int   writeMotionVectorPredictorSKIP (int);
void  writeMB_Motion_predictor_CABAC(SyntaxElement *, EncodingEnvironmentPtr);
short collocated_mv_available(int, int, int);
short send_index_for_skip_prediction(int);
void  send_index_for_mv_prediction(int, int, int, short, int, int); 
int   determine_mode_block(int,int);
int   compute_mv_cost_for_each_predictor(int, int, int, int, int, int, int, int, int, int, int); 
#ifdef ADAPTIVE_MV_RES
int   compute_mv_cost_for_each_predictor_1(int, int, int, int, int, int, int, int, int, int, int,int,int); 
#endif
int   MVMODE_COST(int,int,int);
void  GetBestPredVector (short*, short, short, int, int, int, int, int, int);
int   writeIndexForMotionVectorPrediction (int, int, int, int, int);
void  SetMotionVectorPredictor_Competition (short  pmv[2], char   **, short  ***,short, int, int, int, int, int, int mb_ext_level);

int write_predictor_index_for_skip_mode32();
int write_predictor_index_for_skip_mode64();

void    init_mv_scale_hb();
void SetMotionVectorPredictor_collocated_HB_SLICE (short  pmv[2], int y, int x, int list, int ref_frame, int block_y, int block_x);

short ****    mv_previous_B_frame;      //!< motion vector       [list][subblock_x][subblock_y][component]
char  ***     ref_idx_previous_B_frame; //!< reference picture   [list][subblock_y][subblock_x]
int   pass_with_writing; 

#endif
