/* 
====================================================================================================================

The copyright in this software is being made available under the License included below. 
This software may be subject to other third party and 	contributor rights, including patent rights, and no such 
rights are granted under this license.

Copyright (c) 2010, QUALCOMM INC.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted only for 
the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
promoting such standards. The following conditions are required to be met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and 
the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
the following disclaimer in the documentation and/or other materials provided with the distribution.
* The name of QUALCOMM INC.  may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

====================================================================================================================
*/

#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <limits.h>
#include <memory.h>
#include <string.h>

#include "global.h"
#include "memalloc.h"
#include "mb_access.h"
#include "elements.h"
#include "image.h"
#include "cabac.h"   
#include "vlc.h"
#include "mode_decision.h"
#include "mb_access.h"

#ifdef GEOM
void LumaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level);
void ChromaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level);
#endif

#ifdef MV_COMPETITION
#include "mv_competition.h"
extern MV_Competition mv_comp;
extern int skip_mode;
#endif

#ifdef RDO_Q
int saved_cbp, saved_I16cbp, saved_I8cbp;
int saved_i16mode;
int saved_cofAC[4][4][2][65];
int saved_I16cofAC[4][4][2][65], saved_I8cofAC[4][4][2][65];
int saved_cofDC[3][2][65];
imgpel saved_enc_picture_imgY[16][16], saved_I16enc_picture_imgY[16][16], saved_I8enc_picture_imgY[16][16];
imgpel saved_img_mpr[16][16], saved_I8img_mpr[16][16];
#endif
#ifdef USE_INTRA_MDDT
int   bestCofAC16[2][16*17];
#endif 

int   bestCofAC16x16 [2][257];
int   bestCofAC16x8  [2][2][129];
int   bestCofAC8x16  [2][2][129];

imgpel pred[16][16];

#define FASTMODE 1
//#define RESET_STATE

extern const int LEVELMVLIMIT[17][6];
extern int   QP2QUANT[40];

extern short OffsetList4x4[15][16];
extern short OffsetList8x8[5][64];
extern const int OffsetBits;

extern int writeDeltaQP(int rdopt, int cbp);
extern int writeCBP_Transform_size (int rdopt, int mb32);
extern int writeLumaCoeff (int rdopt, int mb32);

imgpel   rec_mbY[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL], rec_mbU[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL], rec_mbV[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL];    // reconstruction values

//RD_8x8DATA tr4x4, tr8x8;
RD_8x8DATA tr4x4[NumberOfQP], tr8x8[NumberOfQP];      // for 5 QP..

int   ****cofAC=NULL;   //this is used in store_macroblock_parameters() 
int   ***cofDC=NULL;                       // [yuv][level/run][scan_pos]

int   ****cofAC8x8=NULL;        // [8x8block][4x4block][level/run][scan_pos]
int   **cofAC4x4=NULL, ****cofAC4x4intern=NULL; // [level/run][scan_pos]
int   cbp, cbp8x8, cnt_nonz_8x8;
int64 cbp_blk;
int   cbp_blk8x8;
char  frefframe[4][4], brefframe[4][4];
int   b8mode[4], b8pdir[4];
//short best8x8mode [4];                // [block]
short best8x8pdir  [MAXMODE][4];       // [mode][block]
short best8x8fwref [MAXMODE][4];       // [mode][block]
short best8x8bwref [MAXMODE][4];       // [mode][block]


CSptr cs_mb=NULL, cs_b8=NULL, cs_cm=NULL, cs_imb=NULL, cs_ib8=NULL, cs_ib4=NULL, cs_pc=NULL;
#ifdef USE_INTRA_MDDT
CSptr cs_i16 = NULL;
#endif 
CSptr cs_smb=NULL, cs_eachQP = NULL;
int   best_c_imode;
int   best_i16offset;
short best_mode;
short  bi_pred_me;

//mixed transform sizes definitions
int   luma_transform_size_8x8_flag;

short all_mv8x8[2][2][4][4][2];       //[8x8_data/temp_data][LIST][block_x][block_y][MVx/MVy]
short pred_mv8x8[2][2][4][4][2];

//int   ****cofAC_8x8ts = NULL;        // [8x8block][4x4block][level/run][scan_pos]
//int64    cbp_blk8_8x8ts;
//int      cbp8_8x8ts;
//int      cost8_8x8ts;
//int      cnt_nonz8_8x8ts;
#ifdef RDO_Q
imgpel rec_mbY_intra[4][4][16][16], rec_mbU_intra[4][4][16][16], rec_mbV_intra[4][4][16][16];    // reconstruction values
int   i16offset_intra[4][4];
int   cbp_intra[4][4];
int64 cbp_blk_intra[4][4];
//double rdcost_intra[4][4];
int   cofAC_intra[4][4][12][4][2][65];
int   cofDC_intra[4][4][3][2][65];                       // [yuv][level/run][scan_pos]
char   b4_ipredmode_intra[4][4][16];
char   b8_ipredmode8x8_intra[4][4][4][4];
char   b4_ipredmode_mb_intra[4][4][16];
char   b8_ipredmode8x8_mb_intra[4][4][16];
#define IS_INTRA_MODE(mode)  ((mode==I4MB)||(mode==I8MB)||(mode==I16MB))
#define IS_INTER_SLICE(type) ((type) == B_SLICE || (type) == P_SLICE)
#endif

void RestoreMV8x8(int dir, short bestQP);
// end of mixed transform sizes definitions

extern int   ****cofAC32[1<<(2*MAX_MB_EXT_LEVEL)], ****cofAC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];// ****cofAC8x8=NULL;        // [8x8block][4x4block][level/run][scan_pos]
extern int   ***cofDC32[1<<(2*MAX_MB_EXT_LEVEL)], ***cofDC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];                       // [yuv][level/run][scan_pos]

extern int    **cof32AC16x16[1<<(2*MAX_MB_EXT_LEVEL)], **cof32AC16x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][257];
extern int    ***cof32AC16x8[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC16x8_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];
extern int    ***cof32AC8x16[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC8x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];


// Residue Color Transform
char  b4_ipredmode[16], b4_intra_pred_modes[16];



/*!
************************************************************************
* \brief
*    delete structure for storing coding state
************************************************************************
*/
void
delete_coding_state (CSptr cs)
{
  if (cs != NULL)
  {
    //=== structures of data partition array ===
    if (cs->encenv    != NULL)   free (cs->encenv);
    if (cs->bitstream != NULL)   free (cs->bitstream);

    //=== contexts for binary arithmetic coding ===
    delete_contexts_MotionInfo  (cs->mot_ctx);
    delete_contexts_TextureInfo (cs->tex_ctx);

    //=== coding state structure ===
    free (cs);
    cs=NULL;
  }
}


/*!
************************************************************************
* \brief
*    create structure for storing coding state
************************************************************************
*/
CSptr
create_coding_state ()
{
  CSptr cs;

  //=== coding state structure ===
  if ((cs = (CSptr) calloc (1, sizeof(CSobj))) == NULL)
    no_mem_exit("init_coding_state: cs");

  //=== important variables of data partition array ===
  cs->no_part = 1;
  if ((cs->encenv = (EncodingEnvironment*) calloc (cs->no_part, sizeof(EncodingEnvironment))) == NULL)
    no_mem_exit("init_coding_state: cs->encenv");

  if ((cs->bitstream = (Bitstream*) calloc (cs->no_part, sizeof(Bitstream))) == NULL)
    no_mem_exit("init_coding_state: cs->bitstream");

  //=== context for binary arithmetic coding ===
  cs->mot_ctx = create_contexts_MotionInfo ();
  cs->tex_ctx = create_contexts_TextureInfo();

  return cs;
}


/*!
************************************************************************
* \brief
*    store coding state (for rd-optimized mode decision)
************************************************************************
*/
void
store_coding_state (CSptr cs)
{
  int  i;
  int  i_last = img->currentPicture->idr_flag? 1:cs->no_part; 
  Slice *currSlice = img->currentSlice;

  Macroblock *currMB  = &(img->mb_data [img->current_mb_nr]);

  {
    //=== important variables of data partition array ===
    //only one partition for IDR img
    for (i = 0; i < i_last; i++)
    {
      memcpy (&(cs->encenv[i]), &(currSlice->partArr[i].ee_cabac), sizeof(EncodingEnvironment));
      memcpy (&(cs->bitstream[i]), currSlice->partArr[i].bitstream, sizeof(Bitstream));
    }

    //=== contexts for binary arithmetic coding ===
    memcpy (cs->mot_ctx, currSlice->mot_ctx, sizeof(MotionInfoContexts));
    memcpy (cs->tex_ctx, currSlice->tex_ctx, sizeof(TextureInfoContexts));
  }

  //=== syntax element number and bitcounters ===
  cs->currSEnr = currMB->currSEnr;
  memcpy (cs->bitcounter, currMB->bitcounter, MAX_BITCOUNTER_MB * sizeof(int));

  //=== elements of current macroblock ===
  memcpy (cs->mvd, currMB->mvd, BLOCK_CONTEXT * sizeof(int));
  cs->cbp_bits = currMB->cbp_bits;
}


/*!
************************************************************************
* \brief
*    restore coding state (for rd-optimized mode decision)
************************************************************************
*/
void reset_coding_state (CSptr cs)
{
  int  i;
  int  i_last = img->currentPicture->idr_flag? 1:cs->no_part; 
  Slice *currSlice = img->currentSlice;

  Macroblock *currMB  = &(img->mb_data [img->current_mb_nr]);

  {
    //=== important variables of data partition array ===
    //only one partition for IDR img
    for (i = 0; i < i_last; i++)
    {
      //--- parameters of encoding environments ---
      memcpy (&(currSlice->partArr[i].ee_cabac), &(cs->encenv   [i]), sizeof(EncodingEnvironment));
      memcpy (currSlice->partArr[i].bitstream, &(cs->bitstream[i]), sizeof(Bitstream));
    }


    //=== contexts for binary arithmetic coding ===
    memcpy (currSlice->mot_ctx, cs->mot_ctx, sizeof(MotionInfoContexts));
    memcpy (currSlice->tex_ctx, cs->tex_ctx, sizeof(TextureInfoContexts));

  }


  //=== syntax element number and bit counters ===
  currMB->currSEnr = cs->currSEnr;
  memcpy (currMB->bitcounter, cs->bitcounter, MAX_BITCOUNTER_MB * sizeof(int));

  //=== elements of current macroblock ===
  memcpy (currMB->mvd, cs->mvd, BLOCK_CONTEXT * sizeof(int));
  currMB->cbp_bits = cs->cbp_bits;
}



/*!
************************************************************************
* \brief
*    delete structure for RD-optimized mode decision
************************************************************************
*/
void clear_rdopt ()
{
  int i;
  for(i=0; i<(1<<(2*MAX_MB_EXT_LEVEL)); i++)
  {
    free_mem_DCcoeff (cofDC32[i]);
    free_mem_ACcoeff (cofAC32[i]);
    free_mem_DCcoeff (cofDC32_RDCost[i]);
    free_mem_ACcoeff (cofAC32_RDCost[i]);
    free_mem2Dint(cof32AC16x16[i]);
    free_mem3Dint(cof32AC16x8[i], 2);
    free_mem3Dint(cof32AC8x16[i], 2);
    free_mem2Dint(cof32AC16x16_RDCost[i]);
    free_mem3Dint(cof32AC16x8_RDCost[i], 2);
    free_mem3Dint(cof32AC8x16_RDCost[i], 2);
  }
  free_mem_DCcoeff (cofDC);
  free_mem_ACcoeff (cofAC);

  for(i=0;i<NumberOfQP;i++)
  {
    free_mem_ACcoeff (tr4x4[i].cofAC8x8);
  }
  free_mem_ACcoeff (cofAC8x8);

  free_mem_ACcoeff (cofAC4x4intern);

  if (input->Transform8x8Mode)
  {
    //    free_mem_ACcoeff (cofAC_8x8ts);
    for(i=0;i<NumberOfQP;i++)
    {
      free_mem_ACcoeff (tr8x8[i].cofAC8x8);
    }
  }

  // structure for saving the coding state
  delete_coding_state (cs_mb);
  delete_coding_state (cs_b8);
  delete_coding_state (cs_cm);
  delete_coding_state (cs_imb);
  delete_coding_state (cs_ib8);
  delete_coding_state (cs_ib4);
  delete_coding_state (cs_pc);
#ifdef USE_INTRA_MDDT
  delete_coding_state (cs_i16);
#endif 
  delete_coding_state (cs_smb);
  delete_coding_state (cs_eachQP);
}


/*!
************************************************************************
* \brief
*    create structure for RD-optimized mode decision
************************************************************************
*/
void init_rdopt ()
{
  int i;
  for(i=0; i<(1<<(2*MAX_MB_EXT_LEVEL)); i++)
  {
    get_mem_DCcoeff (&cofDC32[i]);
    get_mem_ACcoeff (&cofAC32[i]);
    get_mem_DCcoeff (&cofDC32_RDCost[i]);
    get_mem_ACcoeff (&cofAC32_RDCost[i]);

    get_mem2Dint(&cof32AC16x16[i],2,257);
    get_mem3Dint(&cof32AC16x8[i], 2, 2, 129);
    get_mem3Dint(&cof32AC8x16[i], 2, 2, 129);
    get_mem2Dint(&cof32AC16x16_RDCost[i],2,257);
    get_mem3Dint(&cof32AC16x8_RDCost[i], 2, 2, 129);
    get_mem3Dint(&cof32AC8x16_RDCost[i], 2, 2, 129);
  }
  rdopt = NULL;

  get_mem_DCcoeff (&cofDC);
  get_mem_ACcoeff (&cofAC);
  //this is used in Intra 8x8 mode decision
  for(i=0;i<NumberOfQP;i++)
  {
    get_mem_ACcoeff (&(tr4x4[i].cofAC8x8)); 
  }
  get_mem_ACcoeff (&cofAC8x8);

  get_mem_ACcoeff (&cofAC4x4intern);
  cofAC4x4 = cofAC4x4intern[0][0];

  if (input->Transform8x8Mode)
  {
    //    get_mem_ACcoeff (&cofAC_8x8ts);
    for(i=0;i<NumberOfQP;i++)
    {
      get_mem_ACcoeff (&(tr8x8[i].cofAC8x8));
    }
  }

  // structure for saving the coding state
  cs_mb  = create_coding_state ();
  cs_b8  = create_coding_state ();
  cs_cm  = create_coding_state ();
  cs_imb = create_coding_state ();
  cs_ib8 = create_coding_state ();
  cs_ib4 = create_coding_state ();
  cs_pc  = create_coding_state ();
#ifdef USE_INTRA_MDDT
  cs_i16  = create_coding_state ();
#endif 
  cs_smb      = create_coding_state ();
  cs_eachQP   = create_coding_state ();
}

/*!
*************************************************************************************
* \brief
*    R-D Cost for an 8x8 Partition
*************************************************************************************
*/
double RDCost_for_8x8blocks (int*    cnt_nonz,   // --> number of nonzero coefficients
                             int64*  cbp_blk,    // --> cbp blk
                             double  lambda,     // <-- lagrange multiplier
                             int     block,      // <-- 8x8 block number
                             int     mode,       // <-- partitioning mode
                             short   pdir,       // <-- prediction direction
                             short   ref,        // <-- reference frame
                             short   bwd_ref
                             ,double* min_rdcost
                             )    // <-- abp type
{
  int  rate=0;
  int64 distortion=0;
  int  mrate;
  int  fw_mode, bw_mode;
  int  cbp     = 0;
  int  pax     = 8*(block & 0x01);
  int  pay     = 8*(block >> 1);
  int  i0      = pax >> 2;
  int  j0      = pay >> 2;
  int  bframe  = (img->type==B_SLICE);
  int  direct  = (bframe && mode==0);
  int  b8value = B8Mode2Value (mode, pdir);

  Macroblock    *currMB    = &img->mb_data[img->current_mb_nr];
  SyntaxElement *currSE    = &img->MB_SyntaxElements[currMB->currSEnr];
  Slice         *currSlice = img->currentSlice;
  DataPartition *dataPart;
  const int     *partMap   = assignSE2partition[0];

  EncodingEnvironmentPtr eep_dp;

  if (input->mv_competition > 0)// skip_mode is for P_SKIP..and here P_SKIP will never happen coz this is 8x8
    skip_mode = FALSE;
  //for sub mb (8x8 and below), there is no SKIP...PSkip or Bskip...and also there is no P_Direct for 8x8...
  img->NoResidueDirect = 0;

  //=====
  //=====  GET COEFFICIENTS, RECONSTRUCTIONS, CBP
  //=====
  currMB->bi_pred_me=0;

  if (direct)
  {
    if (direct_pdir[img->block_y+j0][img->block_x+i0]<0) // mode not allowed
      return (1e20);
    else
      *cnt_nonz = LumaResidualCoding8x8 (0, 0, mode, -1, &cbp, cbp_blk, block, direct_pdir[img->block_y+j0][img->block_x+i0], 0, 0, 
      (short)max(0,direct_ref_idx[LIST_0][img->block_y+j0][img->block_x+i0]), direct_ref_idx[LIST_1][img->block_y+j0][img->block_x+i0]);
  }
  else
  {
    fw_mode   = (pdir==0||pdir==2 ? mode : 0);
    bw_mode   = (pdir==1||pdir==2 ? mode : 0);
    *cnt_nonz = LumaResidualCoding8x8 (0, 0, mode, -1, &cbp, cbp_blk, block, pdir, fw_mode, bw_mode, ref, bwd_ref);
  }

  //=====
  //=====   GET DISTORTION
  //=====
  distortion += compute_SSE(imgY_org, enc_picture->imgY, img->opix_y+pay, img->pix_y+pay, img->pix_x+pax, img->pix_x+pax, 8, 8);

  if(distortion > *min_rdcost)
    return (double)distortion;

  //=====
  //=====   GET RATE
  //=====
  //----- block 8x8 mode -----
  {
    currSE->value1  = b8value;
    currSE->dir_partition1 = pdir;    //what value to set here-> see the input parameter in B8Mode2Value()
    currSE->writing = writeB8_typeInfo_CABAC;

    currSE->type    = SE_MBTYPE;
    dataPart = &(currSlice->partArr[partMap[currSE->type]]);
    dataPart->writeSyntaxElement (currSE, dataPart);
    rate += currSE->len;
    currSE++;
    currMB->currSEnr++;
  }

  //----- motion information -----
  if (!direct)
  {
    if ((img->num_ref_idx_l0_active > 1 ) && (pdir==0 || pdir==2))
      rate  += writeReferenceFrame (mode, i0, j0, 1, ref, 0);
    if(img->num_ref_idx_l1_active > 1 && img->type== B_SLICE)
    {
      if (pdir==1 || pdir==2)
      {
        rate  += writeReferenceFrame (mode, i0, j0, 0, bwd_ref, 0);
      }
    }

#ifdef MV_COMPETITION
    if (input->mv_competition)
      pass_with_writing = 0;
#endif

    if (pdir==0 || pdir==2)
    {
      rate  += writeMotionVector8x8 (i0, j0, i0+2, j0+2, ref,LIST_0, mode, 0);
    }
    if (pdir==1 || pdir==2)
    {
      rate  += writeMotionVector8x8 (i0, j0, i0+2, j0+2, bwd_ref, LIST_1, mode, 0);
    }

#ifdef MV_COMPETITION
    if (input->mv_competition)
      pass_with_writing = 1;
#endif
  }

  //----- coded block pattern (for CABAC only) -----
  dataPart = &(currSlice->partArr[partMap[SE_CBP_INTER]]);
  eep_dp   = &(dataPart->ee_cabac);
  mrate    = arienco_bits_written (eep_dp);
  writeCBP_BIT_CABAC (block, ((*cnt_nonz>0)?1:0), cbp8x8, currMB, 1, eep_dp);
  mrate    = arienco_bits_written (eep_dp) - mrate;
  rate    += mrate;

  //----- luminance coefficients -----
  if (*cnt_nonz)
  {
    rate += writeLumaCoeff8x8 (block, mode, currMB->luma_transform_size_8x8_flag);
  }
  return (double)distortion + lambda * (double)rate;
}


/*!
*************************************************************************************
* \brief
*    Gets mode offset for intra16x16 mode
*************************************************************************************
*/
int I16Offset (int cbp, int i16mode)
{
  return (cbp&15?13:1) + i16mode + ((cbp&0x30)>>2);
}


/*!
*************************************************************************************
* \brief
*    Sets modes and reference frames for a macroblock
*************************************************************************************
*/
void SetModesAndRefframeForBlocks (int mode)
{
  int i,j,k,l;
  Macroblock *currMB = &img->mb_data[img->current_mb_nr];
  int  bframe  = (img->type==B_SLICE);
  int  block_x, block_y;
  int  cur_ref[2];  

  //--- macroblock type ---
  currMB->mb_type = mode;    
  currMB->bi_pred_me= (mode == 1 ? img->bi_pred_me[mode] : 0);  

  //--- block 8x8 mode and prediction direction ---
  switch (mode)
  {
  case 0:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = 0;
      currMB->b8pdir[i] = (bframe ? direct_pdir[img->block_y + (i >> 1)*2][img->block_x + (i & 0x01)*2] : 0);
    }
    break;
  case 1:
  case 2:
  case 3:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = mode;
      currMB->b8pdir[i] = best8x8pdir[mode][i];
    }
    break;
  case P8x8:              //NOT NECESSARY...DUMMY VALUES
    //for(i=0;i<4;i++)    //is taken care inside SetCoeffAndReconstruction8x8()
    //{
    //  currMB->b8mode[i]   = best8x8mode[i];
    //  currMB->b8pdir[i]   = best8x8pdir[mode][i];
    //}
    break;
  case I4MB:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = IBLOCK; 
      currMB->b8pdir[i] = -1;
    }
    break;
  case I16MB:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] =  0;
      currMB->b8pdir[i] = -1;
    }
    break;
  case I8MB:
    for(i=0;i<4;i++)
    {
      currMB->b8mode[i] = I8MB;
      currMB->b8pdir[i] = -1;
    }
    //switch to 8x8 transform
    currMB->luma_transform_size_8x8_flag = 1;
    break;
  default:
    printf ("Unsupported mode in SetModesAndRefframeForBlocks!\n");
    exit (1);
  }

  //#define IS_FW ((best8x8pdir[mode][k]==0 || best8x8pdir[mode][k]==2) && (mode!=P8x8 || best8x8mode[k]!=0 || !bframe))
  //#define IS_BW ((best8x8pdir[mode][k]==1 || best8x8pdir[mode][k]==2) && (mode!=P8x8 || best8x8mode[k]!=0))
#define IS_FW ((best8x8pdir[mode][k]==0 || best8x8pdir[mode][k]==2) && (mode!=P8x8 || !bframe))
#define IS_BW ((best8x8pdir[mode][k]==1 || best8x8pdir[mode][k]==2) && (mode!=P8x8))

  //--- reference frame arrays ---
  if (mode==0 || mode==I4MB || mode==I16MB || mode==I8MB)
  {
    if (bframe)
    {
      if (!mode)
      {
        memcpy(&enc_picture->ref_idx[LIST_0][img->block_y    ][img->block_x],&direct_ref_idx[LIST_0][img->block_y    ][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_0][img->block_y + 1][img->block_x],&direct_ref_idx[LIST_0][img->block_y + 1][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_0][img->block_y + 2][img->block_x],&direct_ref_idx[LIST_0][img->block_y + 2][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_0][img->block_y + 3][img->block_x],&direct_ref_idx[LIST_0][img->block_y + 3][img->block_x], 4 * sizeof(char));

        memcpy(&enc_picture->ref_idx[LIST_1][img->block_y    ][img->block_x],&direct_ref_idx[LIST_1][img->block_y    ][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_1][img->block_y + 1][img->block_x],&direct_ref_idx[LIST_1][img->block_y + 1][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_1][img->block_y + 2][img->block_x],&direct_ref_idx[LIST_1][img->block_y + 2][img->block_x], 4 * sizeof(char));
        memcpy(&enc_picture->ref_idx[LIST_1][img->block_y + 3][img->block_x],&direct_ref_idx[LIST_1][img->block_y + 3][img->block_x], 4 * sizeof(char));
      }
      else
      {
        memset(&enc_picture->ref_idx[LIST_0][img->block_y    ][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 1][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 2][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 3][img->block_x],-1, 4 * sizeof(char));

        memset(&enc_picture->ref_idx[LIST_1][img->block_y    ][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_1][img->block_y + 1][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_1][img->block_y + 2][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_1][img->block_y + 3][img->block_x],-1, 4 * sizeof(char));
      }
    }
    else
    {
      if (!mode)
      {
        memset(&enc_picture->ref_idx[LIST_0][img->block_y    ][img->block_x],0, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 1][img->block_x],0, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 2][img->block_x],0, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 3][img->block_x],0, 4 * sizeof(char));
      }
      else
      {
        memset(&enc_picture->ref_idx[LIST_0][img->block_y    ][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 1][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 2][img->block_x],-1, 4 * sizeof(char));
        memset(&enc_picture->ref_idx[LIST_0][img->block_y + 3][img->block_x],-1, 4 * sizeof(char));
      }
    }
  }
  else
  {
    if (bframe)
    {
      for (j=0;j<4;j++)
      {
        block_y = img->block_y + j;
        for (i=0;i<4;i++)
        {
          block_x = img->block_x + i;
          k = 2*(j >> 1) + (i >> 1);
          l = 2*(j & 0x01) + (i & 0x01);

          enc_picture->ref_idx[LIST_0][block_y][block_x] = -1;
          enc_picture->ref_idx[LIST_1][block_y][block_x] = -1;

          //if(mode == P8x8 && best8x8mode[k]==0)
          //{
          //  enc_picture->ref_idx[LIST_0][block_y][block_x] = direct_ref_idx[LIST_0][block_y][block_x];
          //  enc_picture->ref_idx[LIST_1][block_y][block_x] = direct_ref_idx[LIST_1][block_y][block_x];
          //}
          /*else*/ if (mode ==1 && currMB->bi_pred_me && IS_FW && IS_BW)
          {
            enc_picture->ref_idx[LIST_0][block_y][block_x] = 0;
            enc_picture->ref_idx[LIST_1][block_y][block_x] = 0;
          }
          else
          {
            enc_picture->ref_idx[LIST_0][block_y][block_x] = (IS_FW ? best8x8fwref[mode][k] : -1);
            enc_picture->ref_idx[LIST_1][block_y][block_x] = (IS_BW ? best8x8bwref[mode][k] : -1);
          }
        }
      }
    }
    else
    {
      for (j=0;j<4;j++)
      {
        block_y = img->block_y + j;
        for (i=0;i<4;i++)
        {
          block_x = img->block_x + i;
          k = 2*(j >> 1) + (i >> 1);
          l = 2*(j & 0x01) + (i & 0x01);
          enc_picture->ref_idx[LIST_0][block_y][block_x] = (IS_FW ? best8x8fwref[mode][k] : -1);
        }
      }
    }
  }

  if (bframe)
  {

    for (j = img->block_y; j < img->block_y + 4; j++)
      for (i = img->block_x; i < img->block_x + 4;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];
        cur_ref[LIST_1] = (int) enc_picture->ref_idx[LIST_1][j][i];

        enc_picture->ref_pic_id [LIST_0][j][i] = (cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
        : -1);
        enc_picture->ref_pic_id [LIST_1][j][i] = (cur_ref[LIST_1]>=0 
          ? enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][cur_ref[LIST_1]]
        : -1);
      }
  }
  else
  {  
    for (j = img->block_y; j < img->block_y + 4; j++)
      for (i = img->block_x; i < img->block_x + 4;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];
        enc_picture->ref_pic_id [LIST_0][j][i] = (cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
        : -1);
      }
  }

#undef IS_FW
#undef IS_BW


  if(mode != P8x8)
    //==== motion vectors =====
    SetMotionVectorsMB (currMB, bframe);


}





/*!
*************************************************************************************
* \brief
*    Sets Coefficients and reconstruction for an 8x8 block
*************************************************************************************
*/
void SetCoeffAndReconstruction8x8 (Macroblock* currMB, short QPcount)
{
  int block, k, j, i;
  int cur_ref[2];

  //============= MIXED TRANSFORM SIZES FOR 8x8 PARTITION ==============
  //--------------------------------------------------------------------
  int l;
  int bframe = img->type==B_SLICE; 

  if (currMB->luma_transform_size_8x8_flag)
  {

    //============= set mode and ref. frames ==============
    currMB->b8mode[0]   = tr8x8[QPcount].part8x8mode[0];
    currMB->b8mode[1]   = tr8x8[QPcount].part8x8mode[1];
    currMB->b8mode[2]   = tr8x8[QPcount].part8x8mode[2];
    currMB->b8mode[3]   = tr8x8[QPcount].part8x8mode[3];

    currMB->b8pdir[0]   = tr8x8[QPcount].part8x8pdir[0];
    currMB->b8pdir[1]   = tr8x8[QPcount].part8x8pdir[1];
    currMB->b8pdir[2]   = tr8x8[QPcount].part8x8pdir[2];
    currMB->b8pdir[3]   = tr8x8[QPcount].part8x8pdir[3];

    if (bframe)
    {
      for (j = 0;j<4;j++)
        for (i = 0;i<4;i++)
        {
          k = 2*(j >> 1)+(i >> 1);
          l = 2*(j & 0x01)+(i & 0x01);
          enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x+i] = ((currMB->b8pdir[k] & 0x01) == 0) ? tr8x8[QPcount].part8x8fwref[k] : - 1;
          enc_picture->ref_idx[LIST_1][img->block_y+j][img->block_x+i] = (currMB->b8pdir[k] > 0) ? tr8x8[QPcount].part8x8bwref[k] : - 1;
        }
    }
    else
    {
      for (j = 0;j<4;j++)
        for (i = 0;i<4;i++)
        {
          k = 2*(j >> 1)+(i >> 1);
          l = 2*(j & 0x01)+(i & 0x01);
          enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x+i] = tr8x8[QPcount].part8x8fwref[k];
        }
    }


    for (j = img->block_y;j<img->block_y + BLOCK_MULTIPLE;j++)
    {
      for (i = img->block_x;i<img->block_x + BLOCK_MULTIPLE;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];

        enc_picture->ref_pic_id [LIST_0][j][i] =(cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
        : -1);
      }
    }

    if (bframe)
    {
      for (j = img->block_y; j < img->block_y + BLOCK_MULTIPLE; j++)
      {
        for (i = img->block_x;i<img->block_x + BLOCK_MULTIPLE;i++)
        {
          cur_ref[LIST_1] = (int) enc_picture->ref_idx[LIST_1][j][i];

          enc_picture->ref_pic_id [LIST_1][j][i] = (cur_ref[LIST_1]>=0 
            ? enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][cur_ref[LIST_1]]
          : -1);
        }

      }
    }

    //====== set the mv's for 8x8 partition with transform size 8x8 ======
    //set new mv data for 8x8 transform
    RestoreMV8x8(0, QPcount);

    //==== motion vectors =====
    SetMotionVectorsMB (currMB, bframe);  

    //============= get pre-calculated data ==============
    //restore coefficients from 8x8 transform

    for (block = 0; block<4; block++)
    {
      for (k = 0; k<4; k++)
        for (j = 0; j<2; j++)
          memcpy (img->cofAC[block][k][j],tr8x8[QPcount].cofAC8x8[block][k][j], 65 * sizeof(int));            
    }     
    //restore reconstruction 
    if (tr8x8[QPcount].cnt_nonz_8x8 <= _LUMA_8x8_COEFF_COST_ && 
      ((img->qp + img->bitdepth_luma_qp_scale)!=0 || img->lossless_qpprime_flag==0))
    {
      currMB->cbp     = 0;
      currMB->cbp_blk = 0;
      for (j = 0; j < MB_BLOCK_SIZE; j++)
      {
        memcpy(&enc_picture->imgY[img->pix_y+j][img->pix_x], tr8x8[QPcount].mpr8x8[j], MB_BLOCK_SIZE * sizeof(imgpel));
      }
    }
    else
    {
      currMB->cbp     = tr8x8[QPcount].cbp8x8;     //      cbp8_8x8ts;
      currMB->cbp_blk = tr8x8[QPcount].cbp_blk8x8; //      cbp_blk8_8x8ts;

      for (j = 0; j < MB_BLOCK_SIZE; j++)
      {
        memcpy (&enc_picture->imgY[img->pix_y+j][img->pix_x],tr8x8[QPcount].rec_mbY8x8[j], MB_BLOCK_SIZE * sizeof(imgpel));   
      }
    }
  }
  else
  {
    currMB->b8mode[0]   = tr4x4[QPcount].part8x8mode[0];
    currMB->b8mode[1]   = tr4x4[QPcount].part8x8mode[1];
    currMB->b8mode[2]   = tr4x4[QPcount].part8x8mode[2];
    currMB->b8mode[3]   = tr4x4[QPcount].part8x8mode[3];

    currMB->b8pdir[0]   = tr4x4[QPcount].part8x8pdir[0];
    currMB->b8pdir[1]   = tr4x4[QPcount].part8x8pdir[1];
    currMB->b8pdir[2]   = tr4x4[QPcount].part8x8pdir[2];
    currMB->b8pdir[3]   = tr4x4[QPcount].part8x8pdir[3];

    if (bframe)
    {
      for (j = 0;j<4;j++)
        for (i = 0;i<4;i++)
        {
          k = 2*(j >> 1)+(i >> 1);
          l = 2*(j & 0x01)+(i & 0x01);
          enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x+i] = ((currMB->b8pdir[k] & 0x01) == 0) ? tr4x4[QPcount].part8x8fwref[k] : - 1;
          enc_picture->ref_idx[LIST_1][img->block_y+j][img->block_x+i] = (currMB->b8pdir[k] > 0) ? tr4x4[QPcount].part8x8bwref[k] : - 1;
        }
    }
    else
    {
      for (j = 0;j<4;j++)
        for (i = 0;i<4;i++)
        {
          k = 2*(j >> 1)+(i >> 1);
          l = 2*(j & 0x01)+(i & 0x01);
          enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x+i] = tr4x4[QPcount].part8x8fwref[k];
        }
    }

    for (j = img->block_y;j<img->block_y + BLOCK_MULTIPLE;j++)
    {
      for (i = img->block_x;i<img->block_x + BLOCK_MULTIPLE;i++)
      {
        cur_ref[LIST_0] = (int) enc_picture->ref_idx[LIST_0][j][i];

        enc_picture->ref_pic_id [LIST_0][j][i] =(cur_ref[LIST_0]>=0 
          ? enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][cur_ref[LIST_0]]
        : -1);
      }
    }

    if (bframe)
    {
      for (j = img->block_y; j < img->block_y + BLOCK_MULTIPLE; j++)
      {
        for (i = img->block_x;i<img->block_x + BLOCK_MULTIPLE;i++)
        {
          cur_ref[LIST_1] = (int) enc_picture->ref_idx[LIST_1][j][i];

          enc_picture->ref_pic_id [LIST_1][j][i] = (cur_ref[LIST_1]>=0 
            ? enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][cur_ref[LIST_1]]
          : -1);
        }
      }
    }

    //====== set the mv's for 8x8 partition with transform size 4x4 ======
    //set new mv data for 4x4 transform
    RestoreMV8x8(1, QPcount);

    //==== motion vectors =====
    SetMotionVectorsMB (currMB, bframe);
    //============= get pre-calculated data ==============
    //---------------------------------------------------
    //--- restore coefficients ---
    for (block = 0; block<4+img->num_blk8x8_uv; block++)
    {
      for (k = 0; k<4; k++)
        for (j = 0; j<2; j++)
          memcpy (img->cofAC[block][k][j],tr4x4[QPcount].cofAC8x8[block][k][j], 65 * sizeof(int));            
    }

    if (tr4x4[QPcount].cnt_nonz_8x8<=5 && ((img->qp + img->bitdepth_luma_qp_scale)!=0 || img->lossless_qpprime_flag==0))
    {
      currMB->cbp     = 0;
      currMB->cbp_blk = 0;
      for (j = 0; j < MB_BLOCK_SIZE; j++)
      {
        memcpy (&enc_picture->imgY[img->pix_y+j][img->pix_x],tr4x4[QPcount].mpr8x8[j], MB_BLOCK_SIZE * sizeof(imgpel));            
      }
    }
    else
    {
      currMB->cbp     = tr4x4[QPcount].cbp8x8;     //     cbp8x8;
      currMB->cbp_blk = tr4x4[QPcount].cbp_blk8x8; //     cbp_blk8x8;
      for (j = 0; j < MB_BLOCK_SIZE; j++)
      {
        memcpy (&enc_picture->imgY[img->pix_y+j][img->pix_x],tr4x4[QPcount].rec_mbY8x8[j], MB_BLOCK_SIZE * sizeof(imgpel));            
      }
    }
  }
}


/*!
*************************************************************************************
* \brief
*    Sets motion vectors for a macroblock
*************************************************************************************
*/
void SetMotionVectorsMB (Macroblock* currMB, int bframe)
{
  int i, j, k, l, mode8, pdir8, ref, by, bx;
  short ******all_mv  = img->all_mv;
  int  bw_ref;
  int jdiv, jmod;

  if (!bframe)
  {
    for (j = 0; j<4; j++)
    {
      jmod = j & 0x01;
      jdiv = j >>   1;
      by    = img->block_y+j;
      for (i = 0; i<4; i++)
      {
        mode8 = currMB->b8mode[k=2*jdiv+(i>>1)];
        l     = 2*jmod + (i & 0x01);

        bx   = img->block_x+i;

        pdir8 = currMB->b8pdir[k];
        ref    = enc_picture->ref_idx[LIST_0][by][bx];

        if (pdir8>=0) 
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];
        }
        else
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;
        }
      }
    }
  }
  else
  {
    for (j = 0; j<4; j++)
    {
      jmod = j & 0x01;
      jdiv = j >>   1;
      by    = img->block_y+j;
      for (i = 0; i<4; i++)
      {
        mode8 = currMB->b8mode[k=2*jdiv+(i>>1)];
        l     = 2*jmod + (i & 0x01);

        bx    = img->block_x+i;

        pdir8 = currMB->b8pdir[k];
        ref    = enc_picture->ref_idx[LIST_0][by][bx];
        bw_ref = enc_picture->ref_idx[LIST_1][by][bx];

        if (currMB->bi_pred_me && (pdir8 == 2) && currMB->mb_type==1)
        {
          all_mv  = currMB->bi_pred_me == 1 ? img->bipred_mv1 : img->bipred_mv2;
          ref = 0;
          bw_ref = 0;
        }

        if (pdir8==-1) // intra
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;
          enc_picture->mv[LIST_1][by][bx][0] = 0;
          enc_picture->mv[LIST_1][by][bx][1] = 0;
        }
        else if (pdir8==0) // list 0
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];
          enc_picture->mv[LIST_1][by][bx][0] = 0;
          enc_picture->mv[LIST_1][by][bx][1] = 0;
          enc_picture->ref_idx[LIST_1][by][bx] = -1;
        }
        else if (pdir8==1) // list 1
        {
          enc_picture->mv[LIST_0][by][bx][0] = 0;
          enc_picture->mv[LIST_0][by][bx][1] = 0;          
          enc_picture->ref_idx[LIST_0][by][bx] = -1;
          enc_picture->mv[LIST_1][by][bx][0] = all_mv [j][i][LIST_1][bw_ref][mode8][0];
          enc_picture->mv[LIST_1][by][bx][1] = all_mv [j][i][LIST_1][bw_ref][mode8][1];
        }
        else if (pdir8==2) // bipredictive
        {
          enc_picture->mv[LIST_0][by][bx][0] = all_mv [j][i][LIST_0][ ref][mode8][0];
          enc_picture->mv[LIST_0][by][bx][1] = all_mv [j][i][LIST_0][ ref][mode8][1];                   
          enc_picture->mv[LIST_1][by][bx][0] = all_mv [j][i][LIST_1][bw_ref][mode8][0];
          enc_picture->mv[LIST_1][by][bx][1] = all_mv [j][i][LIST_1][bw_ref][mode8][1];
        }
        else
        {
          error("invalid direction mode", 255);
        }

      }
    }
  }
}



/*!
*************************************************************************************
* \brief
*    R-D Cost for a macroblock
*************************************************************************************
*/
int RDCost_for_macroblocks (double   lambda,       // <-- lagrange multiplier
                            int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
                            int      *mode_idx,
                            double*  min_rdcost,   // <-> minimum rate-distortion cost
                            double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
                            int i16mode,
                            short QPcount)
{

  int         i, j; 
  int         rate = 0, coeff_rate = 0;
  int64       distortion = 0;
  double      rdcost;
  Macroblock  *currMB   = &img->mb_data[img->current_mb_nr];
  //  Macroblock  *prevMB   = img->current_mb_nr ? &img->mb_data[img->current_mb_nr-1] : NULL;
  int         bframe    = (img->type==B_SLICE);
  int         dummy;
  int         cr_cbp = 0;
  int      return_val = 0;

#ifdef MV_COMPETITION
  short iter, nbiter;
  short ******all_mv = img->all_mv;
#endif

  //=====
  //=====  SET REFERENCE FRAMES AND BLOCK MODES
  //=====
#ifdef GEOM //arbitrary     
  if(currMB->geo_mode >= 0)
    currMB->mb_type = mode;
  else
#endif
    SetModesAndRefframeForBlocks (mode);

#ifdef MV_COMPETITION
  if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
    nbiter = mv_comp.nb_mode_for_skip + 1;
  else
    nbiter = 1;

  // Let's iterate on each possible mode for the skip
  for (iter= 0; iter < nbiter; iter++)
  {
    if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))  
    {
      distortion = 0;
      coeff_rate = 0;
      rate = 0;
      cr_cbp = 0;
    }

#endif

    //=====
    //=====  GET COEFFICIENTS, RECONSTRUCTIONS, CBP
    //=====
    if (bframe && mode==0)
    {
      int block_x=img->pix_x>>2;
      int block_y=img->pix_y>>2;    
      for (j = block_y;j< block_y + 4;j++)
        for (i = block_x;i<block_x + 4;i++)
          if (direct_pdir[j][i] < 0)
            return 0;
    }

#ifdef MV_COMPETITION
    if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
    {
      // The last iteration consist of re-launching with the bestmode,
      // to set needed variables for the encoder
      if (iter == (nbiter - 1))
        mv_comp.current_predictor_for_skip = currMB->best_predictor_for_skip;
      else
      {
        mv_comp.current_predictor_for_skip = iter;
        if ((mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][0] == NOT_AVAILABLE) || (mv_comp.mv_pred_skip[mv_comp.current_predictor_for_skip][1] == NOT_AVAILABLE))
        {
          continue;
        }
      }

      LumaResidualCoding (0, 0, mode, *mode_idx);
      if (img->yuv_format!=YUV400)
        ChromaResidualCoding (0, 0, mode, *mode_idx, &dummy);
    }
    else //if((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
    {
#endif
#ifdef GEOM
      if(currMB->geo_mode != -1)
      {
        LumaResidualCoding_geo (0, 0, currMB->geo_mode, *mode_idx, 0);

      }
      else
#endif
        if (mode<P8x8)
        {
          LumaResidualCoding (0, 0, mode, *mode_idx);
        }
        else if (mode==P8x8)
        {
          SetCoeffAndReconstruction8x8 (currMB, QPcount);
        }
        else if (mode==I4MB)
        {
#if defined RDO_Q
          if(input->UseRDO_Q) 
          {
            if (currMB->c_ipred_mode == DC_PRED_8)    //only store during 1st chroma Pred, for other chroma Pred restore it.
              currMB->cbp = Mode_Decision_for_Intra4x4Macroblock (lambda, &dummy);
            set_I4MB_parameters();
          }
          else
#endif
            currMB->cbp = Mode_Decision_for_Intra4x4Macroblock (lambda, &dummy);
        }
        else if (mode == I16MB)
        {

#if defined RDO_Q
          if(input->UseRDO_Q)
          {
            //only store during 1st chroma Pred, for other chroma Pred restore it.
            if (currMB->c_ipred_mode == DC_PRED_8)
            {
#ifdef USE_INTRA_MDDT         
              if(input->UseIntraMDDT)
                Intra16x16_Mode_Decision_RDopt(currMB, &i16mode, lambda);
              else
#endif
                Intra16x16_Mode_Decision(currMB, &i16mode);
            }
            set_I16MB_parameters(&i16mode);
          }
          else
#endif
          {
#ifdef USE_INTRA_MDDT        
            if(input->UseIntraMDDT)
              Intra16x16_Mode_Decision_RDopt(currMB, &i16mode, lambda);
            else
#endif
              Intra16x16_Mode_Decision(currMB, &i16mode);
          }
        }
        else if (mode==I8MB)
        {
#if defined RDO_Q
          if(input->UseRDO_Q) //speed up intra coding in RDOQ for MB size 16x16, not for 32x32 or higher
          {
            //only store during 1st chroma Pred, for other chroma Pred restore it.
            if (currMB->c_ipred_mode == DC_PRED_8)
              currMB->cbp = Mode_Decision_for_new_Intra8x8Macroblock(lambda, &dummy);    
            set_I8MB_parameters();
          }
          else
#endif
            currMB->cbp = Mode_Decision_for_new_Intra8x8Macroblock(lambda, &dummy);
        }

#if defined RDO_Q
        if(input->UseRDO_Q)
        {
          if(1)
          { 
            img->i16offset = 0;
            dummy = 0;
            if (img->yuv_format!=YUV400)
            {
#ifdef GEOM
              if(currMB->geo_mode != -1)
              {
                ChromaResidualCoding_geo (0, 0, currMB->geo_mode, *mode_idx, 0);
              }
              else
#endif
                ChromaResidualCoding (0, 0 , mode, *mode_idx, &dummy);
            }

            if (mode==I16MB)     
              img->i16offset = I16Offset  (currMB->cbp, i16mode);

            if(IS_INTER_SLICE(img->type) && IS_INTRA_MODE(mode))
              store_macroblock_parameters_intra(mode); 
          }
        }
        else
#endif
        {
          img->i16offset = 0;
          dummy = 0;
          if (img->yuv_format!=YUV400)
          {
#ifdef GEOM
            if(currMB->geo_mode != -1)
              ChromaResidualCoding_geo (0, 0 , currMB->geo_mode, *mode_idx, 0);
            else
#endif         
              ChromaResidualCoding (0, 0 , mode, *mode_idx, &dummy);
          }
          if (mode==I16MB)     
            img->i16offset = I16Offset  (currMB->cbp, i16mode);
        }


#ifdef MV_COMPETITION
    }  //else end //if((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
#endif

    {    
      //=====   GET DISTORTION
      distortion += compute_SSE(imgY_org, enc_picture->imgY, img->opix_y, img->pix_y, img->opix_x, img->opix_x, MB_BLOCK_SIZE, MB_BLOCK_SIZE);
      distortion += compute_SSE(imgUV_org[0], enc_picture->imgUV[0], img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);
      distortion += compute_SSE(imgUV_org[1], enc_picture->imgUV[1], img->opix_c_y, img->pix_c_y, img->opix_c_x, img->opix_c_x, img->mb_cr_size_y, img->mb_cr_size_x);

      if (distortion > *min_rdcost)
        rdcost = (double)distortion;
      else
      {
        //=====   S T O R E   C O D I N G   S T A T E   =====
        //---------------------------------------------------
        store_coding_state (cs_cm);

        //=====   GET RATE
        rate = writeMBLayer (1, &coeff_rate);

        //=====   R E S T O R E   C O D I N G   S T A T E   =====
        //-------------------------------------------------------
        reset_coding_state (cs_cm);

        rdcost = (double)distortion + lambda * max(0.5,(double)rate);
      }
    }  

    if (rdcost < *min_rdcost)
    {                
      //=====   U P D A T E   M I N I M U M   C O S T   =====
      //-----------------------------------------------------
      *min_rdcost = rdcost;
      *min_rate = lambda * (double)coeff_rate;

#ifdef MV_COMPETITION      
      if ((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE))
      {
        int by, bx;

        currMB->best_predictor_for_skip = mv_comp.current_predictor_for_skip;

        for (by = 0;by < 4;by++)
          for (bx = 0;bx < 4;bx++)
          {
            all_mv [by][bx][0][0][0][0] = mv_comp.mv_pred_skip[currMB->best_predictor_for_skip][0];
            all_mv [by][bx][0][0][0][1] = mv_comp.mv_pred_skip[currMB->best_predictor_for_skip][1];
          }
      }
#endif
      return_val = 1;
    }
    else 
    {
#ifdef MV_COMPETITION
      if (!((input->mv_competition > 0) && (mode == 0) && (img->type==P_SLICE)))
      {
#endif
#if FASTMODE
        // Reordering RDCost comparison order of mode 0 and mode 1 in P_SLICE
        // if RDcost of mode 0 and mode 1 is same, we choose best_mode is 0
        // This might not always be good since mode 0 is more biased towards rate than quality.
        if((img->type!=P_SLICE || mode != 0 || rdcost != *min_rdcost) || input->ProfileIDC>=FREXT_HP)
#endif
          return_val = 0;
#ifdef MV_COMPETITION
      }
#endif
    }

#ifdef MV_COMPETITION
  }  //for (iter= 0; iter < nbiter; iter++)
#endif 

  return (return_val);
}

#ifdef RDO_Q
/*!
****************************************************************************
* \brief
*    save encoding information for intra MB
****************************************************************************
*/
void store_macroblock_parameters_intra (int mode)
{
  int        i, j, k;
  int        num_blk8x8 = 4 + img->num_blk8x8_uv;
  Macroblock *currMB  = &img->mb_data[img->current_mb_nr];
  //																		  I4 I16	    I8  PCM
  int        intra_mode_mapping_table[] = {-1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 1, -1, -1, 2, 3};
  int        luma_mode = intra_mode_mapping_table[mode];
  int        chroma_mode = currMB->c_ipred_mode; 

  assert(luma_mode != -1);

  if(currMB->mb_type == I8MB)
  {
    for(j = 0; j < BLOCK_MULTIPLE; j++)
    {
      //memcpy(b8_ipredmode8x8_intra[luma_mode][chroma_mode][j], &img->ipredmode[img->block_y+j][img->block_x],BLOCK_MULTIPLE * sizeof(char));
      memcpy(b8_ipredmode8x8_intra[luma_mode][chroma_mode][j], &img->ipredmode8x8[img->block_y+j][img->block_x], BLOCK_MULTIPLE * sizeof(char));
    }
    memcpy(b8_ipredmode8x8_mb_intra[luma_mode][chroma_mode], currMB->intra_pred_modes8x8, BLOCK_MULTIPLE*BLOCK_MULTIPLE*sizeof(char));
  }
  else if (currMB->mb_type == I4MB)
  {
    for(j = 0; j < BLOCK_MULTIPLE; j++)
      memcpy(&b4_ipredmode_intra[luma_mode][chroma_mode][BLOCK_MULTIPLE * j], &img->ipredmode[img->block_y + j][img->block_x],BLOCK_MULTIPLE * sizeof(char));
    memcpy(b4_ipredmode_mb_intra[luma_mode][chroma_mode], currMB->intra_pred_modes, BLOCK_MULTIPLE*BLOCK_MULTIPLE*sizeof(char));
  }

  //--- reconstructed blocks ----
  for (j = 0; j < MB_BLOCK_SIZE; j++)
  {
    memcpy(rec_mbY_intra[luma_mode][chroma_mode][j],&enc_picture->imgY[img->pix_y+j][img->pix_x], MB_BLOCK_SIZE * sizeof(imgpel));
  }
  if (img->yuv_format != YUV400)
  {
    for (j = 0; j<img->mb_cr_size_y; j++)
    {
      memcpy(rec_mbU_intra[luma_mode][chroma_mode][j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
      memcpy(rec_mbV_intra[luma_mode][chroma_mode][j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
    }
  }


  //--- coeff, cbp, kac ---
  for(i = 0; i < num_blk8x8; i++)
    for(j = 0; j < 4; j++)
      for(k = 0; k < 2; k++)
        memcpy(cofAC_intra[luma_mode][chroma_mode][i][j][k], img->cofAC[i][j][k], sizeof(int)*65);

  for(i = 0; i < 3; i++)
    for(j = 0; j < 2; j++)
      memcpy(cofDC_intra[luma_mode][chroma_mode][i][j], img->cofDC[i][j], sizeof(int)*65);

  cbp_intra[luma_mode][chroma_mode]     = currMB->cbp;
  cbp_blk_intra[luma_mode][chroma_mode] = currMB->cbp_blk;
  i16offset_intra[luma_mode][chroma_mode] = img->i16offset;
}

/*!
****************************************************************************
* \brief
*    save/assign encoding information for Intra4x4 MB
****************************************************************************
*/
void set_I4MB_parameters()
{
  Macroblock  *currMB   = &img->mb_data[img->current_mb_nr];
  int *src1, *dest1;
  imgpel *src2, *dest2, *src3, *dest3;
  int b8, b4,j, y;

  for (b8=0; b8<4; b8++)
  {
    for (b4=0; b4<4; b4++)
    {
      for (j=0; j<2; j++)    
      {
        if (currMB->c_ipred_mode == DC_PRED_8)
        {
          src1 = img->cofAC[b8][b4][j];
          dest1 = saved_cofAC[b8][b4][j];
        }
        else
        {
          dest1 = img->cofAC[b8][b4][j];
          src1 = saved_cofAC[b8][b4][j];
        }
        memcpy (dest1, src1, 18 * sizeof(int));
      }
    }
  }

  for (y=0; y<MB_BLOCK_SIZE; y++)
  {                
    if (currMB->c_ipred_mode == DC_PRED_8)
    {
      src2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      dest2 = &saved_enc_picture_imgY[y][0];
      src3 = &img->mpr[y][0];
      dest3 = &saved_img_mpr[y][0];
    }
    else
    {
      dest2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      src2 = &saved_enc_picture_imgY[y][0];
      dest3 = &img->mpr[y][0];
      src3 = &saved_img_mpr[y][0];
    }

    memcpy (dest2, src2, MB_BLOCK_SIZE * sizeof(imgpel));                
    memcpy (dest3, src3, MB_BLOCK_SIZE * sizeof(imgpel)); 
  }

  if(currMB->c_ipred_mode == DC_PRED_8)
  {
    saved_cbp = currMB->cbp;
  }
  else
  {
    currMB->cbp = saved_cbp;
  }
}

/*!
****************************************************************************
* \brief
*    save/assign encoding information for Intra16x16 MB
****************************************************************************
*/
void set_I16MB_parameters(int *i16mode)
{
  Macroblock  *currMB   = &img->mb_data[img->current_mb_nr];
  int *src1, *dest1;
  imgpel *src2, *dest2;
  int b8, b4,j, y;

  for (b8=0; b8<4; b8++)
  {
    for (b4=0; b4<4; b4++)
    {
      for (j=0; j<2; j++)    
      {
        if (currMB->c_ipred_mode == DC_PRED_8){
          src1 = img->cofAC[b8][b4][j];
          dest1 = saved_I16cofAC[b8][b4][j];
        }
        else
        {
          dest1 = img->cofAC[b8][b4][j];
          src1 = saved_I16cofAC[b8][b4][j];
        }
        memcpy (dest1, src1, 18 * sizeof(int));
      }
    }
  }

  for(j=0; j<2; j++)
  {
    if (currMB->c_ipred_mode == DC_PRED_8)
    {
      src1 = img->cofDC[0][j];
      dest1 = saved_cofDC[0][j];
    }
    else
    {
      dest1 = img->cofDC[0][j];
      src1 = saved_cofDC[0][j];
    }
    memcpy(dest1, src1, 18 * sizeof(int));
  }

  for (y=0; y<MB_BLOCK_SIZE; y++){                
    if (currMB->c_ipred_mode == DC_PRED_8){
      src2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      dest2 = &saved_I16enc_picture_imgY[y][0];
    }
    else
    {
      dest2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      src2 = &saved_I16enc_picture_imgY[y][0];
    }
    memcpy (dest2, src2, MB_BLOCK_SIZE * sizeof(imgpel));                
  }

  if(currMB->c_ipred_mode == DC_PRED_8){
    saved_I16cbp = currMB->cbp;
    saved_i16mode = *i16mode;
  }
  else
  {
    currMB->cbp = saved_I16cbp;
    *i16mode = saved_i16mode;
  }
}

/*!
****************************************************************************
* \brief
*    save/assign encoding information for Intra8x8 MB
****************************************************************************
*/
void set_I8MB_parameters()
{
  Macroblock  *currMB   = &img->mb_data[img->current_mb_nr];
  int *src1, *dest1;
  imgpel *src2, *dest2, *src3, *dest3;
  int b8, b4,j, y;

  for (b8=0; b8<4; b8++)
  {
    for (b4=0; b4<4; b4++)
    {
      for (j=0; j<2; j++)    
      {
        if (currMB->c_ipred_mode == DC_PRED_8){
          src1 = img->cofAC[b8][b4][j];
          dest1 = saved_I8cofAC[b8][b4][j];
        }    
        else
        {
          dest1 = img->cofAC[b8][b4][j];
          src1 = saved_I8cofAC[b8][b4][j];
        }
        memcpy (dest1, src1, 65 * sizeof(int));
      }
    }
  }

  for (y=0; y<MB_BLOCK_SIZE; y++){                
    if (currMB->c_ipred_mode == DC_PRED_8){
      src2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      dest2 = &saved_I8enc_picture_imgY[y][0];
      src3 = &img->mpr[y][0];
      dest3 = &saved_I8img_mpr[y][0];
    }
    else
    {
      dest2 = &enc_picture->imgY[img->pix_y+y][img->pix_x];
      src2 = &saved_I8enc_picture_imgY[y][0];
      dest3 = &img->mpr[y][0];
      src3 = &saved_I8img_mpr[y][0];
    }
    memcpy (dest2, src2, MB_BLOCK_SIZE * sizeof(imgpel));                
    memcpy (dest3, src3, MB_BLOCK_SIZE * sizeof(imgpel)); 
  }

  if(currMB->c_ipred_mode == DC_PRED_8){

    saved_I8cbp = currMB->cbp;
  }
  else
  {
    currMB->cbp = saved_I8cbp;
  }
}

#endif

/*!
*************************************************************************************
* \brief
*    Store macroblock parameters
*************************************************************************************
*/
void store_macroblock_parameters (int mode)
{
  int  j, ****i4p, ***i3p;
  Macroblock *currMB  = &img->mb_data[img->current_mb_nr];
  int        bframe   = (img->type==B_SLICE);

  //--- store best mode ---
  best_mode = mode;
  best_c_imode = currMB->c_ipred_mode;
  best_i16offset = img->i16offset;

  // If condition is not really necessary.
  bi_pred_me = (mode == 1) ? currMB->bi_pred_me : 0;  

  memcpy(b8mode, currMB->b8mode, BLOCK_MULTIPLE * sizeof(int));
  memcpy(b8pdir, currMB->b8pdir, BLOCK_MULTIPLE * sizeof(int));

  // Residue Color Transform
  //for (k = 0, j=img->block_y; j<img->block_y+BLOCK_MULTIPLE; j++, k+=BLOCK_MULTIPLE)
  memcpy(b4_intra_pred_modes,currMB->intra_pred_modes, MB_BLOCK_PARTITIONS * sizeof(char));
  memcpy(b8_intra_pred_modes8x8,currMB->intra_pred_modes8x8, MB_BLOCK_PARTITIONS * sizeof(char));
  for (j = 0 ; j<BLOCK_MULTIPLE; j++)
  {
    memcpy(&b4_ipredmode[j * BLOCK_MULTIPLE],&img->ipredmode[img->block_y + j][img->block_x],BLOCK_MULTIPLE * sizeof(char));
    memcpy(b8_ipredmode8x8[j],&img->ipredmode8x8[img->block_y + j][img->block_x],BLOCK_MULTIPLE * sizeof(char));
  }  
  //--- reconstructed blocks ----
  for (j = 0; j < MB_BLOCK_SIZE; j++)
  {
    memcpy(rec_mbY[j],&enc_picture->imgY[img->pix_y+j][img->pix_x], MB_BLOCK_SIZE * sizeof(imgpel));
  }

  if (img->yuv_format != YUV400)
  {
    for (j = 0; j<img->mb_cr_size_y; j++)
    {
      memcpy(rec_mbU[j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
      memcpy(rec_mbV[j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
    }
  }


  //--- coeff, cbp, kac ---
  //lets not make the cbp=0 for mode=0 in Pslice..coz it can be Pdirect also...

  i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
  i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
  cbp     = currMB->cbp;
  cbp_blk = currMB->cbp_blk;

  //--- store transform size ---
  luma_transform_size_8x8_flag = currMB->luma_transform_size_8x8_flag;

  for (j = 0; j<4; j++)
    memcpy(frefframe[j],&enc_picture->ref_idx[LIST_0][img->block_y+j][img->block_x], BLOCK_MULTIPLE * sizeof(char));

  if (bframe)
  {
    for (j = 0; j<4; j++)
      memcpy(brefframe[j],&enc_picture->ref_idx[LIST_1][img->block_y+j][img->block_x], BLOCK_MULTIPLE * sizeof(char));
  }  


#ifdef USE_INTRA_MDDT
  if(input->UseIntraMDDT)
  {
    memcpy(bestCofAC16[0], img->cofAC16[0], sizeof(int)*16*17);
    memcpy(bestCofAC16[1], img->cofAC16[1], sizeof(int)*16*17);
  }
#endif 

  memcpy(bestCofAC16x16[0],    img->cofAC16x16[0],    sizeof(int)*257);
  memcpy(bestCofAC16x16[1],    img->cofAC16x16[1],    sizeof(int)*257);
  memcpy(bestCofAC16x8 [0][0], img->cofAC16x8 [0][0], sizeof(int)*129);
  memcpy(bestCofAC16x8 [0][1], img->cofAC16x8 [0][1], sizeof(int)*129);
  memcpy(bestCofAC16x8 [1][0], img->cofAC16x8 [1][0], sizeof(int)*129);
  memcpy(bestCofAC16x8 [1][1], img->cofAC16x8 [1][1], sizeof(int)*129);
  memcpy(bestCofAC8x16 [0][0], img->cofAC8x16 [0][0], sizeof(int)*129);
  memcpy(bestCofAC8x16 [0][1], img->cofAC8x16 [0][1], sizeof(int)*129);
  memcpy(bestCofAC8x16 [1][0], img->cofAC8x16 [1][0], sizeof(int)*129);
  memcpy(bestCofAC8x16 [1][1], img->cofAC8x16 [1][1], sizeof(int)*129);
}


/*!
*************************************************************************************
* \brief
*    Set stored macroblock parameters
*************************************************************************************
*/
void set_stored_macroblock_parameters (short bestQPcount)
{
  int  i, j, k, ****i4p, ***i3p;
  Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];
  int         mode     = best_mode;
  int         bframe   = (img->type==B_SLICE);
  //  char    **ipredmodes = img->ipredmode;

  imgpel        **imgY  = enc_picture->imgY;
  imgpel       ***imgUV = enc_picture->imgUV;
  int        block_x, block_y;  
  short   *cur_mv;

  //===== reconstruction values =====
  for (j = 0; j < MB_BLOCK_SIZE; j++)
  {
    memcpy(&imgY[img->pix_y+j][img->pix_x],rec_mbY[j], MB_BLOCK_SIZE * sizeof(imgpel));
  }

  if (img->yuv_format != YUV400)
  {
    for (j = 0; j<img->mb_cr_size_y; j++)
    {
      memcpy(&imgUV[0][img->pix_c_y+j][img->pix_c_x],rec_mbU[j], img->mb_cr_size_x * sizeof(imgpel));
      memcpy(&imgUV[1][img->pix_c_y+j][img->pix_c_x],rec_mbV[j], img->mb_cr_size_x * sizeof(imgpel));
    }
  }

  //===== coefficients and cbp =====
  i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
  i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
  currMB->cbp      = cbp;
  currMB->cbp_blk = cbp_blk;
  //==== macroblock type ====
  currMB->mb_type = mode;

  memcpy(currMB->b8mode,b8mode, BLOCK_MULTIPLE * sizeof(int));
  memcpy(currMB->b8pdir,b8pdir, BLOCK_MULTIPLE * sizeof(int));

  currMB->bi_pred_me = currMB->mb_type == 1 ? bi_pred_me : 0;  

  if (mode == P8x8 && input->Transform8x8Mode)
  {
    RestoreMV8x8(!luma_transform_size_8x8_flag , bestQPcount);       //1  = restore 4x4 mvs and 0 =  restore 8x8 mvs
  }

  //==== transform size flag ====
  if (((currMB->cbp & 15) == 0) && !(currMB->mb_type == I4MB || currMB->mb_type == I8MB))
    currMB->luma_transform_size_8x8_flag = 0;
  else
    currMB->luma_transform_size_8x8_flag = luma_transform_size_8x8_flag;

  rdopt->luma_transform_size_8x8_flag  = currMB->luma_transform_size_8x8_flag;

  //==== reference frames =====
  for (j = 0; j < 4; j++)
  {
    block_y = img->block_y + j;
    for (i = 0; i < 4; i++)
    {
      block_x = img->block_x + i;
      k = 2*(j >> 1)+(i >> 1);

      // backward prediction or intra
      if ((currMB->b8pdir[k] == 1) || IS_INTRA(currMB))
      {
        enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
        enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;          
        enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
        enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;
      }
      else
      {
        if (currMB->bi_pred_me && (currMB->b8pdir[k] == 2) && currMB->mb_type==1)
        {
          cur_mv = currMB->bi_pred_me == 1 
            ? img->bipred_mv1[j][i][LIST_0][0][currMB->b8mode[k]] 
          : img->bipred_mv2[j][i][LIST_0][0][currMB->b8mode[k]];

          enc_picture->ref_idx    [LIST_0][block_y][block_x] = 0;                         
          enc_picture->ref_pic_id [LIST_0][block_y][block_x] = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][0];
          enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
        }
        else
        {
          cur_mv = img->all_mv[j][i][LIST_0][(short)frefframe[j][i]][currMB->b8mode[k]];

          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = frefframe[j][i];
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][(short)frefframe[j][i]];
          enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
          enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
        }
      }

      // forward prediction or intra
      if ((currMB->b8pdir[k] == 0) || IS_INTRA(currMB))
      {
        enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
        enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
        enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
        enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
      }
    }
  }

  if (bframe)
  {
    for (j=0; j<4; j++)
    {
      block_y = img->block_y + j;
      for (i=0; i<4; i++)
      {          
        block_x = img->block_x + i;
        k = 2*(j >> 1)+(i >> 1);

        // forward
        if (IS_INTRA(currMB)||(currMB->b8pdir[k] == 0))
        {
          enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
        }
        else
        {
          if (currMB->bi_pred_me && (currMB->b8pdir[k] == 2) && currMB->mb_type==1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_1][0][currMB->b8mode[k]] 
            : img->bipred_mv2[j][i][LIST_1][0][currMB->b8mode[k]];

            enc_picture->ref_idx    [LIST_1][block_y][block_x] = 0; 
            enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][0];
            enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];        
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_1][(short)brefframe[j][i]][currMB->b8mode[k]];

            enc_picture->ref_idx    [LIST_1][block_y][block_x] = brefframe[j][i];
            enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][(short)brefframe[j][i]];
            enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];
          }
        }
      }
    }
  }

  //==== intra prediction modes ====
  currMB->c_ipred_mode = best_c_imode;
  img->i16offset = best_i16offset;

  if(currMB->mb_type == I8MB)
  {
    memcpy(currMB->intra_pred_modes8x8,b8_intra_pred_modes8x8, MB_BLOCK_PARTITIONS * sizeof(char));            
    memcpy(currMB->intra_pred_modes   ,b8_intra_pred_modes8x8, MB_BLOCK_PARTITIONS * sizeof(char));            
    for(j = 0; j < BLOCK_MULTIPLE; j++)
    {
      memcpy(&img->ipredmode   [img->block_y+j][img->block_x], b8_ipredmode8x8[j], BLOCK_MULTIPLE * sizeof(char));
      memcpy(&img->ipredmode8x8[img->block_y+j][img->block_x], b8_ipredmode8x8[j], BLOCK_MULTIPLE * sizeof(char));
    }
  }
  else if (mode!=I4MB && mode!=I8MB)
  {
    memset(currMB->intra_pred_modes,DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char));
    for(j = img->block_y; j < img->block_y + BLOCK_MULTIPLE; j++)
      memset(&img->ipredmode[j][img->block_x], DC_PRED, BLOCK_MULTIPLE * sizeof(char));
  }
  // Residue Color Transform
  else if (mode == I4MB)
  {
    memcpy(currMB->intra_pred_modes,b4_intra_pred_modes, MB_BLOCK_PARTITIONS * sizeof(char));
    for(j = 0; j < BLOCK_MULTIPLE; j++)
      memcpy(&img->ipredmode[img->block_y + j][img->block_x],&b4_ipredmode[BLOCK_MULTIPLE * j], BLOCK_MULTIPLE * sizeof(char));
  }

  //==== motion vectors =====
  //SetMotionVectorsMB (currMB, bframe);

#ifdef USE_INTRA_MDDT
  if(input->UseIntraMDDT)
  {
    memcpy(img->cofAC16[0], bestCofAC16[0], sizeof(int)*16*17);
    memcpy(img->cofAC16[1], bestCofAC16[1], sizeof(int)*16*17);
  }
#endif 

  memcpy(img->cofAC16x16[0],    bestCofAC16x16[0],    sizeof(int)*257);
  memcpy(img->cofAC16x16[1],    bestCofAC16x16[1],    sizeof(int)*257);
  memcpy(img->cofAC16x8 [0][0], bestCofAC16x8 [0][0], sizeof(int)*129);
  memcpy(img->cofAC16x8 [0][1], bestCofAC16x8 [0][1], sizeof(int)*129);
  memcpy(img->cofAC16x8 [1][0], bestCofAC16x8 [1][0], sizeof(int)*129);
  memcpy(img->cofAC16x8 [1][1], bestCofAC16x8 [1][1], sizeof(int)*129);
  memcpy(img->cofAC8x16 [0][0], bestCofAC8x16 [0][0], sizeof(int)*129);
  memcpy(img->cofAC8x16 [0][1], bestCofAC8x16 [0][1], sizeof(int)*129);
  memcpy(img->cofAC8x16 [1][0], bestCofAC8x16 [1][0], sizeof(int)*129);
  memcpy(img->cofAC8x16 [1][1], bestCofAC8x16 [1][1], sizeof(int)*129);
}



/*!
*************************************************************************************
* \brief
*    Set reference frames and motion vectors
*************************************************************************************
*/
void SetRefAndMotionVectors (int block, int mode, int pdir, int fwref, int bwref)
{
  int     i, j=0;
  int     bslice  = (img->type==B_SLICE);
  int     pmode   = (mode==1||mode==2||mode==3?mode:4);
  int     j0      = ((block >> 1)<<1);
  int     i0      = ((block & 0x01)<<1);
  int     j1      = j0 + (input->part_size[pmode][1]);
  int     i1      = i0 + (input->part_size[pmode][0]);
  int     block_x, block_y;
  short   *cur_mv;
  Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];

  if (pdir<0)
  {
    for (j = img->block_y + j0; j < img->block_y + j1; j++)
    {
      for (i=img->block_x + i0; i<img->block_x +i1; i++)
      {
        enc_picture->ref_pic_id[LIST_0][j][i] = -1;
        enc_picture->ref_pic_id[LIST_1][j][i] = -1;
      }
      memset(&enc_picture->ref_idx[LIST_0][j][img->block_x + i0], -1, (input->part_size[pmode][0]) * sizeof(char));
      memset(&enc_picture->ref_idx[LIST_1][j][img->block_x + i0], -1, (input->part_size[pmode][0]) * sizeof(char));
      memset(enc_picture->mv[LIST_0][j][img->block_x + i0], 0, 2*(input->part_size[pmode][0]) * sizeof(short));
      memset(enc_picture->mv[LIST_1][j][img->block_x + i0], 0, 2*(input->part_size[pmode][0]) * sizeof(short));
    }
    return;
  }

  if (!bslice)
  {
    for (j=j0; j<j1; j++)
    {
      block_y = img->block_y + j;
      memset(&enc_picture->ref_idx   [LIST_0][block_y][img->block_x + i0], fwref, (input->part_size[pmode][0]) * sizeof(char));
      for (i=i0; i<i1; i++)
      {
        block_x = img->block_x + i;        
        cur_mv = img->all_mv[j][i][LIST_0][fwref][mode];                
        enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
        enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
        enc_picture->ref_pic_id[LIST_0][block_y][block_x] = enc_picture->ref_pic_num[LIST_0+currMB->list_offset][fwref];
      }
    }
    return;
  }
  else
  {
    for (j=j0; j<j1; j++)
    {
      block_y = img->block_y + j;
      for (i=i0; i<i1; i++)
      {
        block_x = img->block_x + i;
        if (mode==0)
        {
          pdir  = direct_pdir[block_y][block_x];
          fwref = direct_ref_idx[LIST_0][block_y][block_x];
          bwref = direct_ref_idx[LIST_1][block_y][block_x];
        }

        if ((pdir==0 || pdir==2))
        {
          if (currMB->bi_pred_me && (pdir == 2) && mode == 1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_0][0][mode]
            : img->bipred_mv2[j][i][LIST_0][0][mode];

            enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_0][block_y][block_x]    = 0;            
            enc_picture->ref_pic_id[LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0+currMB->list_offset][0];
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_0][fwref][mode];

            enc_picture->mv        [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_0][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_0][block_y][block_x] = fwref;
            enc_picture->ref_pic_id[LIST_0][block_y][block_x] = 
              enc_picture->ref_pic_num[LIST_0+currMB->list_offset][(short)enc_picture->ref_idx[LIST_0][block_y][block_x]];
          }
        }
        else
        {
          enc_picture->mv        [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv        [LIST_0][block_y][block_x][1] = 0;
          enc_picture->ref_idx   [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id[LIST_0][block_y][block_x]    = -1;
        }

        if ((pdir==1 || pdir==2))
        {
          if (currMB->bi_pred_me && (pdir == 2) && mode == 1)
          {
            cur_mv = currMB->bi_pred_me == 1 
              ? img->bipred_mv1[j][i][LIST_1][0][mode]
            : img->bipred_mv2[j][i][LIST_1][0][mode];

            enc_picture->mv        [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_1][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_1][block_y][block_x]    = 0;            
            enc_picture->ref_pic_id[LIST_1][block_y][block_x]    = enc_picture->ref_pic_num[LIST_1+currMB->list_offset][0];
          }
          else
          {
            cur_mv = img->all_mv[j][i][LIST_1][bwref][mode];

            enc_picture->mv        [LIST_1][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv        [LIST_1][block_y][block_x][1] = cur_mv[1];
            enc_picture->ref_idx   [LIST_1][block_y][block_x] = bwref;
            enc_picture->ref_pic_id[LIST_1][block_y][block_x] = 
              enc_picture->ref_pic_num[LIST_1+currMB->list_offset][(short)enc_picture->ref_idx[LIST_1][block_y][block_x]];
          }
        }
        else
        {
          enc_picture->mv        [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv        [LIST_1][block_y][block_x][1] = 0;
          enc_picture->ref_idx   [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id[LIST_1][block_y][block_x]    = -1;
        }
      }
    }
  }
}

/*!
*************************************************************************************
* \brief
*    Restore motion vectors for 8x8 partition
*************************************************************************************
*/
void RestoreMVBlock8x8(int dir, int block8x8, RD_8x8DATA tr, int bframe)
{
  int i, j, i0, j0, ii, jj;
  short ******all_mv  = img->all_mv;
  short ******pred_mv = img->pred_mv;
  short pdir8  = tr.part8x8pdir [block8x8];
  short mode   = tr.part8x8mode [block8x8];
  short ref    = tr.part8x8fwref[block8x8];
  short bw_ref = tr.part8x8bwref[block8x8];

  i0 = (block8x8 & 0x01) << 1;
  j0 = (block8x8 >> 1) << 1;
  ii = i0+2;
  jj = j0+2;

  if (!bframe)
  {
    if (pdir8>=0) //(mode8!=IBLOCK)&&(mode8!=I16MB))  // && ref != -1)
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv [j][i][LIST_0][ref][4][0] = all_mv8x8 [dir][LIST_0][j][i][0] ;
          all_mv [j][i][LIST_0][ref][4][1] = all_mv8x8 [dir][LIST_0][j][i][1] ;
          pred_mv[j][i][LIST_0][ref][4][0] = pred_mv8x8[dir][LIST_0][j][i][0];
          pred_mv[j][i][LIST_0][ref][4][1] = pred_mv8x8[dir][LIST_0][j][i][1];
        }
    }
  }
  else
  {
    if (pdir8==0) // forward
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv [j][i][LIST_0][ref][mode][0] = all_mv8x8 [dir][LIST_0][j][i][0] ;
          all_mv [j][i][LIST_0][ref][mode][1] = all_mv8x8 [dir][LIST_0][j][i][1] ;
          pred_mv[j][i][LIST_0][ref][mode][0] = pred_mv8x8[dir][LIST_0][j][i][0];
          pred_mv[j][i][LIST_0][ref][mode][1] = pred_mv8x8[dir][LIST_0][j][i][1];
        }
    }
    else if (pdir8==1) // backward
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv [j][i][LIST_1][bw_ref][mode][0] = all_mv8x8 [dir][LIST_1][j][i][0] ;
          all_mv [j][i][LIST_1][bw_ref][mode][1] = all_mv8x8 [dir][LIST_1][j][i][1] ;
          pred_mv[j][i][LIST_1][bw_ref][mode][0] = pred_mv8x8[dir][LIST_1][j][i][0];
          pred_mv[j][i][LIST_1][bw_ref][mode][1] = pred_mv8x8[dir][LIST_1][j][i][1];
        }
    }
    else if (pdir8==2) // bidir
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv [j][i][LIST_0][ref][mode][0] = all_mv8x8 [dir][LIST_0][j][i][0] ;
          all_mv [j][i][LIST_0][ref][mode][1] = all_mv8x8 [dir][LIST_0][j][i][1] ;
          pred_mv[j][i][LIST_0][ref][mode][0] = pred_mv8x8[dir][LIST_0][j][i][0];
          pred_mv[j][i][LIST_0][ref][mode][1] = pred_mv8x8[dir][LIST_0][j][i][1];

          all_mv [j][i][LIST_1][bw_ref][mode][0] = all_mv8x8 [dir][LIST_1][j][i][0] ;
          all_mv [j][i][LIST_1][bw_ref][mode][1] = all_mv8x8 [dir][LIST_1][j][i][1] ;
          pred_mv[j][i][LIST_1][bw_ref][mode][0] = pred_mv8x8[dir][LIST_1][j][i][0];
          pred_mv[j][i][LIST_1][bw_ref][mode][1] = pred_mv8x8[dir][LIST_1][j][i][1];
        }
    }
    else
    {
      error("invalid direction mode", 255);
    }
  }
}

/*!
*************************************************************************************
* \brief
*    Restore motion vectors of 8x8 partitions of one macroblock
*************************************************************************************
*/
void RestoreMV8x8(int dir, short QPcount)
{
  int block8x8;

  int bframe = (img->type == B_SLICE);

  for (block8x8=0; block8x8<4; block8x8++)
    RestoreMVBlock8x8(dir, block8x8, tr8x8[QPcount], bframe);   
}


/*!
*************************************************************************************
* \brief
*    Store predictors for 8x8 partition
*************************************************************************************
*/

void StoreNewMotionVectorsBlock8x8(int dir, int block8x8, int mode, int fw_ref, int bw_ref, int pdir8, int bframe)
{
  int i, j, i0, j0, ii, jj;
  short ******all_mv  = img->all_mv;
  short ******pred_mv = img->pred_mv;


  i0 = (block8x8 & 0x01) << 1;
  j0 = (block8x8 >> 1) << 1;
  ii = i0+2;
  jj = j0+2;

  if (pdir8<0)
  {
    for (j=j0; j<jj; j++)
    {
      memset(&all_mv8x8[dir][LIST_0][j][i0], 0, 2 * 2 * sizeof(short));
      memset(&all_mv8x8[dir][LIST_1][j][i0], 0, 2 * 2 * sizeof(short));
    }
    return;
  }

  if (!bframe)
  {
    for (j=j0; j<jj; j++)
    {
      for (i=i0; i<ii; i++)
      {
        all_mv8x8 [dir][LIST_0][j][i][0] = all_mv [j][i][LIST_0][fw_ref][4][0];
        all_mv8x8 [dir][LIST_0][j][i][1] = all_mv [j][i][LIST_0][fw_ref][4][1];
        pred_mv8x8[dir][LIST_0][j][i][0] = pred_mv[j][i][LIST_0][fw_ref][4][0];
        pred_mv8x8[dir][LIST_0][j][i][1] = pred_mv[j][i][LIST_0][fw_ref][4][1];
      }
    }
    return;
  }
  else
  {
    if ((pdir8==0 || pdir8==2))
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv8x8 [dir][LIST_0][j][i][0] = all_mv [j][i][LIST_0][fw_ref][mode][0];
          all_mv8x8 [dir][LIST_0][j][i][1] = all_mv [j][i][LIST_0][fw_ref][mode][1];
          pred_mv8x8[dir][LIST_0][j][i][0] = pred_mv[j][i][LIST_0][fw_ref][mode][0];
          pred_mv8x8[dir][LIST_0][j][i][1] = pred_mv[j][i][LIST_0][fw_ref][mode][1];
        }
    }
    else
    {
      for (j=j0; j<jj; j++)
        memset(&all_mv8x8[dir][LIST_0][j][i0], 0, 2 * 2 * sizeof(short));
    }

    if ((pdir8==1 || pdir8==2))
    {
      for (j=j0; j<jj; j++)
        for (i=i0; i<ii; i++)
        {
          all_mv8x8 [dir][LIST_1][j][i][0] = all_mv [j][i][LIST_1][bw_ref][mode][0];
          all_mv8x8 [dir][LIST_1][j][i][1] = all_mv [j][i][LIST_1][bw_ref][mode][1];
          pred_mv8x8[dir][LIST_1][j][i][0] = pred_mv[j][i][LIST_1][bw_ref][mode][0];
          pred_mv8x8[dir][LIST_1][j][i][1] = pred_mv[j][i][LIST_1][bw_ref][mode][1];
        }
    }
    else
    {
      for (j=j0; j<jj; j++)
        memset(&all_mv8x8[dir][LIST_1][j][i0], 0, 2 * 2 * sizeof(short));
    }
  }
}

/*!
************************************************************************
* \brief
*    restore coding state (for rd-optimized mode decision), used for 8x8 transformation
************************************************************************
*/
void reset_coding_state_cs_cm()
{
  reset_coding_state(cs_cm);
}

void LoadRefAndMotionVectors_From_ExtMBdata(int mode,short *pdir, short *fwref, short *bwref,short *bi_pred_me,int mb_ext_level, int transform8x8_above)
{
  int     i, j,m,n;
  int     j0      = 0;
  int     i0      = 0;
  int     j1      = 2;
  int     i1      = 2;
  short   *cur_mv;
  int Ext_mode= (mb_ext_level==0&&transform8x8_above)? (mode+4): mode;

  if (mb_ext_level==0)
  {
    for (j=0; j<4; j+=2)
    {
      for (i=0; i<4; i+=2)
      {
        int block =(j>>1)*2+ (i>>1);
        tmpExtMBdata= ExtMBdata->NextMB[index32x32]->NextMB[index16x16]->NextMB[block];
        pdir [block]=tmpExtMBdata->pdir[Ext_mode][0];
        fwref[block]=tmpExtMBdata->ref_idx[LIST_0][Ext_mode][0];
        bwref[block]=tmpExtMBdata->ref_idx[LIST_1][Ext_mode][0];
        if (fwref[block]>=0)
        {
          for (m= j; m< j+2;m++)
          {
            for (n= i; n< i+2;n++)
            {
              cur_mv = img->all_mv[m][n][LIST_0][fwref[block]][mode];                
              cur_mv[0] =tmpExtMBdata->mv[LIST_0][Ext_mode][(m-j)*2+ (n-i)][0];
              cur_mv[1] =tmpExtMBdata->mv[LIST_0][Ext_mode][(m-j)*2+ (n-i)][1];
            }
          }
        }
        if (bwref[block]>=0)
        {
          for (m= j; m< j+2;m++)
          {
            for (n= i; n< i+2;n++)
            {
              cur_mv = img->all_mv[m][n][LIST_1][bwref[block]][mode];                
              cur_mv[0] =tmpExtMBdata->mv[LIST_1][Ext_mode][(m-j)*2+ (n-i)][0];
              cur_mv[1] =tmpExtMBdata->mv[LIST_1][Ext_mode][(m-j)*2+ (n-i)][1];
            }
          }
        }
      }
    }
    return;
  }
  if (mb_ext_level==3)
    tmpExtMBdata= ExtMBdata;
  else if (mb_ext_level==2)
    tmpExtMBdata= ExtMBdata->NextMB[index32x32];
  else if (mb_ext_level==1)
    tmpExtMBdata= ExtMBdata->NextMB[index32x32]->NextMB[index16x16];

  for (j=j0; j<j1; j++)
  {
    for (i=i0; i<i1; i++)
    {
      pdir [j*2+ i]=tmpExtMBdata->pdir[Ext_mode][j*2+ i];
      fwref[j*2+ i]=tmpExtMBdata->ref_idx[LIST_0][Ext_mode][j*2+ i];
      bwref[j*2+ i]=tmpExtMBdata->ref_idx[LIST_1][Ext_mode][j*2+ i];
      if (fwref[j*2+ i]>=0)
      {
        for (m= (j<<mb_ext_level); m< ((j+1)<<mb_ext_level);m++)
        {
          for (n= (i<<mb_ext_level); n< ((i+1)<<mb_ext_level);n++)
          {
            cur_mv = img->all_mv[m][n][LIST_0][fwref[j*2+ i]][mode];                
            cur_mv[0] =tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][1];
          }
        }
      }
      if (bwref[j*2+ i]>=0)
      {
        for (m= (j<<mb_ext_level); m< ((j+1)<<mb_ext_level);m++)
        {
          for (n= (i<<mb_ext_level); n< ((i+1)<<mb_ext_level);n++)
          {
            cur_mv = img->all_mv[m][n][LIST_1][bwref[j*2+ i]][mode];                
            cur_mv[0] =tmpExtMBdata->mv[LIST_1][Ext_mode][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->mv[LIST_1][Ext_mode][j*2+ i][1];
          }
        }
      }
    }
  }
  if (img->type==B_SLICE)
  {
    *bi_pred_me= tmpExtMBdata->bi_pred_me;
    for (j=j0; j<j1; j++)
    {
      for (i=i0; i<i1; i++)
      {
        for (m= (j<<mb_ext_level); m< ((j+1)<<mb_ext_level);m++)
        {
          for (n= (i<<mb_ext_level); n< ((i+1)<<mb_ext_level);n++)
          {
            cur_mv = img->bipred_mv1[m][n][LIST_0][0][mode];                
            cur_mv[0] =tmpExtMBdata->bipred_mv[LIST_0][0][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->bipred_mv[LIST_0][0][j*2+ i][1];
            cur_mv = img->bipred_mv1[m][n][LIST_1][0][mode];                
            cur_mv[0] =tmpExtMBdata->bipred_mv[LIST_1][0][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->bipred_mv[LIST_1][0][j*2+ i][1];

            cur_mv = img->bipred_mv2[m][n][LIST_0][0][mode];                
            cur_mv[0] =tmpExtMBdata->bipred_mv[LIST_0][1][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->bipred_mv[LIST_0][1][j*2+ i][1];
            cur_mv = img->bipred_mv2[m][n][LIST_1][0][mode];                
            cur_mv[0] =tmpExtMBdata->bipred_mv[LIST_1][1][j*2+ i][0];
            cur_mv[1] =tmpExtMBdata->bipred_mv[LIST_1][1][j*2+ i][1];
          }
        }
      }
    }
  }
}

void SetRefAndMotionVectors_to_ExtMBdata (int block,int mode, int pdir, int fwref, int bwref,int bi_pred_me,int level,int transform8x8_above)
{
  static int  bx0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,1,0,0}, {0,1,0,1}};
  static int  by0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,1,0,0}, {0,0,0,0}, {0,0,1,1}};
  static int  part_size[5][2] = {{2,2},{2,2}, {2,1},{1,2},  {1,1}};

  int     i, j=0;
  int     bslice  = (img->type==B_SLICE);
  int     pmode   = (mode==1||mode==2||mode==3?mode:4);
  int     j0      = by0[pmode][block];
  int     i0      = bx0[pmode][block];
  int     j1      = j0 + part_size[pmode][1];
  int     i1      = i0 + part_size[pmode][0];
  int     block_x, block_y;
  short   *cur_mv;
  int Ext_mode= (level==0&&transform8x8_above)? (mode+4): mode;

  if (level==0)
  {
    tmpExtMBdata= ExtMBdata->NextMB[index32x32]->NextMB[index16x16]->NextMB[block];
    if (!bslice)
    {
      memset(&tmpExtMBdata->ref_idx[LIST_0][Ext_mode][0], fwref, 4 * sizeof(char));
      memset(&tmpExtMBdata->ref_idx[LIST_1][Ext_mode][0], -1   , 4 * sizeof(char));
      memset(&tmpExtMBdata->pdir           [Ext_mode][0], pdir , 4 * sizeof(char));
      for (j=0; j<2; j++)
      { 
        for (i=0; i<2; i++)
        {
          cur_mv = img->all_mv[(j0<<1)+j][(i0<<1)+i][LIST_0][fwref][mode];                
          tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][1] = cur_mv[1];
        }
      }
      return;
    }
    else
    {

      for (j=0; j<2; j++)
      {
        block_y = img->block_y + ((j0+j)<<level);
        for (i=0; i<2; i++)
        {
          block_x = img->block_x + ((i0+i)<<level);
          tmpExtMBdata->pdir[Ext_mode][j*2+ i]    = pdir;        
          if (fwref>=0)
          {
            cur_mv = img->all_mv[(j0<<1)+j][(i0<<1)+i][LIST_0][fwref][mode];            
            tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][0] = cur_mv[0];
            tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][1] = cur_mv[1];
            tmpExtMBdata->ref_idx   [LIST_0][Ext_mode][j*2+ i] = fwref;
          }
          else
          {
            tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][0] = 0;
            tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][1] = 0;
            tmpExtMBdata->ref_idx   [LIST_0][Ext_mode][j*2+ i]    = -1;
          }

          if (bwref>=0)
          {
            cur_mv = img->all_mv[(j0<<1)+j][(i0<<1)+i][LIST_1][bwref][mode];	            
            tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][0] = cur_mv[0];
            tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][1] = cur_mv[1];
            tmpExtMBdata->ref_idx   [LIST_1][Ext_mode][j*2+ i] = bwref;
          }
          else
          {
            tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][0] = 0;
            tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][1] = 0;
            tmpExtMBdata->ref_idx   [LIST_1][Ext_mode][j*2+ i]    = -1;
          }
        }
      }
    }
    return;
  }

  if (level==3)
    tmpExtMBdata= ExtMBdata;
  else if (level==2)
    tmpExtMBdata= ExtMBdata->NextMB[index32x32];
  else if (level==1)
    tmpExtMBdata= ExtMBdata->NextMB[index32x32]->NextMB[index16x16];


  if (pdir<0)
  {
    for (j = j0; j < j1; j++)
    {
      memset(&tmpExtMBdata->pdir           [Ext_mode][j*2+ i0], -1, (part_size[pmode][0]) * sizeof(char));
      memset(&tmpExtMBdata->ref_idx[LIST_0][Ext_mode][j*2+ i0], -1, (part_size[pmode][0]) * sizeof(char));
      memset(&tmpExtMBdata->ref_idx[LIST_1][Ext_mode][j*2+ i0], -1, (part_size[pmode][0]) * sizeof(char));
      memset(tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i0], 0, 2*(part_size[pmode][0]) * sizeof(short));
      memset(tmpExtMBdata->mv[LIST_1][Ext_mode][j*2+ i0], 0, 2*(part_size[pmode][0]) * sizeof(short));
    }
    return;
  }

  if (!bslice)
  {
    for (j=j0; j<j1; j++)
    {
      memset(&tmpExtMBdata->ref_idx[LIST_0][Ext_mode][j*2+ i0], fwref, (part_size[pmode][0]) * sizeof(char));
      memset(&tmpExtMBdata->ref_idx[LIST_1][Ext_mode][j*2+ i0], -1, (part_size[pmode][0]) * sizeof(char));
      memset(&tmpExtMBdata->pdir           [Ext_mode][j*2+ i0], pdir , (part_size[pmode][0]) * sizeof(char));

      for (i=i0; i<i1; i++)
      {
        cur_mv = img->all_mv[j<<level][i<<level][LIST_0][fwref][mode];                
        tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][0] = cur_mv[0];
        tmpExtMBdata->mv[LIST_0][Ext_mode][j*2+ i][1] = cur_mv[1];
      }
    }
    return;
  }
  else
  {
    for (j=j0; j<j1; j++)
    {
      block_y = img->block_y + (j<<level);
      for (i=i0; i<i1; i++)
      {
        block_x = img->block_x + (i<<level);
        tmpExtMBdata->pdir[Ext_mode][j*2+ i]    = pdir;      
        if (mode == 1)
        {
          tmpExtMBdata->bi_pred_me=bi_pred_me;
          cur_mv = img->bipred_mv1[(j0<<1)+j][(i0<<1)+i][LIST_0][0][mode];
          tmpExtMBdata->bipred_mv [LIST_0][0][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->bipred_mv [LIST_0][0][j*2+ i][1] = cur_mv[1];
          cur_mv = img->bipred_mv1[(j0<<1)+j][(i0<<1)+i][LIST_1][0][mode];
          tmpExtMBdata->bipred_mv [LIST_1][0][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->bipred_mv [LIST_1][0][j*2+ i][1] = cur_mv[1];

          cur_mv = img->bipred_mv2[(j0<<1)+j][(i0<<1)+i][LIST_0][0][mode];
          tmpExtMBdata->bipred_mv [LIST_0][1][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->bipred_mv [LIST_0][1][j*2+ i][1] = cur_mv[1];  

          cur_mv = img->bipred_mv2[(j0<<1)+j][(i0<<1)+i][LIST_1][0][mode];
          tmpExtMBdata->bipred_mv [LIST_1][1][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->bipred_mv [LIST_1][1][j*2+ i][1] = cur_mv[1];
        }

        if (fwref>=0)
        {
          cur_mv = img->all_mv[j<<level][i<<level][LIST_0][fwref][mode];

          tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][1] = cur_mv[1];
          tmpExtMBdata->ref_idx   [LIST_0][Ext_mode][j*2+ i] = fwref;
        }
        else
        {
          tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][0] = 0;
          tmpExtMBdata->mv        [LIST_0][Ext_mode][j*2+ i][1] = 0;
          tmpExtMBdata->ref_idx   [LIST_0][Ext_mode][j*2+ i]    = -1;
        }

        if (bwref>=0)
        {
          cur_mv = img->all_mv[j<<level][i<<level][LIST_1][bwref][mode];

          tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][0] = cur_mv[0];
          tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][1] = cur_mv[1];
          tmpExtMBdata->ref_idx   [LIST_1][Ext_mode][j*2+ i] = bwref;
        }
        else
        {
          tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][0] = 0;
          tmpExtMBdata->mv        [LIST_1][Ext_mode][j*2+ i][1] = 0;
          tmpExtMBdata->ref_idx   [LIST_1][Ext_mode][j*2+ i]    = -1;
        }
      }
    }
  }

}
