#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <memory.h>
#include <assert.h>
#include <time.h>
#include <sys/timeb.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "global.h"
#include "mbuffer.h"
#include "rdopt_coding_state.h"

#include "mode_decision.h"
#include "elements.h"
#include "fmo.h"
#include "cabac.h"

#include "switched_filters.h"

extern short ******EPZSMotion;  //!< Array for storing Motion Vectors

#define SIN_LUT

#define IS_INTER_SLICE(type) ((type) == B_SLICE || (type) == P_SLICE)
#define MAX_LINES 2
typedef struct
{
  int rho;
  int thetai;
  int   accum;
} LinePolar;
int line_candidates;
LinePolar *line;
int theta_size;
//float *theta_scale;
int rho_size[3];//[mb_ext_level]
int *rho_scale[3];//[mb_ext_level][]
int Max_rho[3];//[mb_ext_level]
int rho_bits[3];//[mb_ext_level]
int **accum;
void init_hough();
extern int geo_stat[2][3];

int skipped_geo=0;
int coeff_cost4x4[4][4];
int GeoPart_num[3];
int PreSelect_mode[3];
char ****geo_mask[3];//[mb_ext_level][rho][theta][y][x]
char ****geo_4x4mask[3];//[mb_ext_level][rho][theta][y][x]
char ****geo_filter[3];//[mb_ext_level][rho][theta][y][x]
char ****geo_filterUV[3];//[mb_ext_level][rho][theta][y][x]
char **smfilter;
char **smfilterUV;
char **mask;
char **mask4x4;
char ****saved_partition_candidate;
char geo_mv_predictor[4][32][32][2][6];//[0-8x8;1-16x16;2-32x32;3-64x64][rho][theta][segm][predictors]
char enc_geo[3][GEO_PART_NUM];
char enc_geo_hier[3][GEO_PART_NUM];
char enc_geo_valid[GEO_PART_NUM];
int theta_bits[3];
#if defined RDO_Q
int partition_candidate[3][16][PRE_SELECT_MODE];
#endif
int **geo_mask16_neighbor;
int Segmentation_Selected;
int mv_map[16][16][2];
int edge[4<<MAX_MB_EXT_LEVEL][4<<MAX_MB_EXT_LEVEL];
extern int cluster_counter;
void error(char *text, int code);
extern int no64x64;
void se_linfo(int se, int dummy, int *len,int *info);
void ue_linfo(int ue, int dummy, int *len,int *info);

#ifdef MB32X32
extern int   cbp16[1<<(2*MAX_MB_EXT_LEVEL)], cbp16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
extern int   cbp_32[1<<(2*(MAX_MB_EXT_LEVEL-1))], cbp_32_RDCost[1<<(2*(MAX_MB_EXT_LEVEL-1))];
extern int64 cbp_blk16[1<<(2*MAX_MB_EXT_LEVEL)], cbp_blk16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
extern int   ****cofAC32[1<<(2*MAX_MB_EXT_LEVEL)], ****cofAC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];// ****cofAC8x8=NULL;        // [8x8block][4x4block][level/run][scan_pos]
extern int   ***cofDC32[1<<(2*MAX_MB_EXT_LEVEL)], ***cofDC32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];                       // [yuv][level/run][scan_pos]
extern Macroblock  MB32;
extern Macroblock  MB64;
extern int   luma_transform_size_8x8_flag32[1<<(2*MAX_MB_EXT_LEVEL)], luma_transform_size_8x8_flag32_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];
int   best16x16pdir[4];
extern int saved_mb32_nr;
extern int mb32_mvd[2][BLOCK_MULTIPLE<<MAX_MB_EXT_LEVEL][BLOCK_MULTIPLE<<MAX_MB_EXT_LEVEL][2];          //!< indices correspond to [forw,backw][block_y][block_x][x,y]
#endif

extern int    **cof32AC16x16[1<<(2*MAX_MB_EXT_LEVEL)], **cof32AC16x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][257];
extern int    ***cof32AC16x8[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC16x8_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];
extern int    ***cof32AC8x16[1<<(2*MAX_MB_EXT_LEVEL)], ***cof32AC8x16_RDCost[1<<(2*MAX_MB_EXT_LEVEL)];//[2][2][129];
extern int only_16x16_transform;
extern int   bestCofAC16x16 [2][257];
extern int   bestCofAC16x8  [2][2][129];
extern int   bestCofAC8x16  [2][2][129];


double sinLUT32[32] = {0.0000000000, 0.1950903220, 0.3826834324, 0.5555702330, 0.7071067812, 0.8314696123, 0.9238795325, 0.9807852804, 1.0000000000, 0.9807852804, 0.9238795325, 0.8314696123, 0.7071067812, 0.5555702330, 0.3826834324, 0.1950903220, 
0.0000000000, -0.1950903220, -0.3826834324,-0.5555702330, -0.7071067812, -0.8314696123, -0.9238795325, -0.9807852804, -1.0000000000, -0.9807852804, -0.9238795325, -0.8314696123, -0.7071067812, -0.5555702330, -0.3826834324, -0.1950903220}; //step = 11.25 deg

double cosLUT32[32] = {
  1.0000000000, 0.9807852804, 0.9238795325, 0.8314696123, 0.7071067812, 0.5555702330, 0.3826834324, 0.1950903220,
  0.0000000000, -0.1950903220, -0.3826834324, -0.5555702330, -0.7071067812, -0.8314696123, -0.9238795325, -0.9807852804,
  -1.0000000000, -0.9807852804, -0.9238795325, -0.8314696123, -0.7071067812, -0.5555702330, -0.3826834324, -0.1950903220,
  -0.0000000000, 0.1950903220, 0.3826834324, 0.5555702330, 0.7071067812, 0.8314696123, 0.9238795325, 0.9807852804}; //step = 11.25 deg

  int cotLUT32[32]= {
    668927563, 41184, 19777, 12260, 8192, 5474, 3393, 1629, 0, -1629, -3393, -5474, -8192, -12260, -19777,  -41184,
    -668927563, 41184, 19777, 12260, 8192, 5474, 3393, 1629, 0, -1629, -3393, -5474, -8192, -12260, -19777,  -41184
  };
  int inv_sinLUT32[32]= {
    668927563, 41991, 21407, 14745, 11585, 9852, 8867, 8352, 8192, 8352, 8867, 9852, 11585, 14745, 21407, 41991, 
    -668927563,-41991,-21407,-14745,-11585,-9852,-8867,-8352,-8192,-8352,-8867,-9852,-11585,-14745,-21407,-41991  
  };




  int MB16GeoMask[GEO_PART_NUM][16]={
    {1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0},
    {1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0},
    {0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1},
    {0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1},
    {0,0,0,0,1,0,0,0,1,1,0,0,1,1,1,0},
    {1,0,0,0,1,1,0,0,1,1,1,0,1,1,1,1},
    {0,0,0,0,0,0,0,0,1,0,0,0,1,1,0,0},
    {1,1,0,0,1,1,1,0,1,1,1,1,1,1,1,1},
    {1,1,1,0,1,1,0,0,1,0,0,0,0,0,0,0},
    {1,1,1,1,1,1,1,0,1,1,0,0,1,0,0,0},
    {1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0},
    {1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0}
  };
  int best_geo_mode;

  int motion_cost_geo[GEO_PART_NUM][2][8][2][MAX_REFERENCE_PICTURES][4];
  void save_mv_for_speedup(int mb_ext_level);

  extern int ***EPZSDistortion;  //!< Array for storing SAD Values
  extern StorablePicture *enc_picture;
  extern const int LEVELMVLIMIT[17][6];
  extern int curr_mb32i, curr_mbi;
  extern short best8x8pdir  [MAXMODE][4];       // [mode][block]
  extern short best8x8fwref [MAXMODE][4];       // [mode][block]
  extern short best8x8bwref [MAXMODE][4];       // [mode][block]
  extern int*    mvbits;
  extern imgpel   rec_mbY[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL], rec_mbU[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL], rec_mbV[16<<MAX_MB_EXT_LEVEL][16<<MAX_MB_EXT_LEVEL];    // reconstruction values
  extern int   ****cofAC;        // [8x8block][4x4block][level/run][scan_pos]
  extern int   ***cofDC;                       // [yuv][level/run][scan_pos]
  extern int   cbp;
  extern int64 cbp_blk;
  extern int best_c_imode;
  extern int   luma_transform_size_8x8_flag;
  extern unsigned int*  byte_abs;

  void find_Mb_cluster(int level, int CurrentMbAddr, int *CurrentMbAddr_x, int *CurrentMbAddr_y, int *extend_x, int *extend_y, int *num_MB, int *nextMbAddr);
  void writeMVD_CABAC(SyntaxElement *se, EncodingEnvironmentPtr eep_dp);
  int ResetAvailabilityOfNeighbors32(int mb_x, int mb_y, int *reset_block_x, int *reset_block_y, int blockshape_x, int blockshape_y);
  void getLuma4x4Neighbour (int curr_mb_nr, int block_x, int block_y, int rel_x, int rel_y, PixelPos *pix);

#define DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
  int isfirstTransf;
#endif
  void find_embedded_MBPartition();
  int get_regular_motion(int geo_mode, int segm, int mv[2], int list, int ref, int mb_ext_level);
  int BlockMotionCost32_geo (int mv[2],
    short     ref,           //!< reference idx
    int       list,          //!< reference pciture list
    pel_t ** orig_pic,    // <--  original pixel values for the AxB block
    int       mb_x,          //!< x-coordinate inside macroblock   (in the unit of pel -peisong)
    int       mb_y,          //!< y-coordinate inside macroblock   (in the unit of pel -peisong)
    int       scheme,
    int       geo_mode,     //!< block type (1-16x16 ... 7-4x4)
    int       segm,
    int       search_range,  //!< 1-d search range for integer-position search
    int       lambda_factor, //!< lagrangian parameter for determining motion cost
    int       mb_ext_level) ;
  int                                               //  ==> minimum motion cost after search
    EPZSSubPelBlockMotionCost32_geo (pel_t**   orig_pic,      // <--  original pixel values for the AxB block
    short     ref,           // <--  reference frame (0... or -1 (backward))
    int       list,          // <--  reference picture list 
    int       pic_pix_x,     // <--  absolute x-coordinate of regarded AxB block
    int       pic_pix_y,     // <--  absolute y-coordinate of regarded AxB block
    int       blocktype,     // <--  block type (1-16x16 ... 7-4x4)
    int       pred_mv_x,     // <--  motion vector predictor (x) in sub-pel units
    int       pred_mv_y,     // <--  motion vector predictor (y) in sub-pel units
    short*    mv_x,          // <--> in: search center (x) / out: motion vector (x) - in pel units
    short*    mv_y,          // <--> in: search center (y) / out: motion vector (y) - in pel units
    int       search_pos2,   // <--  search positions for    half-pel search  (default: 9)
    int       search_pos4,   // <--  search positions for quarter-pel search  (default: 9)
#ifdef EIGHTH_PEL
    int       search_pos8,   // <--  search positions for eighth-pel search  (default: 9)
#endif
    int       min_mcost,     // <--  minimum motion cost (cost for center or huge value)
    int       lambda_factor,  // <--  lagrangian parameter for determining motion cost
    int       scheme,
    int       geo_mode,
    int       segm,
    int       mb_ext_level );



#ifdef EIGHTH_PEL
  int                                               //  ==> minimum motion cost after search
    EPZSSubPelBlockMotionCostoneEighth32_geo (pel_t**   orig_pic,      // <--  original pixel values for the AxB block
    short     ref,           // <--  reference frame (0... or -1 (backward))
    int       list,          // <--  reference picture list 
    int       pic_pix_x,     // <--  absolute x-coordinate of regarded AxB block
    int       pic_pix_y,     // <--  absolute y-coordinate of regarded AxB block
    int       blocktype,     // <--  block type (1-16x16 ... 7-4x4)
    int       pred_mv_x,     // <--  motion vector predictor (x) in sub-pel units
    int       pred_mv_y,     // <--  motion vector predictor (y) in sub-pel units
    short*    mv_x,          // <--> in: search center (x) / out: motion vector (x) - in pel units
    short*    mv_y,          // <--> in: search center (y) / out: motion vector (y) - in pel units
    int       search_pos2,   // <--  search positions for    half-pel search  (default: 9)
    int       search_pos4,   // <--  search positions for quarter-pel search  (default: 9)
    int       search_pos8,   // <--  search positions for eighth-pel search  (default: 9)
    int       min_mcost,     // <--  minimum motion cost (cost for center or huge value)
    int       lambda_factor,  // <--  lagrangian parameter for determining motion cost
    int       scheme,
    int       geo_mode,
    int       segm,
    int       mb_ext_level );
#endif

  int get_mem_mv_geo (short ***** mv)
  {
    int k, l, m;

#ifdef MB32X32
    if (((*mv)/*[i][j]*/ = (short****)calloc(2,sizeof(short***))) == NULL)
      no_mem_exit ("get_mem_mv: mv");
    for (k=0; k<2; k++)
    {
      if (((*mv)/*[i][j]*/[k] = (short***)calloc(img->max_num_references,sizeof(short**))) == NULL)
        no_mem_exit ("get_mem_mv: mv");
      for (l=0; l<img->max_num_references; l++)
      {
        if (((*mv)/*[i][j]*/[k][l] = (short**)calloc(9,sizeof(short*))) == NULL)
          no_mem_exit ("get_mem_mv: mv");
        if (((*mv)/*[i][j]*/[k][l][0] = (short*)calloc(2*9,sizeof(short))) == NULL)
          no_mem_exit ("get_mem_mv: mv");
        for (m=1; m<9; m++)
          (*mv)/*[i][j]*/[k][l][m] = (*mv)/*[i][j]*/[k][l][m - 1] + 2;
      }
    }
    return /*(4<<(input->UseExtMB))*(4<<(input->UseExtMB))**/img->max_num_references*9*2*sizeof(short);
#else
    if (((*mv)/*[i][j]*/ = (short****)calloc(2,sizeof(short***))) == NULL)
      no_mem_exit ("get_mem_mv: mv");
    for (k=0; k<2; k++)
    {
      if (((*mv)/*[i][j]*/[k] = (short***)calloc(img->max_num_references,sizeof(short**))) == NULL)
        no_mem_exit ("get_mem_mv: mv");
      for (l=0; l<img->max_num_references; l++)
      {
        if (((*mv)/*[i][j]*/[k][l] = (short**)calloc(9,sizeof(short*))) == NULL)
          no_mem_exit ("get_mem_mv: mv");
        if (((*mv)/*[i][j]*/[k][l][0] = (short*)calloc(2*9,sizeof(short))) == NULL)
          no_mem_exit ("get_mem_mv: mv");
        for (m=1; m<9; m++)
          (*mv)/*[i][j]*/[k][l][m] = (*mv)/*[i][j]*/[k][l][m - 1] + 2;
      }
    }
    return img->max_num_references*2*9*sizeof(short);
#endif
  }
  void free_mem_mv_geo (short**** mv)
  {
    int k, l;
    for (k=0; k<2; k++)
    {
      for (l=0; l<img->max_num_references; l++)
      {
        free (mv/*[i][j]*/[k][l][0]);
        free (mv/*[i][j]*/[k][l]);
      }
      free (mv/*[i][j]*/[k]);
    }
    free (mv);
  }

int                                            //  ==> minimum motion cost after search
EPZS_RMV_Refinement_Pel(pel_t ** cur_pic,    // <--  original pixel values for the AxB block
                          short ref,          // <--  reference picture 
                          int list,           // <--  reference list
                          int list_offset,    // <--  offset for Mbaff
                          char ***refPic,    // <--  reference array
                          short ****tmp_mv,   // <--  mv array
                          int pic_pix_x,      // <--  absolute x-coordinate of regarded AxB block
                          int pic_pix_y,      // <--  absolute y-coordinate of regarded AxB block
                          int blocktype,      // <--  block type (1-16x16 ... 7-4x4)
                          short pred_mv_x,    // <--  motion vector predictor (x) in sub-pel units
                          short pred_mv_y,    // <--  motion vector predictor (y) in sub-pel units
                          short *mv_x,        // <--> in: search center (x) / out: motion vector (x) - in pel units
                          short *mv_y,        // <--> in: search center (y) / out: motion vector (y) - in pel units
                          int search_range,    // <--  1-d search range in pel units
                          int min_mcost,      // <--  minimum motion cost (cost for center or huge value)
                          int lambda_factor,      // <--  lagrangian parameter for determining motion cost
                          int scheme,
                          int geo_mode,
                          int segm,
                          int mb_ext_level);

  int                                            //  ==> minimum motion cost after search
    EPZSPelBlockMotionSearch32_geo (pel_t ** cur_pic,    // <--  original pixel values for the AxB block
    short ref,          // <--  reference picture 
    int list,           // <--  reference list
    int list_offset,    // <--  offset for Mbaff
    char ***refPic,    // <--  reference array
    short ****tmp_mv,   // <--  mv array
    int pic_pix_x,      // <--  absolute x-coordinate of regarded AxB block
    int pic_pix_y,      // <--  absolute y-coordinate of regarded AxB block
    int blocktype,      // <--  block type (1-16x16 ... 7-4x4)
    short pred_mv_x,    // <--  motion vector predictor (x) in sub-pel units
    short pred_mv_y,    // <--  motion vector predictor (y) in sub-pel units
    short *mv_x,        // <--> in: search center (x) / out: motion vector (x) - in pel units
    short *mv_y,        // <--> in: search center (y) / out: motion vector (y) - in pel units
    int search_range,    // <--  1-d search range in pel units
    int min_mcost,      // <--  minimum motion cost (cost for center or huge value)
    int lambda_factor,      // <--  lagrangian parameter for determining motion cost
    int scheme,
    int geo_mode,
    int segm,
    int mb_ext_level);
  int                                               //  ==> minimum motion cost after search
    EPZSSubPelBlockMotionSearch32_geo (pel_t**   orig_pic,      // <--  original pixel values for the AxB block
    short     ref,           // <--  reference frame (0... or -1 (backward))
    int       list,          // <--  reference picture list 
    int       pic_pix_x,     // <--  absolute x-coordinate of regarded AxB block
    int       pic_pix_y,     // <--  absolute y-coordinate of regarded AxB block
    int       blocktype,     // <--  block type (1-16x16 ... 7-4x4)
    int       pred_mv_x,     // <--  motion vector predictor (x) in sub-pel units
    int       pred_mv_y,     // <--  motion vector predictor (y) in sub-pel units
    short*    mv_x,          // <--> in: search center (x) / out: motion vector (x) - in pel units
    short*    mv_y,          // <--> in: search center (y) / out: motion vector (y) - in pel units
    int       search_pos2,   // <--  search positions for    half-pel search  (default: 9)
    int       search_pos4,   // <--  search positions for quarter-pel search  (default: 9)
#ifdef EIGHTH_PEL
    int       search_pos8,   // <--  search positions for eighth-pel search  (default: 9)
#endif
    int       min_mcost,     // <--  minimum motion cost (cost for center or huge value)
    int       lambda_factor,  // <--  lagrangian parameter for determining motion cost
    int       scheme,
    int       geo_mode,
    int       segm,
    int       mb_ext_level );
  int RDCost_for_macroblocks32 (double   lambda,       // <-- lagrange multiplier
    int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
    int      *mode_idx,
    double*  min_rdcost,   // <-> minimum rate-distortion cost
    double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
    int i16mode,
    int mb_ext_level);

  void SetMotionVectorPredictor_Competition (short  pmv[2],
    char   **refPic,
    short  ***tmp_mv,
    short  ref_frame,
    int    list,
    int    block_x,
    int    block_y,
    int    blockshape_x,
    int    blockshape_y);

#ifdef USE_INTRA_MDDT
  int dct_luma8x8(int b8,int *coeff_cost, int intra, int ipmode);
#else
  int dct_luma8x8(int b8,int *coeff_cost, int intra);
#endif
  void SetModesAndRefframe (int b8, short* p_dir, int* fw_mode, int* bw_mode, short* fw_ref, short* bw_ref);
  void LumaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx,int mb_ext_level);
  void ChromaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level);
  int writeMBLayer_Big (int rdopt, int *coeff_rate, int bigger_block_type, int mb32i, int mb16i);
  void prepare_data_for_write_RDCost(int encodeMbAddr, int mbcount, int mode);
  void switchback_data_after_write(int encodeMbAddr, int mbcount, int mode);
  void start_macroblock32(int mb_addr, int mb_field, int mb32);
  void GetBestPredVector (short  *pmv,short mv_x,short mv_y,int /*double*/ lambda,int ref, int list,int modeblock,int mb_x,int mb_y);

  int get_mem2Dchar(char ***array2D, int rows, int columns)
  {
    int i;

    if((*array2D      = (char**)calloc(rows,        sizeof(char*))) == NULL)
      error("get_mem2Dchar: array2D", -1);
    if(((*array2D)[0] = (char* )calloc(rows*columns,sizeof(char ))) == NULL)
      error("get_mem2Dchar: array2D", -1);

    for(i=1 ; i<rows ; i++)
      (*array2D)[i] =  (*array2D)[i-1] + columns  ;

    return rows*columns*sizeof(char);
  }

  int get_mem3Dchar(char ****array3D, int dim1, int dim2, int dim3)
  {
    int  j;

    if(((*array3D) = (char***)calloc(dim1,sizeof(char**))) == NULL)
      error("get_mem3Dchar: array3D", -1);

    for(j=0;j<dim1;j++)
      get_mem2Dchar( (*array3D)+j, dim2, dim3 ) ;

    return dim1*dim2*dim3*sizeof(char);
  }

  int get_mem4Dchar(char *****array4D, int dim1, int dim2, int dim3, int dim4)
  {
    int  j;

    if(((*array4D) = (char****)calloc(dim1,sizeof(char**))) == NULL)
      error("get_mem4Dchar: array4D", -1);

    for(j=0;j<dim1;j++)
      get_mem3Dchar( (*array4D)+j, dim2, dim3, dim4) ;

    return dim1*dim2*dim3*dim4*sizeof(char);
  }


  void free_mem2Dchar(char **array2D)
  {
    if (array2D)
    {
      if (array2D[0]) 
        free (array2D[0]);
      else error ("free_mem2Dchar: trying to free unused memory",100);

      free (array2D);

    } else
    {
      error ("free_mem2Dchar: trying to free unused memory",100);
    }
  }

  void free_mem3Dchar(char ***array3D, int frames)
  {
    int i;

    if (array3D)
    {
      for (i=0;i<frames;i++)
      { 
        free_mem2Dchar(array3D[i]);
      }
      free (array3D);
    } else
    {
      error ("free_mem3Dchar: trying to free unused memory",100);
    }
  }

  void free_mem4Dchar(char ****array4D, int idx, int frames )
  {
    int  j;

    if (array4D)
    {
      for(j=0;j<idx;j++)
        free_mem3Dchar( array4D[j], frames) ;
      free (array4D);
    } else
    {
      error ("free_mem4Dchar: trying to free unused memory",100);
    }
  }

  void get_rho_theta0(int geo_mode, int *rho, int *theta_idx, int mb_ext_level)
  {
    *rho = geo_mode>>theta_bits[mb_ext_level];
    *theta_idx = geo_mode & ((1<<theta_bits[mb_ext_level])-1);
  }

  void get_rho_theta(int geo_mode, int *rho, int *theta_idx, char ***mask, int mb_ext_level)
  {
    *rho = geo_mode>>theta_bits[mb_ext_level];
    *theta_idx = geo_mode & ((1<<theta_bits[mb_ext_level])-1);
    *mask = geo_mask[mb_ext_level][*rho][*theta_idx];
  }
  void get_mask(char **mask, char **mask4x4, char **filter, char **filterUV, int rho, int theta_idx, float theta_step, int mb_ext_level)
  {
#ifndef SIN_LUT
    double theta = theta_idx * theta_step;
#endif
    int i, j, x,y, segm, pred;
    //double sx, sy, rx, ry;
    //double rz;
    int sx_i,sy_i;
    int rx;
    //a  b  c  d  e  f
    static int x0[]={0, 0, 3, 0, 0, 2}; //(x0,y0) and (x1,y1) are the coordinators in a 4x4 block
    static int y0[]={3, 3, 3, 3, 1, 3};
    static int x1[]={0, 1, 3, 0, 0, 3};
    static int y1[]={2, 3, 3, 3, 0, 3};
    int coor[4];
    int blocksize = 16<<mb_ext_level;
    int blocksizeUV;
    int ii, jj, num[2];
    int xn[]={-1,0, 0,1};//4 connect
    int yn[]={ 0,1,-1,0};//4 connect

    //coor is used to convert the coordinators in a 4x4 block to NxN block
    if(blocksize == 8 || blocksize == 16 || blocksize==32 || blocksize==64)
    {
      coor[0] = 0; coor[1] = 3; coor[2] = blocksize-4; coor[3] = blocksize-1;
    }
    else
    {
      error ("blocisize is not correct!", -1);
    }

#ifndef SIN_LUT
    theta = theta*2*M_PI/360;//convert degree to radiant
#endif

    for(x=0;x<blocksize;x++)
    {
      for(y=0;y<blocksize;y++)
      {
        sx_i = (x*2-blocksize+1);
        sy_i = (y*2-blocksize+1);

        if (theta_idx ==0)
          rx = sx_i-rho*2;
        else if (theta_idx==16)
          rx = -sx_i-rho*2;
        else
        {
          rx = (sx_i*cotLUT32[theta_idx]+sy_i*8192-rho*2*inv_sinLUT32[theta_idx]);
          if (inv_sinLUT32[theta_idx]<0)
            rx=-rx;
        }
        //rz = (double)sx_i/tan(theta)+(double)sy_i-(double)(rho*2)/sin(theta);
        //if (sin(theta)<0)
        // rz= -rz;

        //sx = (x-blocksize/2+0.5);
        //sy = (y-blocksize/2+0.5);
        //
        // coordinators after rotation
        //#ifdef SIN_LUT
        //      rx =  sx*cosLUT32[theta_idx] + sy*sinLUT32[theta_idx] - rho;
        //      ry = -sx*sinLUT32[theta_idx] + sy*cosLUT32[theta_idx];
        //#else
        //      rx =  sx*cos(theta) + sy*sin(theta) - rho;
        //      ry = -sx*sin(theta) + sy*cos(theta);
        //#endif

        if (rx < 0)
        {
          mask[y][x]=0;
          //plot(sx, sy, '.');
        }
        else
        {
          mask[y][x]=1;
          //plot(sx, sy, 'o');
        }
      }
    }

    for(segm=0; segm<2; segm++)
    {
      for(pred=0; pred<6;pred++)
      {
        if(mask[coor[y0[pred]]] [coor[x0[pred]]] == segm && mask[coor[y1[pred]]] [coor[x1[pred]]] == segm)
        {
          geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][pred]  = 1;        
        }
        else
        {
          geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][pred]  = 0;        
        }
      }
    }

    for(x=0;x<blocksize;x++)
    { 
      for(y=0;y<blocksize/2;y++)
      {
        int temp = mask[y][x];
        mask[y][x] = mask[blocksize-1-y][x];
        mask[blocksize-1-y][x] = temp;
      }
    }

    //the following assignment is to solve the mismatch between Window and Linux
    if(mb_ext_level ==0)
    {
      if(rho ==0 && theta_idx == 4)
      {
        mask[1][1] = 1;
        mask[14][14] = 0;
      }
    }
    else if(mb_ext_level ==1)
    {
      if(rho ==0 && theta_idx == 4)
      {
        mask[4][4] = 0;
        mask[9][9] = 1;
        mask[22][22] = 0;
      }
      else if(rho ==0 && theta_idx == 12)
        mask[27][4] = 0;
    }
    else
    {
      if(rho ==0 && theta_idx == 4)
      {
        mask[3][3] = 1;
        mask[6][6] = 0;
        mask[8][8] = 1;
        mask[20][20] = 0;
        mask[25][25] = 1;
        mask[38][38] = 0;
        mask[55][55] = 0;
        mask[60][60] = 0;
      }
      else if(rho ==0 && theta_idx == 12)
      {
        mask[43][20] = 0;
        mask[57][6] = 0;
      }
    }


    for(x=0;x<blocksize;x+=4)
    {
      for(y=0;y<blocksize;y+=4)
      {
        segm = mask[y][x];
        mask4x4[y][x] = segm;

        for(i=x; i<x+4; i++)
        {
          for(j=y; j<y+4; j++)
          {
            if(mask[j][i] != segm)
            {
              mask4x4[y][x] = 2;
              break;
            }
          }
          if(mask4x4[y][x] == 2)
            break;
        }
      }
    }

    for(x=0;x<blocksize;x++)
    {
      for(y=0;y<blocksize;y++)
      {
        num[0] = 0; num[1] = 0;

        for(i=0; i<4; i++)//4-connect
        {
          ii = x+xn[i];
          if(ii<0)          ii=0;
          if(ii>=blocksize) ii=blocksize-1;
          jj = y+yn[i];
          if(jj<0)          jj=0;
          if(jj>=blocksize) jj=blocksize-1;
          num[mask[jj][ii]]++;
        }

        if(num[0]>0 && num[1]>0)
        {
          filter[y][x] = 1+mask[y][x];
        }
        else
          filter[y][x] = 0;
      }
    }

    blocksizeUV = blocksize/2;
    for(x=0;x<blocksizeUV;x++)
    {
      for(y=0;y<blocksizeUV;y++)
      {
        num[0] = 0; num[1] = 0;
        for(i=0; i<4; i++)
        {
          ii = x+xn[i];
          if(ii<0)          ii=0;
          if(ii>=blocksizeUV) ii=blocksizeUV-1;
          jj = y+yn[i];
          if(jj<0)          jj=0;
          if(jj>=blocksizeUV) jj=blocksizeUV-1;
          num[mask[jj<<1][ii<<1]]++;
        }

        if(num[0]>0 && num[1]>0)
        {
          filterUV[y][x] = 1+mask[y<<1][x<<1];
        }
        else
          filterUV[y][x] = 0;
      }
    }
  }

  void geo_partition(char ****mask, char ****mask4x4, char ****filter, char ****filterUV, int mb_ext_level)
  {

    float theta_step = THETASTEP;//in unit of degree
    int rho;// = int8(sqrt(2)*blocksize/2);
    int theta_idx;
    //int blocksize = 16<<mb_ext_level;

    memset(enc_geo[mb_ext_level], 0, GEO_PART_NUM);
    memset(enc_geo_hier[mb_ext_level], 0, GEO_PART_NUM);

    switch(mb_ext_level)
    {
    case 0:
    case 1:
    case 2:
      Max_rho[mb_ext_level] = ((16<<mb_ext_level)>>1) - 1; //MAX_RHO_16;
      rho_bits[mb_ext_level] = 3+mb_ext_level;
      break;
    default:
      error("this blocksize is not supported", -1);
    }

    /*******
    case 1
    *******/
    rho=0;
    for(theta_idx=0;theta_idx<=15;theta_idx++)
    {
      get_mask(mask[rho][theta_idx], mask4x4[rho][theta_idx], filter[rho][theta_idx], filterUV[rho][theta_idx], rho, theta_idx, theta_step, mb_ext_level);
      enc_geo[mb_ext_level][(rho<<THETA_BITS)+theta_idx] = 1;
      if(theta_idx%2 == 0)
        enc_geo_hier[mb_ext_level][(rho<<THETA_BITS)+theta_idx] = 1;
    }


    /*******
    case 2
    *******/
    for (rho=1;rho<=Max_rho[mb_ext_level];rho++)
    {
      for(theta_idx=0;theta_idx<=(1<<THETA_BITS)-1;theta_idx++)
      {
        get_mask(mask[rho][theta_idx], mask4x4[rho][theta_idx], filter[rho][theta_idx], filterUV[rho][theta_idx], rho, theta_idx, theta_step, mb_ext_level);
        enc_geo[mb_ext_level][(rho<<THETA_BITS)+theta_idx] = 1;
        if(rho%2==0 && theta_idx%2 == 0)
        {
          enc_geo_hier[mb_ext_level][(rho<<THETA_BITS)+theta_idx] = 1;
        }
      }
    }

    enc_geo[mb_ext_level][0]=0;//16x8 mode
    enc_geo[mb_ext_level][16]=0;//16x8 mode
    enc_geo[mb_ext_level][8]=0;//8x16 mode
  }

  void init_geo()
  {
    int i, j;

    for(i=0; i<2; i++)
      for(j=0; j<3; j++)
        geo_stat[i][j] = 0;

#if GEO_SCHEME == 0 
    img->geo_scheme = 0;
#else
    img->geo_scheme = 1;
#endif

    if(img->geo_scheme != 0)
    {
      for(i=0; i<3; i++)//3 MB levels: 16, 32, 64
      {
        GeoPart_num[i] = GEO_PART_NUM;
        PreSelect_mode[i] = PRE_SELECT_MODE;
        theta_bits[i] = THETA_BITS;
      }
      for(i=0; i<3; i++)//3 MB levels: 16, 32, 64
      {
        get_mem4Dchar(&geo_mask[i], ((16<<i)>>1), (1<<THETA_BITS), 16<<i, 16<<i);
        get_mem4Dchar(&geo_4x4mask[i], ((16<<i)>>1), (1<<THETA_BITS), 16<<i, 16<<i);
        get_mem4Dchar(&geo_filter[i], ((16<<i)>>1), (1<<THETA_BITS), 16<<i, 16<<i);
        get_mem4Dchar(&geo_filterUV[i], ((16<<i)>>1), (1<<THETA_BITS), 8<<i, 8<<i);
        geo_partition(geo_mask[i], geo_4x4mask[i], geo_filter[i], geo_filterUV[i], i);
      }


      find_embedded_MBPartition();

      get_mem4Dchar(&saved_partition_candidate, img->FrameSizeInMbs, 3, 16, PRE_SELECT_MODE);
    }


    init_hough();
  }
  extern int saved_mb32_geo[4];

  void reuse_16x16_geo(int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y, int mb_ext_level)
  {
    int i, mbi, mbj, counter=0, new_lines=0, encodeMbAddr, geo_mode;
    int shift_x[] = {-8, 8, -8,  8};
    int shift_y[] = { 8, 8, -8, -8};
    int rho, theta_idx, new_rho, new_theta_idx, num_theta_360 = 1<<THETA_BITS, num_theta_180 = 1<<(THETA_BITS-1), num_theta_90 = 1<<(THETA_BITS-2);
    double slope, tmp;

    if(mb_ext_level == 2)
    {
      for(i=0; i<4; i++)
      {
        shift_x[i] *= 2;
        shift_y[i] *= 2;
      }
    }
    for(mbj=CurrentMbAddr_y; mbj<=extend_y; mbj+=mb_ext_level)  
    {      
      for(mbi=CurrentMbAddr_x; mbi<=extend_x; mbi+=mb_ext_level)   
      {             

        if(mb_ext_level == 1)
        {
          encodeMbAddr = mbj*img->PicWidthInMbs + mbi;

          geo_mode = img->mb_data[encodeMbAddr].geo_mode;

          if(geo_mode == -1)
          {
            if(img->mb_data[encodeMbAddr].mb_type == 2)
              geo_mode = num_theta_90;
            else if(img->mb_data[encodeMbAddr].mb_type == 3)
              geo_mode = 0;
          }
        }
        else
        {
          geo_mode = saved_mb32_geo[counter];
          if(geo_mode == -1)
          {
            if(saveMode.MBsize32[counter] == 2)
              geo_mode = num_theta_90;
            else if(saveMode.MBsize32[counter] == 3)
              geo_mode = 0;
          }
        }

        if(geo_mode > -1)
        {
          get_rho_theta0(geo_mode, &rho, &theta_idx, mb_ext_level);

          if(theta_idx % num_theta_180 == 0)
          {
            new_rho = shift_x[counter] + rho;
            if(new_rho >=0)
              new_theta_idx = 0;
            else
            {
              new_rho = -new_rho;
              new_theta_idx = num_theta_180;
            }
          }
          else
          {  
#ifdef SIN_LUT
            slope = sinLUT32[(theta_idx+num_theta_90)%num_theta_360]/cosLUT32[(theta_idx+num_theta_90)%num_theta_360];

            tmp = shift_y[counter] - slope*shift_x[counter] + rho/sinLUT32[theta_idx];
            tmp *= fabs(sinLUT32[theta_idx]);
#else
            double theta = theta_idx * THETASTEP * 2*M_PI/360;
            slope = sin(theta+M_PI/2)/cos(theta+M_PI/2);
            tmp = shift_y[counter] - slope*shift_x[counter] + rho/sin(theta);
            tmp *= fabs(sin(theta));
#endif

            new_rho = (tmp>=0)? (int)(tmp+0.5) : (int) (tmp-0.5);
            if(new_rho >= 0)
            {
              if(theta_idx > num_theta_180)
                new_theta_idx = theta_idx - num_theta_180;
              else
                new_theta_idx = theta_idx;
            }
            else
            {
              new_rho = -new_rho;
              new_theta_idx = (theta_idx%num_theta_180) + num_theta_180;
            }
          }

          if(line_candidates >= 4)
          {
            line[4+new_lines].rho = new_rho;
            line[4+new_lines].thetai = new_theta_idx;
          }
          else
          {
            line[line_candidates+new_lines].rho = new_rho;
            line[line_candidates+new_lines].thetai = new_theta_idx;
          }
          new_lines++;
        }
        counter++;
      }
    }

    if(line_candidates >= 4)
      line_candidates = 4+new_lines;
    else
      line_candidates += new_lines;    
  }

  typedef enum 
  {
    P_A = 0,
    P_B,
    P_C,
    P_D,
    P_E,
    P_F,
    P_M //median
  } PREDTYPE;


  PREDTYPE geo_segm_mvp[][2]=
  { //  0          1          2          3          4          5          6          7          8          9          10          11
    {P_A,P_F}, {P_A,P_F}, {P_E,P_M}, {P_E,P_B}, {P_E,P_F}, {P_E,P_F}, {P_E,P_M}, {P_E,P_F}, {P_A,P_F}, {P_M,P_C}, {P_A, P_F}, {P_M, P_C}
  };

  PREDTYPE find_segm_mvp(int mb_ext_level, int geo_mode, int segm, int blocksize, PixelPos *block_a, PixelPos *block_b, PixelPos *block_c, PixelPos *block_d)
  {
    int rho = geo_mode>>5, theta_idx = geo_mode & 31;
    int a,b,c,d,e,f;

    a = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][0] & block_a->available;
    b = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][1] & block_b->available;
    c = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][2] & block_c->available;
    d = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][3] & block_d->available;
    e = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][4] & block_a->available;
    f = geo_mv_predictor[mb_ext_level+1][rho][theta_idx][segm][5] & block_b->available;

    if(a && b && (c||d))
      return P_M;
    else if(a)
      return P_A;
    else if(b)
      return P_B;
    else if(e)
      return P_E;
    else if(f)
      return P_F;
    else if(d)
    {
      error("no P_D available\n", -1);//return P_D;
      return 0;
    }
    else if(c)
      return P_C;
    else 
      return P_M;//error("no neighbors available \n", -1);

  }

  void SegmMVPredictor(int mb_ext_level, PREDTYPE geo_segm_pred, short pmv[2], PixelPos *block_a, PixelPos *block_b, PixelPos *block_c, PixelPos *block_d,
    short  ***tmp_mv)
  {
    int block_offset = 3<<mb_ext_level;

    //if(mb_ext_level==0)
    {
      switch(geo_segm_pred)
      {
      case P_A:
        pmv[0] = block_a->available  ? tmp_mv[block_a->pos_y][block_a->pos_x][0] : 0;
        pmv[1] = block_a->available  ? tmp_mv[block_a->pos_y][block_a->pos_x][1] : 0;
        break;
      case P_B:
        pmv[0] = block_b->available  ? tmp_mv[block_b->pos_y][block_b->pos_x][0] : 0;
        pmv[1] = block_b->available  ? tmp_mv[block_b->pos_y][block_b->pos_x][1] : 0;
        break;
      case P_C:
        pmv[0] = block_c->available  ? tmp_mv[block_c->pos_y][block_c->pos_x][0] : 0;
        pmv[1] = block_c->available  ? tmp_mv[block_c->pos_y][block_c->pos_x][1] : 0;
        break;
      case P_D:
        pmv[0] = block_d->available  ? tmp_mv[block_d->pos_y][block_d->pos_x][0] : 0;
        pmv[1] = block_d->available  ? tmp_mv[block_d->pos_y][block_d->pos_x][1] : 0;
        break;
      case P_E:
        pmv[0] = block_a->available  ? tmp_mv[block_a->pos_y+block_offset][block_a->pos_x][0] : 0;
        pmv[1] = block_a->available  ? tmp_mv[block_a->pos_y+block_offset][block_a->pos_x][1] : 0;
        break;
      case P_F:
        pmv[0] = block_b->available  ? tmp_mv[block_b->pos_y][block_b->pos_x+block_offset][0] : 0;
        pmv[1] = block_b->available  ? tmp_mv[block_b->pos_y][block_b->pos_x+block_offset][1] : 0;
        break;
      default:
        error("geo_segm_mvp[geo][segm] is out of range!", -1);
      }
    }

  }

  void SetMotionVectorPredictor32_geo (short  pmv[2],
    int    geo_mode, 
    int    segm, 
    char   **refPic,
    short  ***tmp_mv,
    short  ref_frame,
    int    list,
    int    block_x,
    int    block_y,
    int    blockshape_x,
    int    blockshape_y,
    int    mb_ext_level)
  {
    int mb_x                 = 4*block_x;
    int mb_y                 = 4*block_y;
    int mb_nr                = img->current_mb_nr;

    int mv_a=0, mv_b=0, mv_c=0, pred_vec=0;
    int mvPredType, rFrameL=0, rFrameU=0, rFrameUR=0;
    int hv;

    PixelPos block_a, block_b, block_c, block_d;



#ifdef MB32X32
    if(mb_ext_level > 0)
    {
      int reset_mb_nr, reset_block_x=block_x, reset_block_y=block_y;

      reset_mb_nr = ResetAvailabilityOfNeighbors32(mb_x, mb_y, &reset_block_x, &reset_block_y, blockshape_x, blockshape_y);

      getLuma4x4Neighbour(reset_mb_nr, reset_block_x, reset_block_y,           -1,  0, &block_a);
      getLuma4x4Neighbour(reset_mb_nr, reset_block_x, reset_block_y,            0, -1, &block_b);
      getLuma4x4Neighbour(reset_mb_nr, reset_block_x, reset_block_y, blockshape_x, -1, &block_c);
      getLuma4x4Neighbour(reset_mb_nr, reset_block_x, reset_block_y,           -1, -1, &block_d);
    }
    else
#endif
    {
      getLuma4x4Neighbour(mb_nr, block_x, block_y,           -1,  0, &block_a);
      getLuma4x4Neighbour(mb_nr, block_x, block_y,            0, -1, &block_b);
      getLuma4x4Neighbour(mb_nr, block_x, block_y, blockshape_x, -1, &block_c);
      getLuma4x4Neighbour(mb_nr, block_x, block_y,           -1, -1, &block_d);
    }

    //update block_a, block_b, block_c, block_d, block_available_right, block_available_below
    if(img->geo_scheme == 0)
    {
      if(geo_segm_mvp[geo_mode][segm] != P_M)
      {  
        SegmMVPredictor(mb_ext_level, geo_segm_mvp[geo_mode][segm], pmv, &block_a, &block_b, &block_c, &block_d, tmp_mv);
        return; 
      }
    }
    else //arbitrary
    {
      PREDTYPE geo_segm_pred;
      //assert(blockshape_x == 16);
      geo_segm_pred = find_segm_mvp(mb_ext_level, geo_mode, segm, blockshape_x, &block_a, &block_b, &block_c, &block_d);
      if(geo_segm_pred != P_M)
      {
        SegmMVPredictor(mb_ext_level, geo_segm_pred, pmv, &block_a, &block_b, &block_c, &block_d, tmp_mv);
        return;
      }
    }


    if (!block_c.available)
    {
      block_c=block_d;
    }

    mvPredType = MVPRED_MEDIAN;


    rFrameL    = block_a.available    ? refPic[block_a.pos_y][block_a.pos_x] : -1;
    rFrameU    = block_b.available    ? refPic[block_b.pos_y][block_b.pos_x] : -1;
    rFrameUR   = block_c.available    ? refPic[block_c.pos_y][block_c.pos_x] : -1;

    /* Prediction if only one of the neighbors uses the reference frame
    * we are checking
    */
    if(rFrameL == ref_frame && rFrameU != ref_frame && rFrameUR != ref_frame)       mvPredType = MVPRED_L;
    else if(rFrameL != ref_frame && rFrameU == ref_frame && rFrameUR != ref_frame)  mvPredType = MVPRED_U;
    else if(rFrameL != ref_frame && rFrameU != ref_frame && rFrameUR == ref_frame)  mvPredType = MVPRED_UR;
    // Directional predictions 
#ifdef MB32X32
    if(blockshape_x == (8<<mb_ext_level) && blockshape_y == (16<<mb_ext_level)) //MB32X32
#else
    if(blockshape_x == 8 && blockshape_y == 16)
#endif
    {
      if(mb_x == 0)
      {
        if(rFrameL == ref_frame)
          mvPredType = MVPRED_L;
      }
      else
      {
        if( rFrameUR == ref_frame)
          mvPredType = MVPRED_UR;
      }
    }
#ifdef MB32X32
    else if(blockshape_x == (16<<mb_ext_level) && blockshape_y == (8<<mb_ext_level)) //MB32X32
#else
    else if(blockshape_x == 16 && blockshape_y == 8)
#endif
    {
      if(mb_y == 0)
      {
        if(rFrameU == ref_frame)
          mvPredType = MVPRED_U;
      }
      else
      {
        if(rFrameL == ref_frame)
          mvPredType = MVPRED_L;
      }
    }

    for (hv=0; hv < 2; hv++)
    {
      mv_a = block_a.available  ? tmp_mv[block_a.pos_y][block_a.pos_x][hv] : 0;
      mv_b = block_b.available  ? tmp_mv[block_b.pos_y][block_b.pos_x][hv] : 0;
      mv_c = block_c.available  ? tmp_mv[block_c.pos_y][block_c.pos_x][hv] : 0;


      switch (mvPredType)
      {
      case MVPRED_MEDIAN:
        if(!(block_b.available || block_c.available))
        {
          pred_vec = mv_a;
        }
        else
        {
          pred_vec = mv_a+mv_b+mv_c-min(mv_a,min(mv_b,mv_c))-max(mv_a,max(mv_b,mv_c));
        }
        break;
      case MVPRED_L:
        pred_vec = mv_a;
        break;
      case MVPRED_U:
        pred_vec = mv_b;
        break;
      case MVPRED_UR:
        pred_vec = mv_c;
        break;
      default:
        break;
      }
      pmv[hv] = pred_vec;
    }
  }

  int                                         //!< minimum motion cost after search
    BlockMotionSearch32_geo (short     ref,           //!< reference idx
    int       list,          //!< reference pciture list
    pel_t ** orig_pic,    // <--  original pixel values for the AxB block
    int       mb_x,          //!< x-coordinate inside macroblock   (in the unit of pel -peisong)
    int       mb_y,          //!< y-coordinate inside macroblock   (in the unit of pel -peisong)
    int       scheme,
    int       geo_mode,     //!< block type (1-16x16 ... 7-4x4)
    int       segm,
    int       search_range,  //!< 1-d search range for integer-position search
    int       lambda_factor, //!< lagrangian parameter for determining motion cost
    int       mb_ext_level) 
  {

    int mv[2],mv_reuse=0;

#ifndef MB32X32
    static pel_t   orig_val [256];
    static pel_t  *orig_pic  [16] = {orig_val,     orig_val+ 16, orig_val+ 32, orig_val+ 48,
      orig_val+ 64, orig_val+ 80, orig_val+ 96, orig_val+112,
      orig_val+128, orig_val+144, orig_val+160, orig_val+176,
      orig_val+192, orig_val+208, orig_val+224, orig_val+240};
#endif

    int       blocktype=1;

    short     pred_mv_x, pred_mv_y, mv_x, mv_y;
    int       i, j;
#ifdef EIGHTH_PEL
    int       mvshift   = (img->mv_res ? 3 : 2);
#endif
    int       max_value = INT_MAX;
    int       min_mcost = max_value;

    int       block_x   = (mb_x>>2);   //scalable to MB32X32
    int       block_y   = (mb_y>>2);

#ifdef MB32X32
    int       bsx       = input->blc_size[blocktype][0]<<mb_ext_level; //blc_size = part_sizes * BLOCK_SIZE 
    int       bsy       = input->blc_size[blocktype][1]<<mb_ext_level;
#else
    int       bsx       = input->blc_size[blocktype][0];
    int       bsy       = input->blc_size[blocktype][1];
#endif

    int       pic_pix_x = img->opix_x + mb_x;
    int       pic_pix_y = img->opix_y + mb_y;

    static int min_mcost_offset;

    short*    pred_mv = img->pred_mv[block_y][block_x][list][ref][blocktype];
    short****** all_mv    = img->all_mv;  
    int list_offset = 0;
    int *prevSad = (input->FMEnable == 3)? EPZSDistortion[list + list_offset][blocktype - 1]: NULL;

    //===========================================
    //=====   GET MOTION VECTOR PREDICTOR   =====
    //===========================================
#ifdef MV_COMPETITION_
    if (input->mv_competition > 0)
      SetMotionVectorPredictor_Competition (pred_mv, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy);
    else
#endif
#ifdef MB32X32
      SetMotionVectorPredictor32_geo (pred_mv, geo_mode, segm, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy, mb_ext_level);  //scalable to MB32X32
#else
      SetMotionVectorPredictor (pred_mv, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy);
#endif  

    pred_mv_x = pred_mv[0];
    pred_mv_y = pred_mv[1];
    mv_reuse = get_regular_motion(geo_mode, segm, mv, list, ref, mb_ext_level);
    if(mv_reuse)
    {
      mv_x = mv[0] / (1 << mvshift);
      mv_y = mv[1] / (1 << mvshift);
      mv_x = Clip3(-2047 + search_range, 2047 - search_range, mv_x);
      mv_y = Clip3(LEVELMVLIMIT[img->LevelIndex][0] + search_range, LEVELMVLIMIT[img->LevelIndex][1]  - search_range, mv_y);
      min_mcost = EPZS_RMV_Refinement_Pel (orig_pic, ref, list, list_offset, 
        enc_picture->ref_idx, enc_picture->mv,pic_pix_x, pic_pix_y, blocktype,
        pred_mv_x, pred_mv_y, &mv_x, &mv_y, search_range, min_mcost, lambda_factor, scheme, geo_mode, segm, mb_ext_level); //scalable to MB32X32
    }
    else
    {

    //==================================
    //=====   INTEGER-PEL SEARCH   =====
    //==================================

    //--- set search center ---
#ifdef EIGHTH_PEL
    mv_x = pred_mv_x / (1 << mvshift);
    mv_y = pred_mv_y / (1 << mvshift);
#else
    mv_x = pred_mv_x / 4;
    mv_y = pred_mv_y / 4;
#endif
    //mv_x = (pred_mv_x + 2)>> 2;
    //mv_y = (pred_mv_y + 2)>> 2;    

    mv_x = Clip3(-2047 + search_range, 2047 - search_range, mv_x);
    mv_y = Clip3(LEVELMVLIMIT[img->LevelIndex][0] + search_range, LEVELMVLIMIT[img->LevelIndex][1]  - search_range, mv_y);

#ifdef MB32X32
    min_mcost = EPZSPelBlockMotionSearch32_geo (orig_pic, ref, list, list_offset, 
      enc_picture->ref_idx, enc_picture->mv,pic_pix_x, pic_pix_y, blocktype,
      pred_mv_x, pred_mv_y, &mv_x, &mv_y, search_range, min_mcost, lambda_factor, scheme, geo_mode, segm, mb_ext_level); //scalable to MB32X32
#else
    min_mcost = EPZSPelBlockMotionSearch (orig_pic, ref, list, list_offset, 
      enc_picture->ref_idx, enc_picture->mv,pic_pix_x, pic_pix_y, blocktype,
      pred_mv_x, pred_mv_y, &mv_x, &mv_y, search_range, min_mcost, lambda_factor);
#endif
    }

    if(img->filterParam == SIFO_FIRST_PASS_FPO)
    {
      if(img->currMEOffset[list] == 0)
      {
        min_mcost_offset = min_mcost;
      }
      else
      {
        if(min_mcost < min_mcost_offset)
        {
          min_mcost_offset = min_mcost;
          if(input->EPZSSpatialMem)  
          {
            EPZSMotion[list + list_offset][ref][blocktype - 1][block_y][pic_pix_x >> 2][0] = (short) mv_x;
            EPZSMotion[list + list_offset][ref][blocktype - 1][block_y][pic_pix_x >> 2][1] = (short) mv_y;
          }
        }
      }
    }


    //===== convert search center to quarter-pel units =====
    mv_x <<= 2;
    mv_y <<= 2;

    //==============================
    //=====   SUB-PEL SEARCH   =====
    //==============================
    if (!input->DisableSubpelME)
    {
      if (input->FMEnable != 3 || (ref == 0 || img->structure != FRAME || (ref > 0 && min_mcost < 3.5 * prevSad[pic_pix_x >> 2])))
      {

        if (input->hadamard == 1)
        {
          min_mcost = max_value;
        }

        {
          if (input->EPZSSubPelME)
#ifdef EIGHTH_PEL
#ifdef MB32X32
            min_mcost =  EPZSSubPelBlockMotionSearch32_geo (orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
            pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, 9, min_mcost, lambda_factor, scheme, geo_mode, segm, mb_ext_level);            
#else
            min_mcost =  EPZSSubPelBlockMotionSearch (orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
            pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, 9, min_mcost, lambda_factor);            
#endif
#else
#ifdef MB32X32
            min_mcost =  EPZSSubPelBlockMotionSearch32 (orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
            pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, min_mcost, lambda_factor, mb_ext_level);            
#else
            min_mcost =  EPZSSubPelBlockMotionSearch (orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
            pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, min_mcost, lambda_factor);            
#endif
#endif
          else
          {
#ifdef MB32X32
            error("should not get here !\n", -1);
#endif

          }
        }
      }
    }

    //===============================================
    //=====   SET MV'S AND RETURN MOTION COST   =====
    //===============================================

#ifdef MV_COMPETITION_
    if (input->mv_competition > 0)
      GetBestPredVector( pred_mv,mv_x,mv_y,lambda_factor,ref,list,blocktype,mb_x,mb_y);  
#endif

    if(img->filterParam == SIFO_FIRST_PASS_FPO)
    {
      if(img->currMEOffset[list] == 0)
      {
        for(j = block_y; j < block_y + (bsy>>2); j++)    
        {
          for(i = block_x; i < block_x + (bsx>>2); i++)
          {
            all_mv[j][i][list][ref][blocktype][0] = mv_x;
            all_mv[j][i][list][ref][blocktype][1] = mv_y;
          }
        }
      }
      else
      {
        if(min_mcost < img->min_mcost_offset[list])
        {
          for(j = block_y; j < block_y + (bsy>>2); j++)    
          {
            for(i = block_x; i < block_x + (bsx>>2); i++)
            {
              all_mv[j][i][list][ref][blocktype][0] = mv_x;
              all_mv[j][i][list][ref][blocktype][1] = mv_y;
            }
          }
        }
      }
    }
    else
    {
      for (j=block_y; j < block_y + (bsy>>2); j++)    
      {
        for (i=block_x; i < block_x + (bsx>>2); i++)
        {
          all_mv[j][i][list][ref][blocktype][0] = mv_x;
          all_mv[j][i][list][ref][blocktype][1] = mv_y;
        }
      }
    }

    return min_mcost;
  }


  void
    PartitionMotionSearch32_geo (int scheme,
    pel_t ** orig_pic,    // <--  original pixel values for the AxB block
    int    geo_mode,
    int    segm, //MB32x32: block8x8=32x32, 32x16, 16x32, 16x16; MB16x16: block8x8=16x16, 16x8, 8x16, 8x8 -peisong 
    int    lambda_factor,
#ifdef RDO_Q
    int   transform8x8,
#endif
    int  mb_ext_level
    )
  {
#ifdef MB32X32  
    //upper left corner co-or in the unit of 4x4 pel per block -peisong
    static int  bx0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,4,0,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,8,0,8}}
    };
    static int  by0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,0,0,0}, {0,0,4,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,0,0,0}, {0,0,8,8}}
    };
#else
    static int  bx0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}};
    static int  by0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}};
#endif

    char  **ref_array;
    short ***mv_array;
    short *all_mv;
    short ref;
    int   v, h, mcost, search_range, i, j;
    int   pic_block_x, pic_block_y;
    int   bslice    = (img->type==B_SLICE);
    int   blocktype = 1;
    //int   geo_blocktype=0;
    int   block8x8  = 0;
    int   parttype  = (blocktype<4?blocktype:4);
#ifdef MB32X32
    int   step_h0   = (input->part_size[ parttype][0])<<mb_ext_level; // in the unit of 4x4 pel per block (at or above 8x8 level) -peisong
    int   step_v0   = (input->part_size[ parttype][1])<<mb_ext_level; 
    int   step_h    = (input->part_size[blocktype][0])<<mb_ext_level; // all levels -peisong
    int   step_v    = (input->part_size[blocktype][1])<<mb_ext_level;
#else
    int   step_h0   = (input->part_size[ parttype][0]);
    int   step_v0   = (input->part_size[ parttype][1]);
    int   step_h    = (input->part_size[blocktype][0]);
    int   step_v    = (input->part_size[blocktype][1]);
#endif
    int   list;
    int   numlists  = bslice ? 2 : 1;
    int   list_offset = img->mb_data[img->current_mb_nr].list_offset; 
    int   block_y;
    int   *m_cost = NULL;
#ifdef MB32X32
    int   by = by0_ext[mb_ext_level][parttype][block8x8]; //scalable to MB32X32 because by0 and bx0 have been adapted to MB32X32
    int   bx = bx0_ext[mb_ext_level][parttype][block8x8];
    //  int   mb32i = (mb_ext_level==0) ? 0 : ((mb_ext_level==1) ? curr_mb32i : 4);//mb_ext_level=1: 0~3; mb_ext_level=2: 4
#else
    int   by = by0[parttype][block8x8]; //scalable to MB32X32 because by0 and bx0 have been adapted to MB32X32
    int   bx = bx0[parttype][block8x8];
#endif
    int   mcost_temp;


    //===== LOOP OVER REFERENCE FRAMES =====
    for (list=0; list<numlists;list++)
    {
      for (ref=0; ref < listXsize[list+list_offset]; ref++)
      {
#ifdef RDO_Q
        if(input->UseRDO_Q)
        {
          if (Motion_Selected == 0)  
            m_cost = &motion_cost_geo[geo_mode][segm][blocktype][list][ref][block8x8];
        }
        else
#endif
          m_cost = &motion_cost_geo[geo_mode][segm][blocktype][list][ref][block8x8];

        //----- set search range ---
#ifdef _FULL_SEARCH_RANGE_
        if      (input->full_search == 2) 
          search_range = input->search_range;
        else if (input->full_search == 1) 
          search_range = input->search_range /  (min(ref,1)+1);
        else                              
          search_range = input->search_range / ((min(ref,1)+1) * min(2,blocktype));
#else
        search_range = input->search_range / ((min(ref,1)+1) * min(2,blocktype));
#endif

        //----- set arrays -----
        ref_array = enc_picture->ref_idx[list];
        mv_array  = enc_picture->mv[list];

        //----- init motion cost -----
        //motion_cost[blocktype][list][ref][block8x8] = 0;
#ifdef RDO_Q
        if (!(input->UseRDO_Q) || Motion_Selected == 0)
#endif
          *m_cost = 0;

        //===== LOOP OVER SUB MACRO BLOCK partitions
        //for 32x32, 32x16 and 16x32 step_h(v)0=step_h(v)  -peisong
        for (v=by; v<by + step_v0; v += step_v)// by: the coordinator of 8x8 block in the unit of 4x4 in a 16x16 MB -peisong
        {
          pic_block_y = img->block_y + v;

          for (h=bx; h<bx+step_h0; h+=step_h)
          {
            all_mv = img->all_mv[v][h][list][ref][blocktype];
            pic_block_x = img->block_x + h;

            //--- motion search for block ---

#ifdef RDO_Q
            if(input->UseRDO_Q) 
            {
#ifdef MB32X32
              //            int       bsx       = (input->blc_size[blocktype][0])<<mb_ext_level; //blc_size = part_sizes * BLOCK_SIZE 
              //            int       bsy       = (input->blc_size[blocktype][1])<<mb_ext_level;
#else
              int       bsx       = input->blc_size[blocktype][0];
              int       bsy       = input->blc_size[blocktype][1];
#endif
              if (Motion_Selected == 0)
              { 
#ifdef MB32X32

                int mv[2],mv_reuse=0;
                if(Segmentation_Selected==0)
                  mv_reuse = get_regular_motion(geo_mode, segm, mv, list, ref, mb_ext_level);

                if(mv_reuse)
                  mcost = BlockMotionCost32_geo     (mv, ref, list, orig_pic, h<<2, v<<2, scheme, geo_mode, segm, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32
                else
                {
                  img->currMEOffset[list] = 0;
                  mcost = BlockMotionSearch32_geo     (ref, list, orig_pic, h<<2, v<<2, scheme, geo_mode, segm, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32

                  if(img->filterParam == SIFO_FIRST_PASS_FPO)
                  {
                    img->min_mcost_offset[list] = mcost;
                    if (img->noMEOffsets[list] > 0 && (ref == 0))
                    {
                      for (i=0; i<img->noMEOffsets[list]; i++)
                      {
                        img->currMEOffset[list] = img->offsetMETab[list][i];
                        mcost_temp = BlockMotionSearch32_geo     (ref, list, orig_pic, h<<2, v<<2, scheme, geo_mode, segm, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32
                        mcost = (mcost_temp < mcost)? mcost_temp: mcost;
                        img->min_mcost_offset[list] = mcost;
                      }
                    }
                  }
                }
#else
                mcost = BlockMotionSearch     (ref, list, h<<2, v<<2, blocktype, search_range, lambda_factor);
#endif
                *m_cost += mcost;
              }
            }
            else
            {
#ifdef MB32X32
              img->currMEOffset[list] = 0;
              mcost = BlockMotionSearch32_geo     (ref, list, orig_pic, h<<2, v<<2, scheme, geo_mode, segm, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32

              if(img->filterParam == SIFO_FIRST_PASS_FPO)
              {
                img->min_mcost_offset[list] = mcost;
                if (img->noMEOffsets[list] > 0 && (ref == 0))
                {
                  for (i=0; i<img->noMEOffsets[list]; i++)
                  {
                    img->currMEOffset[list] = img->offsetMETab[list][i];
                    mcost_temp = BlockMotionSearch32_geo     (ref, list, orig_pic, h<<2, v<<2, scheme, geo_mode, segm, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32
                    mcost = (mcost_temp < mcost)? mcost_temp: mcost;
                    img->min_mcost_offset[list] = mcost;
                  }
                }
              }
#else
              mcost = BlockMotionSearch     (ref, list, h<<2, v<<2, blocktype, search_range, lambda_factor);
#endif
              *m_cost += mcost;
            }

#else
#ifdef MB32X32
            mcost = BlockMotionSearch32     (ref, list, h<<2, v<<2, blocktype, search_range, lambda_factor, mb_ext_level); //scalable to MB32X32
#else
            mcost = BlockMotionSearch     (ref, list, h<<2, v<<2, blocktype, search_range, lambda_factor);
#endif
            *m_cost += mcost;
#endif
            //--- set motion vectors and reference frame (for motion vector prediction) ---
            for (j=0; j<step_v; j++) //scalable to MB32X32
            {
              block_y = pic_block_y+j;  
              memset(&ref_array [block_y][pic_block_x], ref, step_h * sizeof(char));

              for (i=0; i<step_h; i++)
              {
                memcpy(mv_array  [block_y][pic_block_x+i], all_mv, 2* sizeof(short));
              }
            }
          }
        }
      }
    }
  }

  int best8x8fwref_geo[GEO_PART_NUM][2];
  int best8x8pdir_geo[GEO_PART_NUM][2];
  int best8x8bwref_geo[GEO_PART_NUM][2];
  extern short**** geo_mv[GEO_PART_NUM][2];
  extern short****** saved_all_mv;
  extern short****** saved_pred_mv;

  /*
  * restore_flag = 0 -- back up img->all_mv
  * restore_flag = 1 -- restore img->all_mv
  */
  void backup_restore_all_mv(short****** all_mv, short****** saved_all_mv, int mb_ext_level, int restore_flag)
  {
    int i, j, list, ref, mode=1, k;


    for(i=0; i<(4<<mb_ext_level); i++)
      for(j=0; j<(4<<mb_ext_level); j++)
        for(list=0; list<2; list++)
          for(ref=0; ref<img->max_num_references; ref++)
            //for(mode=1; mode<2; mode++)
            for(k=0; k<2; k++)                    
            {
              if(restore_flag)
                all_mv [i][j][list][ref][mode][k] = saved_all_mv [i][j][list][ref][mode][k];
              else
                saved_all_mv [i][j][list][ref][mode][k] = all_mv [i][j][list][ref][mode][k];
            }

  }

  void backup_geo_mv(int geo_mode, int segm, char best_ref[2], short best_pdir, int mb_ext_level)
  {
    int list, ref, mode=1, k;

    best8x8fwref_geo [geo_mode][segm] = best_ref[LIST_0];
    best8x8pdir_geo  [geo_mode][segm] = best_pdir;
    best8x8bwref_geo [geo_mode][segm] = best_ref[LIST_1];
    for(list=0; list<2; list++)
      for(ref=0; ref<img->max_num_references; ref++)
        for(k=0; k<2; k++)                    
        {
          geo_mv     [geo_mode][segm]/*[i][j]*/[list][ref][mode][k] = img->all_mv [0][0][list][ref][mode][k];
        }

  }

  void copy_geo_mv(int mbi_x, int mbi_y, int geo_mode, int segm)//, int mb_ext_level
  {
    int i, j, list, ref, mode=1, k;


    best8x8fwref [1][0] = best8x8fwref [1][1] = best8x8fwref [1][2] = best8x8fwref [1][3] = best8x8fwref_geo [geo_mode][segm];
    best8x8pdir  [1][0] = best8x8pdir  [1][1] = best8x8pdir  [1][2] = best8x8pdir  [1][3] = best8x8pdir_geo  [geo_mode][segm];
    best8x8bwref [1][0] = best8x8bwref [1][1] = best8x8bwref [1][2] = best8x8bwref [1][3] = best8x8bwref_geo [geo_mode][segm];


    for(i=0; i<4; i++)
      for(j=0; j<4; j++)
        for(list=0; list<2; list++)
          for(ref=0; ref<img->max_num_references; ref++)
            //for(mode=1; mode<2; mode++)
            for(k=0; k<2; k++)           
              img->all_mv[i][j][list][ref][mode][k] = geo_mv[geo_mode][segm]/*[mbi_y*4+i][mbi_x*4+j]*/[list][ref][mode][k];

  }

  int BIDPartitionCost32_geo (//int   blocktype,
    //int   block8x8,
    int   scheme,
    int   geo_mode,
    int   segm,
    short fw_ref,
    short bw_ref,
    int   lambda_factor, 
    int blocktype, 
    int block8x8,
    int mb_ext_level)
  {
#ifdef MB32X32
    static int  bx0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,4,0,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,8,0,8}}
    };
    static int  by0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,0,0,0}, {0,0,4,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,0,0,0}, {0,0,8,8}}
    };
#else
    static int  bx0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}};
    static int  by0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}};
    int   diff[64];
    int   curr_blk[MB_BLOCK_SIZE][MB_BLOCK_SIZE]; // ABT pred.error buffer
#endif

    int   pic_pix_x, pic_pix_y, block_x, block_y;
    int   v, h, mcost, i, j, k;
    int   mvd_bits  = 0;
    int   parttype  = (blocktype<4?blocktype:4);
#ifdef MB32X32
    int   step_h0   = (input->part_size[ parttype][0])<<mb_ext_level;
    int   step_v0   = (input->part_size[ parttype][1])<<mb_ext_level;
    int   step_h    = (input->part_size[blocktype][0])<<mb_ext_level;
    int   step_v    = (input->part_size[blocktype][1])<<mb_ext_level;
#else
    int   step_h0   = (input->part_size[ parttype][0]);
    int   step_v0   = (input->part_size[ parttype][1]);
    int   step_h    = (input->part_size[blocktype][0]);
    int   step_v    = (input->part_size[blocktype][1]);
#endif
    int   bxx, byy;                               // indexing curr_blk
#ifdef MB32X32
    int   bx = bx0_ext[mb_ext_level][parttype][block8x8];
    int   by = by0_ext[mb_ext_level][parttype][block8x8];
#else
    int   bx = bx0[parttype][block8x8];
    int   by = by0[parttype][block8x8];
#endif
    short   ******all_mv = img->all_mv;
    short   ******  p_mv = img->pred_mv;

    //----- cost for motion vector bits -----
    if (img->mv_res)
    {
      for (v=by; v<by + step_v0; v+=step_v)
      {
        for (h=bx; h<bx + step_h0; h+=step_h)
        {
          if (((all_mv [v][h][LIST_0][fw_ref][blocktype][0]&1)==0) && ((all_mv [v][h][LIST_0][fw_ref][blocktype][1]&1)==0))
          {
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_0][fw_ref][blocktype][0],1) - roundInt(p_mv[v][h][LIST_0][fw_ref][blocktype][0],1) ];
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_0][fw_ref][blocktype][1],1) - roundInt(p_mv[v][h][LIST_0][fw_ref][blocktype][1],1) ];
          }
          else
          {
            mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][0] - p_mv[v][h][LIST_0][fw_ref][blocktype][0] ];
            mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][1] - p_mv[v][h][LIST_0][fw_ref][blocktype][1] ];
            mvd_bits +=1;
          }
          if (((all_mv [v][h][LIST_1][bw_ref][blocktype][0]&1)==0) && ((all_mv [v][h][LIST_1][bw_ref][blocktype][1]&1)==0))
          {
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_1][bw_ref][blocktype][0],1) - roundInt(p_mv[v][h][LIST_1][bw_ref][blocktype][0],1) ];
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_1][bw_ref][blocktype][1],1) - roundInt(p_mv[v][h][LIST_1][bw_ref][blocktype][1],1) ];
          }
          else
          {
            mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][0] - p_mv[v][h][LIST_1][bw_ref][blocktype][0] ];
            mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][1] - p_mv[v][h][LIST_1][bw_ref][blocktype][1] ];
            mvd_bits +=1;
          }
        }
      }
    }
    else
    {
      for (v=by; v<by + step_v0; v+=step_v)  //scalable to MB32X32
      {
        for (h=bx; h<bx + step_h0; h+=step_h)
        {
          mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][0] - p_mv[v][h][LIST_0][fw_ref][blocktype][0] ];
          mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][1] - p_mv[v][h][LIST_0][fw_ref][blocktype][1] ];

          mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][0] - p_mv[v][h][LIST_1][bw_ref][blocktype][0] ];
          mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][1] - p_mv[v][h][LIST_1][bw_ref][blocktype][1] ];
        }
      }
    }
    mcost = WEIGHTED_COST (lambda_factor, mvd_bits);

    //----- cost of residual signal -----
    for (byy=0, v=by; v<by + step_v0; byy+=4, v++)  //scalable to MB32X32
    {
      pic_pix_y = img->opix_y + (block_y = (v<<2));  //scalable to MB32X32
      for (bxx=0, h=bx; h<bx + step_h0; bxx+=4, h++)
      {
#if GEO_SCHEME == 0 
        if(scheme == 0)
        {
          int b4x4 = (byy>>2)*(step_h0<<mb_ext_level)+(bxx>>2);
          if(MB16GeoMask[geo_mode][b4x4] != segm)
            continue;
        }
#endif
        pic_pix_x = img->opix_x + (block_x = (h<<2));
        LumaPrediction4x4 (block_x, block_y, 2, blocktype, blocktype, fw_ref, bw_ref);

        for (k=j=0; j<4; j++)
        {
          for (  i=0; i<4; i++)
          {
            if(mask[byy+j][bxx+i] == segm)
            {
              mcost += byte_abs [imgY_org[pic_pix_y+j][pic_pix_x+i] - img->mpr[j+block_y][i+block_x]];
            }
          }
        }

#if GEO_SCHEME == 0 
        if(scheme == 0)
          //if ((!input->Transform8x8Mode) || (blocktype>4))
          mcost += SATD (diff, input->hadamard);
#endif
      }
    }


    return mcost;
  }

  /*!
  ***********************************************************************
  * \brief
  *    Motion Cost for Bidirectional modes
  ***********************************************************************
  */
  int BPredPartitionCost32_geo (//int   blocktype,
    //int   block8x8,
    int geo_mode,
    int   segm,
    short fw_ref,
    short bw_ref,
    int   lambda_factor,
    int   list,
    int mb_ext_level)
  {
    int blocktype = 1, block8x8=0;

#ifdef MB32X32
    static int  bx0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,4,0,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,8,0,8}}
    };
    static int  by0_ext[3][5][4] = { {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}},
    {{0,0,0,0}, {0,0,0,0}, {0,4,0,0}, {0,0,0,0}, {0,0,4,4}},
    {{0,0,0,0}, {0,0,0,0}, {0,8,0,0}, {0,0,0,0}, {0,0,8,8}}
    };
    int (*bx0)[4]=bx0_ext[mb_ext_level];
    int (*by0)[4]=by0_ext[mb_ext_level];
    int   diff[64];
    int   curr_blk[MB_BLOCK_SIZE<<MAX_MB_EXT_LEVEL][MB_BLOCK_SIZE<<MAX_MB_EXT_LEVEL]; // ABT pred.error buffer
#else
    static int  bx0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,2,0,2}};
    static int  by0[5][4] = {{0,0,0,0}, {0,0,0,0}, {0,2,0,0}, {0,0,0,0}, {0,0,2,2}};
    int   diff[64];
    int   curr_blk[MB_BLOCK_SIZE][MB_BLOCK_SIZE]; // ABT pred.error buffer
#endif  
    int   bsx       = min(input->blc_size[blocktype][0],8); //scalable to MB32X32
    int   bsy       = min(input->blc_size[blocktype][1],8);

    int   pic_pix_x, pic_pix_y, block_x, block_y;
    int   v, h, mcost, i, j, k;
    int   mvd_bits  = 0;
    int   parttype  = (blocktype<4?blocktype:4);
#ifdef MB32X32
    int   step_h0   = (input->part_size[ parttype][0])<<mb_ext_level;
    int   step_v0   = (input->part_size[ parttype][1])<<mb_ext_level;
    int   step_h    = (input->part_size[blocktype][0])<<mb_ext_level;
    int   step_v    = (input->part_size[blocktype][1])<<mb_ext_level;
#else
    int   step_h0   = (input->part_size[ parttype][0]);
    int   step_v0   = (input->part_size[ parttype][1]);
    int   step_h    = (input->part_size[blocktype][0]);
    int   step_v    = (input->part_size[blocktype][1]);
#endif
    int   bxx, byy;                               // indexing curr_blk

    short   ******all_mv = list ? img->bipred_mv1 : img->bipred_mv2;
    short   ******  p_mv = img->pred_mv;
    if (img->mv_res)
    {
      for (v=by0[parttype][block8x8]; v<by0[parttype][block8x8]+step_v0; v+=step_v)
      {
        for (h=bx0[parttype][block8x8]; h<bx0[parttype][block8x8]+step_h0; h+=step_h)
        {
          if (((all_mv [v][h][LIST_0][fw_ref][blocktype][0]&1)==0) && ((all_mv [v][h][LIST_0][fw_ref][blocktype][1]&1)==0))
          {
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_0][fw_ref][blocktype][0],1) - roundInt(p_mv[v][h][LIST_0][fw_ref][blocktype][0],1) ];
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_0][fw_ref][blocktype][1],1) - roundInt(p_mv[v][h][LIST_0][fw_ref][blocktype][1],1) ];
          }
          else
          {
            mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][0] - p_mv[v][h][LIST_0][fw_ref][blocktype][0] ];
            mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][1] - p_mv[v][h][LIST_0][fw_ref][blocktype][1] ];
            mvd_bits +=1;
          }
          if (((all_mv [v][h][LIST_1][bw_ref][blocktype][0]&1)==0) && ((all_mv [v][h][LIST_1][bw_ref][blocktype][1]&1)==0))
          {
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_1][bw_ref][blocktype][0],1) - roundInt(p_mv[v][h][LIST_1][bw_ref][blocktype][0],1) ];
            mvd_bits += mvbits[ roundInt(all_mv [v][h][LIST_1][bw_ref][blocktype][1],1) - roundInt(p_mv[v][h][LIST_1][bw_ref][blocktype][1],1) ];
          }
          else
          {
            mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][0] - p_mv[v][h][LIST_1][bw_ref][blocktype][0] ];
            mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][1] - p_mv[v][h][LIST_1][bw_ref][blocktype][1] ];
            mvd_bits +=1;
          }
        }
      }
    }
    else
    {
      for (v=by0[parttype][block8x8]; v<by0[parttype][block8x8]+step_v0; v+=step_v)
      {
        for (h=bx0[parttype][block8x8]; h<bx0[parttype][block8x8]+step_h0; h+=step_h)
        {
          mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][0] - p_mv[v][h][LIST_0][fw_ref][blocktype][0] ];
          mvd_bits += mvbits[ all_mv [v][h][LIST_0][fw_ref][blocktype][1] - p_mv[v][h][LIST_0][fw_ref][blocktype][1] ];

          mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][0] - p_mv[v][h][LIST_1][bw_ref][blocktype][0] ];
          mvd_bits += mvbits[ all_mv [v][h][LIST_1][bw_ref][blocktype][1] - p_mv[v][h][LIST_1][bw_ref][blocktype][1] ];
        }
      }
    }
    mcost = WEIGHTED_COST (lambda_factor, mvd_bits);

    //----- cost of residual signal -----
    for (byy=0, v=by0[parttype][block8x8]; v<by0[parttype][block8x8]+step_v0; byy+=4, v++) //scalable to MB32X32
    {

      pic_pix_y = img->opix_y + (block_y = (v<<2));      //scalable to MB32X32

      for (bxx=0, h=bx0[parttype][block8x8]; h<bx0[parttype][block8x8]+step_h0; bxx+=4, h++)//scalable to MB32X32
      {
        int b4x4 = (byy/4)*(4<<mb_ext_level)+(bxx/4);
        if(MB16GeoMask[geo_mode][b4x4] != segm)
          continue;

        pic_pix_x = img->opix_x + (block_x = (h<<2));        //scalable to MB32X32
        LumaPrediction4x4Bi (block_x, block_y, 2, blocktype, blocktype, fw_ref, bw_ref, list);

        for (k=j=0; j<4; j++)
        {
          for (  i=0; i<4; i++)
            diff[k++] = curr_blk[byy+j][bxx+i] = 
            imgY_org[pic_pix_y+j][pic_pix_x+i] - img->mpr[j+block_y][i+block_x];            
        }

        mcost += SATD (diff, input->hadamard);          
      }
    }

    return mcost;
  }

  void list_prediction_cost32_geo(int list, int scheme, int geo_mode, int segm, RD_PARAMS enc_mb, int bmcost[5], char best_ref[2], int mb_ext_level)
  {
    short ref;
    int mcost;
    int cur_list = list < BI_PRED ? enc_mb.list_offset[list] : enc_mb.list_offset[LIST_0];

    //--- get cost and reference frame for forward prediction ---

    if (list < BI_PRED)
    {
      for (ref=0; ref < listXsize[cur_list]; ref++)
      {
        if (!img->checkref || list || ref==0 || CheckReliabilityOfRef (0, list, ref, 1)) //img->checkref=0 -peisong
        {
          // limit the number of reference frames to 1 when switching SP frames are used
          if((!input->sp2_frame_indicator && !input->sp_output_indicator)||
            ((input->sp2_frame_indicator || input->sp_output_indicator) && (img->type!=P_SLICE && img->type!=SP_SLICE))||
            ((input->sp2_frame_indicator || input->sp_output_indicator) && ((img->type==P_SLICE || img->type==SP_SLICE) &&(ref==0))))
          {
            mcost  = (input->rdopt 
              ? REF_COST (enc_mb.lambda_mf, ref, cur_list) 
              : (int) (2 * enc_mb.lambda_me * min(ref, 1)));     

            mcost += motion_cost_geo[geo_mode][segm][1][list][ref][0];
            if (mcost < bmcost[list])
            {
              bmcost[list]   = mcost;
              best_ref[list] = (char)ref;
            }
          }
        }
      }
    }
    else if (list == BI_PRED)
    {
      bmcost[list]  = (input->rdopt 
        ? (REF_COST  (enc_mb.lambda_mf, (short)best_ref[LIST_0], cur_list)
        +  REF_COST  (enc_mb.lambda_mf, (short)best_ref[LIST_1], cur_list + LIST_1)) 
        : (int) (2 * (enc_mb.lambda_me * (min((short)best_ref[LIST_0], 1) + min((short)best_ref[LIST_1], 1)))));    
#ifdef MB32X32
      bmcost[list] += BIDPartitionCost32_geo (scheme, geo_mode, segm, (short)best_ref[LIST_0], (short)best_ref[LIST_1], enc_mb.lambda_mf, 1, 0, mb_ext_level);    
#else
      bmcost[list] += BIDPartitionCost (mode, block, (short)best_ref[LIST_0], (short)best_ref[LIST_1], enc_mb.lambda_mf);    
#endif
    }
    else
    {
      error("list > BI_PRED", -1);
    }
  }  

  void store_macroblock_parameters_geo (int geo_mode)
  {
    int  j, ****i4p, ***i3p;
    Macroblock *currMB  = &img->mb_data[img->current_mb_nr];

    //--- store best mode ---
    best_geo_mode = geo_mode;
    best_c_imode = currMB->c_ipred_mode;

    //--- reconstructed blocks ----
    for (j = 0; j < MB_BLOCK_SIZE; j++)
    {
      memcpy(rec_mbY[j],&enc_picture->imgY[img->pix_y+j][img->pix_x], MB_BLOCK_SIZE * sizeof(imgpel));
    }


    if (img->yuv_format != YUV400)
    {
      for (j = 0; j<img->mb_cr_size_y; j++)
      {
        memcpy(rec_mbU[j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
        memcpy(rec_mbV[j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
      }
    }


    //--- coeff, cbp, kac ---
    {
      i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
      i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
      cbp     = currMB->cbp;
      cbp_blk = currMB->cbp_blk;
    }


    //--- store transform size ---
    luma_transform_size_8x8_flag = currMB->luma_transform_size_8x8_flag;

    memcpy(bestCofAC16x16[0],    img->cofAC16x16[0],    sizeof(int)*257);
    memcpy(bestCofAC16x16[1],    img->cofAC16x16[1],    sizeof(int)*257);
    memcpy(bestCofAC16x8 [0][0], img->cofAC16x8 [0][0], sizeof(int)*129);
    memcpy(bestCofAC16x8 [0][1], img->cofAC16x8 [0][1], sizeof(int)*129);
    memcpy(bestCofAC16x8 [1][0], img->cofAC16x8 [1][0], sizeof(int)*129);
    memcpy(bestCofAC16x8 [1][1], img->cofAC16x8 [1][1], sizeof(int)*129);
    memcpy(bestCofAC8x16 [0][0], img->cofAC8x16 [0][0], sizeof(int)*129);
    memcpy(bestCofAC8x16 [0][1], img->cofAC8x16 [0][1], sizeof(int)*129);
    memcpy(bestCofAC8x16 [1][0], img->cofAC8x16 [1][0], sizeof(int)*129);
    memcpy(bestCofAC8x16 [1][1], img->cofAC8x16 [1][1], sizeof(int)*129);
  }



  int RDCost_for_macroblocks32_geo (double   lambda,       // <-- lagrange multiplier
    int      mode,         // <-- modus (0-COPY/DIRECT, 1-16x16, 2-16x8, 3-8x16, 4-8x8(+), 5-Intra4x4, 6-Intra16x16)
    int      geo_mode,
    int      *mode_idx,
    double*  min_rdcost,   // <-> minimum rate-distortion cost
    double*  min_rate,     // --> bitrate of mode which has minimum rate-distortion cost. 
    //                            int i16mode,
    int mb_ext_level)
  {

    int         i, j, k, mbi, mbj, ii, jj; 
    int         j1, j2;
    int         rate = 0, coeff_rate = 0;
    int64       distortion = 0;
    double      rdcost;
    Macroblock  *currMB;
    //Macroblock  *prevMB;
    int         bframe    = (img->type==B_SLICE);
    int         use_of_cc =  (img->type!=I_SLICE &&  input->symbol_mode!=CABAC);
    int         dummy;
    int      return_val = 0;
    int saved_luma_transform_size_8x8_flag;
    int encodeMbAddr, CurrentMbAddr_x, CurrentMbAddr_y, extend_x, extend_y, num_MB, nextMbAddr, mb16_count=0, mb32_count=0;
    int ****i4p, ***i3p;
    int **i2p;


    /*******************************
    * restore some global variables
    *******************************/
    set_MB_parameters(saved_mb32_nr);
    saved_luma_transform_size_8x8_flag = img->mb_data[img->current_mb_nr].luma_transform_size_8x8_flag;

    //=====   S T O R E   C O D I N G   S T A T E   =====
    //---------------------------------------------------
    store_coding_state (cs_cm);


    find_Mb_cluster(mb_ext_level, img->current_mb_nr, &CurrentMbAddr_x, &CurrentMbAddr_y, &extend_x, &extend_y, &num_MB, &nextMbAddr);


    mb16_count=0;
    mb32_count=0;
    for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi+=mb_ext_level)  
    {      
      for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj+=mb_ext_level)   
      {             
        for(ii=0; ii<(1<<(mb_ext_level-1)); ii++)
        {
          for(jj=0; jj<(1<<(mb_ext_level-1)); jj++)
          {
            encodeMbAddr = (mbi+ii)*img->PicWidthInMbs + (mbj+jj);

            start_macroblock32 (encodeMbAddr, FALSE, 0);//reset img->current_mb_nr and other global variables

            currMB   = &img->mb_data[img->current_mb_nr];   
            //=====
            //=====  SET REFERENCE FRAMES AND BLOCK MODES
            //=====    
            img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;


            //=====
            //=====  GET COEFFICIENTS, RECONSTRUCTIONS, CBP
            //=====

            if (mode<P8x8)
            {
              only_16x16_transform = currMB->luma_transform_size_8x8_flag == 2;
              LumaResidualCoding_geo (mbj-CurrentMbAddr_x+jj, mbi-CurrentMbAddr_y+ii, geo_mode, *mode_idx, mb_ext_level);
              only_16x16_transform = 0;
#ifndef MB32X32          
              if(mode==0 && currMB->cbp!=0 && (img->type != B_SLICE || img->NoResidueDirect==1)) 
                return 0;
              if(mode==0 && currMB->cbp==0 && currMB->luma_transform_size_8x8_flag==1) //for B_skip, luma_transform_size_8x8_flag=0 only
                return 0;
#endif
            }

#ifdef RDO_Q
              img->i16offset = 0;
              dummy = 0;
              if ((img->yuv_format!=YUV400))

                ChromaResidualCoding_geo (mbj-CurrentMbAddr_x+jj, mbi-CurrentMbAddr_y+ii, geo_mode, *mode_idx, mb_ext_level);
#else
            if (input->rdopt==3 && img->type!=B_SLICE)
            {
              // We need the reconstructed prediction residue for the simulated decoders.
              compute_residue_mb (mode==I16MB?i16mode:-1);
            }

            //Rate control
            if (input->RCEnable)
            {
              if (mode == I16MB)
                memcpy(pred,img->mprr_2[i16mode],MB_PIXELS * sizeof(imgpel));
              else
                memcpy(pred,img->mpr,MB_PIXELS * sizeof(imgpel));
            }

            img->i16offset = 0;
            dummy = 0;
            if ((!(img->residue_transform_flag && (mode==I4MB || mode==I16MB || mode==I8MB)))
              && (img->yuv_format!=YUV400))
              ChromaResidualCoding (&dummy);

            if (mode==I16MB)     
              img->i16offset = I16Offset  (currMB->cbp, i16mode);

#endif

            //=====
            //=====   GET DISTORTION
            //=====
            // LUMA
            {
              for (j = 0; j < MB_BLOCK_SIZE; j++)
              {
                j1 = j + img->opix_y;
                j2 = j + img->pix_y;
                for (i=img->opix_x; i<img->opix_x+MB_BLOCK_SIZE; i++)        
#ifdef  INTERNAL_BIT_DEPTH_INCREASE
                  distortion += SQR_DEPTH(imgY_org[j1][i], enc_picture->imgY[j2][i], input->InputBitDepth, img->BitDepthIncrease);
#else
                  distortion += img->quad [imgY_org[j1][i] - enc_picture->imgY[j2][i]];
#endif
              }
            }

            if (img->yuv_format != YUV400)
            {
              // CHROMA
              for (j = 0; j<img->mb_cr_size_y; j++)
              {
                j1 = j + img->opix_c_y;
                j2 = j + img->pix_c_y;
                for (i=img->opix_c_x; i<img->opix_c_x+img->mb_cr_size_x; i++)
                {
#ifdef  INTERNAL_BIT_DEPTH_INCREASE
                  distortion += SQR_DEPTH(imgUV_org[0][j1][i], enc_picture->imgUV[0][j2][i], input->InputBitDepth, img->BitDepthIncreaseChroma);
                  distortion += SQR_DEPTH(imgUV_org[1][j1][i], enc_picture->imgUV[1][j2][i], input->InputBitDepth, img->BitDepthIncreaseChroma);
#else
                  distortion += img->quad [imgUV_org[0][j1][i] - enc_picture->imgUV[0][j2][i]];
                  distortion += img->quad [imgUV_org[1][j1][i] - enc_picture->imgUV[1][j2][i]];
#endif
                }
              }
            }

            if(distortion > *min_rdcost)
            {
              set_MB_parameters(saved_mb32_nr);
              return (0);
            }

            /******************************************
            *save macroblock info for each 16x16 block
            *****************************************/
            i4p=cofAC32_RDCost[mb16_count]; cofAC32_RDCost[mb16_count]=img->cofAC; img->cofAC=i4p;  //MB32X32
            i3p=cofDC32_RDCost[mb16_count]; cofDC32_RDCost[mb16_count]=img->cofDC; img->cofDC=i3p;  //MB32X32
            i2p=cof32AC16x16_RDCost[mb16_count]; cof32AC16x16_RDCost[mb16_count]=img->cofAC16x16; img->cofAC16x16=i2p;
            cbp16_RDCost[mb16_count] = currMB->cbp;  //MB32X32
            cbp_blk16_RDCost[mb16_count] = currMB->cbp_blk;  //MB32X32

            if (((currMB->cbp & 15) == 0) && !(IS_OLDINTRA(currMB) || currMB->mb_type == I8MB))//originally done in set_stored_macroblock_parameters -peisong
              luma_transform_size_8x8_flag32_RDCost[mb16_count] = 0;
            else
              luma_transform_size_8x8_flag32_RDCost[mb16_count] = currMB->luma_transform_size_8x8_flag;
            mb16_count++;
          }//jj
        }//ii

        if(mb_ext_level == 2)
        {
          //prepare 32x32 block cbp     
          cbp_32_RDCost[mb32_count]=0;
          for(k=0; k<4; k++)
          {
            if(cbp16_RDCost[mb32_count*4+k] != 0)
            {
              cbp_32_RDCost[mb32_count] = 1;
              break;
            }
          }      

          mb32_count++;
        }

      } // mbj             
    }//mbi

    if(mb_ext_level == 1)
    {    
      //prepare 32x32 block cbp     
      MB32.cbp=0;
      for(k=0; k<4; k++)
      {    
        if(cbp16_RDCost[k] != 0)
        {
          MB32.cbp = 1;
          break;
        }
      }      
      MB32.mb_type = mode;
      MB32.geo_mode = geo_mode;
    }
    else
    {   
      //prepare 64x64 block cbp     
      MB64.cbp=0;
      for(k=0; k<4; k++)
      {
        if(cbp_32_RDCost[k] != 0)
        {
          MB64.cbp = 1;//will be used in writeMBLayer64
          break;
        }
      }      

      MB64.mb_type = mode;//will be used in writeMBLayer64
      MB64.geo_mode = geo_mode;
    }

    mb16_count=0;
    mb32_count=0;
    for(mbi=CurrentMbAddr_y; mbi<=extend_y; mbi+=mb_ext_level)  
    {      
      for(mbj=CurrentMbAddr_x; mbj<=extend_x; mbj+=mb_ext_level)   
      {             
        if(mb_ext_level == 2)
          MB32.cbp = cbp_32_RDCost[mb32_count];//will be used in writeMBLayer64

        for(ii=0; ii<(1<<(mb_ext_level-1)); ii++)
        {
          for(jj=0; jj<(1<<(mb_ext_level-1)); jj++)
          {
            encodeMbAddr = (mbi+ii)*img->PicWidthInMbs + (mbj+jj);

            start_macroblock32 (encodeMbAddr, FALSE, 0);//reset img->current_mb_nr and other global variables

            currMB   = &img->mb_data[img->current_mb_nr];   

            /******************************************
            *for the upper left 16x16 block, set b8mode
            *b8pdir for the whole 32x32 block in order
            *to write motion info in 1 shot
            * mv and ref_idx are set in SetModesAndRefframeForBlocks32
            *****************************************/

            if((mb_ext_level==1 || mb32_count == 0) && mb16_count == 0)
            {
              int i;
              for(i=0;i<4;i++)
              {
                currMB->b8mode[i] = mode;
                currMB->b8pdir[i] = best16x16pdir[i];
              }    
            }

            prepare_data_for_write_RDCost(encodeMbAddr, mb16_count, mode);

            img->mb_data[encodeMbAddr].luma_transform_size_8x8_flag = saved_luma_transform_size_8x8_flag;

#ifdef H264_COMPLIANT
            if(mode>0)
            {
              int i;
              for(i=0;i<4;i++)
              {
                currMB->b8mode[i] = 1;
                if(mb_ext_level == 1)
                  currMB->b8pdir[i] = best16x16pdir[mb16_count];
                else
                  currMB->b8pdir[i] = best16x16pdir[mb32_count];
              }    
            }
            write_mb32_mbtype = 0;
            prepare_mv_h264((mbj-CurrentMbAddr_x+jj), (mbi-CurrentMbAddr_y+ii), mode);
            currMB->mb_type = 1;
            rate += writeMBLayer (1, &coeff_rate);
            //currMB->mb_type = mode;
            switch_back_mv();
#else
            if(mb_ext_level == 1)
              rate += writeMBLayer_Big (1, &coeff_rate, 1, 0, mb16_count);//mb16_count: 0~3
            else
              rate += writeMBLayer_Big (1, &coeff_rate, 2, mb32_count, mb16_count&3);
#endif
            switchback_data_after_write(encodeMbAddr, mb16_count, mode);

            if(((double)distortion + lambda * max(0.5,(double)rate)) > *min_rdcost)
            {
              set_MB_parameters(saved_mb32_nr);
              reset_coding_state (cs_cm);
              return (0);
            }
            mb16_count++;
          }
        }

        mb32_count++;    
      } // j       
    }//i

    //=====   R E S T O R E   C O D I N G   S T A T E   =====
    //-------------------------------------------------------
    //restore some global variables
    set_MB_parameters(saved_mb32_nr);
    //restore some global variables

    reset_coding_state (cs_cm);


    rdcost = (double)distortion + lambda * max(0.5,(double)rate);

    if (!(rdcost >= *min_rdcost ||
      ((img->qp + img->bitdepth_luma_qp_scale)==0 && img->lossless_qpprime_flag==1 && distortion!=0)))
    {               

      {
        //=====   U P D A T E   M I N I M U M   C O S T   =====
        //-----------------------------------------------------
        *min_rdcost = rdcost;
        *min_rate = lambda * (double)coeff_rate;

#ifdef BEST_NZ_COEFF
        for (j=0;j<4;j++)
          for (i=0; i<(4+img->num_blk8x8_uv); i++)
            gaaiMBAFF_NZCoeff[j][i] = img->nz_coeff[img->current_mb_nr][j][i]; 
#endif
        return_val = 1;
      }


    }
    else 
    {
#if FASTMODE
      // Reordering RDCost comparison order of mode 0 and mode 1 in P_SLICE
      // if RDcost of mode 0 and mode 1 is same, we choose best_mode is 0
      // This might not always be good since mode 0 is more biased towards rate than quality.
      if((img->type!=P_SLICE || mode != 0 || rdcost != *min_rdcost) || input->ProfileIDC>=FREXT_HP)
#endif
        return_val = 0;
    }

    return (return_val);
  } 

  void store_macroblock_parameters32_geo (int geo_mode, int mb_ext_level)
  {
    int  j, ****i4p, ***i3p;
    Macroblock *currMB  = &img->mb_data[img->current_mb_nr];
    //int        bframe   = (img->type==B_SLICE);
    int **i2p;

    //--- store best mode ---
    best_geo_mode = geo_mode;

    best_c_imode = currMB->c_ipred_mode;

    //--- reconstructed blocks ----
#ifdef MB32X32
    for (j = 0; j < (MB_BLOCK_SIZE<<mb_ext_level); j++)
#else
    for (j = 0; j < MB_BLOCK_SIZE; j++)
#endif

    {
#ifdef MB32X32
      memcpy(rec_mbY[j],&enc_picture->imgY[img->pix_y+j][img->pix_x], (MB_BLOCK_SIZE<<mb_ext_level) * sizeof(imgpel));
#else
      memcpy(rec_mbY[j],&enc_picture->imgY[img->pix_y+j][img->pix_x], MB_BLOCK_SIZE * sizeof(imgpel));
#endif

    }


    if (img->yuv_format != YUV400)
    {
#ifdef MB32X32
      for (j = 0; j<(img->mb_cr_size_y<<mb_ext_level); j++)
#else
      for (j = 0; j<img->mb_cr_size_y; j++)
#endif
      {
#ifdef MB32X32
        memcpy(rec_mbU[j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], (img->mb_cr_size_x<<mb_ext_level) * sizeof(imgpel));
        memcpy(rec_mbV[j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], (img->mb_cr_size_x<<mb_ext_level) * sizeof(imgpel));
#else
        memcpy(rec_mbU[j],&enc_picture->imgUV[0][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
        memcpy(rec_mbV[j],&enc_picture->imgUV[1][img->pix_c_y+j][img->pix_c_x], img->mb_cr_size_x * sizeof(imgpel));
#endif

      }
    }


    //--- coeff, cbp, kac ---
    //if (mode || bframe)
    {
#ifdef MB32X32
      int i;
      for(i=0; i<(1<<(2*mb_ext_level)); i++)
      {
        i4p=cofAC32[i]; cofAC32[i]=cofAC32_RDCost[i]; cofAC32_RDCost[i]=i4p;
        i3p=cofDC32[i]; cofDC32[i]=cofDC32_RDCost[i]; cofDC32_RDCost[i]=i3p;
        i2p=cof32AC16x16[i]; cof32AC16x16[i]=cof32AC16x16_RDCost[i]; cof32AC16x16_RDCost[i]=i2p;
      }
#else
      i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
      i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
#endif

#ifdef MB32X32

      //if(input->UseExtMB == 2)//MB64X64
      memcpy(cbp_32, cbp_32_RDCost, (1<<(2*(mb_ext_level-1))) * sizeof(int)); 

      memcpy(cbp16, cbp16_RDCost, (1<<(2*mb_ext_level)) * sizeof(int)); 
      memcpy(cbp_blk16, cbp_blk16_RDCost, (1<<(2*mb_ext_level)) * sizeof(int64));
#else
      cbp     = currMB->cbp;
      cbp_blk = currMB->cbp_blk;
#endif
    }

    cbp=0;
    //prepare 32x32 block cbp      
    if((mb_ext_level == 1) && ((cbp16[0] != 0) || (cbp16[1] != 0) || (cbp16[2] != 0) || (cbp16[3] != 0)))
      cbp = 1;

    //prepare 64x64 block cbp      
    if((mb_ext_level == 2) && ((cbp_32[0] != 0) || (cbp_32[1] != 0) || (cbp_32[2] != 0) || (cbp_32[3] != 0)))
      cbp = 1;

#ifdef MB32X32
    memcpy(luma_transform_size_8x8_flag32, luma_transform_size_8x8_flag32_RDCost, (1<<(2*mb_ext_level)) * sizeof(int)); 
#else
    //--- store transform size ---
    luma_transform_size_8x8_flag = currMB->luma_transform_size_8x8_flag;
#endif

  }

  void compute_mode_RD_cost32_geo(int scheme,
    int geo_mode, 
    int *mode_idx,
    Macroblock *currMB, 
    RD_PARAMS *enc_mb, 
    double *min_rdcost, 
    double *min_rate, 
    short bslice, 
    int   mb_ext_level)
  {

    //--- transform size ---     
    int mode = 3;//to enable bigger transform
    currMB->luma_transform_size_8x8_flag = input->Transform8x8Mode==2
      ?  (mode >= 1 && mode <= 3)
      || (mode == 0 && bslice && active_sps->direct_8x8_inference_flag)
      || ((mode == P8x8) && (enc_mb->valid[4]))
      :  0; 

    if(input->DisableSmallTransInLargeMB && mb_ext_level>0 && input->Transform8x8Mode==1)      //Only big transform is allowed for big blocks--Rahul
      currMB->luma_transform_size_8x8_flag = 2;


    // Encode with coefficients
    img->NoResidueDirect = 0;  

    {
#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
      isfirstTransf = 1;
#endif
      while(1)
      {
        //printf("\n-----------------------RDCost_for_macroblock32--------------------\n\n");

        if (mb_ext_level >0)
        {
          if(RDCost_for_macroblocks32_geo (enc_mb->lambda_md, 3, geo_mode, mode_idx, min_rdcost, min_rate, mb_ext_level))
            store_macroblock_parameters32_geo (geo_mode, mb_ext_level);
        }
        else
        {
          short dummy=0;
          currMB->geo_mode = geo_mode;
          if(RDCost_for_macroblocks (enc_mb->lambda_md, 3, mode_idx, min_rdcost, min_rate, 0, dummy)) //mode = 3 for geometry partition
            store_macroblock_parameters_geo (geo_mode);
        }
#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
        isfirstTransf=0;
#endif

        // Go through transform modes. 
        // Note that if currMB->cbp is 0 one could choose to skip 8x8 mode
        // although this could be due to deadzoning decisions.
        //if (input->Transform8x8Mode==1 && currMB->cbp!=0) 
        if (input->Transform8x8Mode==1)
        {
          //=========== try mb_types 1,2,3 with 8x8 transform ===========
          if ((mode >= 1 && mode <= 3) && currMB->luma_transform_size_8x8_flag == 0)
          {
            //try with 8x8 transform size
            currMB->luma_transform_size_8x8_flag = 1;
            continue;
          }
          // try partition 16x16 with 16x16 transform
          else if ((mode == 1) && currMB->luma_transform_size_8x8_flag == 1)
          {
            //try with 16x16 transform size
            currMB->luma_transform_size_8x8_flag = 2;
            continue;
          }
          // try partition 16x16 with 16x16 transform
          else if ((mode == 2) && currMB->luma_transform_size_8x8_flag == 1)
          {
            //try with 16x16 transform size
            currMB->luma_transform_size_8x8_flag = 2;
            continue;
          }
          // try partition 16x16 with 16x16 transform
          else if ((mode == 3) && currMB->luma_transform_size_8x8_flag == 1)
          {
            //try with 16x16 transform size
            currMB->luma_transform_size_8x8_flag = 2;
            continue;
          }
          else
          {
            currMB->luma_transform_size_8x8_flag = 0;
            break;
          }
        }
        else
          break;
      }


    }
  }

  //min_rdcost0 is the minimal cost of regular mode and it will be used to decide whether to use geometry partition or regular modes
  double compute_mode_RD_cost_RDOQ32_geo(double min_rdcost0, Macroblock *currMB, RD_PARAMS *enc_mb, int mb_ext_level)
  {
    int mode_idx=0;
    short       bslice      = (img->type==B_SLICE);


    int deltaQP, bestQP=currMB->qp;
    double RDOQ_min_rdcost=min_rdcost0, min_rdcost=min_rdcost0; 
    double min_rate;
    int qp_left, qp_up;
    int best_deltaQP=0;
    int deltaQPCnt; 
    int master_cr_qp=0, master_cr_cbp=0, chroma_qp=0;

    static int deltaQPTabB[] = {0, 2, 3};
    int deltaQPTabSizeB = 3;
    static int deltaQPTabP[] = {0, 1, -1, 2, -2};
    int deltaQPTabSizeP = 1;
    int deltaQPTabSize = bslice? deltaQPTabSizeB : deltaQPTabSizeP;
    int qp_anchor;

    int geo_mode;

    qp_left = (currMB->mb_available_left) ? currMB->mb_available_left->qp:img->masterQP;
    qp_up   = (currMB->mb_available_up  ) ? currMB->mb_available_up->qp  :img->masterQP;
    qp_anchor = (qp_left + qp_up + 1) >> 1;

    isfirstQP = 1;
    for (deltaQPCnt=0; deltaQPCnt<deltaQPTabSize; deltaQPCnt++)
    {
      if(bslice)
      {
        deltaQP = deltaQPTabB[deltaQPCnt];
      }
      else
        deltaQP = deltaQPTabP[deltaQPCnt];

      currMB->qp=Clip3(0, 51, (img->masterQP+deltaQP));
      img->qp = currMB->qp;       //this is set coz img->qp is used in 8x8 DCT, KLT, 16x16 DCT, 16x8 DCT, 8x16 DCT
      //for 4x4 DCT it uses currMB->qp......inconsistency
      currMB->delta_qp = currMB->qp - currMB->prev_qp;
      set_chroma_qp(currMB);


      //backup MB32X32 information    //this is used MB32.qp in start_macroblock32 called during modeRDO
      MB32.prev_qp = currMB->prev_qp;
      MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac
      MB32.qp = currMB->qp; //????
      saved_mb32_nr = img->current_mb_nr;
      //backup MB32X32 information


#ifdef MB32X32
      if(final_mb_encoding || (mb_ext_level==0 && clusterof16_isbetterthan_one32_duringRDOQ) )   //during write_mb_cluster, we only do best qp and best mode....
#else
      if(final_mb_encoding)   //during write_mb_cluster, we only do best qp and best mode....
#endif
      {
        if(currMB->qp != finalbestQP)
          continue;
      }
      else   //skip these checking during final QP
      {
        // skip this QP if deltaQP is too large based on local stats
        if(!bslice && (deltaQP != 0) && !(currMB->qp-qp_anchor >= -2 && currMB->qp-qp_anchor <= 1) && currMB->mb_available_left && currMB->mb_available_up)
          continue; 
        if(bslice  &&                   !(currMB->qp-qp_anchor >= -1 && currMB->qp-qp_anchor <= 2) && currMB->mb_available_left && currMB->mb_available_up)
          continue;

        //prevent QP to become too high..otherwise chroma will be affected.
        if(input->successive_Bframe==0)
        {     
          static byte QP_SCALE_CR[52]=
          {
            0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,
            12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,
            28,29,29,30,31,32,32,33,34,34,35,35,36,36,37,37,
            37,38,38,38,39,39,39,39
          };

          chroma_qp = Clip3 ( -img->bitdepth_chroma_qp_scale, 51, currMB->qp + img->chroma_qp_offset[0] );
          chroma_qp = (chroma_qp < 0 ? chroma_qp : QP_SCALE_CR[chroma_qp]) + img->bitdepth_chroma_qp_scale;
          if( (!isfirstQP) && (chroma_qp > master_cr_qp) && (master_cr_cbp!=0) )
            continue;
        }
      }
      store_coding_state (cs_eachQP);
      //==========================================

      if (input->BiPredMotionEstimation)
        img->bi_pred_me[1] =0;  

      mode_idx=0;

      //===== GET BEST MACROBLOCK MODE =====
      for (geo_mode=0; geo_mode<GeoPart_num[mb_ext_level]; geo_mode++)  
        //for (ctr16x16=0, index=0; index < max_index; index++)         
      { 
        int rho, theta_idx;

        if(img->geo_scheme == 1)
        {
          if(enc_geo_valid[geo_mode]==0)
            continue;
        }

        get_rho_theta(geo_mode, &rho, &theta_idx, &mask, mb_ext_level);
        mask4x4 = geo_4x4mask[mb_ext_level][rho][theta_idx];
        smfilter = geo_filter[mb_ext_level][rho][theta_idx];
        smfilterUV = geo_filterUV[mb_ext_level][rho][theta_idx];
        compute_mode_RD_cost32_geo(img->geo_scheme, geo_mode, &mode_idx, currMB, enc_mb, &min_rdcost, &min_rate, bslice, mb_ext_level);

        mode_idx++;
      }// for (ctr16x16=0, index=0; index<max_index; index++)


      //==========================================
      reset_coding_state (cs_eachQP);

#ifdef MB32X32
      if(!final_mb_encoding && (!clusterof16_isbetterthan_one32_duringRDOQ || mb_ext_level!=0) )
#else
      if(!final_mb_encoding)
#endif
      {
        if(input->successive_Bframe==0)
        {     
          //chroma_qp = currMB->qpc[0];
          if(isfirstQP) // deltaQP =0 has to be test first!
          {
            master_cr_cbp = img->mb_data[img->current_mb_nr].cbp>>4;
            master_cr_qp  = chroma_qp;
          }
        }
      }

      if (min_rdcost < RDOQ_min_rdcost)
      {
        RDOQ_min_rdcost=min_rdcost;
        bestQP=currMB->qp;
        best_deltaQP = deltaQPCnt;  //deltaQP;
      }

      isfirstQP = 0;

      //if(best_mode==0 && cbp==0)   //no need to check other QPs if the best mode is SKIP for current QP
      //  break;

    }//for (deltaQPCnt=0; deltaQPCnt<deltaQPTabSize; deltaQPCnt++)


    currMB->qp = bestQP;  //Clip3(0, 51, (img->masterQP + best_deltaQP));
    img->qp    = bestQP;
    currMB->delta_qp = currMB->qp - currMB->prev_qp;
    set_chroma_qp(currMB);


    //  make sure to store the bestQP to MB32.qp. as this is used in start_macroblock32
    MB32.prev_qp = currMB->prev_qp; 
    MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac
    MB32.qp = currMB->qp; //?????

    return RDOQ_min_rdcost;
  }

  int LumaResidualCoding8x8_Transf ( int   *cbp,        //!< Output: cbp (updated according to processed 8x8 luminance block)
    int64 *cbp_blk,    //!< Output: block cbp (updated according to processed 8x8 luminance block)
    int   block8x8)    //!< block number of 8x8 block
  {
    int    block_y, block_x, pic_pix_y, pic_pix_x, i, j, nonzero = 0, cbp_blk_mask;
    int    coeff_cost = 0;
    int    mb_y       = (block8x8 >> 1) << 3;
    int    mb_x       = (block8x8 & 0x01) << 3;
    int    pix_y;
    int    cbp_mask   = 1 << block8x8;
    int    bxx, byy;                   // indexing curr_blk
    int    scrFlag    = 0; // 0=noSCR, 1=strongSCR, 2=jmSCR
    int    skipped    = 0;//(fw_mode == 0 && bw_mode == 0 && (img->type != B_SLICE));
    Macroblock* currMB = &img->mb_data[img->current_mb_nr];
    //set transform size
    int    need_8x8_transform = currMB->luma_transform_size_8x8_flag;
    // Residue Color Transform
    //int residue_R, residue_G, residue_B, temp;

    if (img->type==B_SLICE)
      scrFlag = 1;

    //===== loop over 4x4 blocks =====
    for (byy=0, block_y=mb_y; block_y<mb_y+8; byy+=4, block_y+=4)
    {
      pic_pix_y = img->opix_y + block_y;

      for (bxx=0, block_x=mb_x; block_x<mb_x+8; bxx+=4, block_x+=4)
      {
        pic_pix_x = img->opix_x + block_x;

        cbp_blk_mask = (block_x>>2) + block_y;



        //===== get displaced frame difference ======

        {
          if(!need_8x8_transform)
          {

            //===== get displaced frame difference ======                
            for (j=0; j<4; j++)
            {
              pix_y = pic_pix_y + j;
              for (i=0; i<4; i++)
              {
                img->m7[j][i] = imgY_org[pix_y][pic_pix_x + i] - img->mpr[j+block_y][i+block_x];

              }
            } 

            //===== DCT, Quantization, inverse Quantization, IDCT, Reconstruction =====      
            if ( (img->NoResidueDirect != 1 && !skipped  ) ||
              ((img->qp + img->bitdepth_luma_qp_scale)==0 && img->lossless_qpprime_flag==1) )
            {
              //===== DCT, Quantization, inverse Quantization, IDCT, Reconstruction =====
              if (img->type!=SP_SLICE)  
#ifdef USE_INTRA_MDDT
                nonzero = dct_luma   (block_x, block_y, &coeff_cost, 0, -1);
#else
                nonzero = dct_luma   (block_x, block_y, &coeff_cost, 0);
#endif

              if (nonzero)
              {
                (*cbp_blk) |= (int64)1 << cbp_blk_mask;  // one bit for every 4x4 block
                (*cbp)     |= cbp_mask;           // one bit for the 4x4 blocks of an 8x8 block
              }
            }
          }
          else
          {
            for (j=0; j<4; j++)
            {
              pix_y = pic_pix_y + j;
              for (i=0; i<4; i++)
              {
                img->m7[j+byy][i+bxx] = imgY_org[pix_y][pic_pix_x+i] - img->mpr[j+block_y][i+block_x];

              }
            }
          }
        } 
      }
    }

    if(need_8x8_transform)
    {
      if (img->NoResidueDirect != 1 && !skipped)
      {
        if (img->type!=SP_SLICE)
#ifdef USE_INTRA_MDDT
          nonzero = dct_luma8x8   (block8x8, &coeff_cost, 0, -1);
#else
          nonzero = dct_luma8x8   (block8x8, &coeff_cost, 0);
#endif

        if (nonzero)
        {
          (*cbp_blk) |= 51 << (4*block8x8-2*(block8x8 & 0x01)); // corresponds to 110011, as if all four 4x4 blocks contain coeff, shifted to block position
          (*cbp)     |= cbp_mask;           // one bit for the 4x4 blocks of an 8x8 block
        }
      }
    }

    /*
    The purpose of the action below is to prevent that single or 'expensive' coefficients are coded.
    With 4x4 transform there is larger chance that a single coefficient in a 8x8 or 16x16 block may be nonzero.
    A single small (level=1) coefficient in a 8x8 block will cost: 3 or more bits for the coefficient,
    4 bits for EOBs for the 4x4 blocks,possibly also more bits for CBP.  Hence the total 'cost' of that single
    coefficient will typically be 10-12 bits which in a RD consideration is too much to justify the distortion improvement.
    The action below is to watch such 'single' coefficients and set the reconstructed block equal to the prediction according
    to a given criterium.  The action is taken only for inter luma blocks.

    Notice that this is a pure encoder issue and hence does not have any implication on the standard.
    coeff_cost is a parameter set in dct_luma() and accumulated for each 8x8 block.  If level=1 for a coefficient,
    coeff_cost is increased by a number depending on RUN for that coefficient.The numbers are (see also dct_luma()): 3,2,2,1,1,1,0,0,...
    when RUN equals 0,1,2,3,4,5,6, etc.
    If level >1 coeff_cost is increased by 9 (or any number above 3). The threshold is set to 3. This means for example:
    1: If there is one coefficient with (RUN,level)=(0,1) in a 8x8 block this coefficient is discarded.
    2: If there are two coefficients with (RUN,level)=(1,1) and (4,1) the coefficients are also discarded
    sum_cnt_nonz is the accumulation of coeff_cost over a whole macro block.  If sum_cnt_nonz is 5 or less for the whole MB,
    all nonzero coefficients are discarded for the MB and the reconstructed block is set equal to the prediction.
    */

    if (img->NoResidueDirect != 1 && !skipped && coeff_cost <= _LUMA_COEFF_COST_ &&
      ((img->qp + img->bitdepth_luma_qp_scale)!=0 || img->lossless_qpprime_flag==0))// last set of conditions
      // cannot skip when perfect reconstruction is as in switching pictures or SI pictures
    {
      coeff_cost  = 0;
      (*cbp)     &=  (63 - cbp_mask);
      (*cbp_blk) &= ~(51 << (4*block8x8-2*(block8x8 & 0x01)));

      for (j=mb_y; j<mb_y+8; j++)
        memcpy(&enc_picture->imgY[img->pix_y + j][img->pix_x + mb_x], &img->mpr[j][mb_x], 2 * BLOCK_SIZE * sizeof(imgpel));
    }

    return coeff_cost;
  }

  void ComputeResidue (imgpel **curImg, int img_m7[16][16], int mb_y, int mb_x, int opix_y, int opix_x, int width, int height);

  void LumaResidualCoding_Transf ()
  {
    int j,block8x8;
    int sum_cnt_nonz, nonzero;
    Macroblock *currMB = &img->mb_data[img->current_mb_nr];  

    currMB->cbp     = 0 ;
    currMB->cbp_blk = 0 ;
    sum_cnt_nonz    = 0 ;

    if( currMB->luma_transform_size_8x8_flag == 2 || only_16x16_transform==1  )
    {
      ComputeResidue (imgY_org, img->m7, 0, 0, img->opix_y, img->opix_x, 16, 16);
      nonzero = dct_luma_16x16_new();
      if (nonzero)
      {
        currMB->cbp_blk = 0xffff; // all sixteen 4x4 blocks contain coeff
        currMB->cbp = 0xf;        // alll 8x8 blocks contain coeff
      }
    }
    else
    {
      for (block8x8=0; block8x8<4; block8x8++)
      {
        //short bw_ref;

        sum_cnt_nonz += LumaResidualCoding8x8_Transf (&(currMB->cbp), &(currMB->cbp_blk), block8x8);
      }

      if (sum_cnt_nonz <= _LUMA_MB_COEFF_COST_ &&
        ((img->qp + img->bitdepth_luma_qp_scale)!=0 || img->lossless_qpprime_flag==0))// modif ES added last set of conditions
        //cannot skip if SI or switching SP frame perfect reconstruction is needed
      {
        currMB->cbp     &= 0xfffff0 ;
        currMB->cbp_blk &= 0xff0000 ;
        //if(!img->residue_transform_flag)
        {
          for (j=0; j < MB_BLOCK_SIZE; j++)
            memcpy(&enc_picture->imgY[img->pix_y+j][img->pix_x], img->mpr[j], MB_BLOCK_SIZE * sizeof (imgpel));
        }
      }
    }
  }

  void LumaResidualCoding8x8_Pred (int mbi_x, 
    int mbi_y, 
    int   *cbp,        //!< Output: cbp (updated according to processed 8x8 luminance block)
    int64 *cbp_blk,    //!< Output: block cbp (updated according to processed 8x8 luminance block)
    int   block8x8,    //!< block number of 8x8 block
    short p_dir,       //!< prediction direction
    int   fw_mode,     //!< list0 prediction mode (1-7, 0=DIRECT)
    int   bw_mode,     //!< list1 prediction mode (1-7, 0=DIRECT)
    short fw_refframe, //!< reference picture for list0 prediction
    short bw_refframe,  //!< reference picture for list0 prediction
    int segm, 
    int geo_mode,
    int mb_ext_level
    )
  {
    int    block_y, block_x;

    int    mb_y       = (block8x8 >> 1) << 3;
    int    mb_x       = (block8x8 & 0x01) << 3;

    int    bxx, byy;                   // indexing curr_blk

    //===== loop over 4x4 blocks =====
    for (byy=0, block_y=mb_y; block_y<mb_y+8; byy+=4, block_y+=4)
    {
      for (bxx=0, block_x=mb_x; block_x<mb_x+8; bxx+=4, block_x+=4)
      {
        //===== prediction of 4x4 block =====
        LumaPrediction4x4 (block_x, block_y, p_dir, fw_mode, bw_mode, fw_refframe, bw_refframe);           
      }
    }
  }

  void LumaResidualCoding_Pred (int mbi_x, int mbi_y, int segm, int geo_mode, int mb_ext_level)
  {
    int block8x8;
    int fw_mode, bw_mode;
    short p_dir, refframe;
    //int sum_cnt_nonz;
    Macroblock *currMB = &img->mb_data[img->current_mb_nr]; 

    for (block8x8=0; block8x8<4; block8x8++)
    {
      short bw_ref;
      SetModesAndRefframe (block8x8, &p_dir, &fw_mode, &bw_mode, &refframe, &bw_ref);

      LumaResidualCoding8x8_Pred (mbi_x, mbi_y, &(currMB->cbp), &(currMB->cbp_blk), block8x8,
        p_dir, fw_mode, bw_mode, refframe, bw_ref, segm, geo_mode, mb_ext_level);
    }
  }

  void LumaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level)
  {
    int segm, i, j;
    int mpr[2][16][16];
    int mbx = mbi_x<<4;
    int mby = mbi_y<<4;
    static imgpel backup_mpr[PRE_SELECT_MODE][64][64];

    img->bi_pred_me[1] = 0; //mode = 1, img->bi_pred_me will be used in SetModesAndRefframeForBlocks


#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
    if(isfirstQP && isfirstTransf)
#else
    if(isfirstQP)
#endif
    {
      for(segm=0; segm<2; segm++)
      {
        copy_geo_mv(mbi_x, mbi_y, geo_mode, segm);//, mb_ext_level

        SetModesAndRefframeForBlocks (1); //use mode=1 for geometry partition

        LumaResidualCoding_Pred (mbi_x, mbi_y, segm, geo_mode, mb_ext_level);

        for(j=0; j<16; j++)
          for(i=0; i<16; i++)
            mpr[segm][j][i] = img->mpr[j][i];
      }

#if GEO_SCHEME == 0
      if(img->geo_scheme == 0)
      {
        for(j=0; j<16; j+=4)
        {
          for(i=0; i<16; i+=4)
          {
            segm = MB16GeoMask[geo_mode][(j>>2)*(4<<mb_ext_level) + (i>>2)];
            for(k=0; k<4; k++)
              for(l=0; l<4; l++)
                img->mpr[j+k][i+l] = mpr[segm][j+k][i+l];
            //img->mpr[j][i] = mpr[segm][j][i];     

          }
        }
      }      
      else //arbitrary
#endif
      {
        //int rho = geo_mode>>5, theta_idx = geo_mode & 31;
        for(j=0; j<16; j++)
        {
          for(i=0; i<16; i++)
          {
            //        if(geo_mask16[rho][theta_idx][j][i] == segm)

            segm = mask[mby+j][mbx+i];
            if(smfilter[mby+j][mbx+i])
            {
              if(segm == 0)
                img->mpr[j][i] = (mpr[0][j][i]*2 + mpr[1][j][i])/3;
              else
                img->mpr[j][i] = (mpr[0][j][i]   + mpr[1][j][i]*2)/3;
            }
            else
              img->mpr[j][i] = mpr[segm][j][i];
          }
        }
      }   


      for(j=0; j<16; j++)
      {
        for(i=0; i<16; i++)
        {
          backup_mpr[mode_idx][mby+j][mbx+i] = img->mpr[j][i];
        }
      }
    }
    else
    {
//def MCP_SPEEDUP_FIX   // this is a temporal fix. The correct fix should be set mb_type =3 after ChromaResidual Coding, because the cbp coding depends on mb_type. 
      //for(segm=0; segm<2; segm++)
      {
        //copy_geo_mv(mbi_x, mbi_y, geo_mode, segm);//, mb_ext_level
        img->mb_data[img->current_mb_nr].mb_type = 1;
        //SetModesAndRefframeForBlocks (1); //use mode=1 for geometry partition
      }



      for(j=0; j<16; j++)
      {
        for(i=0; i<16; i++)
        {
          img->mpr[j][i] = backup_mpr[mode_idx][mby+j][mbx+i];
        }
      }
    }


    LumaResidualCoding_Transf ();
  }

  void ChromaResidualCoding_Transf (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level, imgpel mpr_c[2][2][16][16], int* cr_cbp)
  {
    int   uv, block8, block_y, block_x, j, i;
    //int   fw_mode, bw_mode;
    //short p_dir, refframe, bw_ref;
    int   skipped = (img->mb_data[img->current_mb_nr].mb_type == 0 && (img->type == P_SLICE || img->type == SP_SLICE));
    static imgpel backup_mpr_c[PRE_SELECT_MODE][2][64][64];//[uv][y][x]
    //int   yuv = img->yuv_format - 1; //ADD-VG-15052004

    //int   block8x8_idx[3][4][4] =     //ADD-VG-15052004
    //{ { {0, 1, 0, 0}, 
    //{2, 3, 0, 0},
    //{0, 0, 0, 0},
    //{0, 0, 0, 0}, },
    //
    //{ {0, 1, 0, 0}, 
    //{0, 1, 0, 0}, 
    //{2, 3, 0, 0},
    //{2, 3, 0, 0}  },
    //
    //{ {0, 0, 1, 1},
    //{0, 0, 1, 1},
    //{2, 2, 3, 3},
    //{2, 2, 3, 3}  }
    //};
    //int temp;
    int segm;

    for (*cr_cbp=0, uv=0; uv<2; uv++)
    {
      //===== prediction of chrominance blocks ===d==
      block8 = 0;
#if GEO_SCHEME == 0
      if(img->geo_scheme == 0)
      {
        for (block_y=0; block_y < img->mb_cr_size_y; block_y+=2)
          for (block_x=0; block_x < img->mb_cr_size_x; block_x+=2)
          {
            //block8 = block8x8_idx[yuv][block_y>>2][block_x>>2];
            //SetModesAndRefframe (block8, &p_dir, &fw_mode, &bw_mode, &refframe, &bw_ref);

            //ChromaPrediction4x4 (uv, block_x, block_y, p_dir, fw_mode, bw_mode, refframe, bw_ref);

            //===== prediction of chrominance blocks ===d==
            //block8 = 0;

            segm = MB16GeoMask[geo_mode][(block_y>>1)*(4<<mb_ext_level) + (block_x>>1)];
            for(j=0; j<2; j++)
              for(i=0; i<2; i++)
                img->mpr[block_y+j][block_x+i] = mpr_c[segm][uv][block_y+j][block_x+i];

          }
      }
      else //arbitrary
#endif
      {
        int mb_x = (mbi_x<<3);
        int mb_y = (mbi_y<<3);
        for (block_y=0; block_y < img->mb_cr_size_y; block_y++)
          for (block_x=0; block_x < img->mb_cr_size_x; block_x++)
          {
            //block8 = block8x8_idx[yuv][block_y>>2][block_x>>2];
            //SetModesAndRefframe (block8, &p_dir, &fw_mode, &bw_mode, &refframe, &bw_ref);

            //ChromaPrediction4x4 (uv, block_x, block_y, p_dir, fw_mode, bw_mode, refframe, bw_ref);

            //===== prediction of chrominance blocks ===d==
            //block8 = 0;

#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF 
            if(isfirstQP && isfirstTransf)
#else
            if(isfirstQP)
#endif
            {
              segm = mask[mbi_y*16+(block_y<<1)][mbi_x*16+(block_x<<1)];            
              if(smfilterUV[mb_y+block_y][mb_x+block_x])
              {
                if(segm == 0)
                  img->mpr[block_y][block_x] = (mpr_c[0][uv][block_y][block_x]*2+ mpr_c[1][uv][block_y][block_x])/3;
                else
                  img->mpr[block_y][block_x] = (mpr_c[0][uv][block_y][block_x]  + mpr_c[1][uv][block_y][block_x]*2)/3;
              }
              else
                img->mpr[block_y][block_x] = mpr_c[segm][uv][block_y][block_x];
              backup_mpr_c[mode_idx][uv][mb_y+block_y][mb_x+block_x] = img->mpr[block_y][block_x];
            }
            else
            {
              img->mpr[block_y][block_x] = backup_mpr_c[mode_idx][uv][mb_y+block_y][mb_x+block_x];
            }

          }
      }
      // ==== set chroma residue to zero for skip Mode in SP frames 
      if (img->NoResidueDirect)
      {
        for (j=0; j<img->mb_cr_size_y; j++)
          memcpy(&enc_picture->imgUV[uv][img->pix_c_y+j][img->pix_c_x], img->mpr[j], img->mb_cr_size_x * sizeof(imgpel));             
        ;

      }
      else
        if (skipped)
        {
          for (j=0; j<img->mb_cr_size_y; j++)
            memcpy(&enc_picture->imgUV[uv][img->pix_c_y+j][img->pix_c_x], img->mpr[j], img->mb_cr_size_x * sizeof(imgpel));
        }
        else
        {
          for (j=0; j<img->mb_cr_size_y; j++)
            for (i=0; i<img->mb_cr_size_x; i++)
            {
              img->m7[j][i] = imgUV_org[uv][img->opix_c_y+j][img->opix_c_x+i] - img->mpr[j][i];
            }
        }

        //===== DCT, Quantization, inverse Quantization, IDCT, and Reconstruction =====
        //===== Call function for skip mode in SP frames to properly process frame ====

        {
          if (!img->NoResidueDirect && !skipped)
          {
            //even if the block is intra it should still be treated as SP
            *cr_cbp=dct_chroma   (uv,*cr_cbp); 
          }
        }
    }  
    //===== update currMB->cbp =====
    img->mb_data[img->current_mb_nr].cbp += ((*cr_cbp)<<4);  

  }

  void ChromaResidualCoding_Pred (int geo_mode, int segm, imgpel mpr_c[2][2][16][16])
  {
    int   uv, block8, block_y, block_x;
    int   fw_mode, bw_mode;
    short p_dir, refframe, bw_ref;
    //int   skipped = (img->mb_data[img->current_mb_nr].mb_type == 0 && (img->type == P_SLICE || img->type == SP_SLICE));
    int   yuv = img->yuv_format - 1; //ADD-VG-15052004

    int   block8x8_idx[3][4][4] =     //ADD-VG-15052004
    { { {0, 1, 0, 0}, 
    {2, 3, 0, 0},
    {0, 0, 0, 0},
    {0, 0, 0, 0}, },

    { {0, 1, 0, 0}, 
    {0, 1, 0, 0}, 
    {2, 3, 0, 0},
    {2, 3, 0, 0}  },

    { {0, 0, 1, 1},
    {0, 0, 1, 1},
    {2, 2, 3, 3},
    {2, 2, 3, 3}  }
    };
    //int temp;

    for (uv=0; uv<2; uv++)
    {
      //===== prediction of chrominance blocks ===d==
      block8 = 0;
      for (block_y=0; block_y < img->mb_cr_size_y; block_y+=4)
        for (block_x=0; block_x < img->mb_cr_size_x; block_x+=4)
        {
          block8 = block8x8_idx[yuv][block_y>>2][block_x>>2];
          SetModesAndRefframe (block8, &p_dir, &fw_mode, &bw_mode, &refframe, &bw_ref);

          ChromaPrediction4x4 (uv, block_x, block_y, p_dir, fw_mode, bw_mode, refframe, bw_ref);
        }

        for(block_y=0; block_y < img->mb_cr_size_y; block_y++)
          for (block_x=0; block_x < img->mb_cr_size_x; block_x++)
          {
            mpr_c[segm][uv][block_y][block_x] = img->mpr[block_y][block_x];
          }
    }   
  }

  void ChromaResidualCoding_geo (int mbi_x, int mbi_y, int geo_mode, int mode_idx, int mb_ext_level)
  {
    int segm, dummy;
    imgpel mpr_c[2][2][16][16];  

#ifdef DO_PREDICTION_ONLY_FOR_FIRST_TRANSF
    if(isfirstQP && isfirstTransf)
#else
    if(isfirstQP)
#endif
    {
      for(segm=0; segm<2; segm++)
      {
        copy_geo_mv(mbi_x, mbi_y, geo_mode, segm);//, mb_ext_level
        SetModesAndRefframeForBlocks (1); //use mode=1 for geometry partition

        ChromaResidualCoding_Pred(geo_mode, segm, mpr_c);
      }
    }

    ChromaResidualCoding_Transf(mbi_x, mbi_y, geo_mode, mode_idx, mb_ext_level, mpr_c, &dummy);
  }

  void set_stored_macroblock_parameters_geo (int mb_ext_level)
  {
    int  i, j, k, ****i4p, ***i3p;
    Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];
    //int         mode     = best_mode;
    int         bframe   = (img->type==B_SLICE);
    //char    **ipredmodes = img->ipredmode;

    imgpel        **imgY  = enc_picture->imgY;
    imgpel       ***imgUV = enc_picture->imgUV;
    int        block_x, block_y;  
    short   *cur_mv;
    int segm;


    //===== reconstruction values =====
    for (j = 0; j < MB_BLOCK_SIZE; j++)
    {
      memcpy(&imgY[img->pix_y+j][img->pix_x],rec_mbY[j], MB_BLOCK_SIZE * sizeof(imgpel));
    }

    if (img->yuv_format != YUV400)
    {
      for (j = 0; j<img->mb_cr_size_y; j++)
      {
        memcpy(&imgUV[0][img->pix_c_y+j][img->pix_c_x],rec_mbU[j], img->mb_cr_size_x * sizeof(imgpel));
        memcpy(&imgUV[1][img->pix_c_y+j][img->pix_c_x],rec_mbV[j], img->mb_cr_size_x * sizeof(imgpel));
      }
    }

    //===== coefficients and cbp =====
    i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
    i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
    currMB->cbp      = cbp;
    currMB->cbp_blk = cbp_blk;
    //==== macroblock type ====
    currMB->mb_type = 3;  
    currMB->geo_mode = best_geo_mode;

    currMB->bi_pred_me = 0;

    //==== transform size flag ====
    if (((currMB->cbp & 15) == 0) && !(IS_OLDINTRA(currMB) || currMB->mb_type == I8MB))
      currMB->luma_transform_size_8x8_flag = 0;
    else
      currMB->luma_transform_size_8x8_flag = luma_transform_size_8x8_flag;

    rdopt->luma_transform_size_8x8_flag  = currMB->luma_transform_size_8x8_flag;

    //==== reference frames =====
    for (j = 0; j < 4; j++)
    {
      block_y = img->block_y + j;
      for (i = 0; i < 4; i++)
      {
        block_x = img->block_x + i;
        k = 2*(j >> 1)+(i >> 1);

        if(img->geo_scheme == 0)
          segm = MB16GeoMask[best_geo_mode][4*j+i];
        else
        {     
          int rho = best_geo_mode>>5, theta_idx = best_geo_mode & 31;    
          segm = geo_mask[mb_ext_level][rho][theta_idx][j*4][i*4];
        }

        // backward prediction or intra
        if (best8x8pdir_geo[best_geo_mode][segm] == 1)
        {
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;          
          enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;
        }
        else
        {

          {
            cur_mv = geo_mv[best_geo_mode][segm]/*[j][i]*/[LIST_0][(short)best8x8fwref_geo[best_geo_mode][segm]][1];//mode = 1

            enc_picture->ref_idx    [LIST_0][block_y][block_x]    = best8x8fwref_geo[best_geo_mode][segm];
            enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][(short)best8x8fwref_geo[best_geo_mode][segm]];
            enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];
          }
        }

        // forward prediction or intra
        if (best8x8pdir_geo[best_geo_mode][segm] == 0)
        {
          enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
        }
      }
    }

    if (bframe)
    {
      for (j=0; j<4; j++)
      {
        block_y = img->block_y + j;
        for (i=0; i<4; i++)
        {          
          block_x = img->block_x + i;
          k = 2*(j >> 1)+(i >> 1);

          if(img->geo_scheme == 0)
            segm = MB16GeoMask[best_geo_mode][4*j+i];
          else
          {     
            int rho = best_geo_mode>>5, theta_idx = best_geo_mode & 31;    
            segm = geo_mask[mb_ext_level][rho][theta_idx][j*4][i*4];
          }

          // forward
          if (best8x8pdir_geo[best_geo_mode][segm] == 0)
          {
            enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
            enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
            enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
            enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;
          }
          else
          {

            {
              cur_mv = geo_mv[best_geo_mode][segm]/*[j][i]*/[LIST_1][(short)best8x8bwref_geo[best_geo_mode][segm]][1]; //mode = 1

              enc_picture->ref_idx    [LIST_1][block_y][block_x] = best8x8bwref_geo[best_geo_mode][segm];
              enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][(short)best8x8bwref_geo[best_geo_mode][segm]];
              enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
              enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];
            }
          }
        }
      }
    }

    //==== intra prediction modes ====

    {
      memset(currMB->intra_pred_modes,DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char));
      for(j = img->block_y; j < img->block_y + BLOCK_MULTIPLE; j++)
        memset(&img->ipredmode[j][img->block_x], DC_PRED, BLOCK_MULTIPLE * sizeof(char));
    }

    memcpy(img->cofAC16x16[0],    bestCofAC16x16[0],    sizeof(int)*257);
    memcpy(img->cofAC16x16[1],    bestCofAC16x16[1],    sizeof(int)*257);
    memcpy(img->cofAC16x8 [0][0], bestCofAC16x8 [0][0], sizeof(int)*129);
    memcpy(img->cofAC16x8 [0][1], bestCofAC16x8 [0][1], sizeof(int)*129);
    memcpy(img->cofAC16x8 [1][0], bestCofAC16x8 [1][0], sizeof(int)*129);
    memcpy(img->cofAC16x8 [1][1], bestCofAC16x8 [1][1], sizeof(int)*129);
    memcpy(img->cofAC8x16 [0][0], bestCofAC8x16 [0][0], sizeof(int)*129);
    memcpy(img->cofAC8x16 [0][1], bestCofAC8x16 [0][1], sizeof(int)*129);
    memcpy(img->cofAC8x16 [1][0], bestCofAC8x16 [1][0], sizeof(int)*129);
    memcpy(img->cofAC8x16 [1][1], bestCofAC8x16 [1][1], sizeof(int)*129);

  }

  Boolean decide_whether_to_do_geo()
  {
    if(best_mode==I4MB  || best_mode==I16MB || best_mode==I8MB || 
      (best_mode==0 && cbp == 0))//IS_INTRA
      return FALSE;
    else
      return TRUE;

  }

  void set_stored_macroblock_parameters32_geo (int mb_ext_level)
  {
    int  i, j, k;
    Macroblock  *currMB  = &img->mb_data[img->current_mb_nr];
    //int         mode     = best_mode; //best_mode is decided in store_macroblock_parameters32 -peisong
    int         bframe   = (img->type==B_SLICE);
    //char    **ipredmodes = img->ipredmode;

    imgpel        **imgY  = enc_picture->imgY;
    imgpel       ***imgUV = enc_picture->imgUV;
    int        block_x, block_y;  
    short   *cur_mv;
    int segm;


    //===== reconstruction values =====
    for (j = 0; j < (MB_BLOCK_SIZE<<mb_ext_level); j++) //MB32X32
    {
      memcpy(&imgY[img->pix_y+j][img->pix_x],rec_mbY[j], (MB_BLOCK_SIZE<<mb_ext_level) * sizeof(imgpel)); //MB32X32

    }


    if (img->yuv_format != YUV400)
    {
#ifdef MB32X32
      for (j = 0; j<(img->mb_cr_size_y << mb_ext_level); j++)
#else
      for (j = 0; j<img->mb_cr_size_y; j++)
#endif
      {
#ifdef MB32X32
        memcpy(&imgUV[0][img->pix_c_y+j][img->pix_c_x],rec_mbU[j], (img->mb_cr_size_x <<mb_ext_level) * sizeof(imgpel));
        memcpy(&imgUV[1][img->pix_c_y+j][img->pix_c_x],rec_mbV[j], (img->mb_cr_size_x <<mb_ext_level) * sizeof(imgpel));
#else
        memcpy(&imgUV[0][img->pix_c_y+j][img->pix_c_x],rec_mbU[j], img->mb_cr_size_x * sizeof(imgpel));
        memcpy(&imgUV[1][img->pix_c_y+j][img->pix_c_x],rec_mbV[j], img->mb_cr_size_x * sizeof(imgpel));
#endif

      }
    }

#ifndef MB32X32
    //===== coefficients and cbp =====
    i4p=cofAC; cofAC=img->cofAC; img->cofAC=i4p;
    i3p=cofDC; cofDC=img->cofDC; img->cofDC=i3p;
    currMB->cbp      = cbp;
    currMB->cbp_blk = cbp_blk;
#endif
    //==== macroblock type ====
    currMB->mb_type = 3;  

#ifdef MB32X32
    if(mb_ext_level == 1)
    {
      MB32.mb_type    = 3;
      MB32.geo_mode = best_geo_mode;

      MB32.cbp=0;
      //prepare 32x32 block cbp      
      for(i=0; i<4; i++)
      {
        if(cbp16[i] != 0)
        {
          MB32.cbp = 1;
          break;
        }
      }      
    }

    if(mb_ext_level == 2)//MB64X64
    {
      int mbi;
      MB64.mb_type    = 3;
      MB64.geo_mode = best_geo_mode;

      MB64.cbp=0;
      //prepare 32x32 block cbp      
      for(mbi=0; mbi<4; mbi++)
      {
        if(cbp_32[mbi] != 0)
        {
          MB64.cbp = 1;
          break;
        }
      }      
    }


#endif

    currMB->bi_pred_me = 0;

#ifdef MB32X32
    if(mb_ext_level == 1)
      MB32.bi_pred_me    = currMB->bi_pred_me;

    if(mb_ext_level == 2)//MB64X64
      MB64.bi_pred_me    = currMB->bi_pred_me;
#endif


#ifndef MB32X32
    //==== transform size flag ====
    if (((currMB->cbp & 15) == 0) && !(IS_OLDINTRA(currMB) || currMB->mb_type == I8MB))
      currMB->luma_transform_size_8x8_flag = 0;
    else
      currMB->luma_transform_size_8x8_flag = luma_transform_size_8x8_flag;
#endif  
    rdopt->luma_transform_size_8x8_flag  = currMB->luma_transform_size_8x8_flag;



    //==== reference frames =====
#ifdef MB32X32
    for (j = 0; j < (4<<mb_ext_level); j++)
#else
    for (j = 0; j < 4; j++)
#endif
    {
      block_y = img->block_y + j;
#ifdef MB32X32
      for (i = 0; i < (4<<mb_ext_level); i++)
#else
      for (i = 0; i < 4; i++)
#endif
      {
        block_x = img->block_x + i;
#ifdef MB32X32
        k = 2*(j >> (1+mb_ext_level))+(i >> (1+mb_ext_level));
#else
        k = 2*(j >> 1)+(i >> 1);
#endif

        // backward prediction or intra
        if(img->geo_scheme == 0)
          segm = MB16GeoMask[best_geo_mode][4*j+i];
        else
        {     
          int rho = best_geo_mode>>5, theta_idx = best_geo_mode & 31;    
          segm = geo_mask[mb_ext_level][rho][theta_idx][j*4][i*4];
        }

        // backward prediction or intra
        if (best8x8pdir_geo[best_geo_mode][segm] == 1)
        {
          enc_picture->ref_idx    [LIST_0][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = -1;          
          enc_picture->mv         [LIST_0][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_0][block_y][block_x][1] = 0;

        }
        else
        {

          {
            cur_mv = geo_mv[best_geo_mode][segm]/*[j][i]*/[LIST_0][(short)best8x8fwref_geo[best_geo_mode][segm]][1];//mode = 1

            enc_picture->ref_idx    [LIST_0][block_y][block_x]    = best8x8fwref_geo[best_geo_mode][segm];
            enc_picture->ref_pic_id [LIST_0][block_y][block_x]    = enc_picture->ref_pic_num[LIST_0 + currMB->list_offset][(short)best8x8fwref_geo[best_geo_mode][segm]];
            enc_picture->mv         [LIST_0][block_y][block_x][0] = cur_mv[0];
            enc_picture->mv         [LIST_0][block_y][block_x][1] = cur_mv[1];

          }
        }

        // forward prediction or intra
        if (best8x8pdir_geo[best_geo_mode][segm] == 0)
        {
          enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
          enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
          enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
          enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;

        }
#ifdef GEOM_OFFSET
        keep_mv_segm2(block_x, block_y, i, j, ~segm, best_geo_mode, 1);
#endif
      }
    }

    if (bframe)
    {
#ifdef MB32X32
      for (j=0; j<(4<<mb_ext_level); j++)
#else
      for (j=0; j<4; j++)
#endif
      {
        block_y = img->block_y + j;
#ifdef MB32X32
        for (i=0; i<(4<<mb_ext_level); i++)
#else
        for (i=0; i<4; i++)
#endif
        {          
          block_x = img->block_x + i;
#ifdef MB32X32
          k = 2*(j >> (1+mb_ext_level))+(i >> (1+mb_ext_level));
#else
          k = 2*(j >> 1)+(i >> 1);
#endif   
          if(img->geo_scheme == 0)
            segm = MB16GeoMask[best_geo_mode][4*j+i];
          else
          {     
            int rho = best_geo_mode>>5, theta_idx = best_geo_mode & 31;    
            segm = geo_mask[mb_ext_level][rho][theta_idx][j*4][i*4];
          }

          // forward
          if (best8x8pdir_geo[best_geo_mode][segm] == 0)
          {
            enc_picture->ref_idx    [LIST_1][block_y][block_x]    = -1;
            enc_picture->ref_pic_id [LIST_1][block_y][block_x]    = -1;
            enc_picture->mv         [LIST_1][block_y][block_x][0] = 0;
            enc_picture->mv         [LIST_1][block_y][block_x][1] = 0;

          }
          else
          {
            {
              cur_mv = geo_mv[best_geo_mode][segm]/*[j][i]*/[LIST_1][(short)best8x8bwref_geo[best_geo_mode][segm]][1]; //mode = 1

              enc_picture->ref_idx    [LIST_1][block_y][block_x] = best8x8bwref_geo[best_geo_mode][segm];
              enc_picture->ref_pic_id [LIST_1][block_y][block_x] = enc_picture->ref_pic_num[LIST_1 + currMB->list_offset][(short)best8x8bwref_geo[best_geo_mode][segm]];
              enc_picture->mv         [LIST_1][block_y][block_x][0] = cur_mv[0];
              enc_picture->mv         [LIST_1][block_y][block_x][1] = cur_mv[1];
            }
          }

#ifdef GEOM_OFFSET
          keep_mv_segm2(block_x, block_y, i, j, ~segm, best_geo_mode, 0);
#endif
        }
      }
    }

    {
      memset(currMB->intra_pred_modes,DC_PRED, MB_BLOCK_PARTITIONS * sizeof(char));
#ifdef MB32X32
      for(j = img->block_y; j < img->block_y + (BLOCK_MULTIPLE<<mb_ext_level); j++)
        memset(&img->ipredmode[j][img->block_x], DC_PRED, (BLOCK_MULTIPLE<<mb_ext_level) * sizeof(char));
#else
      for(j = img->block_y; j < img->block_y + BLOCK_MULTIPLE; j++)
        memset(&img->ipredmode[j][img->block_x], DC_PRED, BLOCK_MULTIPLE * sizeof(char));
#endif
    }

  }

  void copy_partition_candidate(int rd_pass)
  {
    int i, j, k;
    if(img->geo_scheme == 1)
    {
      for(i=0; i<3; i++)
        for(j=0; j<16; j++)
          for(k=0; k<PreSelect_mode[i]; k++)
          {
            if(rd_pass==0)
              saved_partition_candidate[cluster_counter][i][j][k] =partition_candidate[i][j][k];
            else
              partition_candidate[i][j][k] = saved_partition_candidate[cluster_counter][i][j][k];
          }    
    }
  }
  /*
  * min_rdcost0-the minimum rdcost of normal modes
  * return: 0-normal modes still have minimum rdcost 1-geometry partition has minimum cost
  */
  int encode_one_macroblock_geo (double min_rdcost0, int mb_ext_level)
  {  
    int L, geo_mode, segm;
    int         rerun, runs;//, index=0;//, ctr16x16, dummy, block, mode, 
    short       best_pdir;
    RD_PARAMS   enc_mb;
    double      min_rdcost;//, max_rdcost=1e30;
    char        best_ref[2] = {0, -1};
    int         bmcost[5] = {INT_MAX};
    int         cost=0;

    short       islice      = (img->type==I_SLICE);
    short       bslice      = (img->type==B_SLICE);
    short       pslice      = (img->type==P_SLICE) || (img->type==SP_SLICE);
    short       intra       = (islice || (pslice && img->mb_y==img->mb_y_upd && img->mb_y_upd!=img->mb_y_intra));
    int rho, theta_idx;  
    Macroblock* currMB      = &img->mb_data[img->current_mb_nr];

    int i, j;
    static pel_t   orig_val [(MB_BLOCK_SIZE<<MAX_MB_EXT_LEVEL)*(MB_BLOCK_SIZE<<MAX_MB_EXT_LEVEL)];
    static pel_t  *orig_pic  [MB_BLOCK_SIZE<<MAX_MB_EXT_LEVEL];
    int       blocktype = 1;
    int       bsx       = input->blc_size[blocktype][0]<<mb_ext_level; //blc_size = part_sizes * BLOCK_SIZE 
    int       bsy       = input->blc_size[blocktype][1]<<mb_ext_level;

    int ii;
    int worst_of_8_cost, worst_of_8_idx;
    int best_geo_mode_SAD[PRE_SELECT_MODE][2];//best 8 geo modes [][0]:mode, [][1]:cost
    for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
    {
      best_geo_mode_SAD[ii][0] =  -1;
      best_geo_mode_SAD[ii][1] = INT_MAX;
    }

    for(i=0; i<(MB_BLOCK_SIZE<<mb_ext_level); i++)
    {
      orig_pic[i] = orig_val+(MB_BLOCK_SIZE<<mb_ext_level)*i;
    }
    //==================================
    //=====   GET ORIGINAL BLOCK   =====
    //==================================
    for (j = 0; j < bsy; j++)  //scalable to MB32X32
      memcpy(orig_pic[j],&imgY_org[img->opix_y+j][img->opix_x], bsx *sizeof(imgpel));

    if(!decide_whether_to_do_geo())
    {
      currMB->geo_mode = -1;
      skipped_geo ++ ;
      return 0;
    }

    backup_restore_all_mv(img->all_mv, saved_all_mv, mb_ext_level, 0);
    backup_restore_all_mv(img->pred_mv, saved_pred_mv, mb_ext_level, 0);

#ifdef RDO_Q
    if(input->UseRDO_Q && active_pps->entropy_coding_mode_flag == CABAC)
    {
      estRunLevel_CABAC(LUMA_4x4);
      estRunLevel_CABAC(LUMA_8x8);
      estRunLevel_CABAC(LUMA_16AC);
#ifdef USE_INTRA_MDDT
      estRunLevel_CABAC(LUMA_16x16);
#endif
      estRunLevel_CABAC(LUMA_16x16P);
      estRunLevel_CABAC(LUMA_16x8P);
      estRunLevel_CABAC(LUMA_8x16P);
    }
#endif



    init_enc_mb_params(currMB, &enc_mb, intra, bslice);

    for(ii=0; ii<GeoPart_num[mb_ext_level]; ii++)
    {
      enc_geo_valid[ii] = enc_geo[mb_ext_level][ii];
    }
    if(Segmentation_Selected == 1)
    {
      if(img->geo_scheme == 1)
      {
        for(ii=0; ii<GeoPart_num[mb_ext_level]; ii++)
        {
          enc_geo_valid[ii] = 0;
        }
        for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
        {
          int selected_geo_segm = partition_candidate[mb_ext_level][mb_ext_level==0?curr_mbi:(mb_ext_level==1?curr_mb32i:0)][ii];
          if(selected_geo_segm != -1)
            enc_geo_valid[selected_geo_segm] = 1;
        }
      }
    }
    else
    {
      if(img->geo_scheme == 1)
      {
        if(mb_ext_level > 0)
        {

          memset(enc_geo_valid, 0, GeoPart_num[mb_ext_level]*sizeof(char));

          if(line_candidates > 0)
          {          
            int rho, theta_idx, geo_mode;
            for(L = 0; L<line_candidates; L++)
            {
              rho = line[L].rho;
              rho = max(0, min(rho, Max_rho[mb_ext_level]));
              theta_idx = (line[L].thetai+theta_size*2)%(theta_size*2);

              geo_mode = (rho<<THETA_BITS)+theta_idx;
              if(enc_geo[mb_ext_level][geo_mode])
                enc_geo_valid[geo_mode] = 1;
            }

          }

          if(mb_ext_level == 1)
          {         
            for(ii=0; ii<GeoPart_num[mb_ext_level]; ii++)
            {
              if(enc_geo_hier[mb_ext_level][ii])
                enc_geo_valid[ii] = 1;
            }
          }
        }
      }
    }


    {
#ifdef WIN32
      struct _timeb tstruct1;
      struct _timeb tstruct2;
#else
      struct timeb tstruct1;
      struct timeb tstruct2;
#endif

      int me_tmp_time;

#ifdef WIN32
      _ftime( &tstruct1 );    // start time ms
#else
      ftime(&tstruct1);
#endif

      // reset chroma intra predictor to default
      currMB->c_ipred_mode = DC_PRED_8;

      //=====   S T O R E   C O D I N G   S T A T E   =====
      //---------------------------------------------------
      store_coding_state (cs_cm);


      if( Segmentation_Selected == 0)
        runs = 2;
      else
        runs = 1;
      // Perform multiple encodings if rdopt with losses is enabled
      for (rerun=0; rerun<runs; rerun++)
      {


        if(rerun == 1 && Segmentation_Selected == 0)
        {
          memset(enc_geo_valid, 0, GeoPart_num[mb_ext_level]*sizeof(char));

          if(mb_ext_level > 0)
          {
            int r, t, rho, best_rho, best_theta_idx, best_idx, best_cost, geo_mode_tmp;
            for(L = 0; L<2; L++)
            {
              best_cost = best_geo_mode_SAD[L][1];
              best_idx  = L;
              for(ii=L; ii<PreSelect_mode[mb_ext_level]; ii++)
              {
                if(best_cost > best_geo_mode_SAD[ii][1])
                {
                  best_cost = best_geo_mode_SAD[ii][1];
                  best_idx = ii;
                }
              }
              if(best_idx != L)
              {
                int best_geo_mode = best_geo_mode_SAD[best_idx][0];

                best_geo_mode_SAD[best_idx][0] = best_geo_mode_SAD[L][0];
                best_geo_mode_SAD[best_idx][1] = best_geo_mode_SAD[L][1];
                best_geo_mode_SAD[L][0] = best_geo_mode;
                best_geo_mode_SAD[L][1] = best_cost;
              }

              if(best_geo_mode_SAD[L][0] > -1)
              {
                get_rho_theta0(best_geo_mode_SAD[L][0], &best_rho, &best_theta_idx, mb_ext_level);

                for(r=-1; r<=1; r++)
                {
                  for(t=-1; t<=1; t++)
                  {
                    rho = r + best_rho;
                    rho = max(0, min(rho, Max_rho[mb_ext_level]));
                    theta_idx = (t+best_theta_idx+theta_size*2)%(theta_size*2);
                    geo_mode_tmp = (rho<<THETA_BITS)+theta_idx;
                    if(enc_geo[mb_ext_level][geo_mode_tmp])
                      enc_geo_valid[geo_mode_tmp] = 1;
                  }
                }
              }
            }
          }
          else
          {
            for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
            {         
              enc_geo_valid[best_geo_mode_SAD[ii][0]] = 1;
            }
          }

          for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
          {
            best_geo_mode_SAD[ii][0] =  -1;
            best_geo_mode_SAD[ii][1] = INT_MAX;
          }

          Segmentation_Selected = 1;
        }


        worst_of_8_cost = INT_MAX;
        //===== MOTION ESTIMATION FOR 32x32, 32x16, 16x32 BLOCKS =====      
        for (geo_mode=0; geo_mode<GeoPart_num[mb_ext_level]; geo_mode++)
        {
          if(img->geo_scheme == 1)
          {
            if(enc_geo_valid[geo_mode]==0)
              continue;
          }

          get_rho_theta(geo_mode, &rho, &theta_idx, &mask, mb_ext_level);
          mask4x4 = geo_4x4mask[mb_ext_level][rho][theta_idx];
          smfilter = geo_filter[mb_ext_level][rho][theta_idx];
          smfilterUV = geo_filterUV[mb_ext_level][rho][theta_idx];
          //bi_pred_me = 0;
          //img->bi_pred_me[mode]=0;
          //if (enc_mb.valid[mode] && !inter_skip)
          {
            for (cost=0, segm=0; segm<2; segm++)
            {
              PartitionMotionSearch32_geo (img->geo_scheme, orig_pic, geo_mode, segm, enc_mb.lambda_mf, 0, mb_ext_level);     
              //--- get cost and reference frame for List 0 prediction ---
              bmcost[LIST_0] = INT_MAX;
#ifdef MB32X32
              list_prediction_cost32_geo(LIST_0, img->geo_scheme, geo_mode, segm, enc_mb, bmcost, best_ref, mb_ext_level);
#else
              list_prediction_cost(LIST_0, block, mode, enc_mb, bmcost, best_ref);
#endif       
              if (bslice)
              {
                //--- get cost and reference frame for List 1 prediction ---
                bmcost[LIST_1] = INT_MAX;
#ifdef MB32X32
                list_prediction_cost32_geo(LIST_1, img->geo_scheme, geo_mode, segm, enc_mb, bmcost, best_ref, mb_ext_level);
#else
                list_prediction_cost(LIST_1, block, mode, enc_mb, bmcost, best_ref);
#endif         
                // Compute bipredictive cost between best list 0 and best list 1 references
#ifdef MB32X32
                list_prediction_cost32_geo(BI_PRED, img->geo_scheme, geo_mode, segm, enc_mb, bmcost, best_ref, mb_ext_level);
#else
                list_prediction_cost(BI_PRED, block, mode, enc_mb, bmcost, best_ref);
#endif         
                {
                  bmcost[BI_PRED_L0] = INT_MAX;
                  bmcost[BI_PRED_L1] = INT_MAX;
                }

                // Determine prediction list based on mode cost
                determine_prediction_list(3, bmcost, best_ref, &best_pdir, &cost, &bi_pred_me);//set mode=3 to bypass BiPredMotionEstimation
              }
              else // if (bslice)
              {
                best_pdir  = 0;
                cost      += bmcost[LIST_0];
              }          

              backup_geo_mv(geo_mode, segm, best_ref, best_pdir, mb_ext_level);
              //----- set reference frame and direction parameters -----
              if(segm ==0)
              {
                if(cost > worst_of_8_cost)
                {
                  break;
                }
              }
            } // for (cost=0, segm=0; segm<2; segm++)

            worst_of_8_cost = best_geo_mode_SAD[0][1];
            worst_of_8_idx  = 0;
            for(ii=1; ii<PreSelect_mode[mb_ext_level]; ii++)
            {
              if(best_geo_mode_SAD[ii][1]>worst_of_8_cost)
              {
                worst_of_8_cost = best_geo_mode_SAD[ii][1];
                worst_of_8_idx  = ii;
              }
            }
            if (cost < worst_of_8_cost)
            {
              best_geo_mode_SAD[worst_of_8_idx][0] = geo_mode;
              best_geo_mode_SAD[worst_of_8_idx][1] = cost;
            }


          } // if (enc_mb.valid[mode])      

        }//geo_mode

        if(rerun == 1)
          Segmentation_Selected = 0;
      }

#ifdef WIN32
      _ftime(&tstruct2);   // end time ms
#else
      ftime(&tstruct2);    // end time ms
#endif

      me_tmp_time=(int)((tstruct2.time*1000+tstruct2.millitm) - (tstruct1.time*1000+tstruct1.millitm)); 
      me_tot_time += me_tmp_time;
      me_time += me_tmp_time;

      if(Segmentation_Selected==0)
      {
        if(img->geo_scheme == 1)
        {
          for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
            partition_candidate[mb_ext_level][mb_ext_level==0?curr_mbi:(mb_ext_level==1?curr_mb32i:0)][ii] = best_geo_mode_SAD[ii][0];
        }
      } 

      //========= C H O O S E   B E S T   M A C R O B L O C K   M O D E =========
      //-------------------------------------------------------------------------
      if (input->rdopt)
      {
        // store_coding_state (cs_cm);    
        {        
          //min_rdcost0 = INT_MAX;
          min_rdcost = min_rdcost0;

          //if (input->BiPredMotionEstimation)
          //  img->bi_pred_me[1] =0;  
          if(img->geo_scheme == 1)
          {
            for(ii=0; ii<GeoPart_num[mb_ext_level]; ii++)
              enc_geo_valid[ii] = 0;
            for(ii=0; ii<PreSelect_mode[mb_ext_level]; ii++)
              enc_geo_valid[best_geo_mode_SAD[ii][0]] = 1;
          }

          min_rdcost = compute_mode_RD_cost_RDOQ32_geo(min_rdcost, currMB, &enc_mb, mb_ext_level);
        }
      }

    } // for (rerun=0; rerun<runs; rerun++) 

    //=====  S E T   F I N A L   M A C R O B L O C K   P A R A M E T E R S ======
    //---------------------------------------------------------------------------  
    if(input->rdopt && min_rdcost < min_rdcost0)
    { 
      if (cbp!=0) //cbp is set in store_macroblock_parameters -peisong
        currMB->prev_cbp = 1;    
      else if (cbp==0 && !input->RCEnable)
      {
        currMB->delta_qp = 0;
        currMB->qp       = currMB->prev_qp;
        set_chroma_qp(currMB);
        img->qp          = currMB->qp;
        currMB->prev_cbp = 0;

        //  make sure to save qp info into MB32.qp as this is used in start_macroblock32
        MB32.qp = currMB->qp;
        //MB32.prev_qp = currMB->prev_qp;
        //MB32.prev_delta_qp = currMB->prev_delta_qp; //for delta_qp encoding in cabac
      }    

      if(mb_ext_level == 0)
        set_stored_macroblock_parameters_geo (mb_ext_level);
      else
        set_stored_macroblock_parameters32_geo (mb_ext_level);

      //rdopt->min_rdcost = input->rdopt ? min_rdcost : min_cost;
      rdopt->min_rdcost = min_rdcost;


      return 1;
    }
    else
    {
      backup_restore_all_mv(img->all_mv, saved_all_mv, mb_ext_level, 1);
      backup_restore_all_mv(img->pred_mv, saved_pred_mv, mb_ext_level, 1);

      if(mb_ext_level == 2)
        MB64.geo_mode = -1;
      else if(mb_ext_level == 1)
        MB32.geo_mode = -1;
      else if(mb_ext_level == 0)
        currMB->geo_mode = -1;
      else
        error("mb_ext_level is not correct (encode_one_macroblock_geo())\n", -1);

      return 0;
    }

  }

  int MBType2Value_geo (Macroblock* currMB)
  {
    static const int dir1offset[3]    =  { 1,  2, 3};
    static const int dir2offset[3][3] = {{ 0,  4,  8},   // 1. block forward
    { 6,  2, 10},   // 1. block backward
    {12, 14, 16}};  // 1. block bi-directional

    int mbtype, pdir0, pdir1;

    if (img->type!=B_SLICE)
    {
      return 3; //use P_8x16
    }
    else
    {
      mbtype = 3;//use B_8x16
      pdir0  = best8x8pdir_geo[currMB->geo_mode][0];
      pdir1  = best8x8pdir_geo[currMB->geo_mode][1];

      if      (mbtype==0)       return 0;
      else if (mbtype==I4MB || mbtype==I8MB)
        return 23;
      else if (mbtype==I16MB)   return 23 + img->i16offset;
      else if (mbtype==P8x8)    return 22;
#if B_MBTYPE
      else if (mbtype==1)       return 1;
      else if (mbtype==2)       return 2;
      else                      return 3;
#else
      else if (mbtype==1)       return dir1offset[pdir0];
      else if (mbtype==2)       return 4 + dir2offset[pdir0][pdir1];
      else                      return 5 + dir2offset[pdir0][pdir1];
#endif
    }
  }
  int u_1 (char *tracestring, int value, Bitstream *bitstream);
  int writeMB_geoInfo_VLC(SyntaxElement *se, struct datapartition *dataPart)
  {
    int bits=0;
    int geo_mode = se->value1;

    if(geo_mode == -1)
    {
      bits += u_1 ("mb_geo_flag", 0, dataPart->bitstream);
    }
    else
    {
      int i;
      bits += u_1 ("mb_geo_flag", 1, dataPart->bitstream);

      for(i=0; i<(se->value2); i++)     
        bits += u_1 ("mb_geo_mode", (geo_mode>>i)&1, dataPart->bitstream);
    }
    return bits;
  }

  void writeMB_geoInfo_CABAC (SyntaxElement *se, EncodingEnvironmentPtr eep_dp)
  {
    int geo_mode = se->value1;

    if(geo_mode == -1)
    {
      biari_encode_symbol_eq_prob (eep_dp, 0);
    }
    else
    {
      int i;
      biari_encode_symbol_eq_prob (eep_dp, 1);

      if(img->geo_scheme == 0)
      {
        for(i=0; i<4; i++)
          biari_encode_symbol_eq_prob (eep_dp, (geo_mode>>i)&1);
      }
      else
      {
        for(i=0; i<(se->value2); i++)     
          biari_encode_symbol_eq_prob (eep_dp, (geo_mode>>i)&1);
      }
    }
  }

  int writeMotionVector_geo (int geo_mode,
    int segm,
    int  i0,
    int  j0,
    int  i1,
    int  j1,
    int  refframe,
    int  list_idx,
    int  mb_ext_level)
  {
    int            i, j, k, l, m;
    int            curr_mvd;
    DataPartition* dataPart;

    int            rate       = 0;
    int            step_h     = input->part_size[1][0] << mb_ext_level;
    int            step_v     = input->part_size[1][1] << mb_ext_level;
    Macroblock*    currMB     = &img->mb_data[img->current_mb_nr];
    SyntaxElement* currSE     = &img->MB_SyntaxElements[currMB->currSEnr];
    Slice*         currSlice  = img->currentSlice;
    int*           bitCount   = currMB->bitcounter;
    const int*     partMap    = assignSE2partition[input->partition_mode];
    int            refindex   = refframe;

    //short******    all_mv     = img->all_mv;
    short******    pred_mv    = img->pred_mv;
    int rho, theta_idx; 
    char **mask;
    get_rho_theta(geo_mode, &rho, &theta_idx, &mask, mb_ext_level);
    //rho = geo_mode>>5, theta_idx = geo_mode & 31;    

    //if (currMB->bi_pred_me && currMB->b8pdir[0]==2 && mv_mode == 1 && refindex == 0)
    //  all_mv = currMB->bi_pred_me == 1? img->bipred_mv1 : img->bipred_mv2 ;

    assert(j1 == step_v && i1==step_h);

    for (j=j0; j<j1; j+=step_v)
    {
      for (i=i0; i<i1; i+=step_h)
      {

        int mv_shift =0;  //1/8 pel as default 
        int currMvVec;
        int predMvVec;




#ifndef TRELLIS_ONLY
#ifdef RDO_Q
        if(input->UseRDO_Q)
        {         
          short pred_mv_stored[2];

          SetMotionVectorPredictor32_geo (pred_mv_stored, geo_mode, segm, enc_picture->ref_idx[list_idx], enc_picture->mv[list_idx], (short)refindex, list_idx, i, j, (16<<mb_ext_level), (16<<mb_ext_level), mb_ext_level);  //scalable to MB32X32
          //SetMotionVectorPredictor (pred_mv_stored,                       enc_picture->ref_idx[list_idx], enc_picture->mv[list_idx], (short)refindex, list_idx, i, j, input->blc_size[mv_mode][0],input->blc_size[mv_mode][1]);
          pred_mv[j][i][list_idx][refindex][1][0]=pred_mv_stored[0];
          pred_mv[j][i][list_idx][refindex][1][1]=pred_mv_stored[1];

        }
        else
        {
          short pred_mv_stored[2];

          SetMotionVectorPredictor32_geo (pred_mv_stored, geo_mode, segm, enc_picture->ref_idx[list_idx], enc_picture->mv[list_idx], (short)refindex, list_idx, i, j, (16<<mb_ext_level), (16<<mb_ext_level), mb_ext_level);  //scalable to MB32X32
          //SetMotionVectorPredictor (pred_mv_stored,                       enc_picture->ref_idx[list_idx], enc_picture->mv[list_idx], (short)refindex, list_idx, i, j, input->blc_size[mv_mode][0],input->blc_size[mv_mode][1]);
          pred_mv[j][i][list_idx][refindex][1][0]=pred_mv_stored[0];
          pred_mv[j][i][list_idx][refindex][1][1]=pred_mv_stored[1];
        }

#endif   //RDO_Q
#endif      


        if (img->mv_res)
        {
          if (((geo_mv[geo_mode][segm][list_idx][refindex][1][0]& 1) ==0)&&((geo_mv[geo_mode][segm][list_idx][refindex][1][1]& 1))==0)
            mv_shift =1; //switch to 1/4 pel

          if(input->symbol_mode == CABAC)
          {
            img->subblock_x = i; // position used for context determination
            img->subblock_y = j; // position used for context determination
            currSE->value1 = mv_shift;
            currSE->type   = SE_MVD; 
            currSE->value2 = 0;
            currSE->writing  = writeMVRES_4_8_CABAC;
            dataPart = &(currSlice->partArr[partMap[SE_MVD]]);
            dataPart->writeSyntaxElement (currSE, dataPart);
#if TRACE
            snprintf(currSE->tracestring, TRACESTRING_SIZE, "mv_shift  = %3d  ", mv_shift);
#endif
            bitCount[BITS_INTER_MB] += currSE->len;
            rate                    += currSE->len;
            currSE++;  
            currMB->currSEnr++;
          }


        }
        else
        {
          mv_shift=0;
        }


        for (k=0; k<2; k++) 
        {   

          if (img->mv_res && (mv_shift > 0))
          {
            int scaled_mvd;
            currMvVec=roundInt(geo_mv[geo_mode][segm][list_idx][refindex][1][k],mv_shift);
            predMvVec=roundInt(pred_mv[j][i][list_idx][refindex][1][k],mv_shift);
            curr_mvd = currMvVec - predMvVec;
            scaled_mvd = curr_mvd*(1<< mv_shift);
            //--- store (oversampled) mvd ---
            for (l=0; l < step_v; l++)
            {
              for (m=0; m < step_h; m++)
              {
#if GEO_SCHEME == 0
                if(img->geo_scheme == 0)
                {
                  if(MB16GeoMask[geo_mode][l*step_h+m] == segm) 
                    currMB->mvd[list_idx][j+l][i+m][k] = scaled_mvd;
                }
                else
#endif
                {
                  if(mask[l*4][m*4] == segm) 
                  {
                    if(mb_ext_level==0)
                      currMB->mvd[list_idx][j+l][i+m][k] = scaled_mvd;
                    else
                      mb32_mvd[list_idx][j+l][i+m][k] = scaled_mvd;
                  }
                }
              }
            }
          }
          else

          {
            curr_mvd = geo_mv[geo_mode][segm]/*[j][i]*/[list_idx][refindex][1][k] - pred_mv[j][i][list_idx][refindex][1][k];
            //--- store (oversampled) mvd ---
            for (l=0; l < step_v; l++)
            {
              for (m=0; m < step_h; m++)
              {
#if GEO_SCHEME == 0
                if(img->geo_scheme == 0)
                {
                  if(MB16GeoMask[geo_mode][l*step_h+m] == segm) 
                    currMB->mvd[list_idx][j+l][i+m][k] = curr_mvd;
                }
                else
#endif
                {
                  if(mask[l*4][m*4] == segm) 
                  {
                    if(mb_ext_level==0)
                      currMB->mvd[list_idx][j+l][i+m][k] = curr_mvd;
                    else
                      mb32_mvd[list_idx][j+l][i+m][k] = curr_mvd;
                  }
                }
              }
            }
          }
          currSE->value1 = curr_mvd;
          currSE->value2 = 0;
          currSE->type   = SE_MVD;
          if (input->symbol_mode == UVLC)
          {
            currSE->mapping = se_linfo;
          }
          else
          {
            img->subblock_x = i; // position used for context determination
            img->subblock_y = j; // position used for context determination

            currSE->value2  = (2*k+list_idx)*2+mv_shift;

            currSE->writing = writeMVD_CABAC;
          }  
          dataPart = &(currSlice->partArr[partMap[SE_MVD]]);
          dataPart->writeSyntaxElement (currSE, dataPart);
          bitCount[BITS_INTER_MB] += currSE->len;
          rate                    += currSE->len;
          currSE++;  
          currMB->currSEnr++;
        }

      }
    }
    return rate;
  }

  int ref_idx_ctx_geo(int mv_mode, int geo_mode, int segm, int i, int j, int list_idx, int ref, int mb_ext_level)
  {
    int k;
    int a=0, b=0;
    PixelPos block_a, block_b;
    int mv_eighth;
    int mb_nr = img->current_mb_nr;
    int subblock_x=0, subblock_y=0; 

    if(mb_ext_level ==0)
    {    
      subblock_x = i;
      subblock_y = j;
    }
    else
    {  
      if(i==0 && j==0 )
      {
        subblock_x = 0;
        subblock_y = 0;
        mb_nr      = img->current_mb_nr;
      }
      else if(i==0 && j==(2<<mb_ext_level) )
      {
        subblock_x = 0;
        subblock_y = 0;
        mb_nr      = img->current_mb_nr + (img->PicWidthInMbs << (mb_ext_level-1));
      }
      else if(i==(2<<mb_ext_level) && j==0 )
      {
        subblock_x = 0;
        subblock_y = 0;
        mb_nr      = img->current_mb_nr + (1<<(mb_ext_level- 1));
      }
      else
      {
        error("subblock_x and subblock_y are out of the range\n", -1);
      }

    }

    getLuma4x4Neighbour(mb_nr, subblock_x, subblock_y, -1,  0, &block_a);
    getLuma4x4Neighbour(mb_nr, subblock_x, subblock_y,  0, -1, &block_b);

    if (block_b.available)
    {
      for(k=0; k<2; k++)
        b |= absm(img->mb_data[block_b.mb_addr].mvd[list_idx][block_b.y][block_b.x][k]) & 1;
    }
    else
      b=0;

    if (block_a.available)
    {
      for(k=0; k<2; k++)
        a |= absm(img->mb_data[block_a.mb_addr].mvd[list_idx][block_a.y][block_a.x][k]) & 1;
    }
    else
      a = 0;

    mv_eighth = ((geo_mv[geo_mode][segm][list_idx][ref][1][0]& 1) ==1) || ((geo_mv[geo_mode][segm][list_idx][ref][1][1]& 1)==1);

    if(a==0 && b==0)
      return mv_eighth;
    else
      return 2+mv_eighth;
  }

  int writeReferenceFrame_geo (int mode, int geo_mode, int segm, int i, int j, int fwd_flag, int  ref)
  {
    Macroblock*     currMB    = &img->mb_data[img->current_mb_nr];
    SyntaxElement*  currSE    = &img->MB_SyntaxElements[currMB->currSEnr];
    Slice*          currSlice = img->currentSlice;
    int*            bitCount  = currMB->bitcounter;
    const int*      partMap   = assignSE2partition[input->partition_mode];
    int             rate      = 0;
    DataPartition*  dataPart;
    int             num_ref   = ( fwd_flag ? listXsize[LIST_0+currMB->list_offset]: listXsize[LIST_1+currMB->list_offset]);
    int             flag_mode = 0;

    if( num_ref == 1 )
    {
      return 0;
    }

    if ( num_ref == 2 )
    {
      flag_mode = 1;
    }

    currSE->value1 = ref;
    currSE->value2  = 0;
    currSE->type   = SE_REFFRAME;

    dataPart = &(currSlice->partArr[partMap[currSE->type]]);
    if (input->symbol_mode == UVLC)
    {
      if(input->symbol_mode == UVLC && img->mv_res)
      {
        if(ref == 0 && mode <= 4)
          currSE->value2 = ref_idx_ctx_geo(mode, geo_mode, segm, i, j, !fwd_flag, ref, 0);
        write_ref_idx(mode, currSE, dataPart);
      }
      else
      {
        if( flag_mode )
        {
          currSE->bitpattern = 1 - currSE->value1;
          currSE->len = 1;
          writeSyntaxElement2Buf_Fixed(currSE, dataPart->bitstream);
        }
        else
        {
          currSE->mapping = ue_linfo;
          dataPart->writeSyntaxElement (currSE, dataPart);
        }
      }
    }
    else
    {
      currSE->context = BType2CtxRef (mode);
      img->subblock_x = i; // position used for context determination
      img->subblock_y = j; // position used for context determination
      currSE->writing = writeRefFrame_CABAC;
      currSE->value2 = (fwd_flag)? LIST_0:LIST_1;
      dataPart->writeSyntaxElement (currSE, dataPart);
    }

    bitCount[BITS_INTER_MB] += currSE->len;
    rate                    += currSE->len;
#if TRACE
    if (fwd_flag)
    {
      snprintf(currSE->tracestring, TRACESTRING_SIZE, "ref_idx_l0 = %d", currSE->value1);
    }
    else
    {
      snprintf(currSE->tracestring, TRACESTRING_SIZE, "ref_idx_l1 = %d", currSE->value1);
    }
#endif
    currSE++;
    currMB->currSEnr++;

    return rate;
  }



  int writeMotionInfo2NAL_geo (int geo_mode, int mb_ext_level)
  {
    int refframe;//k, j0, i0, 
    //int jj;
    Macroblock*     currMB    = &img->mb_data[img->current_mb_nr];
    int             no_bits   = 0;
    //int   bframe          = (img->type==B_SLICE);
    int   step_h0         = ((input->blc_size[IS_P8x8(currMB) ? 4 : 1][0]<<mb_ext_level) >> 2);
    int   step_v0         = ((input->blc_size[IS_P8x8(currMB) ? 4 : 1][1]<<mb_ext_level) >> 2);
    int   pdir, segm;
    //=== If multiple ref. frames, write reference frame for the MB ===
    //if (IS_INTERMV (currMB))
    {
      // if UVLC is turned on, a 8x8 macroblock with all ref=0 in a P-frame is signalled in macroblock mode
      //if (!IS_P8x8 (currMB) || !ZeroRef (currMB) || input->symbol_mode==CABAC || bframe)
      {
        for (segm=0; segm<2; segm++)
        {
          pdir = best8x8pdir_geo[geo_mode][segm];
          if (pdir==0 || pdir==2)//has forward vector
          {
            no_bits += writeReferenceFrame_geo (3, geo_mode, segm, 0, 0, 1, best8x8fwref_geo[geo_mode][segm]);//enc_picture->ref_idx[LIST_0][img->block_y][img->block_x]
          }
        }
        for (segm=0; segm<2; segm++)
        {
          pdir = best8x8pdir_geo[geo_mode][segm];
          if (pdir==1 || pdir==2)//has backward vector
          {
            no_bits += writeReferenceFrame_geo (3, geo_mode, segm, 0, 0, 0, best8x8bwref_geo[geo_mode][segm]);//enc_picture->ref_idx[LIST_1][img->block_y][img->block_x]
          }
        }
      }
    }

    //===== write forward motion vectors =====
    //if (IS_INTERMV (currMB))
    {
      for (segm=0; segm<2; segm++)
      {
        pdir = best8x8pdir_geo[geo_mode][segm];
        {
          if (pdir==0 || pdir==2)//has forward vector
          {
            refframe  = best8x8fwref_geo[geo_mode][segm];//enc_picture->ref_idx[LIST_0][img->block_y][img->block_x];
            no_bits  += writeMotionVector_geo (geo_mode, segm, 0, 0, step_h0, step_v0, refframe, LIST_0, mb_ext_level);//, currMB->b8mode[k]
          }
        }
      }
    }


    //===== write backward motion vectors =====
    //if (IS_INTERMV (currMB) && bframe)
    {
      for (segm=0; segm<2; segm++)
      {
        pdir = best8x8pdir_geo[geo_mode][segm];
        {
          if (pdir==1 || pdir==2)//has backward vector
          {
            refframe  = best8x8bwref_geo[geo_mode][segm]; //enc_picture->ref_idx[LIST_1][img->block_y][img->block_x];
            no_bits  += writeMotionVector_geo (geo_mode, segm, 0, 0, step_h0, step_v0, refframe, LIST_1, mb_ext_level);//, currMB->b8mode[k]
          }
        }
      }
    }
    return no_bits;
  }

  void set_context_geo()
  {
    Macroblock*     currMB    = &img->mb_data[img->current_mb_nr];

    if(currMB->mb_type >= MAXMODE)
      currMB->mb_type = 3;
  }

  void dense_motion_field16(int mbcount, int transform8x8)
  {
    int i, j, k;
    int blocktype=7, list=0, ref=0;
    short  ******mv;
    if (transform8x8)
      mv = img->all_mv8[mbcount];
    else
      mv = img->all_mv4[mbcount];

    for (j=0; j < 4; j++)    
    {
      for (i=0; i < 4; i++)
      {
        for(k=0; k<2; k++)
        {
          mv_map[j][i][k] = mv[j][i][list][ref][blocktype][k];              
        }
      }
    }
  }


  void dense_motion_field(int mb32count, int CurrentMbAddr_x, int CurrentMbAddr_y, int extend_x, int extend_y, int transform8x8, int mb_ext_level)
  {
    int i, j, mbi, mbj, ii, jj, k, start_x, start_y, mb_count=mb32count*4;
    int blocktype=7, list=0, ref=0;


    for(mbj=CurrentMbAddr_y; mbj<=extend_y; mbj+=mb_ext_level)  
    {      
      for(mbi=CurrentMbAddr_x; mbi<=extend_x; mbi+=mb_ext_level)   
      {             
        for(jj=0; jj<(1<<(mb_ext_level-1)); jj++)
        {
          for(ii=0; ii<(1<<(mb_ext_level-1)); ii++)
          {
            start_y = (mb32count>>1)*2 + mbj - CurrentMbAddr_y + jj;
            start_x = (mb32count& 1)*2 + mbi - CurrentMbAddr_x + ii;
            if (transform8x8)
            {
              for (j=0; j < 4; j++)    
              {
                for (i=0; i < 4; i++)
                {
                  for(k=0; k<2; k++)
                  {
                    mv_map[start_y*4+j][start_x*4+i][k] = img->all_mv8[mb_count][j][i][list][ref][blocktype][k];              
                  }
                }
              }
            }
            else
            {
              for (j=0; j < 4; j++)    
              {
                for (i=0; i < 4; i++)
                {
                  for(k=0; k<2; k++)
                  {
                    mv_map[start_y*4+j][start_x*4+i][k] = img->all_mv4[mb_count][j][i][list][ref][blocktype][k];
                  }
                }
              }
            }

            mb_count++;
          }
        }

      }
    }

  }


  /*-----------------------------------------------
  SOBEL ALGORITHM 
  ---------------------------------------------*/
  int compare_edge(const void *arg1, const void *arg2)
  {
    return (*(int *)arg2 - *(int *)arg1) ;
  }

  void edge_detect(int start_x, int start_y, int mb_ext_level)
  {  
    int i, j, k, xi, yj, x, y, ke, kv, rows, cols, sum;
    int edge_1d[256];
    int edge_thres;
    int op[2][3][3] = 
    {              {{-1, 0, 1}, //vertical edge
    {-2, 0, 2},
    {-1, 0, 1}},
    {{1, 2, 1},  //horizontal edge
    {0, 0, 0},
    {-1,-2,-1}}
    };

    rows = 4<<mb_ext_level;//in the unit of 4x4 mv block
    cols = 4<<mb_ext_level;//in the unit of 4x4 mv block

    k=0;
    for(y=0; y<rows; y++)
    {
      for(x=0; x<cols; x++)  
      {
        edge[y][x] = 0;
        /*-------GRADIENT APPROXIMATION------*/
        for(kv=0; kv<2; kv++)//motion vector element
        {
          for(ke=0; ke<2; ke++)//edge direction
          {
            sum = 0;
            for(i=-1; i<=1; i++)  
            {
              for(j=-1; j<=1; j++)  
              {
                xi = x+i;
                xi = (xi<0) ? 0 : ((xi>=cols) ? cols-1 : xi);
                xi += start_x;

                yj = y+j;
                yj = (yj<0) ? 0 : ((yj>=rows) ? rows-1 : yj);
                yj += start_y;

                sum = sum +  mv_map[yj][xi][kv] * op[ke][j+1][i+1];
              }  
            }
            /*---GRADIENT MAGNITUDE APPROXIMATION (Myler p.218)----*/       
            edge[y][x] += abs(sum);
          }//ke
        }//kv    

        edge_1d[k++] = edge[y][x];
      }   
    }


    //thresholding
    qsort((int *)edge_1d, k, sizeof(int), compare_edge);
    edge_thres = 2*rows;
    for(y=0; y<rows; y++)
      for(x=0; x<cols; x++)
        if(edge[y][x] < edge_1d[edge_thres])
          edge[y][x] = 0;


  }

  //function [pdetect,tetadetect,accum] = houghline(rows, cols, Imbinary,pstep,tetastep)
  /*%Comments:
  %       This function uses polar representation of lines i.e. x*cos(teta)+y*sin(teta)=p to detect 
  %       lines in binary image. upper left corner of image is the origin of polar coordinate system.
  %
  %Arguments:
  %       Imbinary - a binary image. image pixels that have value equal to 1 are
  %                  interested pixels for HOUGHLINE function.
  %       pstep    - interval for radius of lines in polar coordinates.
  %       tetastep - interval for angle of lines in polar coordinates.
  %
  %Returns:
  %       pdetect     - a vactor that contains radius of detected lines in
  %                     polar coordinates system.
  %       tetadetect  - a vector that contains angle of detcted lines in
  %                     polar coordinates system.
  %       accum - the accumulator array in Hough space.
  %
  %Written by :
  %       Amin Sarafraz
  %       Geomatics Department,Faculty of Engineering
  %       University of Tehran,Iran
  %May 5,2004         - Original version
  %November 24,2004   - Modified version,slightly faster and better performance.      */    

  void init_hough()
  {
    int i, j, temp;
    float thetastep = THETASTEP;
    int pstep  = PSTEP;

    for(i=0; i<3; i++)//mb_ext_level
    {
      temp = (int)((16<<i)/2/pstep);
      rho_size[i] = temp * 2 + 1;
      rho_scale[i] = (int *)calloc(rho_size[i], sizeof(int));
      for(j=-temp; j<=temp; j++)
      { 
        rho_scale[i][j+temp] = j*pstep;
      }
    }

    theta_size = (int)(180/thetastep);

    accum = (int **)calloc(rho_size[2], sizeof(int *));
    for(i=0; i<rho_size[2]; i++)
      accum[i] = (int *)calloc(theta_size, sizeof(int));

    line = (LinePolar *)calloc(rho_size[2]*theta_size, sizeof(LinePolar));
  }
  void free_hough()
  {
    int i;
    for(i=0; i<3; i++)
      free(rho_scale[i]);
    //free(theta_scale);

    for(i=0; i<rho_size[2]; i++)
      free(accum[i]);
    free(accum);
    free(line);
  }
  int compare(const void *line1, const void *line2 )
  {
    return ( ((LinePolar*)line2)->accum - ((LinePolar*)line1)->accum);
  }
  int  houghline(int mb_ext_level)
  {                         
    //       thresh   - a threshold value that determines the minimum number of
    //                  pixels that belong to a line in image space. threshold must 
    //                  be bigger than or equal to 3(default).
    int i, j, r, t, n, Indp, rhoi, thetai, min_rho, max_rho, shift;
    int max_flag;
    int rows = 4<<mb_ext_level;//in the unit of 4x4 mv block
    int cols = 4<<mb_ext_level;//in the unit of 4x4 mv block
    int blocksize = 16<<mb_ext_level;
    int yIndex, xIndex;
    int thresh = 3;
    int pstep  = PSTEP;
    //double theta;//, thetastep = THETASTEP;
    int total;
    double rho, absolute_x, absolute_y;
    int neigh[][2]={{-1,-1}, {0,-1}, {1,-1}, {-1,0}, {1,0}, {-1,1}, {0,1}, {1,1}}; //8-connected neighbors {rho,theta}


    // Voting
    for(i=0; i<rho_size[mb_ext_level]; i++)
    {
      for(j=0; j<theta_size; j++)
        accum[i][j] = 0;
    }

    min_rho = rho_scale[mb_ext_level][0];
    max_rho = rho_scale[mb_ext_level][rho_size[mb_ext_level]-1];
    shift = rho_size[mb_ext_level]>>1;

    for(yIndex=0; yIndex<rows; yIndex++) //index of 4x4 block mv
    {
      absolute_y = blocksize - 1 - yIndex * 4 -blocksize/2 + 0.5 - 1.5;
      for(xIndex=0; xIndex<cols; xIndex++)
      {
        if(edge[yIndex][xIndex] != 0)
        {
          absolute_x = xIndex * 4 - blocksize/2 +0.5 + 1.5;
          for(i=0; i<theta_size; i++) 
          {
#ifndef SIN_LUT
            double theta = i*THETASTEP*M_PI/180;
#endif
#ifdef SIN_LUT
            rho = absolute_x*cosLUT32[i]+absolute_y*sinLUT32[i];
#else
            rho = absolute_x*cos(theta)+absolute_y*sin(theta);
#endif

            if (rho >= min_rho && rho <= max_rho)
            {
              Indp = (int)(fabs(rho)/pstep+0.5);
              Indp = (rho>0)? Indp:-Indp;
              accum[Indp+shift][i] = accum[Indp+shift][i]+1;
            }
          }
        }
      }
    }
    // Finding local maxima in accum
    total = 0;
    for(r = 0; r < rho_size[mb_ext_level]; r++)
    {
      for(t = 0; t < theta_size; t++)
      {
        if( accum[r][t] > thresh)
        {
          max_flag = 1;
          for(n=0; n<8; n++) // neighbors
          {
            rhoi = r + neigh[n][0];
            rhoi = (rhoi<0)? 0 : ((rhoi>(rho_size[mb_ext_level]-1))?(rho_size[mb_ext_level]-1):rhoi);
            thetai = t + neigh[n][1];
            thetai = (thetai<0)? 0 : ((thetai>(theta_size-1))?(theta_size-1):thetai);

            if( accum[r][t] < accum[rhoi][thetai])
            {
              max_flag = 0;
              break;
            }
          }      
          if(max_flag)           
          {
            if(rho_scale[mb_ext_level][r]<0)
            {
              line[total].rho = abs(rho_scale[mb_ext_level][r]);
              line[total].thetai = t+(int)(180/THETASTEP);
            }
            else
            {
              line[total].rho = rho_scale[mb_ext_level][r];
              line[total].thetai = t;
            }
            line[total++].accum =accum[r][t];
          }
        }
      }
    }
    qsort((void *)line, total, sizeof(LinePolar), compare);
    // Calculation of detected lines parameters(Radius & Angle).

    return total;
  }



  void MV_segmentation(int mb32count, int mb_ext_level)
  {
    int start_x=0, start_y=0;

    switch (mb_ext_level)
    {
    case 0:
      start_x = start_y = 0;
      break;
    case 1:
      start_x=(mb32count&1)  * 8; //starting point of 4x4 motion vector
      start_y=(mb32count>>1) * 8;
      break;
    case 2:
      start_x = start_y = 0;
      break;
    default:
      error("out of range\n", -1);
      break;
    }

    //edge point detection
    edge_detect(start_x, start_y, mb_ext_level);

    //line detection
    line_candidates = houghline(mb_ext_level);
  }


#define MV_LEVEL 13
  //motion vector block size
  int  mv_bx[MV_LEVEL] = {64,64,32,32,32,16,16,16,8, 8,8,4,4};
  int  mv_by[MV_LEVEL] = {64,32,64,32,16,32,16,8, 16,8,4,8,4};
  int start_mv_level[]={6,3,0};//[mb_ext_level]
  char geo_motion_flag[3][GEO_PART_NUM][2][MV_LEVEL][16][16];//[mb_ext_level][GEO_PART_NUM][segm][MV_LEVEL][4x4 block y idx][4x4 block x idx]
  int regular_motion [MV_LEVEL][16][16][2][MAX_REFERENCE_PICTURES][2];
  void find_embedded_MBPartition()
  {
    int i, j, ii, jj, x, y, rho, theta_idx, segm;
    int size, mv_lev;
    char **mask;

    for(i=0; i<3; i++)//mb_ext_level
    {    
      size = 16<<i;
      for(j=0; j<Max_rho[i]*(1<<THETA_BITS); j++)//geo_mode
      {
        get_rho_theta(j, &rho, &theta_idx, &mask, i);
        for(segm=0; segm<2; segm++)
        {
          for(mv_lev=start_mv_level[i]; mv_lev<MV_LEVEL; mv_lev++)//
          {        
            for(y=0; y<size; y+=mv_by[mv_lev])
              for(x=0; x<size; x+=mv_bx[mv_lev])
              {
                geo_motion_flag[i][j][segm][mv_lev][y>>2][x>>2]=1;
                for(jj=y; jj<y+mv_by[mv_lev]; jj++)
                  for(ii=x; ii<x+mv_bx[mv_lev]; ii++)
                    if(mask[jj][ii]!=segm)
                      geo_motion_flag[i][j][segm][mv_lev][y>>2][x>>2] = 0;
              }         
          }        
        }      
      }    
    }

  } 

  void save_mv_for_speedup(int mb_ext_level)
  {
    int i0=0, j0=0, list, ref, k;
    int x, y, b4x, b4y, size;
    //int mode[]={1,2,2,3,3};//[partition];
    int mv_lev, mv_lev_i, tot_mv_lev=0; 

    size = 16<<mb_ext_level;

    if(mb_ext_level==0)
    {
      int mb32i = curr_mbi/4;
      int mb16i = curr_mbi%4;
      i0 = ((mb32i&1)<<3) + ((mb16i&1)<<2); // x offset relative to the upper left conner of 64x64 in the unit of 4x4 block
      j0 = ((mb32i/2)<<3) + ((mb16i/2)<<2); // y offset relative to the upper left conner of 64x64 in the unit of 4x4 block
      tot_mv_lev = 7;//mode 1~7
    }
    else if(mb_ext_level==1)
    {
      i0 = (curr_mb32i&1)<<3;
      j0 = (curr_mb32i/2)<<3;
      tot_mv_lev = 3;//mode 1~3
    }
    else if(mb_ext_level==2)
    {
      i0 = 0;
      j0 = 0;
      tot_mv_lev = 3;//mode 1~3
    }
    else
      error("mb_ext_level error !\n", -1);





    for(mv_lev_i=0; mv_lev_i<tot_mv_lev; mv_lev_i++)
    {
      if(mb_ext_level > 0 && ((mv_lev_i==1 && input->InterSearch16x16==0)|| (mv_lev_i==2 && input->InterSearch16x8==0) || (mv_lev_i==3 && input->InterSearch8x16==0)))
      {
        for(list=0; list<2; list++)
          for(ref=0; ref<img->max_num_references; ref++)      
          {
            mv_lev = start_mv_level[mb_ext_level]+mv_lev_i;

            for(y=0; y<size; y+=mv_by[mv_lev])
              for(x=0; x<size; x+=mv_bx[mv_lev])
              {
                b4y=y>>2;
                b4x=x>>2; 
                for(k=0; k<2; k++)
                {              
                  regular_motion [mv_lev][j0+b4y][i0+b4x][list][ref][k] = INT_MAX;
                  //geo_pred_mv[geo_mode][segm][i][j][list][ref][mode][k] = img->pred_mv[i][j][list][ref][mode][k];
                }
              }
          }
      }
      else
      {
        for(list=0; list<2; list++)
          for(ref=0; ref<img->max_num_references; ref++)      
          {
            mv_lev = start_mv_level[mb_ext_level]+mv_lev_i;

            for(y=0; y<size; y+=mv_by[mv_lev])
              for(x=0; x<size; x+=mv_bx[mv_lev])
              {
                b4y=y>>2;
                b4x=x>>2; 
                for(k=0; k<2; k++)
                {              
                  regular_motion [mv_lev][j0+b4y][i0+b4x][list][ref][k] = img->all_mv[b4y] [b4x][list][ref][mv_lev_i+1][k];
                  //geo_pred_mv[geo_mode][segm][i][j][list][ref][mode][k] = img->pred_mv[i][j][list][ref][mode][k];
                }
              }
          }

      }
    }
  }

  int get_regular_motion(int geo_mode, int segm, int mv[2], int list, int ref, int mb_ext_level)
  {
    int i0=0, j0=0, x, y, mv_lev, b4x, b4y, k;
    int size;

    size = 16<<mb_ext_level;

    if(mb_ext_level==0)
    {
      int mb32i = curr_mbi/4;
      int mb16i = curr_mbi%4;
      i0 = ((mb32i&1)<<3) + ((mb16i&1)<<2); // x offset relative to the upper left conner of 64x64 in the unit of 4x4 block
      j0 = ((mb32i/2)<<3) + ((mb16i/2)<<2); // y offset relative to the upper left conner of 64x64 in the unit of 4x4 block
    }
    else if(mb_ext_level==1)
    {
      i0 = (curr_mb32i&1)<<3;
      j0 = (curr_mb32i/2)<<3;
    }
    else if(mb_ext_level==2)
    {
      i0 = 0;
      j0 = 0;
    }
    else
      error("mb_ext_level error !\n", -1);

    for(mv_lev=start_mv_level[mb_ext_level]+1; mv_lev<MV_LEVEL; mv_lev++)
    {
      for(y=0; y<size; y+=mv_by[mv_lev])
        for(x=0; x<size; x+=mv_bx[mv_lev])
        {
          b4y=y>>2;
          b4x=x>>2; 

          if(geo_motion_flag[mb_ext_level][geo_mode][segm][mv_lev][b4y][b4x])
          {
            for(k=0; k<2; k++)
            {
              mv[k]=regular_motion [mv_lev][j0+b4y][i0+b4x][list][ref][k];
              //geo_pred_mv[geo_mode][segm][i][j][list][ref][mode][k] = img->pred_mv[i][j][list][ref][mode][k];
            }
            if(mv[0] == INT_MAX)
              continue;
            else
              return 1;

          }
        }
    }
  {
    char **mask;
    int rho,theta_idx;
    int i,x,y,temp[4]={0,0,0,0};
    int xidx[4]={0,size-4,0,size-4};      //(xidx,yidx) are coordinates of corner 4x4 blocks in 16x16MB or 32x32MB or 64x64MB
    int yidx[4]={0,0,size-4,size-4};      //(0=TopLeft, 1=TopRight, 2=Bottomleft, 3=BottomRight)
    int b4x=0,b4y=0;      //4x4 block index in 16x16MB or 32x32MB or 64x64MB

    rho = geo_mode>>theta_bits[mb_ext_level];
    theta_idx = geo_mode & ((1<<theta_bits[mb_ext_level])-1);
    mask = geo_mask[mb_ext_level][rho][theta_idx];

    for(i=0;i<4;i++)
      for(x = xidx[i]  ; x < xidx[i]+4  ;  x++)
        for(y = yidx[i]  ; y < yidx[i]+4  ;  y++)
          temp[i] += mask[y][x];
//-------------------------
//|  0  |     |     |  1  |
//|     |     |     |     |
//-------------------------
//|     |     |     |     |
//|     |     |     |     |
//-------------------------
//|     |     |     |     |
//|     |     |     |     |
//-------------------------
//|  2  |     |     |  3  |
//|     |     |     |     |
//-------------------------
//select the 4x4 block which covers maximun for that corner mode
    if(temp[0]>=temp[1] && temp[0]>=temp[2] && temp[0]!=0)
    {
      b4x = 0;              b4y = 0;                      //0
    }
    else if(temp[1]>=temp[3] && temp[1]>=temp[0] && temp[1]!=0)
    {
      b4x = (size>>2)-1;    b4y = 0;                      //1
    }
    else if(temp[3]>=temp[2] && temp[3]>=temp[1] && temp[3]!=0)
    {
      b4x = (size>>2)-1;    b4y = (size>>2)-1;            //3
    }
    else if(temp[2]>=temp[0] && temp[2]>=temp[3] && temp[2]!=0)
    {
      b4x = 0;              b4y = (size>>2)-1;            //2
    }

    //assign 4x4 MV
    mv[0]=regular_motion [12][j0+b4y][i0+b4x][list][ref][0];  
    mv[1]=regular_motion [12][j0+b4y][i0+b4x][list][ref][1];

    //enc_geo[mb_ext_level][geo_mode] = 1;
    return 1;
  }

    return 0;
  }


  int                                         //!< minimum motion cost after search
    BlockMotionCost32_geo (int mv[2],
    short     ref,           //!< reference idx
    int       list,          //!< reference pciture list
    pel_t ** orig_pic,    // <--  original pixel values for the AxB block
    int       mb_x,          //!< x-coordinate inside macroblock   (in the unit of pel -peisong)
    int       mb_y,          //!< y-coordinate inside macroblock   (in the unit of pel -peisong)
    int       scheme,
    int       geo_mode,     //!< block type (1-16x16 ... 7-4x4)
    int       segm,
    int       search_range,  //!< 1-d search range for integer-position search
    int       lambda_factor, //!< lagrangian parameter for determining motion cost
    int       mb_ext_level) 
  {
    int       blocktype=1;

    short     pred_mv_x, pred_mv_y, mv_x, mv_y;
    int       i, j;
#ifdef EIGHTH_PEL
    //int       mvshift   = (img->mv_res ? 3 : 2);
#endif
    int       min_mcost = INT_MAX;

    int       block_x   = (mb_x>>2);   //scalable to MB32X32
    int       block_y   = (mb_y>>2);

#ifdef MB32X32
    int       bsx       = input->blc_size[blocktype][0]<<mb_ext_level; //blc_size = part_sizes * BLOCK_SIZE 
    int       bsy       = input->blc_size[blocktype][1]<<mb_ext_level;
#else
    int       bsx       = input->blc_size[blocktype][0];
    int       bsy       = input->blc_size[blocktype][1];
#endif

    int       pic_pix_x = img->opix_x + mb_x;
    int       pic_pix_y = img->opix_y + mb_y;

    short*    pred_mv = img->pred_mv[block_y][block_x][list][ref][blocktype];
    short****** all_mv    = img->all_mv;  

    //===========================================
    //=====   GET MOTION VECTOR PREDICTOR   =====
    //===========================================
#ifdef MV_COMPETITION_
    if (input->mv_competition > 0)
      SetMotionVectorPredictor_Competition (pred_mv, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy);
    else
#endif
#ifdef MB32X32
      SetMotionVectorPredictor32_geo (pred_mv, geo_mode, segm, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy, mb_ext_level);  //scalable to MB32X32
#else
      SetMotionVectorPredictor (pred_mv, enc_picture->ref_idx[list], enc_picture->mv[list], ref, list, block_x, block_y, bsx, bsy);
#endif  



    pred_mv_x = pred_mv[0];
    pred_mv_y = pred_mv[1];

    //==================================
    //=====   INTEGER-PEL SEARCH   =====
    //==================================


    //===== convert search center to quarter-pel units =====
    mv_x = mv[0];
    mv_y = mv[1];

    //==============================
    //=====   SUB-PEL SEARCH   =====
    //==============================
#ifdef EIGHTH_PEL
    min_mcost =  EPZSSubPelBlockMotionCostoneEighth32_geo(orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
      pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, 9, min_mcost, lambda_factor, scheme, geo_mode, segm, mb_ext_level);   
#else
    min_mcost =  EPZSSubPelBlockMotionCost32_geo (orig_pic, ref, list, pic_pix_x, pic_pix_y, blocktype,
      pred_mv_x, pred_mv_y, &mv_x, &mv_y, 9, 9, 9, min_mcost, lambda_factor, scheme, geo_mode, segm, mb_ext_level);            
#endif

    //===============================================
    //=====   SET MV'S AND RETURN MOTION COST   =====
    //===============================================

#ifdef MV_COMPETITION_
    if (input->mv_competition > 0)
      GetBestPredVector( pred_mv,mv_x,mv_y,lambda_factor,ref,list,blocktype,mb_x,mb_y);  
#endif

    for (j=block_y; j < block_y + (bsy>>2); j++)      //scalable to MB32X32
    {
      for (i=block_x; i < block_x + (bsx>>2); i++)
      {
        all_mv[j][i][list][ref][blocktype][0] = mv_x;
        all_mv[j][i][list][ref][blocktype][1] = mv_y;
      }
    }


    return min_mcost;
  }




